#include <iostream>
#include <set>
#include <algorithm>

int n;
std::set<int> data;

void input_data() noexcept {
	int k;
	std::cin >> n >> k;

	data.clear();
	for (int i = 0; i < k; ++i) {
		int input;
		std::cin >> input;
		data.insert(input);
	}
}

void encode() noexcept {
	int value = *data.begin();
	if (n % 2 == 1)
		if (value == 1)
			std::cout << (n + 1) / 2 << std::endl;
		else if (value == (n + 1) / 2)
			std::cout << n << std::endl;
		else if (value == n)
			std::cout << 1 << std::endl;
		else
			std::cout << n + 1 - value << std::endl;
	else
		std::cout << n + 1 - value << std::endl;
}

void decode() noexcept {
	int value = *data.begin();
	if (n % 2 == 1)
		if (value == 1)
			std::cout << n << std::endl;
		else if (value == (n + 1) / 2)
			std::cout << 1 << std::endl;
		else if (value == n)
			std::cout << (n + 1) / 2 << std::endl;
		else
			std::cout << n + 1 - value << std::endl;
	else
		std::cout << n + 1 - value << std::endl;
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	int a, m;
	std::cin >> a >> m;
	for (int mi = 0; mi < m; ++mi) {
		input_data();
		if (a == 1)
			encode();
		else
			decode();
	}
	return 0;
}
