#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <string>
#include <random>
#include <cmath>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
void fastio() { ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0); }

const long long INF = 2e9;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;

int main() {
	fastio();
	ll z;
	cin >> z;
	ll t;
	cin >> t;
	while (t--) {
		ll n, k;
		cin >> n >> k;
		vector<ll> a(k);
		for (ll i = 0; i < k; i++) {
			cin >> a[i];
			a[i]--;
		}
		//sort(all(a));
		if (z == 1) {
			vector<ll> ans = a;
			reverse(all(ans));
			set<ll> used(all(a));
			for (ll i = 0; i < k; i++) {
				while (used.find(ans[i]) != used.end()) {
					ans[i] = (ans[i] + n - 1) % n;
				}
				used.insert(ans[i]);
			}
			sort(all(ans));
			for (ll x : ans) cout << x + 1 << " ";
			cout << endl;
		}
		else {
			vector<ll> ans = a;
			set<ll> used(all(a));
			for (ll i = 0; i < k; i++) {
				while (used.find(ans[i]) != used.end()) {
					ans[i] = (ans[i] + 1) % n;
				}
				used.insert(ans[i]);
			}
			sort(all(ans));
			for (ll x : ans) cout << x + 1 << " ";
			cout << endl;
		}
	}
	return 0;
}