#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/priority_queue.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <bits/stdc++.h>
#define int int64_t
#define double long double
#define MULTITASK
#define NO_INTERACTIVE
using namespace std;
using namespace __gnu_pbds;
void solve();
int32_t main() {
#ifdef NO_INTERACTIVE
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
#ifdef BIBIKOV
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#endif
#endif
    int tt = 1;
#ifdef MULTITASK
    cin >> tt;
#endif
    while (tt--) {
        solve();
#ifdef MULTITASK
        cout << '\n';
#endif
    }
}

void solve() {
    int n, ans = 0;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    for (int m = 0; m < (1 << n); m++) {
        int p = -1, q = n + 1, c = 0;
        for (int i = 0; i < n; i++) {
            if (m & (1 << i)) {
                if (p < a[i])
                    p = a[i], c++;
            } else if (a[i] < q) {
                q = a[i], c++;
            }
        }
        ans = max(ans, c);
    }
    cout << ans;
}
