#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)((x).size())
#define all(x) (x).begin(),(x).end()

using pii = pair<int, int>;
using ll = long long;
const int MAXN = 100 + 5;
const int MAXA = 300 + 1;
const ll inf = 1e18;

ll w[MAXN];
//int dp[MAXN][MAXA][MAXA];

bitset<MAXA> mxb[MAXN][MAXA];

void solve() {
    int n, q;
    cin >> n >> q;

    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    sort(w, w + n);
    mxb[0][0][0] = 1;
    for (int i = 0; i < n; i++) {
        for (int a = 0; a < MAXN; a++) {
            mxb[i + 1][a] |= mxb[i][a];
            if (a + w[i] < MAXA)mxb[i + 1][a + w[i]] |= mxb[i][a];
            mxb[i + 1][a] |= (mxb[i][a] << w[i]);
        }
    }
    /*   dp[0][0][0] = 1;
       for (int i = 0; i < n; i++) {
           for (int a = 0; a < MAXA; a++) {
               for (int b = 0; b < MAXA; b++) {
                   if (dp[i][a][b] == 0)continue;
                   //cout << i << ' ' << a << ' ' << b << '\n';
                   dp[i + 1][a][b] = 1;
                   if (a + w[i] < MAXA && a >= w[i] - 1)dp[i + 1][a + w[i]][b] = 1;
                   if (b + w[i] < MAXA && b >= w[i] - 1)dp[i + 1][a][b + w[i]] = 1;
               }
           }
       }
   */

    ll z;
    cin >> z;

    ll sum = 0;
    for (int i = 0; i < q; i++) {
        ll k, ai, bi;
        cin >> k >> ai >> bi;
        k -= sum * z;
        ai -= sum * z;
        bi -= sum * z;
        //cout << k << ' ' << ai << ' ' << bi << '\n';
        int ind = (upper_bound(w, w + n, k) - w);
        bool ok = true;
        for (int j = 0; j <= ai; j++) {
            for (int u = 0; u <= bi; u++) {
                ok &= mxb[ind][j][u];
            }
        }
        if (ok) {
            cout << "Yes\n";
            sum += i + 1;
        } else {
            cout << "No\n";
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t = 1;
    while (t--)
        solve();
    return 0;
}
