#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;
struct konf {
	int l, r, num;
	konf(int _l, int _r, int _num) {
		l = _l;
		r = _r;
		num = _num;
	}
	konf() {}
};

int chek(int a) {
	int a0 = a, q=0;
	for (int i = 0; i < 31; i++) {
		q += a0 % 2;
		a0 /= 2;
	}
	return q;
}

bool f(int a, int c) {
	if ((a >> c) % 2 == 0) return false;
	else return true;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n; 
		if (n > 20) {
			for (int i = 0; i < n; i++) {
				int l, r;
				cin >> l >> r;
				if (n < n / 2)
					cout << i + 1 << ' ';
			}
			cout << '\n';
		}
		vector<konf> z0(n), z;
		map<int, vector<int>> m;
		for (int i = 0; i < n; i++) {
			int l, r;
			cin >> l >> r;
			z0[i] = konf(l, r, i);
			m[l].push_back(i);
			m[r].push_back(i);
		}
		z = z0;
		sort(z.begin(), z.end(), [&](konf a, konf b) {
			if (a.l == b.l) return a.r < b.r;
			return a.l < b.l;
			});
		set<int> s;
		vector<pair<int, int>> kol;
		for (auto& i : m) {
			sort(i.second.begin(), i.second.end(), [&](int a, int b) {
				if (z0[a].l == i.first && z0[b].r == i.first) return true;
				return false;
				});
			for (auto& j : i.second) {
				if (z0[j].l == i.first) s.insert(j);
				else {
					if (s.count(j) == 1) {
						kol.push_back({ i.first, j });
						s.clear();
						break;
					}
				}
			}
		}
		vector<int>used(n);
		vector<int> ans;
		int M = kol.size();


		for (int i = 0; i < (1 << n); i++) {
			if (chek(i) != n / 2) continue;
			vector<konf> z1;
			for (auto& j : z0) {
				if (f(i, j.num)==0) {
					z1.push_back(j);
				}
			}
			set<int> s0;
			vector<pair<int, int>> kol0;
			for (auto& ii : m) {
				for (auto& j : ii.second) {
					if (f(i, j)) continue;
					if (z0[j].l == ii.first) s0.insert(j);
					else {
						if (s0.count(j) == 1) {
							kol0.push_back({ ii.first, j });
							s0.clear();
							break;
						}
					}
				}
			}
			if (kol0.size() == M / 2) {
				for (int ii = 0; ii < n; ii++) {
					if (i % 2 == 0) cout << ii + 1 << ' ';
					i /= 2;
				}
				break;
			}

		}
		cout << '\n';
	}
}
