#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define f(n) for(int i = 0; i < n; ++i)
#define pb push_back
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

typedef long long ll;
typedef vector<int> vei;

int k;

vector<int> l, r;
vector<int> ct;
int cur = 1;
vector<int> leafs(1);
vector<int> L, R, ans;

void dfs(int v, int prev) { //prev = 0 if left, 1 if right
    if(l[v]==-1) {
        leafs.pb(0);
        if(ct[v]<=k) leafs[cur] = 1;
        L[v] = cur;
        R[v] = cur;
        cur++;
        ans[v] = 1;
        return;
    }
    ct[l[v]] = ct[v];
    ct[r[v]] = ct[v];
    if(prev==0) ct[r[v]]++;
    else if(v != 0) ct[l[v]]++;
    dfs(l[v], 0);
    dfs(r[v], 1);
    ans[v] = ans[l[v]] + ans[r[v]];
}

void solve() {
    int n, q;
    cin>>n>>k>>q;
    l.resize(n, -1);
    r.resize(n, -1);
    L.resize(n, -1);
    R.resize(n, -1);
    ct.resize(n);
    f(n) {
        int t;
        cin>>t;
        if(t==2) {
            cin>>l[i]>>r[i];
            --l[i];--r[i];
        }
    }

    dfs(0, -1);

    f(q) {
        int u;
        cin>>u;
        --u;
        cout<<ans[u]<<'\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int tc = 1;
    // cin >> tc;
    for(int i = 0; i < tc; ++i) solve();
}