#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define f(n) for(int i = 0; i < n; ++i)
#define pb push_back
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

typedef long long ll;
typedef vector<int> vei;

int timer = 0;

bool is_tl() {
    if(timer == 500) {
        if(clock() > CLOCKS_PER_SEC * 0.9) return 1;
    }
    return 0;
}


mt19937 rnd(1329);
vector<pair<int, int>> segs;

struct sob {
    int x, t, ind;  //t = 0 open, t = 1 close
};

bool cmpx(sob a, sob b) {
    if(a.x == b.x) return a.t < b.t;
    return a.x < b.x;
}

int calc(vector<int> in) {
    vector<sob> au;
    f(segs.size()) {
        au.pb({segs[in[i]].first, 0, i});
        au.pb({segs[in[i]].second, 1, i});
    }
    sort(all(au), cmpx);
    vector<int> dp(in.size());
    int curmax = 0;
    for(auto e : au) {
        if(e.t == 1) {
            curmax = max(curmax, dp[e.ind]);
            continue;
        }
        dp[e.ind] = curmax + 1;
    }
    return curmax;
}

void solve() {
    int n;
    cin>>n;
    segs.resize(n);
    for(int i = 0; i < n; ++i) {
        cin >> segs[i].first >> segs[i].second;
    }
    vei al;
    f(n) al.pb(i);
    int m = calc(al);
    vector<int> in, out;
    f(n/2) in.pb(i);
    f(n/2) out.pb(n/2+i);
    int mod = 1000000;
    int temp = mod;
    int prevcalc = calc(in);
    f(100000) {
        vector<int> prin = in, prout = out;
        for(int i = 0; i < 1 + rnd()%3; ++i) {
            int i1 = rnd()%(n/2), i2 = rnd()%(n/2);
            swap(in[i1], out[i2]);
        }
        int clc = calc(in);
        if(clc==m/2) break;
        if(abs(prevcalc-m/2) > abs(clc-m/2) || rnd()%mod < temp) {
            prevcalc = clc;
        }
        else {
            swap(prin, in);
            swap(prout, out);
        }
    }
    sort(all(in));
    for(auto e : in) cout<<e+1<<' ';
    cout<<'\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int tc = 1;
    cin >> tc;
    for(int i = 0; i < tc; ++i) solve();
}