#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <numeric>
#include <deque>

using namespace std;

//#define DEBUG

#define all(x) x.begin(), x.end()
#define nl '\n'
#define int long long

#ifdef DEBUG

#define deb(x) cout << #x << '=' << x << ' ';
#define debnl(x) cout << #x << '=' << x << endl;
#define print(a) {cout << #a << endl; for (auto x: a) cout << x << ' '; cout << endl; }

#else

#define deb(x)
#define debnl(x)
#define print(a)

#endif

typedef long long ll;
typedef pair<int, int> ii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;

void fastIO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int INF = 1e9+1;

void solve();

signed main() {
	fastIO();
	int T = 1;
	//cin >> T;
	while (T--) {
		solve();
	}
}

ii calc(deque<int> a, ll w){
    int n = a.size();
    int shift = 0;
    int ans = a.back() - a.front();
    int ans_moves = 0;
    print(a);
    for (int i = 0; i < n - 1; i++){
        debnl(i);
        int d = w - (a.back() + shift);
        debnl(d);
        shift += d;
        a.pop_back();
        if (a.back() + shift < ans){
            ans = a.back() + shift;
            ans_moves = shift;

        }
        debnl(ans);
    }

    return make_pair(ans, ans_moves);
}

void solve() {
    ll h, w, k;
    cin >> h >> w >> k;
    vi raw_cs, raw_rs;
    deque<int> rs, cs;
    for (int i = 0; i < k; i++){
        int x, y;
        cin >> x >> y;
        x--, y--;
        raw_rs.push_back(x), raw_cs.push_back(y);
    }
    sort(all(raw_rs)), sort(all(raw_cs));
    raw_cs.resize(unique(all(raw_cs)) - raw_cs.begin());
    raw_rs.resize(unique(all(raw_rs)) - raw_rs.begin());
    for (auto el: raw_cs) cs.push_back(el);
    for (auto el: raw_rs) rs.push_back(el);
    print(cs);
    print(rs);
    ii answer1 = calc(rs, h);
    reverse(all(rs));
    for (int i = 0; i < rs.size(); i++) rs[i] = h - 1 - rs[i];
    answer1 = min(answer1, calc(rs, h));
    ii answer2 = calc(cs, w);
    reverse(all(cs));
    for (int i = 0; i < cs.size(); i++) cs[i] = w - 1 - cs[i];
    answer2 = min(answer2, calc(cs, w));
    cout << (answer1.first+1) * (answer2.first+1) << ' ' << answer1.second + answer2.second;
}
