#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <numeric>

using namespace std;

#define DEBUG

#define all(x) x.begin(), x.end()
#define nl '\n'

#ifdef DEBUG

#define deb(x) cout << #x << '=' << x << ' ';
#define debnl(x) cout << #x << '=' << x << endl;
#define print(a) {cout << #a << endl; for (auto x: a) cout << x << ' '; cout << endl; }

#else

#define deb(x)
#define debnl(x)
#define print(a)

#endif

typedef long long ll;
typedef pair<int, int> ii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;

void fastIO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

int P;

void solve();

signed main() {
	//fastIO();
	int T = 1;
	cin >> P;
	cin >> T;

	while (T--) {
		solve();
	}

	//cout << endl;
}

int n, k;
vi a;

void movef(int i) {
	if (i == 0) {
		if (a[i] == n - k) {
			a = vi(k);
			iota(all(a), 0);
		}
		else {
			a[i]++;
		}
		return;
	}
	if (a[i] < n - 1) {
		a[i]++;
		return;
	}
	movef(i - 1);
	a[i] = a[i - 1] + 1;

}

void moveb(int i) {
	if (i == 0) {
		if (a[i] == 0) {
			a[i] = n - k;
		}
		else a[i]--;
		return;
	}
	if (a[i - 1] + 1 < a[i]) {
		a[i]--;
		return;
	}
	moveb(i - 1);
	a[i] = n - (k - i);
}

void solve() {
	cin >> n >> k;
	a = vi(k);
	for (int i = 0; i < k; i++) {
		cin >> a[i], a[i]--;
	}
	if (P == 1) movef(k - 1);
	else moveb(k - 1);
	for (int i = 0; i < k; i++) {
		cout << a[i] + 1 << ' ';
	}
	cout << endl;
}










