#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <queue>
#include <algorithm>
#include <numeric>

using namespace std;

//#define DEBUG

#define all(x) x.begin(), x.end()
#define nl '\n'

#ifdef DEBUG

#define deb(x) cout << #x << '=' << x << ' ';
#define debnl(x) cout << #x << '=' << x << endl;
#define print(a) {cout << #a << endl; for (auto x: a) cout << x << ' '; cout << endl; }

#else

#define deb(x)
#define debnl(x)
#define print(a)

#endif

typedef long long ll;
typedef pair<int, int> ii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;

void fastIO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int INF = 1e9 + 1;

void solve();

signed main() {
	fastIO();
	int T = 1;
	//cin >> T;
	while (T--) {
		solve();
	}
}

const int N = 101;
const int A = 301, B = 301;

bool dp[N][A][B];

void solve() {
	int n;
	cin >> n;
	int q;
	cin >> q;
    vi w(n);
    dp[0][0][0] = 1;
    for (int i = 0; i < n; i++) cin >> w[i];
    for (int i = 0; i < n; i++){
        for (int j = 0; j < A; j++){
            for (int k = 0; k < B; k++){
				dp[i + 1][j][k] |= dp[i][j][k];
                if (j + w[i] < A) dp[i+1][j + w[i]][k] |= dp[i][j][k];
                if (k + w[i] < B) dp[i+1][j][k + w[i]] |= dp[i][j][k];
            }
        }
    }
    
	int z;
	cin >> z;

    for (int it = 0; it < q; it++){
        int _, a, b;
        cin >> _ >> a >> b;
        bool flag = true;
        for (int i = 0; i <= a; i++){
            for (int j = 0; j <= b; j++){
                flag &= dp[n][i][j];
				deb(dp[n][i][j]);
            }
        }

        if (flag) cout << "Yes";
        else cout << "No";
		cout << nl;
    }

}
