#include <bits/stdc++.h>

using namespace std;

void solvefirst() {
	int n, k;
	cin >> n >> k;
	vector<int> a(n);
	for (int i = 0; i < k; ++i) {
		int x;
		cin >> x;
		--x;
		a[x] = 1;
	}
	vector<int> b(n);
	int cnt = 0;
	for (int i = 0; i < n; ++i) {
		if (a[i] == 1) {
			++cnt;
		} else {
			if (cnt > 0) {
				b[i] = 1;
				--cnt;
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		if (a[i] == 0 && b[i] == 0 && cnt > 0) {
			b[i] = 1;
			--cnt;
		}
	}
	for (int i = 0; i < n; ++i) {
		if (b[i] == 1) {
			cout << i + 1 << " ";
		}
	}
	cout << "\n";
}

void solvesecond() {
	int n, k;
	cin >> n >> k;
	vector<int> b(n);
	for (int i = 0; i < k; ++i) {
		int x;
		cin >> x;
		--x;
		b[x] = 1;
	}
	vector<int> a(n);
	vector<int> st;
	for (int i = 0; i < n; ++i) {
		if (b[i] == 1) {
			if (!st.empty()) {
				a[st.back()] = 1;
				st.pop_back();
				b[i] = 2;
			}
		} else {
			st.push_back(i);
		}
	}
	for (int i = 0; i < n; ++i) {
		if (b[i] == 1) {
			if (!st.empty()) {
				a[st.back()] = 1;
				st.pop_back();
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		if (a[i] == 1) {
			cout << i + 1 << " ";
		}
	}
	cout << "\n";
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int a, m;
	cin >> a >> m;
	while (m--) {
		if (a == 1) {
			solvefirst();
		} else {
			solvesecond();
		}
	}
	return 0;
}