#include <bits/stdc++.h>

using namespace std;

constexpr int maxn = 2e5 + 5;

vector<int> g[maxn];

int ans[maxn];

void dfs(int v, int k, int used, int prv) {
    if (used > k) {
        return;
    }
    if (g[v].empty()) {
        ans[v] = 1;
        return;
    }
    if (v == 0) {
        dfs(g[v][0], k, used, 0);
        dfs(g[v][1], k, used, 1);
    } else {
        dfs(g[v][prv], k, used, prv);
        dfs(g[v][prv ^ 1], k, used + 1, prv ^ 1);
    }
    ans[v] = ans[g[v][0]] + ans[g[v][1]];
}

void solve() {
    int n, k, q;
    cin >> n >> k >> q;
    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        if (t == 2) {
            int l, r;
            cin >> l >> r;
            l--, r--;
            g[i].push_back(l);
            g[i].push_back(r);
        }
    }
    dfs(0, k, 0, 0);
    while (q--) {
        int u;
        cin >> u;
        u--;
        cout << ans[u] << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
