#pragma GCC optimize("O3")
#include <bits/stdc++.h>
   
using namespace std;
   
constexpr int maxn = 2e5 + 5;
   
vector<int> g[maxn];
   
int l[maxn], r[maxn], nw[maxn];
   
long long dp[maxn][2];
  
vector<int> ord;
  
int pr[maxn];
   
void dfs(int v) {
    dp[v][0] = 0;
    dp[v][1] = nw[v];
    ord.push_back(v);
    for (auto u : g[v]) {
        if (u != pr[v]) {
            pr[u] = v;
            dfs(u);
            dp[v][1] += dp[u][0];
            dp[v][0] += max(dp[u][0], dp[u][1]);
        }
    }
}
   
vector<int> ans;
  
bool used[maxn];
   
void get_ans(int v, int pr, int vl) {
    if (vl == 1) {
        used[v] = true;
        ans.push_back(v);
        for (auto u : g[v]) {
            if (u != pr) {
                get_ans(u, v, 0);
            }
        }
    } else {
        used[v] = false;
        for (auto u : g[v]) {
            if (u != pr) {
                if (dp[u][0] > dp[u][1]) {
                    get_ans(u, v, 0);
                } else {
                    get_ans(u, v, 1);
                }
            }
        }
    }
}
  
pair<long long, long long> get(int n, long long x, long long y, long long m) {
    // dfs(0, 0);
    for (auto v : ord) {
        dp[v][0] = 0;
        dp[v][1] = nw[v];
        for (auto u : g[v]) {
            if (u != pr[v]) {
                dp[v][1] += dp[u][0];
                dp[v][0] += max(dp[u][0], dp[u][1]);
            }
        }
    }
    long long sert = 0;
    for (int i = 0; i < n; ++i) {
        sert ^= (x * 1LL * (i + 1) + y * 1LL * nw[i] % m * nw[i]) % m;
    }
    return {max(dp[0][0], dp[0][1]), sert};
}
   
void solve() {
    int n, q;
    cin >> n >> q;
    for (int i = 0; i < n; ++i) {
        g[i].clear();
    }
    ord.clear();
    ans.clear();
    long long x, y, m;
    cin >> x >> y >> m;
    for (int i = 0; i < n - 1; ++i) {
        int s, f;
        cin >> s >> f;
        s--, f--;
        g[s].push_back(f);
        g[f].push_back(s);
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
        nw[i] = r[i];
    }
    dfs(0);
    long long max_val = max(dp[0][0], dp[0][1]);
    if (dp[0][0] > dp[0][1]) {
        get_ans(0, 0, 0);
    } else {
        get_ans(0, 0, 1);
    }
    for (int i = 0; i < n; ++i) {
        nw[i] = l[i];
    }
    ord.clear();
    dfs(0);
    reverse(ord.begin(), ord.end());
    long long min_val = max(dp[0][0], dp[0][1]);
    long long add_sum = 0;
    for (int i = 0; i < (int)ans.size(); ++i) {
        add_sum += r[ans[i]] - l[ans[i]];
    }
    vector<long long> vl(ans.size() + 1);
    for (int i = 0; i < n; ++i) {
        nw[i] = l[i];
    }
    vector<int> used_nw(n);
    for (int i = 0; i < (int)ans.size(); ++i) {
        used_nw[ans[i]] = 1;
    }
    long long sert = 0;
    for (int i = 0; i < n; ++i) {
        if (!used_nw[i]) {
            sert ^= (x * 1LL * (i + 1) + y * 1LL * l[i] % m * l[i]) % m;
        }
    }
    vector<long long> pr_sert(ans.size() + 1), suf_sert(ans.size() + 1);
    vl[0] = get(n, x, y, m).first;
    vl.back() = max_val;
    for (int i = (int)ans.size() - 1; i >= 0; --i) {
        vl[i] = max(min_val, vl[i + 1] - (r[ans[i]] - l[ans[i]]));
    }
    for (int i = 0; i < (int)ans.size(); ++i) {
        nw[ans[i]] = r[ans[i]];
        pr_sert[i + 1] = pr_sert[i] ^ ((x * 1LL * (ans[i] + 1) + y * 1LL * r[ans[i]] % m * r[ans[i]]) % m);
    }
    for (int i = (int)ans.size() - 1; i >= 0; --i) {
        suf_sert[i] = suf_sert[i + 1] ^ ((x * 1LL * (ans[i] + 1) + y * 1LL * l[ans[i]] % m * l[ans[i]]) % m);
    }
    vector<long long> qs(q);
    for (int i = 0; i < q; ++i) {
        cin >> qs[i];
        if (min_val <= qs[i] && qs[i] <= max_val) {
            int pos = lower_bound(vl.begin(), vl.end(), qs[i]) - vl.begin();
            long long sert_nw = sert;
            if (pos != 0) {
                sert_nw ^= pr_sert[pos - 1];
            }
            if (pos != suf_sert.size()) {
                sert_nw ^= suf_sert[pos];
            }
            if (pos != 0 && pos - 1 < (int)ans.size()) {
                sert_nw ^= (x * 1LL * (ans[pos - 1] + 1) + y * 1LL * (r[ans[pos - 1]] - (vl[pos] - qs[i])) % m * (r[ans[pos - 1]] - (vl[pos] - qs[i]))) % m;
            }
            cout << sert_nw << endl;
        } else {
            cout << -1 << endl;
        }
    }
    while (true) {
        int ind;
        cin >> ind;
        ind--;
        if (ind == -1) {
            break;
        }
        if (min_val <= qs[ind] && qs[ind] <= max_val) {
            int pos = lower_bound(vl.begin(), vl.end(), qs[ind]) - vl.begin();
            for (int i = 0; i < n; ++i) {
                nw[i] = l[i];
            }
            for (int i = 0; i + 1 < pos && i < (int)ans.size(); ++i) {
                nw[ans[i]] = r[ans[i]];
            }
            if (pos != 0 && pos - 1 < (int)ans.size()) {
                nw[ans[pos - 1]] = r[ans[pos - 1]] - (vl[pos] - qs[ind]);
            }
            for (int i = 0; i < n; ++i) {
                cout << nw[i] << ' ';
            }
            cout << endl;
        } else {
            cout << -1 << endl;
        }
    }
}
   
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
