#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <math.h>

using namespace std;
typedef long long ll;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, q;
	cin >> n >> q;
	vector<ll> w(n);
	for (int i = 0; i < n; ++i) {
		cin >> w[i];
	}
	vector<ll> dp(n+1);
	sort(w.begin(), w.end());
	for (int i = 0; i < n; ++i) {
		if (dp[i] >= w[i] - 1) {
			dp[i+1] = dp[i] + w[i];
		}
	}
	while (q--) {
		ll k, a, b;
		cin >> k >> a >> b;
		if (dp[n] >= a) {
			cout << "Yes\n";
		}
		else {
			cout << "No\n";
		}
	}
	return 0;
}