#include <bits/stdc++.h>

using namespace std;

#define fast ios::sync_with_stdio(false);cin.tie(0);
typedef long long ll;

int get_m(vector<pair<int, int>> otr) {
    vector<pair<int, int>> events;
    int n = otr.size();
    vector<int> vx(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        events.push_back({otr[i-1].first, i});
        events.push_back({otr[i-1].second, -i});
    }
    int mx = 0;
    sort(events.begin(), events.end());
    for (auto [x, idx] : events) {
        if (idx < 0) {
            mx = max(vx[-idx], mx);
        } else {
            vx[idx] = mx + 1;
        }
    }
    return *max_element(vx.begin(), vx.end());
}

vector<int> get_mn(vector<pair<int, int>> otr) {
    vector<pair<int, int>> events;
    int n = otr.size();
    vector<int> vx(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        events.push_back({otr[i-1].first, i});
        events.push_back({otr[i-1].second, -i});
    }
    int mx = 0;
    int pr = -1;
    sort(events.begin(), events.end());
    vector<int> p(n + 1, -1);
    for (auto [x, idx] : events) {
        if (idx < 0) {
            if (mx < vx[-idx]) {
                pr = -idx;
            }
            mx = max(vx[-idx], mx);
        } else {
            vx[idx] = mx + 1;
            p[idx] = pr;
        }
    }
    vector<int> ans;
    int st = max_element(vx.begin(), vx.end()) - vx.begin();
    while (p[st] != -1) {
        ans.push_back(st);
        st = p[st];
    }
    ans.push_back(st);
    return ans;
}


void sol() {
    int n;
    cin >> n;
    vector<pair<int, int>> otr(n);
    for (int i = 0; i < n; i++) {
        cin >> otr[i].first >> otr[i].second;
    }
    int m0 = get_m(otr);
    m0/=2;
    for (int i = 0; i < n/2; i++) {
        cout << i + 1 << ' ';
    }
    cout << '\n';
}

int main() {
    fast;
    int t;
    cin >> t;
    while (t--)
        sol();
}
