#include <bits/stdc++.h>

using namespace std;
#define int long long

const int N = 2 * (int) 1e5 + 10;

vector<int> g[N];
int l[N], r[N], dp[N];
vector<int> a;

pair<int, int> dfs(int v) {
    if ((int) g[v].empty()) {
        a.emplace_back(dp[v]);
        l[v] = (int) a.size() - 1, r[v] = (int) a.size() - 1;
        return {l[v], r[v]};
    }
    l[v] = (int) 1e18, r[v] = -(int) 1e18;
    for (auto u: g[v]) {
        dfs(u);
        l[v] = min(l[v], l[u]), r[v] = max(r[v], r[u]);
    }
    return {l[v], r[v]};
}

void calc(int v, int last) {
    if ((int) g[v].empty())
        return;
    if (last == 1)
        dp[g[v][0]] = dp[v] + 1;
    if (last == 0)
        dp[g[v][1]] = dp[v] + 1;
    calc(g[v][0], 0);
    calc(g[v][1], 1);
}

int t[4 * N];

void build(int v, int tl, int tr) {
    if (tl == tr) {
        t[v] = a[tl];
        return;
    }
    int mid = (tl + tr) / 2;
    build(v * 2, tl, mid);
    build(v * 2 + 1, mid + 1, tr);
    t[v] = t[v * 2] + t[v * 2 + 1];
}

int get_sum(int v, int tl, int tr, int ql, int qr) {
    if (tl > qr || tr < ql)
        return 0;
    if (tl >= ql && tr <= qr)
        return t[v];
    int mid = (tl + tr) / 2;
    return get_sum(v * 2, tl, mid, ql, qr) + get_sum(v * 2 + 1, mid + 1, tr, ql, qr);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int n, k, q;
    cin >> n >> k >> q;
    for(int i = 0; i < n; i++){
        int sz;
        cin >> sz;
        g[i].resize(sz);
        for(int j = 0; j < sz; j++)
            cin >> g[i][j], g[i][j]--;
    }
    calc(0, -1);
    for(int i = 0; i < N; i++){
        if(dp[i] <= k)
            dp[i] = 1;
        else
            dp[i] = 0;
    }
    dfs(0);
    build(1, 0, (int)a.size() - 1);
    while(q--){
        int u;
        cin >> u;
        cout << get_sum(1, 0, (int)a.size() - 1, l[u - 1], r[u - 1]) << "\n";
    }
    return 0;
}