#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937 rnd(5523234234);

//const int N = 5000;
//vector<int> p, pos;

//vector<int> match;
//vector<vector<int>> path;
//
//void init(int n) {
//    path.assign(n + 1, {});
//    match.assign((1 << n), -1);
//    vector<vector<int>> kek(n + 1);
//    for (int mask = 0; mask < (1 << n); ++mask) {
//        int cnt = 0;
//        for (int i = 0; i < n; ++i) {
//            if (mask & (1 << i)) {
//                ++cnt;
//            }
//        }
//        kek[cnt].emplace_back(mask);
//    }
//    for (int i = 1; i <= n / 2; ++i) {
//        int m = sz(kek[i]);
//
//        if (m % 2 == 1) {
//            path[i] = kek[i];
//            while (true) {
//                bool ok = 1;
//                shuffle(all(path[i]), rnd);
//                for (int j = 0; j < m; ++j) {
//                    if ((path[i][j] & path[i][(j + 1) % m]) != 0) {
//                        ok = 0;
//                    }
//                }
//                if (ok) {
//                    break;
//                }
//            }
//        } else {
//            shuffle(all(kek[i]), rnd);
//            while (!kek[i].empty()) {
//                int now = kek[i].back();
//                kek[i].pop_back();
//                bool ok = 0;
//                for (int j = 0; j < sz(kek[i]); ++j) {
//                    if ((kek[i][j] & now) == 0) {
//                        match[now] = kek[i][j];
//                        match[kek[i][j]] = now;
//                        swap(kek[i][j], kek[i].back());
//                        ok = 1;
//                        break;
//                    }
//                }
//                assert(ok);
//                kek[i].pop_back();
//            }
//        }
//    }
//}

void encode() {
    int n, k;
    cin >> n >> k;
//    init(n);
    vector<int> a(k);
    int mask = 0;
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
        mask |= (1 << (a[i] - 1));
    }

    for (int dx = 0; dx < 2 * n; ++dx) {
        vector<int> b;
        int cur = 0;
        for (auto x : a) {
            b.emplace_back(1 + (x - 1 + dx) % n);
            cur |= (1 << (b.back() - 1));
        }
        if ((cur & mask) == 0) {
            sort(all(b));
            for (auto i : b) {
                cout << i << ' ';
            }
            cout << en;
            return;
        }
    }
    assert(0);
}

void decode() {
    int n, k;
    cin >> n >> k;
//    init(n);
    vector<int> a(k);
    int mask = 0;
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
        mask |= (1 << (a[i] - 1));
    }

    for (int dx = 0; dx < 2 * n; ++dx) {
        vector<int> b;
        int cur = 0;
        for (auto x : a) {
            b.emplace_back(1 + (x - 1 - dx + n) % n);
            cur |= (1 << (b.back() - 1));
        }
        if ((cur & mask) == 0) {
            sort(all(b));
            for (auto i : b) {
                cout << i << ' ';
            }
            cout << en;
            return;
        }
    }
    assert(0);
}

int main() {
    int tests = 1;
#ifdef THEEVILBID
    freopen("input.txt", "r", stdin);
    tests = 1;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    int type;
    cin >> type;
    cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        if (type == 1) {
            encode();
        } else {
            decode();
        }
    }
    cout << endl;
    return 0;
}
