#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

const int K = 17;

const int MOD = 228228227;
const int base = 179;

int mod;
int k, n, p;
vector<int> a, b;
int used[1 << K];
int vals[1 << K];
int T = 0;
int ans = 0;
int H = 0, hh;
map<int, int> precalc_limit;

int get_mex() {
    ++T;
    for (auto x : a) {
        used[x] = T;
    }
    for (int mex = 0;; ++mex) {
        if (used[mex] != T) {
            return mex;
        }
    }
}

void ultra(int m) {
    for (auto &i : a) {
        hh ^= vals[i];
        i ^= m;
        hh ^= vals[i];
    }
}

int limit() {
    hh = H;
    b = a;
    map<int, pii> mp;
    int last = -1;
    int beg = -1;
    int iter = 0;
    while (true) {
        int m;
        if (mp[hh].first != 0) {
            m = mp[hh].first;
            int id = mp[hh].second;
            if (last == m && beg <= id) {
                a = b;
                precalc_limit[hh] = m;
                return m;
            } else {
                a = b;
                precalc_limit[hh] = -1;
                return -1;
            }
        }
        m = get_mex();
        mp[hh] = {m, iter};
        if (m != last) {
            last = m;
            beg = iter;
        }
        ultra(m - 1);
        ++iter;
    }
}

void rec(int i) {
    if (i == n) {
        int cur;
        if (precalc_limit[H] == 0) {
            cur = limit();
        } else {
            cur = precalc_limit[H];
        }
        if (cur == p) {
            ++ans;
        }
        return;
    }
    for (int x = a[i - 1] + 1; x < (1 << k); ++x) {
        a[i] = x;
        H ^= vals[a[i]];
        rec(i + 1);
        H ^= vals[a[i]];
    }
}

void solve() {
    ans = 0;
    cin >> k >> n >> p;
    a.assign(n, 0);
//    precalc_limit.clear();
//    used.resize(1 << k);
    a[0] = 0;
    rec(1);
    cout << ans << en;
}

int main() {
    int tests = 1;
#ifdef THEEVILBID
    freopen("input.txt", "r", stdin);
    tests = 1;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    vals[0] = base;
    for (int i = 1; i < (1 << K); ++i) {
        vals[i] = 1LL * base * vals[i - 1] % MOD;
    }

    cin >> mod;
    cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
    return 0;
}
