#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

int n, k, q;
vector<vector<int>> g;
vector<int> dp;

void calc(int v, int cnt, int way) {
    if (sz(g[v]) == 0) {
        dp[v] = 1;
        return;
    }
    if (cnt > 0) {
        calc(g[v][way ^ 1], cnt - 1, way ^ 1);
    }
    calc(g[v][way], cnt, way);

    dp[v] = dp[g[v][0]] + dp[g[v][1]];
}

void solve() {
    cin >> n >> k >> q;
    g.resize(n);
    dp.resize(n, 0);
    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        if (t == 2) {
            int l, r;
            cin >> l >> r;
            --l; --r;
            g[i].emplace_back(l);
            g[i].emplace_back(r);
        }
    }
    calc(g[0][0], k, 0);
    calc(g[0][1], k, 1);
    dp[0] = dp[g[0][0]] + dp[g[0][1]];

    for (int w = 0; w < q; ++w) {
        int v;
        cin >> v;
        --v;
        cout << dp[v] << en;
    }
}

int main() {
    int tests = 1;
#ifdef THEEVILBIRD
    freopen("input.txt", "r", stdin);
    tests = 1;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
    return 0;
}
