#include <bits/stdc++.h>

#define int long long
#define endl '\n'

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector <int> l(n);
    vector <int> r(n);
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    vector <vector <int> > graph(n);
    vector <vector <int> > revgraph(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (l[i] <= l[j] && r[i] >= r[j]) {
                graph[i].push_back(j);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (auto j : graph[i]) {
            for (auto k : graph[j]) {
                for (int z = 0; z < graph[i].size(); ++z) {
                    if (graph[i][z] == k) {
                        swap(graph[i][z], graph[i][graph[i].size() - 1]);
                        graph[i].pop_back();
                        break;
                    }
                }
            }
        }
    }

    vector <int> optim;
    for (int i = 0; i < n; ++i) {
        if (graph[i].size() == 0) {
            optim.push_back(i);
        }
    }
    vector <int> sz(optim.size(), 1);
    for (auto i : optim) {
        int cur = i;
        while(revgraph[cur].size() > 0) {
            cur = revgraph[cur][0];
            sz[i]++;
        }
    }

}

signed main()
{
    ios_base::sync_with_stdio(0); cin.tie(0);

     int t;
     cin >> t;
     while(t--) {
        solve();
     }
}
