#include <iostream>
#include "vector"
#include "set"
#include "deque"

#define int long long
#define all(x) (x).begin(), (x).end()

using namespace std;

void solve() {
    int h, w, k; cin >> h >> w >> k;
    set<int> rs, cs;
    for (int i = 0; i < k; ++i) {
        int r, c; cin >> r >> c;
        rs.insert(r); cs.insert(c);
    }
    deque<int> rd;
    for (auto el: rs) {
        rd.push_back(el);
    }
    deque<int> cd;
    for (auto el: cs) {
        cd.push_back(el);
    }
    auto rd1 = rd;
    int mnd = rd.back() - rd.front() + 1, numd = 0;
    int tr = 0, prev = h + 1;
    for (int i = 0; i < rd.size(); ++i) {
        int last = rd.back();
        tr += prev - last;
        prev = last;
        rd.pop_back();
        rd.push_front(last - h);
        if (rd.back() - rd.front() + 1 < mnd) {
            mnd = rd.back() - rd.front() + 1;
            numd = tr;
        }
    }
    rd = rd1;
    int mnu = rd.back() - rd.front() + 1, numu = 0;
    tr = 0, prev = 0;
    for (int i = 0; i < rd.size(); ++i) {
        int last = rd.front();
        tr += last - prev;
        prev = last;
        rd.pop_front();
        rd.push_back(last + h);
        if (rd.back() - rd.front() + 1 < mnu) {
            mnu = rd.back() - rd.front() + 1;
            numu = tr;
        }
    }
    pair<int, int> resv = min(make_pair(mnu, numu), make_pair(mnd, numd));
    auto cd1 = cd;
    int mnr = cd.back() - cd.front() + 1, numr = 0;
    tr = 0, prev = w + 1;
    for (int i = 0; i < cd.size(); ++i) {
        int last = cd.back();
        tr += prev - last;
        prev = last;
        cd.pop_back();
        cd.push_front(last - w);
        if (cd.back() - cd.front() + 1 < mnr) {
            mnr = cd.back() - cd.front() + 1;
            numr = tr;
        }
    }
    cd = cd1;
    int mnl = cd.back() - cd.front() + 1, numl = 0;
    tr = 0, prev = 0;
    for (int i = 0; i < cd.size(); ++i) {
        int last = cd.front();
        tr += last - prev;
        prev = last;
        cd.pop_front();
        cd.push_back(last + w);
        if (cd.back() - cd.front() + 1 < mnl) {
            mnl = cd.back() - cd.front() + 1;
            numl = tr;
        }
    }
    pair<int, int> resh = min(make_pair(mnl, numl), make_pair(mnr, numr));
    cout << resv.first * resh.first << " " << resv.second + resh.second << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    int test = 1;
    while (test--) {
        solve();
    }
}
