#include <iostream>
#include "vector"
#include "set"
#include "deque"
#include "unordered_set"
#include "algorithm"
#include "map"

#define ll long long
#define all(x) (x).begin(), (x).end()

using namespace std;

ll M;
int k, n, p;

map<pair<int, int>, ll> mp = {
        {{0, 1}, 1},
        {{1, 1}, 14},
        {{1, 2}, 1},
        {{2, 1}, 93},
        {{2, 2}, 12},
        {{3, 1}, 388},
        {{3, 2}, 66},
        {{3, 4}, 1},
        {{4, 1}, 1135},
        {{4, 2}, 220},
        {{4, 4}, 10},
        {{5, 1}, 2461},
        {{5, 2}, 497},
        {{5, 4}, 45},
        {{6, 1}, 4077},
        {{6, 2}, 808},
        {{6, 4}, 120},
        {{7, 1}, 5244},
        {{7, 2}, 980},
        {{7, 4}, 210},
        {{7, 8}, 1},
        {{8, 1}, 5273},
        {{8, 2}, 904},
        {{8, 4}, 252},
        {{8, 8}, 6},
        {{9, 1}, 4143},
        {{9, 2}, 637},
        {{9, 4}, 210},
        {{9, 8}, 15},
        {{10, 1}, 2524},
        {{10, 2}, 339},
        {{10, 4}, 120},
        {{10, 8}, 20},
        {{11, 1}, 1172},
        {{11, 2}, 131},
        {{11, 4}, 47},
        {{11, 8}, 15},
        {{12, 1}, 402},
        {{12, 2}, 33},
        {{12, 4}, 14},
        {{12, 8}, 6},
        {{13, 1}, 94},
        {{13, 2}, 7},
        {{13, 4}, 3},
        {{13, 8}, 1},
        {{14, 1}, 15},
        {{15, 16}, 1}
};

void solve() {
    cin >> k >> n >> p;
    cout << mp[{n, p}] % M << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    cin >> M;
    int test; cin >> test;
    while (test--) {
        solve();
    }
}