#include <iostream>
#include "vector"
#include "algorithm"

#define ll long long
#define all(x) (x).begin(), (x).end()

using namespace std;

const int MAXP = 1024;

void solve() {
    int n, q; cin >> n >> q;
    vector<ll> w(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    int z; cin >> z;
    while (q--) {
        ll k, a, b; cin >> k >> a >> b;
        if (a >= (ll)MAXP or b >= (ll)MAXP) {
            cout << "No" << '\n';
            continue;
        }
        vector<vector<bool>> psbl(MAXP, vector<bool>(MAXP, false));
        for (int m1 = 0; m1 < (1 << n); ++m1) {
            vector<bool> used(n, false);
            bool ok = true;
            ll sum = 0;
            for (int i = 0; i < n; ++i) {
                if ((m1 >> i) % 2) {
                    if (w[i] > k) {
                        ok = false;
                        break;
                    }
                    sum += w[i];
                    used[i] = true;
                }
            }
            if (sum >= (ll)MAXP or not ok) continue;
            for (int m2 = 0; m2 < (1 << n); ++m2) {
                ok = true;
                ll sum2 = 0;
                for (int i = 0; i < n; ++i) {
                    if ((m2 >> i) % 2) {
                        if (w[i] > k or used[i]) {
                            ok = false;
                            break;
                        }
                        sum2 += w[i];
                    }
                }
                if (sum2 >= (ll)MAXP or not ok) continue;
                psbl[sum][sum2] = true;
            }
        }
        bool tab[MAXP][MAXP];
        for (int i = 0; i < MAXP; ++i) {
            for (int j = 0; j < MAXP; ++j) {
                tab[i][j] = ((i == 0 or tab[i - 1][j]) and (j == 0 or tab[i][j - 1]) and psbl[i][j]);
            }
        }
        if (tab[a][b]) {
            cout << "Yes" << '\n';
        } else {
            cout << "No" << '\n';
        }
    }
}

signed main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr); cout.tie(nullptr);
    int test = 1;
    while (test--) {
        solve();
    }
}
