#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <numeric>
#include <iomanip>
#include <random>

using namespace std;
using ll = long long;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define len(a) (ll) a.size()

const ll INF = 1e18;

void solve() {
    ll GO, Q;
    cin >> GO >> Q;
    while (Q--) {
        ll n, k;
        cin >> n >> k;
        vector<ll> t(k);
        for (auto &i: t)
            cin >> i;
        if (GO == 1) {
            ll d = t.back() - t[0] + 1;
            vector <ll> ans;
            for (auto& i : t) {
                ll x = i + d;
                if (x > n)
                    x -= n;
                ans.emplace_back(x);
            }
            sort(all(ans));
            for (auto& i : ans)
                cout << i << endl;
        } else if (GO == 2) {
            ll d = t.back() - t[0] + 1;
            vector <ll> ans;
            for (auto& i : t) {
                ll x = i - d;
                if (x <= 0)
                    x += n;
                ans.emplace_back(x);
            }
            sort(all(ans));
            for (auto& i : ans)
                cout << i << endl;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll T = 1;
    while (T--) {
        solve();
    }
    return 0;
}
