//#define _GLIBCXX_DEBUG

#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define len(a) (ll) a.size()
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const ll INF = 1e18;

ll C, n, m;
vector <ll> l, r, now, ans;
vector <vector <ll>> q;

ll cnt() {
    vector <ll> dp(C);
    for (ll i = 1; i < C; i++) {
        dp[i] = dp[i - 1];
        for (auto t : q[i])
            dp[i] = max(dp[i], dp[t - 1] + 1);
    }
    return dp.back();
}

void func() {
    if (!ans.empty()) return;
    if (len(now) == n / 2) {
        q.clear();
        q.resize(C);
        for (auto i : now) {
            q[r[i]].emplace_back(l[i]);
        }
        ll x = cnt();
        if (x == m / 2) {
            ans = now;
        }
        return;
    }
    ll st = 0;
    if (!now.empty())
        st = now.back() + 1;
    for (; st < n; st++) {
        now.emplace_back(st);
        func();
        if (!ans.empty()) return;
        now.pop_back();
    }
}

void solve() {
    cin >> n;
    l.clear(), r.clear(), now.clear(), ans.clear();
    l.resize(n), r.resize(n);
    vector <ll> vals = {0};
    for (ll i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
        vals.emplace_back(l[i]);
        vals.emplace_back(r[i]);
    }
    sort(all(vals));
    vals.resize(unique(all(vals)) - vals.begin());
    C = len(vals) + 1;
    q.resize(C);
    for (ll i = 0; i < n; i++) {
        l[i] = lower_bound(all(vals), l[i]) - vals.begin();
        r[i] = lower_bound(all(vals), r[i]) - vals.begin();
        q[r[i]].emplace_back(l[i]);
    }
    m = cnt();
    func();
    for (auto i : ans)
        cout << i + 1 << ' ';
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    ll T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
