#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2")
#include <bits/stdc++.h>
using namespace std;

#define all(v) (v).begin(), (v).end()
using ll = long long;

ostream& operator<<(ostream& out, const vector<int>& v) {
	for (int x : v) out << x << " ";
	return out;
}

struct t {

	t() {}
	t(int l, int r, int i) : l(l), r(r), i(i) {}

	int l, r, i;

};

int cnt(vector<pair<int, int>> v) {
	sort(all(v), [](pair<int, int> a, pair<int, int> b) {
		return a.second < b.second;
	});
	int ans = 0, r = -1e9;
	for (int i = 0; i < v.size(); i++) {
		if (v[i].first > r) {
			ans++;
			r = v[i].second;
		}
	}
	return ans;
}

int n;
vector<pair<int, int>> v;
vector<pair<int, int>> t;
vector<int> ans;
int m;

bool calc(int i) {
	if (i == n || t.size() == n / 2) {
		return cnt(t) == m / 2;
	}

	if (n - i > n / 2 - t.size()) {
		if (calc(i + 1)) return true;
	}
	t.push_back(v[i]);
	ans.push_back(i + 1);
	if (calc(i + 1)) return true;
	t.pop_back();
	ans.pop_back();
	return false;
}

void solve() {

	cin >> n;
	v.assign(n, pair<int, int>());
	for (int i = 0; i < n; i++) cin >> v[i].first >> v[i].second;
	m = cnt(v);

	t.clear();
	ans.clear();

	calc(0);
	cout << ans << "\n";
}


int main() {
#ifndef LOCAL
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
#endif

	int T;
	cin >> T;
	while (T--) solve();

}
