#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <algorithm>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <queue>
#include <fstream>
#include <deque>
#include <stack>

using namespace std;

typedef long long ll;
#define endl "\n"
#define speed_up ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)

const ll INF = 1e18;

int main() {
	speed_up;
	cout << fixed;
	cout.precision(10);

	ll h, w, k; cin >> h >> w >> k;

	vector<pair<ll, ll>> vec1, vec2;
	for (ll i = 0; i < k; i++) {
		ll a, b; cin >> a >> b;
		vec1.push_back({ b, i });
		vec1.push_back({ b + w, i });
		//vec1.push_back({ b + b + w, i });

		vec2.push_back({ a, i });
		vec2.push_back({ a + h, i });
		//vec2.push_back({ a + a + h, i });
	}

	sort(vec1.begin(), vec1.end());
	sort(vec2.begin(), vec2.end());
	ll m1 = INF;
	ll cnt1 = INF;

	vector<ll> dst1(k, -1);
	set<pair<ll, ll>> st1;
	for (ll i = 0; i < 2 * k; i++) {
		st1.erase({ dst1[vec1[i].second], vec1[i].second });
		st1.insert({ vec1[i].first, vec1[i].second });
		dst1[vec1[i].second] = vec1[i].first;
		if (i >= k) {
			ll nm1 = (*st1.rbegin()).first - (*st1.begin()).first + 1;

			ll c1 = 0;
			if (i < 2 * k - 1) c1 = 2 * w - vec1[i + 1].first + 1;
			ll c2 = vec1[i - k].first;
			ll c = min(c1, c2);

			if (nm1 < m1) {
				m1 = nm1;
				cnt1 = c;
			}
			else if (nm1 == m1) {
				cnt1 = min(cnt1, c);
			}
		}
	}

	/*vector<ll> dst2(k, -1);
	set<pair<ll, ll>> st2;
	ll m2 = INF;
	ll cnt2 = INF;
	for (ll i = 0; i < 2 * k; i++) {
		st2.erase({ dst2[vec2[i].second], vec2[i].second });
		st2.insert({ vec2[i].first, vec2[i].second });
		dst2[vec2[i].second] = vec2[i].first;
		if (i >= k) {
			ll nm2 = (*st2.rbegin()).first - (*st2.begin()).first + 1;
			ll c1 = 0;
			if (i < 2 * k - 1) c1 = 2 * h - vec2[i + 1].first + 1;
			ll c2 = 0;
			if (i > 0) c2 = vec2[i - 1].first;
			ll c = min(c1, c2);

			if (nm2 < m2) {
				m2 = nm2;
				cnt2 = c;
			}
			else if (nm2 == m2) {
				cnt2 = min(cnt2, c);
			}
		}
	}*/

	cout << m1 << " " << cnt1 << endl;
}
