#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <algorithm>
#include <random>
#include <string>
#include <map>
#include <unordered_map>
#include <fstream>

using namespace std;

typedef long long ll;


//umap optimizer
//#include <ext/pb_ds/assoc_container.cpp>
//using namespace __gnu_pbds;
//unordered_map gp_hash_table

vector<vector<ll>> vec;

vector<bool> lft;

vector<ll> l, r;
vector<ll> ls;
ll nid = 0;
ll k;

ll dfs(ll i, ll cnt, ll lefti) {
	ll id = 0;
	ll lfti = lefti;
	l[i] = lefti;
	for (auto p : vec[i]) {
		ll add = 0;
		if (i != 0) add = lft[p] != lft[i];
		lfti += dfs(p, cnt + add, lfti);
		id++;
	}
	if (vec[i].empty()) {
		ls[nid] = cnt <= k;
		nid++;
		r[i] = lefti + 1;
		return 1;
	}
	r[i] = lfti;
	return lfti - lefti;
}

int main() {
	ll n, q; cin >> n >> k >> q;
	vec.resize(n);
	lft.resize(n);
	l.resize(n);
	r.resize(n);
	ll cnt = 0;
	for (ll i = 0; i < n; i++) {
		ll t; cin >> t;
		ll id = 0;
		if (t == 0) cnt++;
		while (t--) {
			ll h; cin >> h; h--;
			vec[i].push_back(h);
			if (id == 0) lft[h] = true;
			id++;
		}
	}
	ls.resize(cnt);

	dfs(0, 0, 0);

	vector<ll> pref(1);
	for (auto p : ls) {
		pref.push_back(*pref.rbegin() + p);
	}

	while (q--) {
		ll u; cin >> u; u--;
		ll nl = l[u], nr = r[u];
		ll cnt = pref[nr] - pref[nl];
		cout << cnt << endl;
	}
}
