#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <deque>
#include <map>
#include <algorithm>

#define eb emplace_back
#define pb push_back
#define all(a) a.begin(), a.end()
#define int long long

using namespace std;

void code() {
	int n, k;
	cin >> n >> k;
	vector<int> v(k);
	deque<pair<int, int>> b;
	map<int, bool> u;
	for (int i = 0; i < k; i++) {
		cin >> v[i];
		v[i]--;
		u[v[i]] = 1;
		if (b.size() == 0 || v[i] != v[i - 1] + 1) {
			b.pb({ v[i], 1 });
		}
		else {
			b.back().second++;
		}
	}
	int s = 0;
	while (u[s]) {
		s++;
	}
	while (b.front().first < s) {
		auto t = b.front();
		b.pop_front();
		b.push_back(t);
	}
	int j = 0;
	vector<int> ans;
	for (auto [st, l] : b) {
		j = max(st+l, j);
		int k = 0;
		while (k < l) {
			if (!u[j%n]) {
				ans.pb(j % n + 1);
				k++;
			}
			j++;
		}
	}
	sort(all(ans));
	for (auto i : ans) {
		cout << i << ' ';
	}
	cout << endl;
}

void decode() {
	int n, k;
	cin >> n >> k;
	vector<int> v(k);
	deque<pair<int, int>> b;
	map<int, bool> u;
	for (int i = 0; i < k; i++) {
		cin >> v[i];
		v[i]--;
		u[v[i]] = 1;
		if (b.size() == 0 || v[i] != v[i - 1] + 1) {
			b.pb({ v[i], 1 });
		}
		else {
			b.back().second++;
		}
	}
	int s = 0;
	while (u[s]) {
		s++;
	}
	while (b.front().first < s) {
		auto t = b.front();
		b.pop_front();
		b.push_back(t);
	}
	vector<int> ans;
	reverse(all(b));
	int j = n - 1;
	for (auto [st, l] : b) {
		j = min(j, st - 1);
		int k = 0;
		while (k < l) {
			if (!u[(j + n) % n]) {
				ans.pb((j + n) % n + 1);
				k++;
			}
			j--;
		}
	}

	sort(all(ans));
	for (auto i : ans) {
		cout << i << ' ';
	}
	cout << endl;
}

void solve() {
	int t, n;
	cin >> t;
	cin >> n;
	while (n--) {
		if (t == 1) {
			code();
		}
		else {
			decode();
		}
	}
}

signed main() {
#ifdef LOCAL
	auto f1 = freopen("C:\\Users\\roi\\source\\repos\\input.txt", "r", stdin);
	auto f2 = freopen("C:\\Users\\roi\\source\\repos\\output.txt", "w", stdout);
#endif
	solve();
}
