#include <iostream>
#include <vector>

struct lec {
	int l, r;
};
int n, k;
std::vector<lec> g;
std::vector<int> dp;
int dfs(int v, int from, int d) {
	if (d > k) {
		return 0;
	}
	if (g[v].l == -1) {
		dp[v] = 1;
		return 1;
	}

	if (from != 1) {
		dp[v] += dfs(g[v].l, -1, d);
	}
	else {
		dp[v] += dfs(g[v].l, -1, d + 1);
	}
	if (from != -1) {
		dp[v] += dfs(g[v].r, 1, d);
	}
	else {
		dp[v] += dfs(g[v].r, 1, d + 1);
	}
	return dp[v];
}
int main() {
	int q;
	std::cin >> n >> k >> q;
	g.resize(n);
	dp.resize(n);
	for (int i = 0; i < n; ++i) {
		int t;
		std::cin >> t;
		if (t == 0) {
			g[i].l = -1;
			g[i].r = -1;
		}
		else {
			std::cin >> g[i].l >> g[i].r;
			--g[i].l;
			--g[i].r;
		}
	}
	dfs(0, 0, 0);
	for (int i = 0; i < q; ++i) {
		int u;
		std::cin >> u;
		std::cout << dp[u - 1] << '\n';
	}
	return 0;
}