#include <iostream>
#include <vector>
#include <bitset>
#include <algorithm>
#include <cmath>

struct lec {
	int l, r, ind;
};
bool operator<(const lec& a, const lec& b) {
	return a.l < b.l;
}
int cnt_m(int n, std::vector<lec>& d) {
	int now_i = 0;
	int ans = 0;
	for (int i = 1; i < n; ++i) {
		if (d[i].l > d[now_i].r) {
			++ans;
			now_i = i;
		}
		else if (d[i].r < d[now_i].r) {
			now_i = i;
		}
	}
	return ans + 1;
}
void solve() {
	int n;
	std::cin >> n;
	std::vector<lec> d(n);
	int index = 0;
	for (lec& i : d) {
		std::cin >> i.l >> i.r;
		i.ind = ++index;
	}
	std::sort(d.begin(), d.end());
	int now_i = 0;
	std::vector<int> ans;
	for (int i = 1; i < n; ++i) {
		if (d[i].l > d[now_i].r) {
			ans.push_back(now_i);
			now_i = i;
		}
		else if (d[i].r < d[now_i].r) {
			now_i = i;
		}
	}
	ans.push_back(now_i);
	int m = ans.size();
	for (int mask = 1; mask < (1 << n); ++mask) {
		int cnt = 0;
		for (int i = 0; i < n; ++i) {
			cnt += (mask >> i) & 1;
		}
		if (cnt != (n >> 1)) {
			continue;
		}
		std::vector<lec> new_d;
		for (int i = 0; i < n; ++i) {
			if ((mask >> i) & 1) {
				new_d.push_back(d[i]);
			}
		}
		if ((m >> 1) == cnt_m(n >> 1, new_d)) {
			for (int i = 0; i < n; ++i) {
				if ((mask >> i) & 1) {
					std::cout << d[i].ind << ' ';
				}
			}
			std::cout << "\n";
			return;
		}
	}
}
int main() {
	int t;
	std::cin >> t;
	while (t--) {
		solve();
	}
}