#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <cstring>

using namespace std;

#define re return
#define ll long long
#define fori(n) for(ll i = 0; i < n; i++)
#define forj(n) for(ll j = 0; j < n; j++)
#define all(x) x.begin(), x.end()

template<class T> istream& operator>>(istream& u, vector<T>& v) { for (auto& i : v) u >> i; re u; }
template<class T, class U> istream& operator>>(istream& u, pair<T, U>& v) { re u >> v.first >> v.second; }

struct info {
	ll l, r, i;
};

void solve1(ll n, ll m, vector<info>& v) {
	fori(n / 2) cout << i + 1 << " ";
	cout << endl;
}

vector<info> tv;
bool ok = false;
void rec(ll pos, ll m, ll mx, ll st, vector<info>& v) {
	if (st == 0) {
		ll q = 0;
		ll prev = -1e9;
		fori(tv.size()) {
			if (tv[i].l > prev) {
				prev = tv[i].r;
				q++;
			}
		}

		if (q * 2 == m) {
			fori(tv.size()) {
				cout << tv[i].i + 1 << " ";
			}
			cout << "\n";
			ok = true;
		}

		re;
	}

	tv.push_back(v[pos]);
	rec(pos + 1, m, mx, st - 1, v);
	tv.pop_back();

	if (st == mx - pos || ok) re;

	rec(pos + 1, m, mx, st, v);
}

void solve2(ll n, ll m, vector<info>& v) {
	ok = false;
	rec(0, m, n, n / 2, v);
}

ll dp[500][1000][251];
bool was[500][1000][251];

ll f(ll pos, ll r, ll del, vector<info>& v) {
	if (pos == v.size()) {
		if (del == 0)re 0;
		else re 1e9;
	}

	if (was[pos][r][del])re dp[pos][r][del];
	was[pos][r][del] = 1;

	dp[pos][r][del] = f(pos + 1, r, del - 1, v);
	if (v[pos].l > r)dp[pos][r][del] = min(dp[pos][r][del], f(pos + 1, v[pos].r, del, v) + 1);
	else dp[pos][r][del] = min(dp[pos][r][del], f(pos + 1, r, del, v));

	re dp[pos][r][del];
}

void get_ans(ll pos, ll r, ll del, vector<info>& v) {
	if (pos == v.size())re;

	if (dp[pos][r][del] == f(pos + 1, r, del - 1, v)) {
		get_ans(pos + 1, r, del - 1, v);
	}
	else {
		cout << pos + 1 << ' ';
		if (v[pos].l > r)get_ans(pos + 1, v[pos].r, del, v);
		else get_ans(pos + 1, r, del, v);
	}
}

void solve3(ll n, ll m, vector<info>& v) {
	memset(was, 0, sizeof(was));
	set<ll> st;
	fori(n) {
		st.insert(v[i].l);
		st.insert(v[i].r);
	}

	map<ll, ll> mp;
	int p = 0;
	for (auto i : st)mp[i] = ++p;
	fori(n) {
		v[i].l = mp[v[i].l];
		v[i].r = mp[v[i].r];
	}

	f(0, 0, n / 2, v);
	get_ans(0, 0, n / 2, v);
	cout << "\n";
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr); cout.tie(nullptr);

	int t; cin >> t;
	while (t--) {
		ll n; cin >> n;
		vector<info> v(n);
		fori(n) {
			cin >> v[i].l >> v[i].r;
			v[i].i = i;
		}

		sort(all(v), [](info& a, info& b) {
			re a.r < b.r;
			});

		ll m = 0;
		ll prev = -1e9;
		fori(n) {
			if (v[i].l > prev) {
				prev = v[i].r;
				m++;
			}
		}


		if (m == n)solve1(n, m, v);
		//else if (n <= 30)solve2(n, m, v);
		else solve3(n, m, v);
	}
}