#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const ll N = 5005;
const ll INF = 1e18;

void solve() {
    ll n, q; cin >> n >> q;
    vector<ll> w(n);
    for (int i = 0; i < n; i++) cin >> w[i];
    sort(w.begin(), w.end());
    ll z; cin >> z;

    vector<ll> dp(n, -INF);
    ll mx = 0;
    for (int i = 0; i < n; i++) {
        if (w[i] <= mx + 1) {
            mx += w[i];
        }
        dp[i] = mx;
    }

    while (q--) {
        ll k, a, b; cin >> k >> a >> b;
        if (k < w[0]) {
            cout << "No" << '\n';
            continue;
        }
        ll idx = upper_bound(w.begin(), w.end(), k) - w.begin() - 1;
        if (dp[idx] >= a) {
            cout << "Yes" << '\n';
        } else {
            cout << "No" << '\n';
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    solve();
}