#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <vector>
#include <string>
#include <set>

using namespace std;
typedef long long ll;
typedef long double ld;
const int SZ = 3e5;

pair<int, int> g[SZ];
int ans[SZ];

void dfs(int k, bool lr = 0, int cnt = 0, int v = 1) { // 0 = l, 1 = r
	ans[v] = (cnt <= k);
	if (g[v].first == 0) {
		return;
	}
	dfs(k, 0, cnt + (v != 1 && lr), g[v].first);
	dfs(k, 1, cnt + (v != 1 && !lr), g[v].second);
	ans[v] = ans[g[v].first] + ans[g[v].second];
	return;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	int n, k, m;
	cin >> n >> k >> m;
	for (int i = 1; i <= n; i++) {
		int t;
		cin >> t;
		if (t == 0) {
			g[i] = { 0, 0 };
		}
		else {
			int l, r;
			cin >> l >> r;
			g[i] = { l, r };
		}
	}
	dfs(k);
	for (int i = 0; i < m; i++) {
		int u;
		cin >> u;
		cout << ans[u] << endl;
	}
}
