#include <bits/stdc++.h>
#define sz(n) (int)(n).size()
using namespace std;
using ll = int64_t;
const int N = 2e5;
struct node {
    int l = -1, r = -1, p = -1;
};
node t[N];
int d2[N], ans[N], cnt[N];
vector<int> que[N];
void calc_depth(int v, int tp) {
    if (t[v].l == -1) return;
    if (tp == -1) {
        d2[t[v].l] = d2[v];
        d2[t[v].r] = d2[v] + 1;
    } else if (tp == 1) {
        d2[t[v].l] = d2[v] + 1;
        d2[t[v].r] = d2[v];
    } else {
        d2[t[v].l] = d2[v];
        d2[t[v].r] = d2[v];
    }
    calc_depth(t[v].l, -1);
    calc_depth(t[v].r, 1);
}
int n, k, q;
void dfs(int v) {
    if (t[v].l != -1) {
        dfs(t[v].l), dfs(t[v].r);
        cnt[v] += cnt[t[v].l] + cnt[t[v].r];
    } else if (d2[v] <= k) {
        cnt[v]++;
    }
    for (int id : que[v]) ans[id] = cnt[v];
}
void tokarenko_trick() {
    cin >> n >> k >> q;
    for (int i = 0; i < n; ++i) {
        int c;
        cin >> c;
        if (c == 2) {
            int l, r;
            cin >> l >> r;
            l--, r--;
            t[i].l = l, t[i].r = r;
            t[l].p = i, t[r].p = i;
        }
    }
    for (int i = 0; i < q; ++i) {
        int v;
        cin >> v;
        v--;
        que[v].emplace_back(i);
    }
    d2[0] = 0;
    calc_depth(0, 0);
    dfs(0);
    for (int i = 0; i < q; ++i) {
        cout <<ans[i] << '\n';
    }
}


signed main() {
    int tt = 1;
#ifdef LOCAL
    freopen("../stream.in","r", stdin);
    freopen("../stream.out","w", stdout);
    cin >> tt;
#else
    cin.tie(nullptr)->sync_with_stdio(false);
    cin.exceptions(cin.failbit);
#endif
    while (tt--) tokarenko_trick();
    return 0;
}