#include <bits/stdc++.h>
#define sz(n) (int)(n).size()
using namespace std;
using ll = int64_t;
struct segm {
    int l, r, id;
    friend bool operator < (const segm & a, const segm & b) {
        if (a.r != b.r) return a.r < b.r;
        if (a.l != b.l) return a.l < b.l;
        return a.id < b.id;
    }
    segm(int l = -1, int r = -1, int id = -1) : l(l), r(r), id(id) {}
};
void tokarenko_trick() {
    int n;
    cin >> n;
    segm s[n];
    for (int i = 0; i < n; ++i) {
        int l, r;
        cin >> l >> r;
        s[i] = {--l, r, i};
    }
    sort(s, s + n);
    for (int i = 0; i < n / 2; ++i) cout << s[i].id + 1 << ' ';
    cout << '\n';
}


signed main() {
    int tt = 1;
#ifdef LOCAL
    freopen("../stream.in","r", stdin);
    freopen("../stream.out","w", stdout);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
    cin.exceptions(cin.failbit);
#endif
    cin >> tt;
    while (tt--) tokarenko_trick();
    return 0;
}