#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx,avx2,bmi,bmi2,popcnt,lzcnt")

typedef long long ll;
typedef double dd;
typedef long double ld;

using namespace std;

#define v(x) vector<x>
#define v2(x) v(v(x))
#define p2(x, y) pair<x, y>
#define all(x) x.begin(), x.end()
#define x first
#define y second

void solve();

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    cout << fixed << setprecision(30);
    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }
}

void solve() {
    int n, q;
    cin >> n >> q;
    v(ll) w(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    ll z;
    cin >> z;
    sort(all(w));
    bitset<100001> dp;
    for (int i = 0; i < 100001; i++) {
        dp[i] = false;
    }
    dp[0] = true;
    for (int i = 0; i < n; i++) {
        dp |= dp << w[i];
    }
    for (int i = 1; i < 100001; i++) {
        dp[i] = dp[i] & dp[i - 1];
    }
    while (q--) {
        ll k, a, b;
        cin >> k >> a >> b;
        if (dp[a]) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}
