#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <queue>

using std::cin;
using std::cout;
using std::vector;
using std::string;
using ll = long long;
using ld  = long double;
using pl = std::pair<ll, ll>;
using sl = std::pair<ll, vector<pl>>;
#define all(x) x.begin(),x.end()


int main()
{
	std::ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll z; cin >> z;
	ll m; cin >> m;

	vector<std::map<vector<ll>, vector<ll>>> mp(8), omp(8);
	std::set<vector<ll>> st;

	for (ll mm = 1; mm < 8; ++mm)
	{
		for (ll i = 1; i < (1 << mm); ++i)
		{
			vector<ll> va;
			for (ll u = 0; u < mm; ++u)
			{
				if (i & (1 << u))va.push_back(u + 1);
			}
			for (ll j = 1; j < (1 << mm); ++j)
			{
				vector<ll> vb;
				for (ll u = 0; u < mm; ++u)
				{
					if (j & (1 << u))vb.push_back(u + 1);
				}

				bool w = 0;
				for (ll& a : va)
				{
					for (ll& b : vb)
					{
						if (a == b)
						{
							w = 1;
							break;
						}
					}
					if (w)break;
				}

				if (st.count(vb) || w || vb.size() != va.size())continue;
				st.insert(vb);
				mp[mm][va] = vb;
				omp[mm][vb] = va;
				break;
			}
		}
		st.clear();
	}

	if (z == 1)
	{
		while (m--)
		{
			ll n, k; cin >> n >> k;
			vector<ll> vc(k); for (ll& i : vc)cin >> i;
			std::sort(all(vc));
			cout << '\t';
			for (ll& i : mp[n][vc])cout << i << ' ';
			cout << '\n';
		}
	}
	if (z == 2)
	{
		while (m--)
		{
			ll n, k; cin >> n >> k;
			vector<ll> vc(k); for (ll& i : vc)cin >> i;
			std::sort(all(vc));
			cout << '\t';
			for (ll& i : omp[n][vc])cout << i << ' ';
			cout << '\n';
		}
	}
	

	cout << std::endl;
}