#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <string>

using ll = int;
using ld = long double;
using std::cin;
using std::cout;
using std::vector;
using std::string;
#define all(x) x.begin(),x.end()

struct el
{
	ll l = -1, r = -1;
};

vector<ll> ms;
vector<ll> ans;
vector<el> vc;

ll k;

//p == 0 - лево
//p == 1 - право
void bd(ll t, ll p, ll c)
{
	if (vc[t].l == -1 && vc[t].r == -1)
	{
		if (c <= k)ms[t] = 1;
		else ms[t] = 0;
		ans[t] = ms[t];
		return;
	}

	bd(vc[t].l, 0, c + (p == 1));
	bd(vc[t].r, 1, c + (p == 0));
	ms[t] = ms[vc[t].l] + ms[vc[t].r];
	ans[t] = ms[t];
}

int main()
{
	std::ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll n, q; cin >> n >> k >> q;
	vc.resize(n);
	ms.resize(n);
	ans.resize(n);
	for (ll i = 0; i < n; ++i)
	{
		ll u; cin >> u;
		if (u == 0)continue;
		ll l, r; cin >> l >> r; --l; --r;
		vc[i] = { l,r };
	}

	bd(0, -1, 0);

	while (q--)
	{
		ll u; cin >> u; --u;
		cout << '\t';
		cout << ans[u] << '\n';
		cout << '\n';
	}
}