#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

void sol1() {
    int n, k;
    cin >> n >> k;
    vector<int> v(k);
    for (int i = 0; i < k; i++) {
        cin >> v[i];
        v[i]--;
    }
    int cnt = 0, id = 0;
    map<int, int> mp;
    for (int i = 0; i < k; i++) {
        mp[v[i]] = -1;
    }

    vector<int> ans;

    for (int i = 0; i < k; i++) {
        cnt++;
        id = v[i] + 1;
        if (id == n) {
            id = 0;
        }
        while (cnt > 0 && mp.find(id) == mp.end()) {
            mp[id] = 1;
            ans.push_back(id);
            id++;
            if (id == n) {
                id = 0;
            }
            cnt--;
        }
    }
    id = 0;
    while (cnt > 0) {
        if (mp.find(id) == mp.end()) {
            mp[id] = 1;
            ans.push_back(id);
            cnt--;
        }
        id++;
        if (id == n) {
            id = 0;
        }
    }

    sort(ans.begin(), ans.end());
    for (auto i : ans) {
        cout << i + 1 << " ";
    }
    cout << endl;
}

void sol2() {
    int n, k;
    cin >> n >> k;
    vector<int> v(k, 0);
    map<int, int> mp;
    for (int i = 0; i < k; i++) {
        int a;
        cin >> a;
        mp[a - 1] = -1;
        v[i] = a - 1;
    }
    vector<int> ans;
    int cnt = 0, id = 0;
    for (int i = k - 1; i >= 0; i--) {
        cnt++;
        id = v[i] - 1;
        if (id == -1) {
            id = n - 1;
        }
        while (cnt > 0 && mp.find(id) == mp.end()) {
            mp[id] = 1;
            ans.push_back(id);
            id--;
            if (id == -1) {
                id = n - 1;
            }
            cnt--;
        }
    }
    id = n - 1;
    while (cnt > 0) {
        if (mp.find(id) == mp.end()) {
            mp[id] = 1;
            ans.push_back(id);
            cnt--;
        }
        id--;
        if (id == -1) {
            id = n - 1;
        }
    }
    sort(ans.begin(), ans.end());
    for (auto i : ans) {
        cout << i + 1 << " ";
    }
    cout << endl;

}

int main()
{
    int a, m;
    cin >> a >> m;
    for (int i = 0; i < m; i++) {
       if (a == 1) {
            sol1();
        } else {
            sol2();
        }
    }

    return 0;
}
