#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

vector<bool> used;

vector<int> f1(vector<int> &v) {
    vector<int> ans(v.size() + 1, 1e9);
    ans[0] = -1e9;
    vector<int> res;
    vector<int> pr(v.size() + 1, -1);
    int mx = 0;
    for (int i = 0; i < v.size(); i++) {
        if (used[v[i]]) {
            continue;
        }
        int cur = v[i];
        for (int j = 1; j < ans.size(); j++) {
            if (cur < ans[j]) {
                ans[j] = cur;
                if (j > mx) {
                    mx = j;
                }
                pr[cur] = ans[j - 1];
                break;
            }
        }
    }
    for (int i = ans.size() - 1; i > 0; i--) {
        if (ans[i] != 1e9) {
            res.push_back(ans[i]);
            int cur = pr[ans[i]];
            while (cur != -1e9) {
                res.push_back(cur);
                cur = pr[cur];
            }
            break;
        }
    }
    reverse(res.begin(), res.end());
    return res;
}

vector<int> f2(vector<int> &v) {
    vector<int> ans(v.size() + 1, -1e9);
    ans[0] = 1e9;
    vector<int> res;
    vector<int> pr(v.size() + 1, -1);
    int mx = 0;
    for (int i = 0; i < v.size(); i++) {
        int cur = v[i];
        if (used[v[i]]) {
            continue;
        }
        for (int j = 1; j < ans.size(); j++) {
            if (cur > ans[j]) {
                ans[j] = cur;
                if (j > mx) {
                    mx = j;
                }
                pr[cur] = ans[j - 1];
                break;
            }
        }
    }
    for (int i = ans.size() - 1; i > 0; i--) {
        if (ans[i] != -1e9) {
            res.push_back(ans[i]);
            int cur = pr[ans[i]];
            while (cur != 1e9) {
                res.push_back(cur);
                cur = pr[cur];
            }
            break;
        }
    }
    reverse(res.begin(), res.end());
    return res;
}

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    long long t;
    cin >> t;
    for (int k = 0; k < t; k++) {
        long long n;
        cin >> n;
        vector<int> v(n);
        used.clear();
        used.resize(n + 1, false);
        for (int j = 0; j < n; j++) {
            cin >> v[j];
        }
        vector<int> res = f1(v);
        for (auto i : res) {
            used[i] = true;
        }
        vector<int> res2 = f2(v);
        /*for (auto i : res) {
            cout << i << " ";
        } cout << endl;
        for (auto i : res2) {
            cout << i << " ";
        } cout << endl << endl;*/
        int mx = res.size() + res2.size();
        for (auto i : res) {
            used[i] = false;
        }
        res2 = f2(v);
        for (auto i : res2) {
            used[i] = true;
        }
        res = f1(v);
        /*for (auto i : res) {
            cout << i << " ";
        } cout << endl;
        for (auto i : res2) {
            cout << i << " ";
        } cout << endl << endl;*/
        mx = max(mx, (int)(res.size() + res2.size()));
        cout << mx << endl;/**/
    }

    return 0;
}

/*
4
5
4 1 2 3 5
10
3 8 10 4 1 2 7 9 5 6
3
1 2 3
6
4 2 5 1 6 3
*/
