#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
#define ff first
#define ss second
#define pb push_back
#define sz(a) (int)a.size()
#define all(a) (a).begin(), (a).end()
#define forn(i, n) for (int i = 0; i < (int)n; i++)

template<class T>
bool inmin(T &x, T y) {
    if (y < x) {
        x = y;
        return true;
    }
    return false;
}

template<class T>
bool inmax(T &x, T y) {
    if (y > x) {
        x = y;
        return true;
    }
    return false;
}

const int INFi = 1e9;
const ll INFl = 1e18;
#define int long long

void solve();

vector<int> adj;
int k;

vector<vector<int>> st;
map<vector<int>, int> id;

void rec(int pos, vector<int> now) {
    if (pos ==  (1 << k)) {
        if (!now.empty() && now[0] == 0) {
            id[now] = sz(st);
            st.pb(now);
        }
        return;
    }
    int siz = sz(now);
    rec(pos + 1, now);
    now.pb(pos);
    rec(pos + 1, now);
}


int mex(vector<int> &s) {
    forn(i, sz(s)) {
        if (s[i] != i) return i;
    }
    return sz(s);
}
vector<int> get_mx;

vector<int> ultra(vector<int> &s) {
    int mx = mex(s);
    get_mx[id[s]] = mx;
    vector<int> nx = s;
    for (auto &x : nx)
        x ^= mx - 1;
    sort(all(nx));
    return nx;
}

int mod;
vector<int> color;
vector<bool> used;

vector<vector<int>> ans;

void calc(int _k) {
    k = _k;
    id.clear();
    st.clear();
    color.clear();
    used.clear();
    ans.clear();
    get_mx.clear();
    //cout << "d" << endl;
    vector<int> now;
    rec(0, now);
    //cout << "d" << endl;
    adj.resize(sz(st));
    get_mx.resize(sz(st));
    forn(i, sz(st)) {
        auto nx = ultra(st[i]);
        adj[i] = id[nx];
    }
    used.resize(sz(st), 0);
    color.resize(sz(st), INFl);
    forn(i, sz(st)) {
        int v = i;
        used[i]= true;
        vector<int> path;
        path.pb(i);
        int cur;
        bool made = false;
        while (true) {
            if (color[adj[v]] != INFl){
                int res = color[adj[v]];
                for (int x : path) {
                    color[x] = res;
                }
                made = true;
                break;
            }
            if (used[adj[v]]) {
                cur = adj[v];
                break;
            }
            v = adj[v];
            path.pb(v);
            used[v] = true;
        }
        if (!made) {
            int nd = get_mx[cur];
            auto cp = path;
            while (cp.back() != cur) {
                if (get_mx[cp.back()] != nd) {
                    nd = -1;
                    break;
                }
                cp.pop_back();
            }
            for (auto x : path) {
                color[x] = nd;
            }
        }
    }
    ans.resize((1 << k) + 1, vector<int> ((1 << k) + 1));
    forn(i, sz(st)) {
        if (color[i] != -1) {
            ans[color[i]][siz]++;
            if (ans[color[i]][siz] >= mod)
                ans[color[i]][siz] -= mod;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("/home/roi/Desktop/kek/read.txt", "r", stdin);
#endif
    cin >> mod;
    int tc = 1;
    cin >> tc;
    forn(i, tc) {
        solve();
    }
    return 0;
}

void solve() {
    int n, _k, p;
    cin >> _k >> n >> p;
    calc(_k);
    cout << ans[p][n] << '\n';
}