#include <iostream>
#include<cmath>
#include<algorithm>
#include<string>
#include<random>
#include<vector>

using namespace std;

int K = 100;
int KK = 1000;

int mex(vector<int>& v)
{
	for (int i = 0; i < v.size(); ++i)
	{
		if (v[i] != i)
		{
			return i;
		}
	}
	return v.size();
}

void ultra(vector<int>& v)
{
	int m = mex(v);
	for (int i = 0; i < v.size(); ++i)
	{
		v[i] = v[i] ^ (m - 1);
	}
	sort(v.begin(), v.end());
}

int lim(vector<int> v)
{
	int cnt = 0;
	int st = 0;

	
	while (st < K && cnt < KK)
	{
		int m = mex(v);
		ultra(v);
		if (mex(v) == m)
		{
			++st;
		}
		else {
			st = 0;
		}
		++cnt;
	}

	if (st < K)
	{
		return -1;
	}
	else {
		return mex(v);
	}

}

int siz(int a)
{
	int ans = 0;

	while (a > 0)
	{
		if (a % 2 == 1)
		{
			++ans;
		}
		a /= 2;
	}

	return ans;
}

int main()
{
	
	long long MOD;
	cin >> MOD;

	vector<int> l(1 << (1 << 5));

	for (int i = 1; i < l.size(); ++i)
	{
		if (i % 2 == 0)
		{
			continue;
		}
		int j = i;
		vector<int> v;
		int num = 0;
		while (j > 0)
		{
			if (j % 2 == 1)
			{
				v.push_back(num);
			}
			j /= 2;
			++num;
		}

		l[i] = lim(v);
		//cout << i << '\n';
	}
	//cout << "finish!\n";
	int t;

	cin >> t;

	for (int q = 0; q < t; ++q)
	{
		int k, n, p;

		cin >> k >> n >> p;
		int ans = 0;
		for (int i = 0; i < (1 << (1 << k)); ++i)
		{
			if (l[i] == p && siz(i) == n)
			{
				++ans;
			}
		}

		ans = ans % MOD;

		cout << ans << "\n";
	}
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
