#include <iostream>
#include <iomanip>
#include <cmath>
#include <vector>
#include <deque>
#include <set>
#include <algorithm>
#include <map>
#define ll long long

const ll inf = 1e18;

using namespace std;

const ll siz = (1ll << 19);

vector<ll> t(2 * siz - 1, 0);

void upd(ll x, ll tl, ll tr, ll ind, ll d) {
	if (tr - tl == 1) {
		t[x] = max(t[x], d);
		return;
	}
	ll mid = (tl + tr) / 2;
	if (ind < mid) {
		upd(x * 2 + 1, tl, mid, ind, d);
	} else {
		upd(x * 2 + 2, mid, tr, ind, d);
	}
	t[x] = max(t[x * 2 + 1], t[x * 2 + 2]);
}

ll getAns(ll x, ll tl, ll tr, ll l, ll r) {
	if (l <= tl && tr <= r) {
		return t[x];
	} 
	if (r <= tl || tr <= l) {
		return 0;
	}
	ll mid = (tl + tr) / 2;
	return max(getAns(x * 2 + 1, tl, mid, l, r), getAns(x * 2 + 2, mid, tr, l, r));
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);

	ll tt;
	cin >> tt;
	while (tt--) {
		ll n;
		cin >> n;
		t = vector<ll>(2 * siz - 1, 0);
		for (ll i = 0; i < n; i++) {
			ll x;
			cin >> x;	
			ll cnt = getAns(0, 0, siz, 0, x);
			upd(0, 0, siz, x, cnt + 1);
		}
		cout << min(n, t[0] + 1) << "\n";
	}

	return 0;
}