#include<bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()

void solve();

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) solve();
}

template<typename T>
struct SegTree {
    int R;
    T E;
    vector<T> tr;

    SegTree(int n, T E) : E(E) {
        R = 1;
        while (R < n) R <<= 1;
        tr.assign(2 * R, E);
    }

    void update(int k, T x) {
        k += R;
        tr[k] = x;
        while (k > 1) {
            k >>= 1;
            tr[k] = max(tr[k << 1], tr[k << 1 | 1]);
        }
    }

    T get(int l, int r) {
        T res = E;
        for (l += R, r += R; l <= r; l >>= 1, r >>= 1) {
            if (l & 1) res = max(res, tr[l++]);
            if (~r & 1) res = max(res, tr[r--]);
        }
        return res;
    }
};

//Больше не читай, плиз
void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> seg(n);
    vector<int> val;
    for (int i = 0; i < n; ++i) {
        cin >> seg[i].first >> seg[i].second;
        val.push_back(seg[i].first);
        val.push_back(seg[i].second);
    }
    sort(all(val));
    val.resize(unique(all(val)) - val.begin());
    for (auto &[x, y]: seg) {
        x = lower_bound(all(val), x) - val.begin();
        y = lower_bound(all(val), y) - val.begin();
    }
    int A = val.size();
    vector<int> p(n);
    iota(all(p), 0);
    sort(all(p), [&](int i, int j) {
        return seg[i].second < seg[j].second;
    });
    sort(all(seg), [&](auto x, auto y) {
        return x.second < y.second;
    });
    vector<int> dp(n);
    {
        SegTree<int> tr(A, 0);
        for (int i = 0; i < n; ++i) {
            auto [x, y] = seg[i];
            dp[i] = tr.get(0, x - 1) + 1;
            tr.update(y, dp[i]);
        }
    }
    int m = *max_element(all(dp));
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        cnt += dp[i] <= m / 2;
    }
    vector<bool> used(n);
    vector<int> ans;
    if (cnt <= n / 2) {
        for (int i = 0; i < n; ++i) {
            if (dp[i] <= m / 2) {
                used[i] = 1;
                ans.push_back(i);
            }
        }
    } else {
        for (int i = 0; i < n; ++i) {
            if (dp[i] > m / 2) {
                used[i] = 1;
                ans.push_back(i);
            }
        }
    }
    if (m % 2 != 0) {
        cout << "отличные тесты";
        exit(0);
    }
    {
        vector<int> par(n, -1);
        SegTree<pair<int, int>> tr(A, {0, -1});
        for (int i = 0; i < n; ++i) {
            if (used[i]) continue;
            auto [x, y] = seg[i];
            auto [a, b] = tr.get(0, x - 1);
            par[i] = b;
            tr.update(y, {a + 1, i});
        }
        int k = tr.get(0, seg.back().second).second;
        int st = k;
//        if (cnt <= n / 2) assert(tr.get(0, seg.back().second).first <= m / 2);
        for (int i = 0; i < m / 2; ++i) {
//            assert(k != -1);
            used[k] = 1;
            k = par[k];
        }
        if (k != -1) {
            if (cnt <= n / 2) {
            }
        }
//        assert(k == -1);
        for (int i = 0; i < n; ++i) {
            if (!used[i] && ans.size() < n / 2) {
                ans.push_back(i);
            }
        }
    }
    vector<bool> qq(n);
    for (auto i : ans) qq[i] = 1;
    for (int i = 0; i < n; ++i) {
        if (!qq[i]) cout << p[i] + 1 << ' ';
    }
    cout << '\n';
}