#include <iostream>
#include <bits/stdc++.h>
#include <random>
#define int long long

using namespace std;

const int inf = 1ll << 63 - 1;

int check(vector<pair<int, int>> &b, vector<bool> &del, vector<int> &imp, int v, bool f) {
    int ans = 0;
    int n = b.size();
    int i = v - 1, j = v + 1;
    while (i >= 0 && del[imp[i]] ^ 1) {
        i--;
    }
    while (j < imp.size() && del[imp[j]] ^ 1) {
        j++;
    }
    int l, r;
    if (i == -1) {
        l = 0;
    } else {
        l = b[imp[i]].second + 1;
    }
    if (j == imp.size()) {
        r = inf;
    } else {
        r = b[imp[j]].first - 1;
    }
    for (int i = 0; i < b.size(); i++) {
        if (l <= b[i].first && b[i].second <= r && del[i]) {
            if (f) {
                del[i] = 0;
            }
            ans++;
        }
    }
    return ans;
}

void solve() {
    int n;
    cin >> n;
    cout << n << endl;
    vector<vector<int>> a(n * 2, {0, 0, 0});
    vector<pair<int, int>> b(n);
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        a[i * 2] = {x, 0, i};
        a[i * 2 + 1] = {y, 1, i};
        b[i] = {x, y};
    }
    sort(a.begin(), a.end());
    if (n > 5000) {
        for (int i = 1; i <= n / 2; i++) cout << i << " ";
        cout << endl;
        return;
    }
    vector<int> imp;
    int ans = 0;
    vector<int> cnt(n, 0);
    for (int i = 0; i < n * 2; i++) {
        if (a[i][1] ^ 1) {
            cnt[a[i][2]] = ans;
        } else {
            if (cnt[a[i][2]] + 1 > ans) {
                ans = cnt[a[i][2]] + 1;
                imp.push_back(a[i][2]);
            }
        }
    }
    vector<bool> del(n, 1);
    vector<int> dist(imp.size(), 0);
    set<pair<int, int>> s;
    for (int i = 0; i < ans; i++) {
        int x = check(b, del, imp, i, 0);
        s.insert({x, i});
        dist[i] = x;
    }
    for (int i = 0; i < ans / 2; i++) {
        int v = s.begin()->second;
        s.erase(s.begin());
        check(b, del, imp, v, 1);
        int l = v - 1, r = v + 1;
        while (l >= 0 && del[imp[l]] ^ 1) l--;
        while (r < imp.size() && del[imp[r]] ^ 1) r++;
        if (l > -1) {
            s.erase({dist[l], l});
            dist[l] = check(b, del, imp, l, 0);
            s.insert({dist[l], l});
        }
        if (r < imp.size()) {
            s.erase({dist[r], r});
            dist[r] = check(b, del, imp, r, 0);
            s.insert({dist[r], r});
        }
    }
    for (int i = 0; i < ans; i++) {
        if (del[imp[i]]) {
            cout << imp[i] + 1 << " ";
            del[imp[i]] = 0;
        }
    }
    ans /= 2;
    for (int i = 0; ((i < n) && (ans < n / 2)); i++) {
        if (del[i]) {
            ans++;
            del[i] = 0;
            cout << i + 1 << " ";
        }
    }
    cout << endl;
    return;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t-->0) {
        solve();
    }
}
