#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double dl;


int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll t;
	cin >> t;
	if (t == 1)
	{
		ll m;
		cin >> m;
		while (m--)
		{
			ll n, k;
			cin >> n >> k;
			vector <ll> a(k);
			for (ll i = 0; i < k; i++) cin >> a[i];
			map <ll, ll> mp;
			for (auto i : a) mp[i]++;
			for (ll i = 1; i < n; i++)
			{
				for (ll j = 0; j < k; j++)
				{
					if (a[j] == 1) a[j] = n;
					else a[j]--;
				}
				bool g = true;
				for (auto j : a)
				{
					if (mp.find(j) != mp.end())
					{
						g = false;
						break;
					}
				}
				if (g)
				{
					sort(a.begin(), a.end());
					for (auto i : a) cout << i << " ";
					cout << "\n";
					break;
				}
			}
		}
	}
	else
	{
		ll m;
		cin >> m;
		while (m--)
		{
			ll n, k;
			cin >> n >> k;
			vector <ll> a(k);
			for (ll i = 0; i < k; i++) cin >> a[i];
			map <ll, ll> mp;
			for (auto i : a) mp[i]++;
			for (ll i = 1; i < n; i++)
			{
				for (ll j = 0; j < k; j++)
				{
					if (a[j] == n) a[j] = 1;
					else a[j]++;
				}
				bool g = true;
				for (auto j : a)
				{
					if (mp.find(j) != mp.end())
					{
						g = false;
						break;
					}
				}
				if (g)
				{
					sort(a.begin(), a.end());
					for (auto i : a) cout << i << " ";
					cout << "\n";
					break;
				}
			}
		}
	}

	return 0;
}
/*

1
2
2 1
1
5 2
1 4

2
2
5 2
2 3
2 1
2


*/