#include <bits/stdc++.h>

using namespace std;
#define ll long long
ll n, k;
vector<ll> num;
map<vector<bool>, vector<bool>> hm;

void encode() {
   
    if (n <= 7) {
        vector<bool> bs(n);
        for (auto o: num)
            bs[o] = true;
        for (int i = 0; i < n; i++) {
            if (hm[bs][i])cout << i + 1 << ' ';
        }
        return;
    }
}

void decode() {

    if (n <= 7) {
        vector<bool> bs(n);
        for (auto o: num)
            bs[o] = true;
        for (int i = 0; i < n; i++) {
            if (hm[bs][i])cout << i + 1 << ' ';
        }
        return;
    }
}

void solve() {
    for (int i = 0; i < (1 << 8); i++) {
        vector<bool> bs(7);
        bitset<7> aaa(i);
        for (int i = 0; i < 7; i++)
            bs[i] = aaa[i];
        if (hm.find(bs) != hm.end())continue;
        auto bs2 = bs;
        do {
            next_permutation(bs2.begin(), bs2.end());
            if (hm.find(bs2) != hm.end())continue;
            bool flag = false;
            for (int i = 0; i < n; i++)if (bs2[i] && bs[i])flag = true;
            if (!flag)
                break;
        } while (true);;
        hm[bs2] = bs;
        hm[bs] = bs2;
    }
    ll a, m;
    cin >> a >> m;
    for (int i = 0; i < m; i++) {
        cin >> n >> k;
        num.resize(k);
        for (auto &o: num) {
            cin >> o;
            o--;
        }
        if (a == 1)encode();
        else decode();
        cout << endl;
    }
}

int main() {
#ifdef VNT
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int q = 1;
    //cin>>q;
    for (int i = 0; i < q; i++) {
        solve();
        cout << '\n';
    }
}