#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<set>
#include<map>
#include<string>
#include<algorithm>
#include<queue>
#include<deque>
#include<random>
#include<bitset>
#include<math.h>

using namespace std;

#define int long long
#define all(v) v.begin(), v.end()
#define endl '\n'
using ll = long long;
using ld = long double;

mt19937 rnd(777);

const int N = 1e6 + 9, M = 1e9 + 7;
const ll INF = 1e9 + 9;

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	cin.tie(0);
	ios_base::sync_with_stdio(0);
#endif

	int n, m, k;
	cin >> n >> m >> k;
	vector<int> valx, valy;
	for (int i = 0; i < k; i++) {
		int a, b;
		cin >> a >> b;
		a--; b--;
		valx.push_back(a);
		valy.push_back(b);
	}
	sort(all(valx));
	sort(all(valy));
	pair<int, int> minx = { INF, 0 }, miny = { INF, 0 };
	for (int i = 0; i < valx.size() - 1; i++) {
		int len = valx[i + 1] - valx[i] - 1;
		int cnt = min(valx[i] + 1, n - valx[i + 1]);
		minx = min(minx, { n - len, cnt });
	}
	for (int i = 0; i < valy.size() - 1; i++) {
		int len = valy[i + 1] - valy[i] - 1;
		int cnt = min(valy[i] + 1, m - valy[i + 1]);
		miny = min(miny, { m - len, cnt });
	}
	
	pair<int, int> minx2 = min(minx, { n - (valx[0] + n - 1 - valx.back()), 0 });
	pair<int, int> miny2 = min(miny, { m - (valy[0] + m - 1 - valy.back()), 0 });


	minx = min(minx, minx2);
	miny = min(miny, miny2);
	cout << minx.first * miny.first << " " << minx.second + miny.second;
}