// 11b top
#include <bits/stdc++.h>

using namespace std;
//#define int long long
const long long MX = 1e9;
vector<int> a;

int countMX(int pos, int x) {
    int ans = 0, pr = -1;
    for (int i = 1; i <= pos; ++i) {
        if (a[i] > x)
            continue;
        if (pr < a[i]) {
            ans++;
            pr = a[i];
        }
    }
    return ans;
}

int countMN(int pos, int x) {
    int ans = 0, pr = (int) a.size() + 1;
    for (int i = 1; i <= pos; ++i) {
        if (a[i] < x)
            continue;
        if (pr > a[i]) {
            ans++;
            pr = a[i];
        }
    }
    return ans;
}

int getmn(int pos, int x) {
    int mn = (int) a.size() + 1, pos_mn = 0;
    for (int i = 1; i <= pos; ++i) {
        if (a[i] >= x && mn > a[i]) {
            mn = a[i];
            pos_mn = i;
        }
    }
    return pos_mn;
}

int getmx(int pos, int x) {
    int mx = 0, pos_mx = 0;
    for (int i = 1; i <= pos; ++i) {
        if (a[i] <= x && mx < a[i]) {
            mx = a[i];
            pos_mx = i;
        }
    }
    return pos_mx;
}


void solve() {
    int n;
    cin >> n;
    a.resize(n + 1);
    for (int i = 1; i <= n; ++i)
        cin >> a[i];
    int ans = 0;
    bool fl1 = 1, fl2 = 1;
    for (int i = 1; i < n; ++i) {
        if (a[i] > a[i + 1])
            fl1 = 0;
        if (a[i] < a[i + 1])
            fl2 = 0;
    }
    if (fl1 || fl2) {
        cout << n << "\n";
        return;
    }
    if (a.back() == n) {
        ans = max(ans, countMX(n, n) + 1);
    }
    if (a.back() == 1) {
        ans = max(ans, countMN(n, 1) + 1);
    }
    vector<int> nvp(n + 1), obrnvp(n + 1);
    vector<int> dp(n + 1, MX);
    dp[0] = -MX;
    for (int i = n; i >= 1; --i) {
        int x = lower_bound(dp.begin(), dp.end(), a[i]) - dp.begin();
        dp[x] = a[i];
        obrnvp[i] = x;
    }
    dp.clear();
    dp.resize(n + 1, MX);
    dp[0] = -MX;
    for (int i = n; i >= 1; --i) {
        int x = lower_bound(dp.begin(), dp.end(), -a[i]) - dp.begin();
        dp[x] = -a[i];
        nvp[i] = x;
    }
    for (int i = 1; i < n; ++i) {
        if (a[i] > a[i + 1]) {
            int pos1 = getmn(i, a[i] + 1);
            int t1 =  countMN(pos1, a[pos1]);
            int t2 = countMX(i, max(a[i], a[pos1] - 1));
            ans = max(ans,t1+ t2 + nvp[i] - 1 + obrnvp[i + 1]);
        } else {
            int pos1 = getmx(i, a[i] - 1);
            ans = max(ans, countMX(pos1, a[pos1]) + countMN(i, a[pos1] + 1) + obrnvp[i] - 1 + nvp[i + 1]);
        }
    }
    cout << ans << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
