// 11b top
//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;
//#define int long long
const long long MX = 1e9;
vector<int> a;

int countMX(int pos, int x) {
    int ans = 0, pr = -1;
    for (int i = 1; i <= pos; ++i) {
        if (a[i] > x)
            continue;
        if (pr < a[i]) {
            ans++;
            pr = a[i];
        }
    }
    return ans;
}

int countMN(int pos, int x) {
    int ans = 0, pr = (int) a.size() + 1;
    for (int i = 1; i <= pos; ++i) {
        if (a[i] < x)
            continue;
        if (pr > a[i]) {
            ans++;
            pr = a[i];
        }
    }
    return ans;
}

int getmn(int pos, int x) {
    int mn = (int) a.size() + 1, pos_mn = 0;
    for (int i = 1; i <= pos; ++i) {
        if (a[i] >= x && mn > a[i]) {
            mn = a[i];
            pos_mn = i;
        }
    }
    return pos_mn;
}

int getmx(int pos, int x) {
    int mx = 0, pos_mx = 0;
    for (int i = 1; i <= pos; ++i) {
        if (a[i] <= x && mx < a[i]) {
            mx = a[i];
            pos_mx = i;
        }
    }
    return pos_mx;
}

vector<int> nvp, obrnvp;

int getmx_obrnvp(int pos, int x) {
    int ans = 0;
    for (int i = pos; i < (int) a.size(); ++i) {
        if (a[i] <= x)
            ans = max(ans, obrnvp[i]);
    }
    return ans;
}

int getmx_nvp(int pos, int x) {
    int ans = 0;
    for (int i = pos; i < (int) a.size(); ++i) {
        if (a[i] >= x)
            ans = max(ans, nvp[i]);
    }
    return ans;
}

int solve(int n, vector<int> b) {
    a.clear();
    a = b;
    int ans = 0;
    bool fl1 = 1, fl2 = 1;
    for (int i = 1; i < n; ++i) {
        if (a[i] > a[i + 1])
            fl1 = 0;
        if (a[i] < a[i + 1])
            fl2 = 0;
    }
    if (fl1 || fl2) {
//        cout << n << "\n";
        return n;
    }
    if (a.back() == n) {
        ans = max(ans, countMX(n, n) + 1);
    }
    if (a.back() == 1) {
        ans = max(ans, countMN(n, 1) + 1);
    }
    nvp.clear();
    nvp.resize(n + 1);
    obrnvp.clear();
    obrnvp.resize(n + 1);
    vector<int> dp(n + 1, MX);
    dp[0] = -MX;
    for (int i = n; i >= 1; --i) {
        int x = lower_bound(dp.begin(), dp.end(), a[i]) - dp.begin();
        dp[x] = a[i];
        obrnvp[i] = x;
    }
    dp.clear();
    dp.resize(n + 1, MX);
    dp[0] = -MX;
    for (int i = n; i >= 1; --i) {
        int x = lower_bound(dp.begin(), dp.end(), -a[i]) - dp.begin();
        dp[x] = -a[i];
        nvp[i] = x;
    }
    for (int i = 1; i < n; ++i) {
        {
            int j = i + 1;
            for (; j <= n; ++j)
                if (a[j] < a[i]) {
                    int pos1 = getmn(j - 1, a[i] + 1);
                    int t1 = countMN(pos1, a[pos1]);
                    int t2 = countMX(i, max(a[i], a[pos1] - 1));
                    ans = max(ans, t1 + t2 + getmx_nvp(j + 1, a[i] + 1) + obrnvp[j]);
                }
        }
        {
            int j = i + 1;
            for (; j <= n; ++j)
                if (a[j] > a[i]) {
                    int pos1 = getmx(j - 1, a[i] - 1);
                    int t1 = countMX(pos1, a[pos1]);
                    int t2 = countMN(i, a[pos1] + 1);
                    ans = max(ans, t1 + t2 + getmx_obrnvp(j + 1, a[i] - 1) + nvp[j]);
                }
        }
    }
    return ans;
}

int solvestupid(int n, vector<int> b) {
    a.clear();
    a = b;
    unordered_map<long long, int> pr_dp;
    pr_dp[0] = 0;
    for (int i = 1; i <= n; ++i) {
        unordered_map<long long, int> dp;
        for (auto [v, ans]: pr_dp) {
            int pos_mx = v / MX;
            int pos_mn = v % MX;
            if (a[i] > a[pos_mx] || pos_mx == 0) {
                dp[i * MX + pos_mn] = max(dp[i * MX + pos_mn], ans + 1);
            } else {
                dp[pos_mx * MX + pos_mn] = ans;
            }
            if (a[i] < a[pos_mn] || pos_mn == 0) {
                dp[pos_mx * MX + i] = max(dp[pos_mx * MX + i], ans + 1);
            } else {
                dp[pos_mx * MX + pos_mn] = ans;
            }
        }
        pr_dp = move(dp);
    }
    int mx = 0;
    for (auto [v, ans]: pr_dp) {
        int pos_mx = v / MX, pos_mn = v % MX;
        if (pos_mx && pos_mn)
            mx = max(mx, ans);
    }
    return mx;
}

random_device rd;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<int> b(n + 1, 0);
        for(int i = 1;i<=n;++i)
            cin >> b[i];
        cout << solve(n, b) << "\n";
//        n = rd() % 5 + 2;
//        for (int i = 1; i <= n; ++i)
//            b[i] = i;
//        shuffle(b.begin() + 1, b.end(), rd);
//        int rr = solvestupid(n, b);
//        int ll = solve(n, b);
//        if (ll != rr) {
//
//            int r = solvestupid(n, b);
//            int l = solve(n, b);
//            cout << n << endl;
//            for (int i = 1; i <= n; ++i)
//                cout << b[i] << " ";
//            break;
//        }
//        cout << "--------------------" << endl;
    }
}