#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const ll INF = 1e18;

struct Nugget {
	ll r, c;
	Nugget () {}
};

void solve() {
	ll h, w, k;
	cin >> h >> w >> k;

	vector <Nugget> nuggets(k);
	for (auto &x: nuggets)
		cin >> x.r >> x.c;

	sort(nuggets.begin(), nuggets.end(), [&] (auto lhs, auto rhs) {
		return lhs.r < rhs.r || (lhs.r == rhs.r && lhs.c < rhs.c);
	});

	pair <ll, ll> answer{INF, INF};
	for (auto &x: nuggets) {
		ll newh = 1, neww = 1, moveh = 0, movew = 0;
		for (auto &y: nuggets) {
			if (y.r < x.r) {
				newh = max(newh, y.r + h - x.r + 1);
				moveh = max(moveh, x.r - y.r);
			} else {
				newh = max(newh, y.r - x.r + 1);
			}

			if (y.c < x.c) {
				neww = max(neww, y.c + w - x.c + 1);
				movew = max(moveh, x.c - y.c);
			} else {
				neww = max(neww, y.c - x.c + 1);
			}
		}

		answer = min(answer, {newh * neww, min(moveh, h - moveh) + min(movew, w - movew)});
	}

	cout << answer.first << ' ' << answer.second << '\n';
}	

signed main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);

	solve();
}