#include <iostream>
#include <set>
#include <random>

using namespace std;

const int MAXN = 2'00'000;

mt19937 rnd;

int dp[MAXN][2];
int l[MAXN], r[MAXN];
vector <int> g[MAXN];

void dfs(int v, int pr=-1){
    for (int u : g[v]) if (u != pr) dfs(u, v);
    int s = 0;
    int s2 = 0;
    for (int u : g[v]){
        if (u == pr) continue;
        s += max(dp[u][0], dp[u][1]);
        s2 += dp[u][0];
    }
    dp[v][0] = s;
    dp[v][1] = r[v] + s2;
}

void solve(){
    int n; cin >> n;
    int q; cin >> q;
    int x, y, m; cin >> x >> y >> m;
    for (int i = 0 ; i < n; i ++){
        dp[i][0] = dp[i][1] = 0;
        g[i].clear();
    }
    for (int i = 0 ; i < n  - 1; i ++){
        int v, u; cin >> v >> u; v--; u--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    int fl = 1;
    for (int i = 0; i < n; i ++){
        cin >>l[i] >> r[i];
        if (l[i] != r[i]) fl = 0;
    }
    dfs(0);
    int o = max(dp[0][0], dp[0][1]);
    int ef = 0;
    for (int j  =0 ; j < n; j ++){
        ef ^= ((long long)x * (j + 1) + ((long long)y * r[j]) * r[j]) % m;
    }
    vector <int> l(q);
    for (int& i : l) cin >> i;
    for (int i : l){
        if (i != o) cout << -1 << ' ';
        else cout << ef << ' ';
    }
    cout << endl;
    int c; cin >> c;
    while (c != 0){
        if (l[c - 1] != o) cout << -1 << endl;
        else{
            for (int i = 0; i < n; i ++) cout << r[i] << ' ';
            cout << endl;
        }
        cin >> c;
    }
}

int main() {
    int t; cin >> t;
    while (t--){
        solve();
    }
}
