#include <bits/stdc++.h>
using namespace std;

#define endl "\n"
#define int long long
#define all(a) a.begin(), a.end()
#define uni(a) sort(all(a)); a.erase(unique(all(a)), a.end())
#define pii pair<int, int>
#define X first
#define Y second

using namespace std;

template<typename T, typename G>
bool rmax(T &a, G b1) {
    T b = b1;
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T, typename G>
bool rmin(T &a, G b1) {
    T b = b1;
    if (b < a) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
istream& operator >> (istream& in, vector<T> &a) {
    for (auto &it : a) {
        in >> it;
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& in, vector<T> &a) {
    for (auto &it : a) {
        in << it << ' ';
    }
    return in;
}

int get_m(vector<pii> &a, int sz) {
    int n = sz;
    vector<int> dp(n, 0);
    vector<int> ask(n, -1);

    for (auto &it : a) {
        rmax(ask[it.Y], it.X);
    }

    for (int i = 1; i < n; i++) {
        if (ask[i] != -1) {
            dp[i] = max(dp[i - 1], dp[ask[i] - 1] + 1);
        } else {
            dp[i] = dp[i - 1];
        }
    }
    return dp.back();
}

void solve() {
    int n;
    cin >> n;
    vector<pair<pii, int>> ax;
    vector<pii> a(n);
    vector<int> my;
    my.push_back(0);

    for (int i = 0; i < n; i++) {
        cin >> a[i].X >> a[i].Y;
        my.push_back(a[i].X);
        my.push_back(a[i].Y);
        my.push_back(a[i].X - 1);
        my.push_back(a[i].Y - 1);
    }

    uni(my);

    for (pii &it : a) {
        it.X = lower_bound(all(my), it.X) - my.begin();
        it.Y = lower_bound(all(my), it.Y) - my.begin();
    }

    int m = get_m(a, my.size());

    for (int mask = 0; mask < (1 << n); mask++) {
        vector<pii> ans;

        for (int i = 0; i < n; i++) {
            if (mask & (1 << i)) {
                ans.push_back(a[i]);
            }
        }

        if (ans.size() * 2 != n) {
            continue;
        }

        int ans_m = get_m(ans, my.size());
        if (ans_m * 2 == m) {
            for (int i = 0; i < n; i++) {
                if (mask & (1 << i)) {
                    cout << i + 1 << ' ';
                }
            }
            cout << endl;
            return;
        }
    }
}

signed main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

#ifdef LOCAL_CLION
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif

    int t = 1;
    cin >> t;

    while (t--) {
        solve();
    }
}
