#include <bits/stdc++.h>

#define all(x) (x).begin(),(x).end()
#define len(x) (int)(x).size()

typedef long long ll;
using namespace std;

#define int ll
struct query {
    ll k, a, b, ind;
};

const int maxa = 1, maxb = 1e5 + 100; // a <= b

void solve() {
    int n, Q;
    cin >> n >> Q;
    vector<ll> w(n);
    for (auto &el : w) {
        cin >> el;
    }

    sort(all(w));

    vector<query> qs(Q);
    vector<bool> ans(Q, false);

    int Z; cin >> Z;
    for (int i = 0; i < Q; ++i) {
        ll k, a, b;
        cin >> k >> a >> b;
        if (a > b)
            swap(a, b);
        qs[i] = {k, a, b, i};
    }

    sort(all(qs), [&] (const query& q1, const query& q2) {
        return q1.k < q2.k;
    });

    vector<bitset<maxb + 1>> dp(maxa + 1);
    int it = 0;
    dp[0][0] = 1;
    vector<int> first_zero(maxa + 1);
    first_zero[0] = 1;
    for (int i = 0; i <= n; ++i) {
        while (it < Q && (qs[it].k < w[i] || i == n)) {
            auto [k, a, b, ind] = qs[it];
            ans[ind] = true;
            for (int j = 0; j <= a; ++j) {
                ans[ind] = ans[ind] && first_zero[j] > b;
            }
            ++it;
        }

        if (i == n)
            break;

        for (int j = maxa; j >= 0; --j) {
            dp[j] |= dp[j]<<w[i];
            if (j - w[i] >= 0) {
                dp[j] |= dp[j - w[i]];
            }

            int z = (~dp[j])._Find_first();
            first_zero[j] = z;
        }
    }

    for (auto el : ans) {
        cout << (el ? "Yes" : "No") << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
#ifdef MT
    cin >> T;
#endif
    while (T--) {
        solve();
    }
    return 0;
}