#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>

using namespace std;

//выбрать n/2 отрезков таких
//что бы максимальное количество непересекающихся отрезков было m/2
// а остальные (n-m)/2 с кем-то да пересекались

void solve()
{
    int n;
    cin>>n;
    vector <pair<int, pair<int, int> > > segments(n); //r,l,i
    for (int i=0; i<n; i++)
    {
        cin>>segments[i].second.first>>segments[i].first;
        segments[i].second.second=i;
    }
    sort(segments.begin(),segments.end());
    vector <int> maxposl;
    unordered_set <int> already;
    int r=-1e9;
    for (int i=0; i<n; i++)
    {
        if (r<segments[i].second.first)
        {
            maxposl.push_back(i);
            r=segments[i].first;
        }
    }
    vector <int> ans;
    int need=(n-maxposl.size())/2;
    int meed=maxposl.size()/2;
    for (int o=0; o<meed; o++)
    {
        vector <set <int> > count(maxposl.size());
        for (int j=0; j<maxposl.size(); j++)
        {
            if (already.find(maxposl[j])!=already.end()) continue;
            for (int i=0; i<n; i++)
            {
                if (i==maxposl[j]) continue;
                if (already.find(i)!=already.end()) continue;
                if (segments[maxposl[j]].first>=segments[i].second.first and segments[maxposl[j]].first<=segments[i].first)
                {
                    count[j].insert(i);
                }
            }
        }
        int u=0;
        for (int j=0; j<maxposl.size(); j++)
        {
            if (count[u].size()<count[j].size()) u=j;
        }
        already.insert(maxposl[u]);
        auto it=count[u].begin();
        int p=min(need,(int)count[u].size());
        need-=min(need,(int)count[u].size());
        vector <int> del;
        for (int i=0; i<p; i++)
        {
            already.insert(*it);
            del.push_back(*it);
            it++;
        }
        for (auto el: del)
        {
            for (int j=0; j<maxposl.size(); j++)
            {
                if (count[j].find(el)!=count[j].end())
                {
                    count[j].erase(el);
                }
            }
        }

    }
    for (auto el: already) ans.push_back(segments[el].second.second+1);
    sort(ans.begin(),ans.end());
    for (auto el: ans) cout<<el<<" ";
    cout<<"\n";
}

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    int t=1;
    cin>>t;
    while (t--)
    {
        solve();
    }
    return 0;
}