#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define f(i, l, r) for (int i = (l); i < (r); i++)
#define ff first
#define sc second
#define all(a) (a).begin(), (a).end()

vector<vector<int>> genc(int n, int k) {
    if (k == 0) return {{}};
    if (k == n) {
        vector<vector<int>> ans = {{}};
        f (i, 1, n + 1) ans[0].push_back(i);
        return ans;
    }
    vector<vector<int>> ans;
    for (int last = k; last <= n; last++) {
        auto res = genc(last - 1, k - 1);
        for (auto &u : res) {
            u.push_back(last);
            ans.push_back(u);
        }
    }
    return ans;
}

void solve() {
    int n; cin >> n;
    vector<int> p(n);
    for (auto &u : p) cin >> u;
    vector<int> dp(n + 1, 1e9);
    dp[0] = 0;
    for (int i = 0; i < n; i++) {
        int L = -1, R = n + 1;
        while (R - L > 1) {
            int M = (L + R) / 2;
            if (dp[M] > p[i]) R = M;
            else L = M;
        }
        dp[R] = p[i];
    }
    int nvp = 0;
    f (i, 0, n + 1) {
        if (dp[i] != 1e9) nvp = i;
    }

    if (nvp >= n - 1) {
        cout << n << '\n';
        return;
    }
    vector<int> pos(n + 1, 0);
    f (i, 0, n) pos[p[i]] = i;
    vector<pair<int, int>> ress;
    int maxpos = -1;
    for (int i = 0; i < n; i++) {
        if (maxpos > pos[i + 1]) {
            ress.push_back({pos[i + 1], maxpos});
        }
        maxpos = max(maxpos, pos[i + 1]);
    }

    if (ress.empty()) {
        cout << nvp + 1 << '\n';
        return;
    }

    random_shuffle(all(ress));
    for (int i = 0; i < min((int)ress.size(), 100); i++) {
        dp[0] = 0;
        int gran = 0;
        for (int j = 0; j < n; j++) {
            if (j == ress[i].ff || j == ress[i].sc) {
                continue;
            }
            int L = -1, R = n + 1;
            while (R - L > 1) {
                int M = (L + R) / 2;
                if (M <= gran && dp[M] < p[j]) L = M;
                else R = M;
            }
            dp[R] = p[j];
            gran = max(gran, R);
        }
        if (gran == nvp) {
            cout << nvp + 2 << '\n';
            return;
        }
    }
    cout << nvp + 1 << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    /*
    auto res = genc(7, 3);
    sort(all(res));
    f(i,0,res.size()) {
        set<int> fir;
        f(j,0,3)fir.insert(res[i][j]);
        for (int j = (i + 1)%res.size();;j = (j + 1) % res.size()) {
            set<int> st = fir;
            for (int ind = 0; ind < 3; ind++) st.insert(res[j][ind]);
            if(st.size()==6){
                cout<<i<<' '<<j<<'\n';
                break;
            }
        }
    }*/

    int tt; cin >> tt;
    while (tt--) {
        solve();
    }

    return 0;
}