// 7f priv
// vot by prizera

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(a) (a).begin(), (a).end()
#define sz(a) (int) a.size()
#define f(i, l, r) for (int i = (l); i < (r); i++)
#define pb push_back
#define sc second
#define ff first
#define pii pair<int, int>
#define int long long

mt19937 rnd(time(NULL));

void solve() {
    int n, q; cin >> n >> q;
    vector<int> a(n);
    for (auto &u : a) cin >> u;
    sort(all(a));
    int z; cin >> z;
    map<int, vector<pair<pii, int>>> reqs;
    vector<string> answers(q);
    f (i, 0, q) {
        int k, A, B; cin >> k >> A >> B;
        int L = -1, R = n;
        while (R - L > 1) {
            int M = (L + R) / 2;
            if (a[M] <= k) L = M;
            else R = M;
        }
        if (L == -1) {
            answers[i] = ((A == 0 && B == 0) ? "Yes" : "No");
        } else {
            reqs[L].pb({{A, B}, i});
        }
    }

    vector<vector<int>> dp(301, vector<int>(301, 0));
    dp[0][0] = 1;
    for (int i = 0; i < n; i++) {
        vector<vector<int>> new_dp = dp;
        for (int j = 0; j <= 300; j++) {
            for (int k = 0; k <= 300; k++) {
                if (dp[j][k] == 1 && j + a[i] <= 300) new_dp[j + a[i]][k] = 1;
                if(dp[j][k] == 1 && k + a[i] <= 300) new_dp[j][k + a[i]] = 1;
            }
        }
        swap(new_dp, dp);

        if (reqs.find(i) != reqs.end()) {
            vector<vector<bool>> can(301, vector<bool>(301, 0));
            can[0][0] = true;
            for (int i = 1; i <= 300; i++) {
                can[i][0] = (dp[i][0] > 0);
                can[0][i] = can[i][0];
            }
            for (int i = 1; i <= 300; i++) {
                for (int j = 1; j <= 300; j++) {
                    //cout << i << ' ' << j << ' ' << can[i][j - 1] << ' ' << can[i - 1][j] << ' ' << (dp[i + j] == 1 && dp[i] == 1 && dost[i + j].find(i) != dost[i + j].end()) << '\n';
                    can[i][j] = (can[i][j - 1] && can[i - 1][j] && dp[i][j]);
                }
            }

            for (auto &u : reqs[i]) {
                answers[u.sc] = (can[u.ff.ff][u.ff.sc] ? "Yes" : "No");
            }
        }
    }

    for (auto &u : answers) cout << u << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    int tt = 1; //cin >> tt;
    while (tt--) {
        solve();
    }

    return 0;
}