#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int INF = 1e9;
const ll INF_ll = 1e18;
const int mod = 1e9 + 7;

vector<vector<int> > g;
vector<ll> l, r, val;


ll x, y, m;

vector<vector<ll> > dp;

void dfs(int v, int curr, vector<vector<int> > &a, int p = -1) {
    dp[v][1] = a[curr][v];
    dp[v][0] = 0;
    for (auto to : g[v]) {
        if (to == p) continue;
        dfs(to, curr, a, v);
        dp[v][0] += max(dp[to][0], dp[to][1]);
        dp[v][1] += dp[to][0];
    }
}

ll check(int v, int x, vector<vector<int> > &a, int curr) {
    if (v == a[0].size()) {
        dfs(0, curr, a);
        ll t = max(dp[0][0], dp[0][1]);
        if (t == x) {
            ll id = 0;
            for (int i = 0; i < a[0].size(); i++) {
                id ^= (x * (i + 1) % m + y * l[i] % m * l[i] % m) % m;
            }
            return id;
        } else {
            return -1;
        }
    }
    for (int i = l[v]; i <= r[v]; i++) {
        a[curr][v] = i;
        ll t = check(v + 1, x, a, curr);
        if (t != -1) {
            return t;
        }
    }
    return -1;
}

void solve() {
    int n, q;
    cin >> n >> q;
    cin >> x >> y >> m;
    g.resize(n);
    l.resize(n);
    r.resize(n);
    val.resize(n);
    dp.resize(n, vector<ll>(2));
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);
    }
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
    }
    vector<vector<int> > a(q, vector<int>(n));
    vector<ll> v(q);
    vector<ll> ans(q);
    for (int i = 0; i < q; i++) {
        cin >> v[i];
        ans[i] = check(0, v[i], a, i);
        cout << ans[i] << ' ';
    }
    cout << endl;
    while (1) {
        int x;
        cin >> x;
        if (x == 0) {
            return;
        }
        x--;
        if (ans[x] == -1) {
            cout << -1 << endl;
        } else {
            for (int i = 0; i < n; i++) {
                cout << a[x][i] << ' ';
            }
            cout << endl;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
        l.clear(), r.clear(), dp.clear(), g.clear();
    }
    return 0;
}