#include <vector>
#include <iostream>
#include <algorithm>
#include <cassert>

using namespace std;

void solve1();
void solve2();

using ll = long long;

pair<ll, int> ans(vector<int> &v, int n, int c){
    for (int i = 0; i < n; ++i) {
        v[i]--;
    }
    sort(v.begin(), v.end());
    v.resize(unique(v.begin(), v.end()) - v.begin());
    n = v.size();
    ll ans = v.back() - v[0] + 1;
    for (int i = 0; i < n; ++i) {
        v.push_back(v[i] + c);
    }
    for (int i = 0; i < n; ++i) {
        ans = min(ans, (ll)v[n - 1 + i] - v[i] + 1);
    }
    int cnt = c;
    for (int i = 0; i < n; ++i) {
        if (v[n - 1 + i] - v[i] + 1 == ans){
            cnt = min(cnt, v[i]);
            cnt = min(cnt, c - v[i]);
            if (v[n - 1 + i] >= c) {
                cnt = min(cnt, v[n - 1 + i] - c + 1);
                cnt = min(cnt, 2 * c - 1 - v[n - 1 + i]);
            }
        }
    }
    if (v[n - 1] - v[0] + 1 == ans){
        cnt = 0;
    }
    return {ans, cnt};
}

int main(){
    int h, w, n;
    cin >> h >> w >> n;
    vector<int> x(n);
    vector<int> y(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> y[i];
    }
    auto [l1, c1] = ans(x, n, h);
    auto [l2, c2] = ans(y, n, w);
    cerr << l1 << ' ' << c1 << endl << l2 << ' ' << c2 << endl;
    cout << l1 * l2 << ' ' << c1 + c2 << endl;
}
