#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <cassert>
#include <iomanip>
#include <cstdio>
#include <bitset>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <random>
#include <ctime>
#define endl '\n'

using namespace std;
using ll = long long;
using ld = long double;
const int N = 2010;
pair <int, int> dp[N][N];
void solve() {
	int n;
	cin >> n;
	for (int i = 0; i <= n + 1; i++)
		for (int j = 0; j <= n + 1; j++)
			for (int t = 0; t <= n + 1; t++)
				dp[i][j] = { -1e9, 0 };
	vector <int> x(n);
	for (auto& r : x)
		cin >> r;
	dp[0][0] = { 0, n + 1 };
	for (int i = 0; i < n; i++) {
		for (int mx = 0; mx <= n; mx++) {
			if (mx < x[i])
				dp[i + 1][x[i]] = max(dp[i + 1][x[i]], { dp[i][mx].first + 1, dp[i][mx].second });
			else
				dp[i + 1][mx] = max(dp[i + 1][mx], dp[i][mx]);

			if (x[i] < dp[i][mx].second)
				dp[i + 1][mx] = max(dp[i + 1][mx], { dp[i][mx].first + 1, x[i] });
			else
				dp[i + 1][mx] = max(dp[i + 1][mx], dp[i][mx]);
		}
	}	
	int ans = 0;
	for (int mx = 0; mx <= n; mx++)
		ans = max(ans, dp[n][mx].first);
	cout << ans;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#endif	
	int t;
	cin >> t;
	while (t--) {
		solve();
		cout << endl;
	}
}
