#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#include <cstdio>
#include <deque>
#include <queue>
#include <bitset>
#include <cassert>
#include <random>
#include <ctime>
#define endl '\n'
using namespace std;
using ll = long long;
using ld = long double;

struct node {
	int l, r, ind;
};

bool cmp(node a, node b) {
	if (a.l != b.l)
		return a.l < b.l;
	return a.r < b.r;
}

int get(vector <node> x) {
	int n = x.size();
	vector <int> dp(n, 1);
	for (int i = 1; i < n; i++) {
		for (int j = 0; j < i; j++) {
			if (x[j].r < x[i].l && dp[j] + 1 > dp[i]) {
				dp[i] = dp[j] + 1;
			}
		}
	}
	return *max_element(dp.begin(), dp.end());
}

void solve() {
	int n;
	cin >> n;
	vector <node> x(n);
	for (int i = 0; i < n; i++) {
		cin >> x[i].l >> x[i].r;
		x[i].ind = i;
	}
	for (int i = 0; i < n / 2; i++)
		cout << i + 1 << ' ';
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#endif 
	int t;
	cin >> t;
	while (t--) {
		solve();
		cout << endl;
	}
}
