#include <bits/stdc++.h>

#define ll int64_t
#define ld long double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define x first
#define y second

#define double ld
#define endl '\n'

using namespace std;

const int inf = 1e9;
const ll INF = 1e18;

void solve_1() {
    int n, k;
    cin >> n >> k;

    vector<int> nums(k);
    for (int & e : nums)
        cin >> e;

    sort(all(nums));
    vector<int> weight(k, 1);

    set<int> aval;

    set<int> ban;
    for (int e : nums)
        ban.insert(e);

    for (int i = 1; i <= 2 * k and i <= n; ++i) {
        if (ban.count(i) == 0)
            aval.insert(i);
    }

    for (int i = 0; i < k; ++i) {
        int j = nums[i] + 1;
        while (weight[i] >= 0 and !ban.count(j) and j <= n) {
            aval.insert(j);
            --weight[i];
            ++j;
        }

        if (i != k - 1)
            weight[i + 1] += weight[i];
    }

    vector<int> ans;

    for (int e : nums) {
        auto z = aval.lower_bound(e);
        if (z != aval.end()) {
            ans.push_back(*z);
            aval.erase(z);
        } else {
            ans.push_back(*aval.begin());
            aval.erase(aval.begin());
        }
    }
    sort(all(ans));

    for (int x : ans)
        cout << x << " ";
    cout << endl;
}

void solve_2() {
    int n, k;
    cin >> n >> k;

    set<int> nums;
    for (int i = 0; i < k; ++i) {
        int x;
        cin >> x;
        nums.insert(-x);
    }

    set<int> aval;
    for (int i = 1; i <= n; ++i) {
        if (nums.count(-i) == 0)
            aval.insert(i);
    }

    vector<int> ans;

    for (int u : nums) {
        int e = -u;
        auto z = aval.lower_bound(e);
        if (z != aval.begin()) {
            --z;
            ans.push_back(*z);
            aval.erase(z);
        } else {
            ans.push_back(*(--aval.end()));
            aval.erase(--aval.end());
        }
    }

    sort(all(ans));
    for (int x : ans)
        cout << x << " ";
    cout << endl;
}

signed main() {
#ifndef LOCAL
    cin.tie(NULL);
    cout.tie(NULL);
    ios_base::sync_with_stdio(false);
#endif

    int a;
    cin >> a;
    int m;
    cin >> m;

    while (m--) {
        if (a == 1) {
            solve_1();
        } else {
            solve_2();
        }
    }

    return 0;
}
