#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const int MAXN = 2e5 + 1;

vector <int> g[MAXN];
vector <int> ans(MAXN, 0);

void dfs(int v, int t, int k) {
    if (g[v].empty()) {
        ans[v]++;
        return;
    }
    if (t == 0) {
        dfs(g[v][0], 0, k);
        ans[v] += ans[g[v][0]];
        if (k >= 1) {
            dfs(g[v][1], 1, k - 1);
            ans[v] += ans[g[v][1]];
        }
    } else {
        dfs(g[v][1], 1, k);
        ans[v] += ans[g[v][1]];
        if (k >= 1) {
            dfs(g[v][0], 0, k - 1);
            ans[v] += ans[g[v][0]];
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, k, q;
    cin >> n >> k >> q;
    for (int i = 0; i < n; i++) {
        int z, a, b;
        cin >> z;
        if  (z == 2) {
            cin >> a >> b;
            g[i + 1].push_back(a);
            g[i + 1].push_back(b);
        }
    }
    dfs(g[1][0], 0, k);
    dfs(g[1][1], 1, k);
    ans[1] = ans[g[1][0]] + ans[g[1][1]];
    while (q--) {
        int v;
        cin >> v;
        cout << ans[v] << "\n";
    }
}
