#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const int MAXN = 30;

struct otr {
    int l;
    int r;
    int id;
};

bool cmp(otr a, otr b) {
    if (a.r == b.r) {
        return a.l > b.l;
    }
    return a.r < b.r;
}
vector <otr> p;
vector <bool> used(MAXN, false);
int n;
int m;
bool ok = false;

bool check() {
    int lastr = 0;
    int mm = 0;
    for (int i = 0; i < n; i++) {
        if (used[i]) {
            continue;
        }
        if (lastr < p[i].l) {
            mm++;
            lastr = p[i].r;
        }
    }
    if (mm * 2 == m) {
        for (int i = 0; i < n; i++) {
            if (!used[i]) {
                cout << p[i].id + 1 << " ";
            }
        }
        cout << "\n";
        return true;
    }
    return false;
}

void resh(int id, int ost) {
    if (ost == 0) {
        ok = check();
        return;
    }
    if (n - id == ost) {
        used[id] = true;
        resh(id + 1, ost - 1);
        used[id] = false;
    } else {
        used[id] = true;
        resh(id + 1, ost - 1);
        used[id] = false;
        if (ok) {
            return;
        }
        resh(id + 1, ost);
    }
}

void solve() {
    ok = false;
    cin >> n;
    p.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> p[i].l >> p[i].r;
        p[i].id = i;
    }
    m = 0;
    int lastr = 0;
    sort(p.begin(), p.end(), cmp);
    for (int i = 0; i < n; i++) {
        if (lastr < p[i].l) {
            m++;
            lastr = p[i].r;
        }
    }
    resh(0, n / 2);

}

int main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}