#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const int MAXN = 20;
const int MAXA = 1501;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, q;
    cin >> n >> q;
    ll z;
    vector <ll> p(n);
    for (int i = 0; i < n; i++) {
        cin >> p[i];
    }
    cin >> z;
    sort(p.begin(), p.end());
    bool dp[MAXA][MAXA];
    for (int i2 = 0; i2 < MAXA; i2++) {
        for (int i3 = 0; i3 < MAXA; i3++) {
            dp[i2][i3] = false;
        }
    }
    dp[0][0] = true;

    for (int i1 = 0; i1 < n; i1++) {
        for (int i2 = MAXA - 1; i2 >= 0; i2--) {
            for (int i3 = MAXA - 1; i3 >= 0; i3--) {
                if (dp[i2][i3]) {
                    break;
                }
                if (i2 >= p[i1] && dp[i2 - p[i1]][i3] && (i2 == 0 || dp[i2 - 1][i3]) && (i3 == 0 || dp[i2][i3 - 1])) {
                    dp[i2][i3] = true;
                    break;
                }
                if (i3 >= p[i1] && dp[i2][i3- p[i1]] && (i2 == 0 || dp[i2 - 1][i3]) && (i3 == 0 || dp[i2][i3 - 1])) {
                    dp[i2][i3] = true;
                    break;
                }
            }
        }
    }
    ll v = 0;
    ll k, a, b;
    ll j, c, d;
    for (ll i = 1; i <= q; i++) {
        cin >> j >> c >> d;
        k = j - v * z;
        a = c - v * z;
        b = d - v * z;
        if (dp[a][b]) {
            v += j;
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}