#include <bits/stdc++.h>

using namespace std;


#define int int64_t

vector<vector<int>> segTree;


void modify(int i,int x,int l,int r,int indV,int j)
{
    if(l > i || r < i)
        return ;
    else if(l == r)
    {
        segTree[j][indV] = x;
        return ;
    }
    int m = (l+r)/2;
    modify(i,x,l,m,indV*2+1,j);
    modify(i,x,m+1,r,indV*2+2,j);
    segTree[j][indV] = max(segTree[j][indV*2+1],segTree[j][indV*2+2]);
}
int get(int lx,int rx,int l,int r,int indV,int j)
{
    if(l > rx || r < lx)
        return -int64_t(1e18);
    else if(l >= lx && r <= rx)
        return segTree[j][indV];
    int m =(l+r)/2;
    int sl = get(lx,rx,l,m,indV*2+1,j);
    int sr = get(lx,rx,m+1,r,indV*2+2,j);
    return max(sl,sr);
}
vector<vector<pair<pair<int,int>,int>>> ev;
vector<int> ans;

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n,q;
    cin >> n >> q;
    ev.resize(n);
    ans.resize(q);
    segTree.resize(3);
    for(int i = 0;i < 3;++i)
    {
        segTree[i].resize(4*n);
    }
    int64_t w[n];
    for(int i = 0;i < n;++i)
    {
        cin >> w[i];
    }
    sort(w,w+n);
    int z;
    cin >> z;
    for(int i = 0;i < q;++i)
    {
        int k,a,b;
        cin >> k >> a >> b;
        if(k < w[0])
        {
            ans[i] = (a+b == 0 ? 1 : 0);
        }
        else
        {
            ev[upper_bound(w,w+n,k)-w-1].push_back({{a,b},i});
        }
    }
    int64_t sum = 0,kk = 0;
    vector<pair<int,int>> xx;
    vector<pair<int,int>> t;
    for(int i = 0;i < n;++i)
    {
        t.push_back({w[i],sum});
        modify(i,2*(w[i]-1)-sum,0,n-1,0,0);
        modify(i,(w[i]-1)-sum,0,n-1,0,1);
        modify(i,-sum,0,n-1,0,2);
        sum += w[i];
        for(int u = 0;u < ev[i].size();++u)
        {
            int a = ev[i][u].first.first;
            int b = ev[i][u].first.second;
            //cout << i << ' ' << a << ' ' << b << ' ' << sum << "\n";
            if(a < b)
                swap(a,b);
            int no = 0;
            int lg = -1,rg = i;
            while(lg < rg)
            {
                int m =(lg+rg+1)/2;
                if(t[m].first-1 <= b)
                {
                    lg = m;
                }
                else
                    rg = m-1;
            }
            int olg = lg;
           // cout << lg << ' ';
            if(get(0,lg,0,n-1,0,0) > 0)
            {
                no = 1;
            }
          //  cout << no;
            rg = i;
            while(lg < rg)
            {
                int m = (lg+rg+1)/2;
                if(t[m].first-1 <= a)
                    lg = m;
                else
                    rg = m-1;
            }
           // cout << olg+1 << ' ' << lg << ' ' << get(olg+1,lg,0,n-1,0,1) << "\n";
            if(get(olg+1,lg,0,n-1,0,1)+b > 0)
            {
                no = 1;
            }
            //cout << no << ' ';
            if(get(lg+1,i,0,n-1,0,2)+a+b > 0)
            {
                no = 1;
            }
            if(no || a+b > sum)
            {
                ans[ev[i][u].second] = 0;
            }
            else
            {
                ans[ev[i][u].second] = 1;
            }
        }
    }
    for(auto c:ans)
        cout << (c ? "Yes\n" : "No\n");
    return 0;


}
/*
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n,q;
    cin >> n >> q;
    int64_t w[n];
    int64_t pp = 2e18;
    int64_t sum = 0;
    for(int i = 0;i < n;++i)
    {
        cin >> w[i];
    }
    sort(w,w+n);
    for(int i = 0;i < n;++i)
    {
        if(w[i] >= sum+2)
        {
            pp = sum+1;
            break;
        }
        sum += w[i];
    }
    pp = sum+1;
   //cout << pp << ' ';
    int z;
    cin >> z;
    while(q--)
    {
        int k,a,b;
        cin >> k >> a >> b;
        if(a >= pp)
        {
            cout << "No\n";
        }
        else
            cout << "Yes\n";
    }
}*/
