#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define int ll

vector<tuple<int, int, int>> que[300003];
int w[300003];
int ans[300003];

void solve() {
    int n, q;
    cin >> n >> q;
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    sort(w, w + n);
    int z;
    cin >> z;
    int maxn = 0;
    for (int i = 0; i < q; ++i) {
        int k, a, b;
        cin >> k >> a >> b;
        maxn = max({maxn, a, b});
        int lb = upper_bound(w, w + n, k) - w;
        if (lb) {
            que[lb - 1].emplace_back(a, b, i);
        } else {
            if (a == 0 && b == 0) {
                ans[i] = 1;
            }
        }
    }
    vector<int> can(maxn + 1, -1);
    can[0] = 0;
    for (int i = 0; i < n; ++i) {
        auto new_can = can;
        for (int j = 0; j <= maxn; ++j) {
            if (can[j] >= w[i] - 1) {
                new_can[j] = max(new_can[j], can[j] + w[i]);
            }
            if (j >= w[i]) {
                new_can[j] = max(new_can[j], can[j - w[i]]);
            }
        }
        can = new_can;
        for (auto abi : que[i]) {
            int a = get<0>(abi);
            int b = get<1>(abi);
            int ind = get<2>(abi);
            int good = 1;
            for (int j = 0; j <= a; ++j) {
                good &= can[j] >= b;
            }
            ans[ind] = good;
        }
    }
    for (int i = 0; i < q; ++i) {
        cout << (ans[i] ? "Yes" : "No") << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
#ifdef Debugg
    freopen(R"(C:\work\untitled\ain.txt)", "r", stdin);
    freopen(R"(C:\work\untitled\aout.txt)", "w", stdout);
#endif
    solve();
    return 0;
}
