#include <iostream>
#include <vector>
using namespace std;

const int MAXN = 2e5 + 123;
pair<int, int> edg[MAXN];
pair<int, bool> rt[MAXN];
int ans[MAXN];

void dfs(int v, int k) {
    if (k < 0)
        return;
    if (edg[v].first == -1) {
        ans[v] = 1;
        return;
    }
    if (v == 0) {
        dfs(edg[v].first, k);
        dfs(edg[v].second, k);
    } else if (rt[v].second) {
        dfs(edg[v].first, k - 1);
        dfs(edg[v].second, k);
    } else {
        dfs(edg[v].first, k);
        dfs(edg[v].second, k - 1);
    }
    ans[v] = ans[edg[v].first] + ans[edg[v].second];
}

signed main() {
    int n, k, q;
    cin >> n >> k >> q;
    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        if (t == 0) {
            edg[i] = {-1, -1};
        } else {
            int l, r;
            cin >> l >> r;
            --l, --r;
            edg[i] = {l, r};
            rt[l] = {i, false};
            rt[r] = {i, true};
        }
    }
    dfs(0, k);
    while (q--) {
        int v;
        cin >> v;
        --v;
        cout << ans[v] << '\n';
    }
}
