#include <bits/stdc++.h>

using namespace std;
using ll = long long;

ofstream debug;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    debug.open("debug.txt");
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll h, w, k;
    cin >> h >> w >> k;
    vector<ll> x(k), y(k);
    for (int i = 0; i < k; i++) cin >> y[i] >> x[i];
    ll height = h, vertical = h;
    ll width = w, horizontal = w;
    std::sort(y.begin(), y.end());
    y.resize(std::unique(y.begin(), y.end()) - y.begin());
    std::sort(x.begin(), x.end());
    x.resize(std::unique(x.begin(), x.end()) - x.begin());
    ll moves = 0;
    ll last = y.back();
    for (ll i: y) {
        if (last - i + 1 < height || last - i + 1 == height && moves < vertical) {
            height = last - i + 1;
            vertical = moves;
        }
        moves = i;
        last = i + h;
    }
    moves = 0;
    ll first = y[0];
    std::reverse(y.begin(), y.end());
    for (ll i: y) {
        if (last - i + 1 < height || last - i + 1 == height && moves < vertical) {
            height = i - first + 1;
            vertical = moves;
        }
        moves = h - i + 1;
        first = i - h;
    }
    moves = 0;
    last = x.back();
    for (ll i: x) {
        if (last - i + 1 < width || last - i + 1 == width && moves < horizontal) {
            width = last - i + 1;
            horizontal = moves;
        }
        moves = i;
        last = i + w;
    }
    moves = 0;
    first = x[0];
    std::reverse(x.begin(), x.end());
    for (ll i: y) {
        if (last - i + 1 < width || last - i + 1 == width && moves < horizontal) {
            width = i - first + 1;
            horizontal = moves;
        }
        moves = w - i + 1;
        first = i - w;
    }
    cout << width * height << " " << horizontal + vertical;
    return 0;
}
