#include <bits/stdc++.h>
#define int long long
#define all(a) a.begin(), a.end()

using namespace std;


int stupidSolve(vector<int> p) {
    int n = (int)p.size();
    int ans = 0;
    for (int mask = 1; mask < (1 << n) - 1; ++mask) {
        vector<int> q, r;
        for (int i = 0; i < n; ++i) {
            if (mask & (1 << i)) {
                q.push_back(p[i]);
            } else {
                r.push_back(p[i]);
            }
        }
        int mxQ = 0, mnR = INT64_MAX, tmpAns = 0;
        for (auto i : q) {
            if (i > mxQ) {
                mxQ = i;
                tmpAns++;
            }
        }
        for (auto i : r) {
            if (i < mnR) {
                mnR = i;
                tmpAns++;
            }
        }
        ans = max(ans, tmpAns);
    }
    return ans;
}

struct Elem {
    int ans, mxQ, mnR;
};

int smartSolve(vector<int> p) {
    int n = (int)p.size();
    p.insert(p.begin(), 0);
    vector<Elem> dp(n + 1, {0, 0, INT64_MAX});
    for (int i = 1; i <= n; ++i) {
        for (int j = i - 1; j >= 0; --j) {
            auto [pAns, pMx, pMn] = dp[j];
            int ans = pAns, mx = pMx, mn = pMn;
            if (p[i] > mx) {
                ans++;
                mx = p[i];
            }
            for (int k = j + 1; k < i; ++k) {
                if (p[k] < mn) {
                    ans++;
                    mn = p[k];
                }
            }
            if (dp[i].ans < ans || (dp[i].ans == ans && dp[i].mxQ > mx)) {
                dp[i] = {ans, mx, mn};
            }
        }
    }
    int ans = 0;
    for (int i = 1; i <= n; ++i) {
        int tmpAns = dp[i].ans;
        int mn = dp[i].mnR;
        for (int j = i + 1; j <= n; ++j) {
            if (p[j] < mn) {
                tmpAns++;
                mn = p[j];
            }
        }
        ans = max(ans, tmpAns);
    }
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t; cin >> t;
    for (int i = 0; i < t; ++i) {
        int n; cin >> n;
        vector<int> p(n);
        for (int j = 0; j < n; ++j) cin >> p[j];
        cout << smartSolve(p) << '\n';
    }
    return 0;
}

