#include <bits/stdc++.h>

#define sz(a) int((a).size())

using namespace std;

typedef long long ll;

const int INF = 2e9;

void solve() {
    int h, w;
    cin >> h >> w;
    int k;
    cin >> k;
    vector<pair<int, int>> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i].first >> a[i].second;
        a[i].first--, a[i].second--;
    }

    ll ans = 1, cnt = 0;

    {
        set<int> s;
        for (int i = 0; i < k; ++i) {
            s.insert(a[i].first);
        }
        pair<int, int> res = {INF, INF};
        for (auto x : s) {
            if (s.find(x) == s.begin()) {
                int xx = *--s.end();
                res = min(res, {xx - x + 1, 0});
            } else {
                int xx = *--s.find(x);
                res = min(res, {h - (x - xx - 1), min(xx + 1, h - x)});
            }
        }
        ans *= res.first;
        cnt += res.second;
    }

    {
        set<int> s;
        for (int i = 0; i < k; ++i) {
            s.insert(a[i].second);
        }
        pair<int, int> res = {INF, INF};
        for (auto y : s) {
            if (s.find(y) == s.begin()) {
                int yy = *--s.end();
                res = min(res, {yy - y + 1, 0});
            } else {
                int yy = *--s.find(y);
                res = min(res, {w - (y - yy - 1), min(yy + 1, w - y)});
            }
        }
        ans *= res.first;
        cnt += res.second;
    }

    cout << ans << ' ' << cnt << '\n';
}

int main() {
#ifdef LOCAL
    freopen("../in.txt", "r", stdin);
    freopen("../out.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    solve();

    return 0;
}