#include <bits/stdc++.h>

using namespace std;
//#define int long long
#define sz(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
using pii = pair<int, int>;
#define ff first
#define ss second

template<typename T1, typename T2>
void mnr(T1 &a, const T2 &b) {
    if (a > b) {
        a = b;
    }
}


template<typename T1, typename T2>
void mxr(T1 &a, const T2 &b) {
    if (a < b) {
        a = b;
    }
};

class DSU {
private:
    vector <int> p;
    vector <int> r;

public:
    int comp;

    explicit DSU(int n) : p(n), r(n), comp(n) {
        iota(all(p), 0);
    }

    int get(int a) {
        return (a == p[a] ? a : p[a] = get(p[a]));
    }

    void unite(int a, int b) {
        a = get(a), b = get(b);
        if (a == b) {
            return;
        }
        --comp;
        if (r[a] > r[b]) {
            swap(a, b);
        }
        p[a] = b;
        r[b] += (r[a] == r[b]);
    }
};

using Segment = tuple <int, int, int>;

bool inter(Segment a, Segment b) {
    auto [l1, r1, id1] = a;
    auto [l2, r2, id2] = b;
    if (l1 > l2) {
        swap(l1, l2);
        swap(r1, r2);
    }
    return (l2 >= l1 && l2 <= r1);
}

void solve() {
    int n;
    cin >> n;
    vector<Segment> v(n);
    {
        int id = 0;
        for (auto &[l, r, i]: v) {
            cin >> l >> r;
            i = id++;
        }
    }
    sort(all(v), [](Segment a, Segment b) {
        if (get<1>(a) != get<1>(b)) {
            return get<1>(a) < get<1>(b);
        }
        return get<0>(a) > get<1>(b);
    });
    vector <int> xs;
    for (auto [l, r, id] : v) {
        xs.push_back(l);
        xs.push_back(r);
    }
    sort(all(xs));
    xs.resize(unique(all(xs)) - xs.begin());
    int m = sz(xs);
    unordered_map <int, int> conv;
    for (int i = 0; i < m; ++i) {
        conv[xs[i]] = i;
    }
    vector <vector <pii> > segsbyr(m + 1);
    int dddd = 0;
    for (auto [l, r, id] : v) {
        segsbyr[conv[r] + 1].emplace_back(conv[l] + 1, dddd++);
    }
    vector <int> dp(m + 1);
    vector <int> pr(m + 1, -1);
    for (int i = 1; i <= m; ++i) {
        for (auto [j, id] : segsbyr[i]) {
            if (dp[i] < dp[j - 1] + 1) {
                pr[i] = id;
                dp[i] = dp[j - 1] + 1;
            }
        }
        if (dp[i] < dp[i - 1]) {
            pr[i] = -1;
            dp[i] = dp[i - 1];
        }
    }
    int cur = m;
    vector <bool> t(n);
//    vector <bool> del(n);
    cerr << dp.back() << "\n";
    while (cur) {
        if (pr[cur] != -1) {
            cerr << get<2>(v[pr[cur]]) << " ";
            t[pr[cur]] = true;
            cur = conv[get<0>(v[pr[cur]])];
        } else {
            --cur;
        }
    }
    vector <vector <int> > g(n);
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (inter(v[i], v[j])) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    vector <int> gptr(n);
    vector <int> amount(n);
    for (int i = 0; i < n; ++i) {
        for (auto j : g[i]) {
            if (t[j]) {
                ++amount[i];
            }
        }
    }
    int M = dp.back();
//    vector <int> res;
    vector <int> sus;
    for (int i = 0; i < n; ++i) {
        if (t[i]) {
            sus.push_back(i);
        }
    }
    int k = sz(sus);
    auto am0 = amount;
    for (int mask = 0; mask < (1 << k); ++mask) {
        if (__builtin_popcount(mask) != k / 2) {
            continue;
        }
        amount = am0;
        vector <int> del(n), res;
        for (int bst = 0; bst < k; ++bst) {
            int bsti = sus[bst];
            if (mask >> bst & 1) {
                del[bsti] = true;
                res.push_back(bsti);
                for (auto j : g[bsti]) {
                    --amount[j];
                    if (!amount[j]) {
                        res.push_back(j);
                        del[j] = true;
                    }
                }
            }
        }
        if (sz(res) <= n / 2) {
            for (int i = 0; i < n; ++i) {
                if (!t[i] && !del[i]) {
                    if (sz(res) < n / 2) {
                        res.push_back(i);
                    }
                }
            }
            vector <int> pt(n, 1);
            for (auto i : res) {
                pt[get<2>(v[i])] = 0;
            }
            for (int i = 0; i < n; ++i) {
                if (pt[i]) {
                    cout << i + 1 << " ";
                }
            }
            return;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
#ifdef SYSTY257
    freopen("inputik.txt", "r", stdin);
    freopen("outputik.txt", "w", stdout);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
}