#pragma GCC optimize("O3")

#include "bits/stdc++.h"

using namespace std;
using ll = long long;
using uint = unsigned int;
#define sz(x) (int)x.size()
#define all(x) (x).begin(), (x).end()

int A;
vector<vector<int>> C[10][10];
void solve_case() {
	int n, k; cin >> n >> k;
	vector<int> a(k);
	for (auto& x : a)
		cin >> x;

	int pos = find(all(C[n][k]), a) - C[n][k].begin();
	if (A == 1) {
		auto& res = C[n][k][(pos + 1) % sz(C[n][k])];
		for (int x : res)
			cout << x << " ";
		cout << "\n";
	} else {
		auto& res = C[n][k][(pos - 1 + sz(C[n][k])) % sz(C[n][k])];
		for (int x : res)
			cout << x << " ";
		cout << "\n";
	}
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
	(void)freopen("../input.txt", "r", stdin);
#endif
	
	cin >> A;
	for (int k = 1; k <= 3; k++) {
		for (int n = 2 * k; n <= 7; n++) {
			for (int mask = 1; mask < (1 << k); mask++) {
				C[n][k].push_back({});
				for (int i = 0; i < k; i++) {
					if ((mask >> i) & 1) {
						C[n][k].back().push_back(i + 1);
					}
				}

				if (sz(C[n][k].back()) != k)
					C[n][k].pop_back();
			}
		}
	}

	int T = 1;
	cin >> T;
	while (T--) {
		solve_case();
	}

	return 0;
}
