#include "bits/stdc++.h"

using namespace std;
using ll = long long;
#define sz(x) (int)x.size()
#define all(x) (x).begin(), (x).end()

int A;

void solve_case() {
	if (A == 1) {
		int n, k; cin >> k >> n;
		vector<int> a(n);
		for (auto& x : a)
			cin >> x;

		for (int shift = 1; shift < k; shift++) {
			auto b = a;
			for (int& x : a) {
				if ((x += shift) > k) x -= k;
			}

			set<int> s(all(a));
			for (int x : b) s.insert(x);

			if (sz(s) == 2 * n) {
				sort(all(a));
				for (int x : a)
					cout << x << " ";
				cout << "\n";
				return;
			}

			a = b;
		}
	} else {
		int n, k; cin >> k >> n;
		vector<int> a(n);
		for (auto& x : a)
			cin >> x;

		for (int shift = -1; shift > -k; shift--) {
			auto b = a;
			for (int& x : a) {
				if ((x += shift) > k) x -= k;
			}

			set<int> s(all(a));
			for (int x : b) s.insert(x);

			if (sz(s) == 2 * n) {
				sort(all(a));
				for (int x : a)
					cout << x << " ";
				cout << "\n";
				return;
			}

			a = b;
		}
	}
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
	(void)freopen("../input.txt", "r", stdin);
#endif

	cin >> A;
	int T; cin >> T;
	while (T--) {
		solve_case();
	}


	return 0;
}