#include "bits/stdc++.h"

using namespace std;
using ll = long long;
#define sz(x) (int)x.size()
#define all(x) (x).begin(), (x).end()

inline void upd(int& x, int nx) {
	x = max(x, nx);
}

void solve_case() {
	int n; cin >> n;
	vector<int> a(n);
	for (auto& x : a)
		cin >> x;

	int res = 0;

	vector<vector<vector<int>>> dp(n, vector<vector<int>>(n + 2, vector<int>(n + 2, -1)));
	dp[0][a[0]][0] = dp[0][n + 1][a[0]] = 1;
	for (int i = 1; i < n; i++) {
		for (int mn = 0; mn <= n + 1; mn++) {
			for (int mx = 0; mx <= n + 1; mx++) {
				if (dp[i - 1][mn][mx] == -1)
					continue;

				if (a[i] < mn)
					upd(dp[i][a[i]][mx], dp[i - 1][mn][mx] + 1);
				if (a[i] > mx)
					upd(dp[i][mn][a[i]], dp[i - 1][mn][mx] + 1);
				if (a[i] >= mn || a[i] <= mx)
					upd(dp[i][mn][mx], dp[i - 1][mn][mx]);
			}
		}
	}

	for (auto& v : dp.back())
		res = max(res, *max_element(all(v)));

	cout << res << "\n";
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
	(void)freopen("../input.txt", "r", stdin);
#endif

	int T = 1;
	cin >> T;
	while (T--) {
		solve_case();
	}

	return 0;
}