#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>

using namespace std;


int main() {
    long long h = 1, w = 2, k = 2;
    cin >> h >> w >> k;
    vector<long long> str1, st1;
    for (long i = 0; i < k; ++i) {
        long long x, y;
        cin >> x >> y;
        --x, --y;
        str1.push_back(x);
        st1.push_back(y);
    }
    sort(str1.begin(), str1.end());
    sort(st1.begin(), st1.end());
    str1.resize(unique(str1.begin(), str1.end()) - str1.begin());
    st1.resize(unique(st1.begin(), st1.end()) - st1.begin());
    long long shift1 = 0, shift2 = 0;
    deque<long long> str, st;
    for (auto u: str1)
        str.push_back(u);
    for (auto u: st1)
        st.push_back(u);
    pair<long long, long long> answer1 = {str.back() - str.front() + 1, 0}, answer2 = {st.back() - st.front() + 1, 0};
    for (long i = 0; i < str.size(); ++i) {
        shift1 += h - (str.back() + shift1) % h;
        if (shift1 >= h)
            break;
        str.push_front(str.back());
        str.pop_back();
        answer1 = min(answer1,
                      {abs((str.back() + shift1) % h - (str.front() + shift1) % h) + 1, shift1});
    }
    for (long i = 0; i < st.size(); ++i) {
        shift2 += w - (st.back() + shift2) % w;
        if (shift2 >= w)
            break;
        st.push_front(st.back());
        st.pop_back();
        answer2 = min(answer2,
                      {abs((st.back() + shift2) % w - (st.front() + shift2) % w) + 1, shift2});
    }
    reverse(str1.begin(), str1.end());
    reverse(st1.begin(), st1.end());
    for (long i = 0; i < str1.size(); ++i) {
        str1[i] = h - 1 - str1[i];
    }
    for (long i = 0; i < st1.size(); ++i) {
        st1[i] = w - 1 - st1[i];
    }
    6
    6
    2
    1
    1
    6
    5
    st.clear();
    str.clear();
    for (auto u: str1)
        str.push_back(u);
    for (auto u: st1)
        st.push_back(u);
    shift1 = shift2 = 0;
    for (long i = 0; i < str.size(); ++i) {
        shift1 += h - (str.back() + shift1) % h;
        if (shift1 >= h)
            break;
        str.push_front(str.back());
        str.pop_back();
        answer1 = min(answer1,
                      {abs((str.back() + shift1) % h - (str.front() + shift1) % h) + 1, shift1});
    }
    for (long i = 0; i < st.size(); ++i) {
        shift2 += w - (st.back() + shift2) % w;
        if (shift2 >= w)
            break;
        st.push_front(st.back());
        st.pop_back();
        answer2 = min(answer2,
                      {abs((st.back() + shift2) % w - (st.front() + shift2) % w) + 1, shift2});
    }
    long long answer3 = answer1.second + answer2.second;
    cout << answer1.first * answer2.first << " " << answer3 << endl;
    return 0;
}