#include <iostream>
#include <vector>
#include <array>
#include <algorithm>
#include <set>

using namespace std;


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    long n, q;
    cin >> n >> q;
    vector<long long> w(n);
    for (long i = 0; i < n; ++i) {
        cin >> w[i];
    }
    long z;
    cin >> z;
    sort(w.begin(), w.end());
    long a = 300, b = 300;
    vector<vector<bool>> dp(a + 1, vector<bool>(b + 1, false));
    dp[0][0] = true;
    for (auto u: w) {
        for (long i = a; i >= 0; --i) {
            if (i - u < 0)
                break;
            for (long j = b; j >= 0; --j) {
                if (dp[i - u][j])
                    dp[i][j] = dp[i - u][j];
            }
        }
        for (long i = a; i >= 0; --i) {
            for (long j = b; j >= 0; --j) {
                if (j - u < 0)
                    continue;
                if (dp[i][j - u])
                    dp[i][j] = dp[i][j - u];
            }
        }
    }
    vector<vector<long>> pref(a + 1, vector<long>(b + 1, 0));
    for (long i = 0; i <= a; ++i) {
        for (long j = 0; j <= b; ++j) {
            pref[i][j] = dp[i][j];
            if (i + j == 0)
                continue;
            if (i - 1 >= 0 && j - 1 >= 0) {
                pref[i][j] += pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1];
            } else if (i - 1 >= 0) {
                pref[i][j] += pref[i - 1][j];
            } else {
                pref[i][j] += pref[i][j - 1];
            }
        }
    }
    for (long i = 0; i < q; ++i) {
        long j, c, d;
        cin >> j >> c >> d;
        if (pref[c][d] == (c + 1) * (d + 1))
            cout << "Yes" << endl;
        else
            cout << "No" << endl;
    }
    return 0;
}
