#include <bits/stdc++.h>
#define size(a) int(a.size())
#define all(a) a.begin(), a.end()
using namespace std;
//using ll = long long;

void solve() {
  int n;
  cin >> n;
  vector<int> l(n), r(n);
  for (int i = 0; i < n; ++i) {
    cin >> l[i] >> r[i];
  }
  vector<unordered_set<int>> g(n);
  for (int i = 0; i < n; ++i) {
    for (int j = i + 1; j < n; ++j) {
      if ((l[i] <= l[j] && l[j] <= r[i]) || (l[i] <= r[j] && r[j] <= r[i])) {
        g[i].insert(j);
        g[j].insert(i);
      }
    }
  }
  vector<int> del(n);
  auto gg = g;
  while (true) {
    int most = 0;
    for (int i = 1; i < n; ++i) {
      if (size(gg[i]) > size(gg[most])) {
        most = i;
      }
    }
    if (gg[most].empty()) {
      break;
    }
    for (int x : gg[most]) {
      gg[x].erase(most);
    }
    gg[most].clear();
    del[most] = 1;
  }
  vector<int> b;
  for (int i = 0; i < n; ++i) {
    if (!del[i]) {
      b.push_back(i);
    }
  }
  assert(size(b) % 2 == 0);
  vector<int> take(n);
  for (int i = 0; i < size(b) / 2; ++i) {
    cout << b[i] + 1 << ' ';
    take[b[i]] = 1;
  }
  int need = n / 2 - size(b) / 2;
  for (int i = 0; i < size(b) / 2; ++i) {
    for (int x : g[b[i]]) {
      if (need == 0) break;
      if (!take[x]) {
        cout << x + 1 << ' ';
        take[x] = 1;
        need -= 1;
      }
    }
  }
  cout << '\n';
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt;
  cin >> tt;
  while (tt--) {
    solve();
  }
  return 0;
}