#include <bits/stdc++.h>
using namespace std;
// #define int long long
#define dbg(x) cout << (#x) << ": " << x << endl;
#define dbga(x, l, r) cout << (#x) << ": "; for (int _=l;_<r;_++) cout << x[_] << " "; cout << endl;
#define pb push_back
const int N = 1e6+9;
int n, k, q;
vector<int> zap[N];
int res[N], l[N], r[N], sz[N];
int d[N];
mt19937 rnd(228);
struct node
{
	int x, y, sz, cnt;
	node *l=0,*r=0;
	node(int xx)
	{
		x = xx;
		y = rnd();
		sz = 1;
		cnt = 1;
	}
};
node *root0[N], *root1[N];
int get_sz(node *t) {return t ? t->sz : 0;}
void upd(node *t) {t->sz = t->cnt + get_sz(t->l) + get_sz(t->r);}
void merge(node *l, node *r, node *&t)
{
	if (!l || !r) t = l ? l : r;
	else if (l->y > r->y) merge(l->r, r, l->r), t = l, upd(t);
	else merge(l, r->l, r->l), t = r, upd(t);
}
void split(node *t, int k, node *&l, node *&r)
{
	if (!t) l = r = 0;
	else if (t->x <= k) split(t->r, k, t->r, r), l = t, upd(l);
	else split(t->l, k, l, t->l), r = t, upd(r);
}
void go(node *t, vector<int>&v)
{
	if (!t) return;
	go(t->l, v);
	v.pb(t->x);
	go(t->r, v);
}
void insert(node *&t, int x)
{
	if (!t) t = new node(x);
	else if (t->x == x) t->cnt++, t->sz++;
	else insert(t->x < x ? t->r : t->l, x), upd(t);
}
void print(node *t, bool ok=0)
{
	if (!t) return;
	print(t->l);
	cout << t->x << " ";
	print(t->r);
	if (ok) cout << endl;
}
int dop0[N], dop1[N];
void dfs(int v, int son=0)
{
	sz[v] = 1;
	if (l[v]) d[l[v]] = d[v] + (son == 1), dfs(l[v], -1), sz[v] += sz[l[v]];
	if (r[v]) d[r[v]] = d[v] + (son == -1), dfs(r[v], 1), sz[v] += sz[r[v]];
	if (sz[v] == 1)
	{
		root0[v] = new node(0);
		return;
	}
	else
	{
		if (sz[l[v]] > sz[r[v]])
		{
			root0[v] = root0[l[v]];
			root1[v] = root1[l[v]];
			dop0[v] = dop0[l[v]];
			dop1[v] = dop1[l[v]];
			if (son == -1)
			{
				dop1[v]++;
			}
			else
			{
				dop0[v]++;
			}
			vector<int> v0, v1;
			go(root0[r[v]], v0);
			go(root1[r[v]], v1);
			for (int x: v0)
			{
				insert(root1[v], x + 1 + dop0[r[v]] - dop1[v]);
			}
			for (int x: v1)
			{
				insert(root1[v], x + dop1[r[v]] - dop1[v]);
			}
		}
		else
		{
			root0[v] = root0[r[v]];
			root1[v] = root1[r[v]];
			dop0[v] = dop0[r[v]];
			dop1[v] = dop1[r[v]];
			if (son == 1)
			{
				dop0[v]++;
			}
			else
			{
				dop1[v]++;
				dbg("tut");
			}
			dbg(get_sz(root0[v]));
			dbg(get_sz(root1[v]));
			vector<int> v0, v1;
			go(root0[l[v]], v0);
			go(root1[l[v]], v1);
			for (int x: v0)
			{
				dbg(x);
				insert(root0[v], x + dop0[l[v]] - dop0[v]);
			}
			for (int x: v1)
			{
				dbg(x);
				insert(root0[v], x + 1 + dop1[l[v]] - dop0[v]);
			}
			dbg(get_sz(root0[v]));
			dbg(get_sz(root1[v]));
		}
		if (zap[v].size())
		{
			int ans = 0;
			node *vv;
			split(root0[v], k - dop0[v] - d[v], vv, root0[v]);
			ans += get_sz(vv);
			merge(vv, root0[v], root0[v]);
			split(root1[v], k - dop1[v] - d[v], vv, root1[v]);
			ans += get_sz(vv);
			merge(vv, root1[v], root1[v]);
			for (int o: zap[v]) res[o] = ans;
		}
	}
	dbg(v + 1);
	dbg(dop0[v]);
	dbg(dop1[v]);
	print(root0[v], 1);
	print(root1[v], 1);
}
signed main()
{
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	cin >> n >> k >> q;
	for (int i=0;i<n;i++)
	{
		int t;
		cin >> t;
		l[i] = r[i] = 0;
		if (t == 2) cin >> l[i] >> r[i], l[i]--, r[i]--;
	}
	for (int o=0;o<q;o++)
	{
		int u;
		cin >> u;
		u--;
		zap[u].pb(o);
	}
	dfs(0);
	dbga(d,0,n);
	for (int i=0;i<q;i++) cout << res[i] << "\n";
}