#include <iostream>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
using namespace std;

const int inf = 1e18;

void solve1() {
    int m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        int n, k;
        cin >> n >> k;
        vector<int> arr(k);
        for (int& i : arr) cin >> i;
        set<int> used;
        for (int i : arr) {
            used.insert(i);
        }
        vector<int> res;
        for (int i : arr) {
            int j = i;
            while (j <= n && used.count(j)) ++j;
            if (j <= n) {
                res.push_back(j);
                used.insert(j);
            } else {
                j = i;
                while (used.count(j)) --j;
                res.push_back(j);
                used.insert(j);
            }
        }
        for (int i : res) {
            cout << i << ' ';
        }
        cout << endl;
    }
}

void solve2() {
    int m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        int n, k;
        cin >> n >> k;
        vector<int> nxt, prv;
        vector<int> a(k);
        for (int& x : a) cin >> x;
        for (int i = 0; i + 1 < k; ++i) {
            if (a[i] > a[i + 1]) {
                for (int j = i + 1; j < k; ++j) {
                    prv.push_back(a[j]);
                }
                for (int j = 0; j <= i; ++j) {
                    nxt.push_back(j);
                }
                break;
            }
        }
        if (prv.empty()) {
            nxt = a;
        }
        set<int> used;
        for (int i : a) {
            used.insert(i);
        }
        vector<int> res;
        for (int i : nxt) {
            int j = i;
            while (used.count(j)) --j;
            res.push_back(j);
            used.insert(j);
        }
        for (int i : prv) {
            int j = i;
            while (used.count(j)) ++j;
            res.push_back(j);
            used.insert(j);
        }
        for (int i : res) {
            cout << i << ' ';
        }
        cout << endl;
    }
}

int32_t main() {
    int t;
    cin >> t;
    if (t == 1) {
        solve1();
    } else {
        solve2();
    }
}
