#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <set>
#include <map>
#include <deque>
#include <cmath>

using namespace std;

typedef long long ll;

#define all(x) x.begin(), x.end()

void solve(void) {
	ll h, w;
	int k;
	cin >> h >> w >> k;
	vector<ll> H(k), W(k), byh, byw;
	for (int i = 0; i < k; ++i) {
		cin >> H[i] >> W[i];
		byh.push_back(H[i]);
		byw.push_back(W[i]);
	}
	sort(all(byh));
	sort(all(byw));
	ll mxh = -1, mnh = -1;
	ll mxw = -1, mnw = -1;
	for (int i = 0; i + 1 < k; ++i) {
		ll hnw = byh[1 + i] - byh[i] - 1;
		ll mnhnw = min(byh[i], h + 1 - byh[i + 1]);
		if (hnw > mxh || (hnw == mxh && mnhnw < mnh)) {
			mxh = hnw;
			mnh = mnhnw;
		}
		ll wnw = byw[1 + i] - byw[i] - 1;
		ll mnwnw = min(byw[i], w + 1 - byw[i + 1]);
		if (wnw > mxw || (wnw == mxw && mnwnw < mnw)) {
			mxw = wnw;
			mnw = mnwnw;
		}
	}
	if ((byh[0] + h - byh[k - 1] - 1) >= mxh) {
		mxh = byh[0] + h - byh[k - 1] - 1;
		mnh = 0;
	}
	if ((byw[0] + w - byw[k - 1] - 1) >= mxw) {
		mxw = byw[0] + w - byw[k - 1] - 1;
		mnw = 0;
	}
	ll hh = h - mxh;
	ll ww = w - mxw;
	cout << hh * ww << ' ' << mnh + mnw << '\n';
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1; //cin >> t;
	while (t--) {
		solve();
	}
}
