#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <set>
#include <map>
#include <deque>
#include <cmath>

using namespace std;

typedef long long ll;

#define all(x) x.begin(), x.end()

void solve() {
	int n; cin >> n;
	vector<int> p(n);
	for (int i = 0; i < n; ++i) {
		cin >> p[i];
	}
	vector<vector<int>> dp(n + 2, vector<int>(n + 2, -1));
	vector<vector<int>> ndp = dp;
	dp[0][n + 1] = 0;
	for (int nxt = 0; nxt < n; ++nxt) {
		for (int i = 0; i <= n + 1; ++i) {
			for (int j = 0; j <= n + 1; ++j) {
				ndp[i][j] = -1;
			}
		}
		for (int mx = 0; mx <= n; ++mx) {
			for (int mn = 1; mn <= n + 1; ++mn) {
				if (dp[mx][mn] == -1) {
					continue;
				}
				int val = dp[mx][mn];
				if (p[nxt] < mx || p[nxt] > mn) {
					ndp[mx][mn] = max(ndp[mx][mn], val);
				}
				if (p[nxt] > mx) {
					ndp[p[nxt]][mn] = max(ndp[p[nxt]][mn], val + 1);
				}
				if (p[nxt] < mn) {
					ndp[mx][p[nxt]] = max(ndp[mx][p[nxt]], val + 1);
				}
			}
		}
		dp = ndp;
	}
	vector<int> dp1(n, 0), dp2(n, 0);
	int mx1 = 0, mx2 = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < i; ++j) {
			if (p[j] < p[i]) {
				dp1[i] = max(dp1[i], dp1[j]);
			} else {
				dp2[i] = max(dp2[i], dp2[j]);
			}
		}
		++dp1[i];
		++dp2[i];
		mx1 = max(mx1, dp1[i]);
		mx2 = max(mx2, dp2[i]);
	}

	int ans = 0;
	for (int i = 0; i <= n + 1; ++i) {
		for (int j = 0; j <= n + 1; ++j) {
			ans = max(ans, dp[i][j]);
		}
	}
	if (ans != mx1 + mx2 && ans != mx1 + mx2 - 1) {
		while (true) {

		}
	}
	cout << ans << '\n';
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1; cin >> t;
	while (t--) {
		solve();
	}
}
