#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <deque>
#include <iomanip>

using namespace std;

typedef long long ll;

#define all(x) x.begin(), x.end()

void solve() {
	int n, q; cin >> n >> q;
	vector<ll> w(n);
	for (int i = 0; i < n; ++i) {
		cin >> w[i];
	}
	ll _; cin >> _;
	sort(all(w));
	map<pair<ll, ll>, ll> dst;
	for (int mask = 0; mask < (1 << n); ++mask) {
		vector<int> not_used;
		ll a = 0;
		ll mx = 0;
		for (int i = 0; i < n; ++i) {
			if (((mask >> i) & 1)) {
				a += w[i];
				mx = max(mx, w[i]);
			} else {
				not_used.push_back(i);
			}
		}
		for (int mask2 = 0; mask2 < (1 << (int)not_used.size()); ++mask2) {
			ll b = 0;
			ll mx2 = 0;
			for (int i = 0; i < (int)not_used.size(); ++i) {
				if (((mask2 >> i) & 1)) {
					b += w[not_used[i]];
					mx2 = max(mx2, w[not_used[i]]);
				}
			}
			if (dst[{a, b}] == 0) {
				dst[{a, b}] = max(mx, mx2) + 1;
			} else {
				dst[{a, b}] = min(dst[{a, b}], max(mx, mx2) + 1);
			}
		}
	}
	for (int i = 0; i < q; ++i) {
		ll k, a, b; cin >> k >> a >> b; k += 1LL;
		bool y = false;
		for (ll A = 0; A <= a; ++A) {
			for (ll B = 0; B <= b; ++B) {
				if (dst[{ A, B }] == 0) {
					y = true;
					break;
				}
				if (dst[{ A, B }] > k) {
					y = true;
					break;
				}
			}
			if (y) {
				break;
			}
		}
		if (y) {
			cout << "No\n";
		} else {
			cout << "Yes\n";
		}
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1; //cin >> t;
	while (t--) {
		solve();
	}
}
