#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>
#include <set>
#include <assert.h>
#include <bitset>
typedef long long ll;
using namespace std;
bitset <5001> dp[5001];
int sum[5001][5001];
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int n, q; cin >> n >> q;
	vector <int> a(n);
	for (int i = 0; i < n; i++) cin >> a[i];
	sort(a.begin(), a.end());
	dp[0][0] = 1;
	ll pl = 0, xst = 5000, yst = 5000;
	for (int i = 0; i < n; i++) {
		for (int x = 5000; x >= 0; x--) {
			if (x >= a[i]) dp[x] = (dp[x] | dp[x - a[i]]);
		}
	}
	for (int i = 0; i <= 5000; i++) {
		for (int j = 0; j <= 5000; j++) {
			if (dp[i][j]) dp[j][i] = 1;
		}
	}
	sum[0][0] = 1;
	for (int i = 0; i <= 5000; i++) {
		for (int j = 0; j <= 5000; j++) {
			if (!i && !j) continue;
			if (i) sum[i][j] += sum[i - 1][j];
			if (j) sum[i][j] += sum[i][j - 1];
			if (i && j) sum[i][j] -= sum[i - 1][j - 1];
			if (dp[i][j]) sum[i][j]++;
		}
	}
	int z; cin >> z;
	while (q--) {
		ll k, a, b; cin >> k >> a >> b;
		if (sum[a][b] == (a + 1) * (b + 1)) cout << "Yes\n";
		else cout << "No\n";
	}
	return 0;
}