#ifdef AVEVAD
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("Ofast")
#pragma GCC targe("avx,avx2,sse,sse2,abm,mmx,popcnt")
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

ll fact(ll n) {
    ll ans = 1;
    for (; n; n--) ans *= n;
    return ans;
}

ll comb(ll n, ll k) {
    return fact(n) / fact(k) / fact(n - k);
}

ll order(ll m, const vector<ll> &a) {
    ll ans = 0, pr = -1;
    for (ll pos = 0; pos < ll(a.size()); pos++) {
        ll e = a[pos];
        for (ll e1 = pr + 1; e1 < e; e1++) {
            ans += comb(m - e1, ll(a.size()) - pos - 1);
        }
        pr = e;
    }
    return ans;
}

vector<ll> kick(const vector<ll> &a, const vector<ll> &b) {
    vector<ll> c;
    ll i = 0, j = 0;
    while (i != ll(a.size()) || j != ll(b.size())) {
        if (i == ll(a.size()) || j != ll(b.size()) && b[j] < a[i]) {
            j++;
        } else {
            c.push_back(a[i] - j);
            i++;
        }
    }
    return c;
}

int main() {
#ifndef AVEVAD
    cin.tie(0);
    ios_base::sync_with_stdio(0);
#endif
    ll tp;
    cin >> tp;
    ll T;
    cin >> T;
    while (T--) {
        ll n, m;
        cin >> m >> n;
        vector<ll> a(n);
        for (ll &i: a) cin >> i, i--;
        ll t = 0;
        for (ll i: a) t |= 1ll << i;
        vector<ll> last_ans;
        ll kek = 0;
        for (ll g = 0; g < (1ll << m); g++) {
            if (t & g) continue;
            if (__builtin_popcountll(t) != __builtin_popcount(g)) continue;
            vector<ll> b;
            for (ll i = 0; i < m; i++) if (g >> i & 1) b.push_back(i);
            if (order(m - n, kick(a, b)) == order(m - n, kick(b, a))) {
                if (tp == 1) {
                    if (!kek) {
                        for (ll e: b) cout << e + 1 << ' ';
                        cout << '\n';
                        kek = 1;
                    }
                } else {
                    last_ans = b;
                }
            }
        }
        if (tp == 2) {
            for (ll e: last_ans) cout << e + 1 << ' ';
            cout << '\n';
        }
    }
}
