#include "bits/stdc++.h"


using namespace std;
using ll = long long;

#define FAST_IO ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)

int k, n, p, ans;
vector<int> datas;


int find_mex(vector<int>& v) {
	vector<bool> used(1 << k + 1, 0);
	for (auto it : v) used[it] = true;
	for (int i = 0; i < used.size(); ++i) if (!used[i]) return i;
	return used.size();
}


void check() {
	vector<int> data_copy = datas;
	int m = find_mex(data_copy);
	int lastm = m;
	int cnt = 0;
	int iters = 0;
	while (cnt < 15) {
		for (auto& it : data_copy) it ^= m - 1;
		m = find_mex(data_copy);
		if (m == lastm) ++cnt;
		else {
			lastm = m;
			cnt = 0;
		}
		if (++iters > 102) return;
	}
	if (lastm == p) ++ans;
}


void recursive(int ind, int last) {
	if (ind == n) {
		check();
		return;
	}
	for (int i = last + 1; i < (1 << k); ++i) {
		datas[ind] = i;
		recursive(ind + 1, i);
	}
}


int main() {
	FAST_IO;
	int m;
	cin >> m;
	int t;
	for (cin >> t; t; --t) {
		cin >> k >> n >> p;
		ans = 0;
		datas = vector<int>(n);
		datas[0] = 0;
		recursive(1, 0);
		cout << ans << endl;
	}
}