#include <bits/stdc++.h>
#define int long long

using namespace std;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, q;
    cin >> n >> q;
    vector<int> w(n);
    for (int i = 0; i < n; i++)
        cin >> w[i];
    int z;
    cin >> z;
    vector<vector<vector<bool>>> dp(w.size() + 1, vector<vector<bool>> (1501, vector<bool> (1501)));
    dp[0][0][0] = true;
    set<pair<int, int>> next = {{0, 0}}, pred;
    for (int i = 0; i < w.size(); i++) {
        pred = next;
        next = {};
        for (auto [j, t] : pred) {
            if (!dp[i][j][t])
                continue;
            dp[i + 1][j][t] = true;
            next.insert({j, t});
            if (j + w[i] <= 1501) {
                dp[i + 1][j + w[i]][t] = true;
                next.insert({j + w[i], t});
            }
            if (t + w[i] <= 1501) {
                dp[i + 1][j][t + w[i]] = true;
                next.insert({j, t + w[i]});
            }    
        }
    }
    vector<vector<int>> pref(1501, vector<int> (1501, 0));
    for (int i = 0; i <= 1501; i++) {
        for (int j = 0; j <= 1501; j++) {
            pref[i + 1][j + 1] = pref[i][j + 1] + pref[i + 1][j] - pref[i][j] + dp[w.size()][i][j];
        }
    }
    while (q--) {
        int k, a, b;
        cin >> k >> a >> b;
        if (pref[a + 1][b + 1] == (a + 1) * (b + 1))
            cout << "Yes\n";
        else
            cout << "No\n";
    }
}