#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const ll infll = 1000000000000000000 + 1;
template<typename T>
bool chmax(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}
void solve_case() {
    int n, q;
    cin >> n >> q;
    ll x, y, m;
    cin >> x >> y >> m;
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<int> l(n), r(n);
    for (int i = 0; i < n; i++) cin >> l[i] >> r[i];
    vector<ll> v(q);
    for (int i = 0; i < q; i++) cin >> v[i];
    vector<vector<ll>> dp(n, vector<ll>(2));
    function<void(int, int)> dfs = [&](int v, int par) {
        dp[v][1] += l[v];
        for (int u : g[v]) {
            if (u == par) continue;
            dfs(u, v);
            dp[v][1] += dp[u][0];
            dp[v][0] += max(dp[u][1], dp[u][0]);
        }
    };
    dfs(0, 0);
    ll zxc = max(dp[0][0], dp[0][1]);
    ll hash = 0;
    for (int i = 0; i < n; i++) {
        hash ^= ((1ll * x * (i + 1) % m) + 1ll * y * (1ll * l[i] * l[i] % m) % m) % m;
    }
    for (int i = 0; i < q; i++) {
        if (v[i] == zxc) {
            cout << hash << " ";
        } else {
            cout << -1 << " ";
        }
    }
    cout << endl;
    int foo;
    while (cin >> foo) {
        foo--;
        if (foo == -1) break;
        if (v[foo] != zxc) {
            cout << -1 << endl;
        } else {
            for (int i = 0; i < n; i++) {
                cout << l[i] << " ";
            }
            cout << endl;
        }
    }
}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    //freopen("inputik.txt", "r", stdin);
#endif
    int T = 1;
    cin >> T;
    while (T--) {
        solve_case();
    }
}