#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <deque>

using namespace std;
typedef long long ll;
#define endl '\n'

const int N = 200010;

int n;

inline int stup(vector <int> A)
{
	n = A.size();

	int an = 0;

	for (int musk = 0; musk < (1 << n); ++musk)
	{
		vector <int> x, y;
		for (int j = 0; j < n; ++j)
		{
			if ((musk >> j) & 1) x.push_back(A[j]);
			else y.push_back(A[j]);
		}
		int ans = 0;
		int mx = 0;
		for (auto i : x)
		{
			ans += i > mx;
			mx = max(mx, i);
		}
		int mn = n + 1;
		for (auto i : y)
		{
			ans += i < mn;
			mn = min(mn, i);
		}

		an = max(an, ans);
	}

	return an;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	
	int t;
	cin >> t;
	while (t--)
	{
		int n;
		cin >> n;
		vector <int> A(n);
		for (auto& i : A) cin >> i;
		auto got = stup(A);
		cout << got << endl;
	}

	return 0;
}