#if !defined(SSLOCAL) && 0
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#endif

#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
constexpr int INF = int(1e9) + 7;
constexpr ll LLINF = ll(2e18) + 13;

ll h, w;
int k;

template<typename T> inline bool smin(T&a, T b) {
  if (b < a) {
    a = b;
    return true;
  }
  return false;
}
template<typename T> inline bool smax(T&a, T b) {
  if (a < b) {
    a = b;
    return true;
  }
  return false;
}

void run(const vector<ll> & crd, vector<ll> & lt, vector<ll> & rt) {
  function<void(ll, ll, ll, bool)> set_max = [&set_max, &lt, &rt](ll l, ll r, ll val, bool left) {
    if (r < l) {
      set_max(l, w, val, left);
      set_max(0, r, val, left);
      return;
    }
    if (left) {
      for (ll i = l; i < r; ++i) {
        lt[i] = max(lt[i], val);
      }
    } else {
      for (ll i = l; i < r; ++i) {
        rt[i] = max(rt[i], val);
      }
    }
  };


  for (int i = 1; i < k; ++i) {
    int x = i, y = 0;
    if (crd[x] > crd[y]) swap(x, y);
    ll dx = crd[y] - crd[x];
    ll dx2 = crd[x] + w - crd[y];
    set_max(0, w - crd[y], dx, y == 0);
    set_max(w - crd[y], w - crd[x], dx2, x == 0);
    set_max(w - crd[x], w, dx, y == 0);
  }

}

int main() {
  ios_base::sync_with_stdio(0); cin.tie(0);

  cin >> h >> w >> k;
  vector<pair<ll, ll>> a(k);
  vector<ll> r(k), c(k);
  for (int i = 0; i < k; ++i) {
    cin >> r[i] >> c[i]; --r[i], --c[i];
  }

  vector<ll> lt(w), rt(w);
  run(c, lt, rt);
  ll ans_x = LLINF, shift;
  for (int i = 0; i < w; ++i) {
    if (lt[i] + rt[i] + 1 < ans_x) {
      ans_x = lt[i] + rt[i] + 1;
      shift = i;
    }
  }
  cout << ans_x << ' ' << min(shift, w - shift) << endl;

  return 0;
}
