#if !defined(SSLOCAL) && 0
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#endif

#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
constexpr int INF = int(1e9) + 7;
constexpr ll LLINF = ll(2e18) + 13;

template<typename T> inline bool smin(T&a, T b) {
  if (b < a) {
    a = b;
    return true;
  }
  return false;
}
template<typename T> inline bool smax(T&a, T b) {
  if (a < b) {
    a = b;
    return true;
  }
  return false;
}

int lno;

void Solve() {
  int n, k;
  cin >> n >> k;
  vector<int> a(k);
  for (int & el : a) cin >> el;
  if (k * 2 == n) {
    vector<int> b;
    for (int i = 0, j = 0; i < n; ++i) {
      while (j < (int)a.size() && a[j] < i + 1) ++j;
      if (j == a.size() || a[j] != i + 1) b.push_back(i + 1);
    }
    for (int x : b) cout << x << ' ';
    cout << endl;
    return;
  }
  if (k == 1) {
    int x = a[0] - 1;
    if (lno == 1) ++x;
    else --x;
    x = (x + n) % n;
    cout << x + 1 << endl;
  }
}

int32_t main() {
  ios_base::sync_with_stdio(0); cin.tie(0);

  int T;
  cin >> lno >> T;
  while (T--) Solve();

  return 0;
}
