//
// ВАСЯ ФЕДОРОВ ЛОХ АХВХАВХАХВАХВХВХА
//
//#pragma GCC optimize("Ofast,no-stack-protector")
//#pragma GCC target("bmi,bmi2,sse,sse2,sse3,sse4,ssse3,mmx,lzcnt,popcnt,tune=native")
#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

vector<pair<int, int>> seg;


bool intersect(int a, int b) {
    if (seg[a].first > seg[b].second || seg[b].first > seg[a].second) {
        return false;
    }
    return true;
}


int findSet(vector<int> &pos) {
    int n = (int) pos.size();
    vector<int> d(n);
    vector<unordered_set<int>> p(n);
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (intersect(pos[i], pos[j])) {
                d[i]++;
                p[i].insert(j);
                d[j]++;
                p[j].insert(i);
            }
        }
    }

    set<pair<int, int>> s;
    for (int i = 0; i < n; i++) {
        s.insert({d[i], i});
    }
    int res = 0;
    while (!s.empty()) {
        auto pr = *s.begin();
        res++;
        for (int i: p[pr.second]) {
            for (int j: p[i]) {
                if (j == pr.second) continue;
                s.erase({d[j], j});
                d[j]--;
                s.insert({d[j], j});
                p[j].erase(i);
            }
            s.erase({d[i], i});
        }
        s.erase(pr);
    }
    return res;
}


void solve() {
    int n;
    cin >> n;
    seg.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> seg[i].first >> seg[i].second;
    }
    vector<int> tmp(n);
    iota(tmp.begin(), tmp.end(), 0);
    int m = findSet(tmp);
    for (int mask = 0; mask < (1 << n); mask++) {
        tmp.clear();
        for (int i = 0; i < n; i++) {
            if (mask & (1 << i)) tmp.push_back(i);
        }
        if (tmp.size() != n / 2) continue;
        int k = findSet(tmp);
        if (k == m / 2) {
            for (int i: tmp) {
                cout << i + 1 << ' ';
            }
            return;
        }
    }
    exit(-1);
}

int main() {
    int t = 1;
#ifdef LOCAL
    freopen("b.in", "r", stdin);
#endif
    cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
}