#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <random>
#include <map>
#include <iomanip>

using namespace std;

typedef long long ll;
typedef long double ld;

const int mxn = (int)210;

#define all(x) begin(x), end(x)
#define int ll
int mex(vector<int>& a) {
	int n = a.size();
	vector<int> used(n);
	for (int i = 0; i < a.size(); i++) {
		if (a[i] >= n) continue;
		used[a[i]] = 1;
	}
	for (int i = 0; i < n; i++) {
		if (!used[i]) return i;
	}
	return n;
}

vector<int> go(vector<int>& a) {
	int n = a.size();
	vector<int> b(n);
	int m = mex(a) - 1;
	for (int i = 0; i < n; i++) {
		b[i] = a[i] ^ m;
	}
	sort(all(b));
	return b;
}

int check(vector<int> a) {
	int n = a.size();
	vector<int> used(n + 1);
	int lst = mex(a);
	while (1) {
		vector<int> nc = go(a);
		if (mex(nc) < lst && mex(nc) != a.size()) {
			exit(1);
		}
		if (mex(nc) == lst) return lst;
		used[mex(nc)]++;
		if (used[mex(nc)] > 2) return -1;
		lst = mex(nc);
		a = nc;
	}
}

int mod;

void solve() {
	int k, n, p;
	cin >> k >> n >> p;
	int ans = 0;
	for (int i = 1; i < (1ll << (1ll << k)); i += 2) {
		vector<int> a;
		for (int j = 0; j < (1ll << k); j++) {
			if (i >> j & 1) {
				a.push_back(j);
			}
		}
		if (a.size() != n) continue;
		if (check(a) == p) {
			ans += 1;
		}
	}
	cout << (ans) % mod << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> mod;
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}