//#pragma GCC optimze("O3,unroll-loops,Ofast")

#include <bits/stdc++.h>

using namespace std;

#define all(a) a.begin(), a.end()

typedef long long ll;
typedef string str;
mt19937 rnd(157);
#define int long long

vector<vector<int>> g;
vector<int> wei;
vector<vector<int>> dp;

void dfs(int v, int p) {
    int sum = 0;
    int sum2 = 0;
    for(int u : g[v]) {
        if(u != p)
            dfs(u, v);
        sum += max(dp[u][1], dp[u][0]);
        sum2 += dp[u][0];
    }
    dp[v][0] = sum;
    dp[v][1] = sum2 + wei[v];
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    for(int _ = 0; _ < t; _++) {
        int n, q;
        cin >> n >> q;
        int x, y, m;
        cin >> x >> y >> m;
        g.clear();
        g.resize(n);
        dp.clear();
        dp.resize(n, vector<int> (2, 0));
        for(int i = 0; i < n - 1; i++) {
            int u, v;
            cin >> u >> v;
            u--;
            v--;
            g[v].push_back(u);
            g[u].push_back(v);
        }
        wei.clear();
        wei.resize(n);
        for(int i = 0; i < n; i++) {
            int l, r;
            cin >> l >> r;
            wei[i] = l;
        }
        vector<int> que(q);
        for(int i = 0; i < q; i++) {
            cin >> que[i];
        }
        dfs(0, 0);
        int ans = max(dp[0][0], dp[0][1]);
        int k = 0;
        for(int i = 1; i <= n; i++) {
            k ^= (x * i + y * wei[i - 1] * wei[i - 1]) % m;
        }
        vector<int> anses(q);
        for(int i = 0; i < q; i++) {
            if(que[i] != ans) {
                cout << -1 << ' ';
                anses[i] = -1;
            } else {
                anses[i] = k;
                cout << k << ' ';
            }
        }
        cout << endl;
        int ind;
        cin >> ind;
        while(ind != 0) {
            ind--;
            if(anses[ind] == -1) {
                cout << -1 << endl;
            } else {
                for(int i = 0; i < n; i++) {
                    cout << wei[i] << ' ';
                }
                cout << endl;
            }
            cin >> ind;
        }
    }
}

