#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct event {
    int l, r, i;

    bool operator<(event b) {
        return pair<int, int>{l, -r} < pair<int, int>{b.l, -b.r};
    }
};

ll get(vector<pair<ll, ll>> h) {
    std::sort(h.begin(), h.end());
    vector<ll> dp(h.size() + 1, 1e9);
    dp[0] = -1;
    for (auto el : h){
        auto it = std::lower_bound(dp.begin(), dp.end(), el.second);
        it--;
        if (*it < el.first){
            it++;
            dp[it - dp.begin()] = el.second;
        }
    }
    ll maxx = 0;
    for (int i = h.size(); i > -1; i--){
        if (dp[i] != 1e9){
            return i;
        }
    }
    return maxx;
}

void solve() {
    int n;
    cin >> n;
    vector<event> had(n);
    map<ll, ll> ussss;
    for (int i = 0; i < n; i++) {
        cin >> had[i].l >> had[i].r;
        had[i].i = i;
        ussss[had[i].l] = 1;
        ussss[had[i].r] = 1;
    }
    int ind = 0;
    for (auto &el : ussss){
        el.second = ind++;
    }
    for(auto &el : had){
        el.r = ussss[el.r];
        el.l = ussss[el.l];
    }
    std::sort(had.begin(), had.end());
    vector<event> stek;
    vector<ll> soot(n);
    vector<pair<ll, ll>> mine;
    for (int i = 0; i < n; i++) {
        if (!stek.empty() && stek.back().r >= had[i].r) {
            stek.pop_back();
        }
        stek.push_back(had[i]);
        mine.push_back({had[i].l, had[i].r});
    }
    for (int i = 0; i < n; i++) {
        soot[had[i].i] = i;
    }
    int min_l = -1;
    int m = get(mine);
    vector<vector<ll>> dp(n, vector<ll>(m / 2, 1e9));
    vector<vector<ll>> pred(n, vector<ll>(m / 2, -1));
    vector<ll> been;
    for (auto elee : stek) {
        int i = soot[elee.i];
        int cnt = 0;
        for (int j = 0; j < n; j++) {
            if (had[j].r < had[i].r) {
                cnt++;
            }
            if (m == 2 && had[j].l > had[i].r) {
                cnt++;
            }
        }
        dp[i][0] = cnt;
        int fffft = 100ll;
        if (fffft > been.size()){
            fffft = been.size();
        }
        for (int s = been.size() - fffft; s < been.size(); s++) {
            int j = been[s];
            int tr = 0;
            for (auto el: had) {
                if (had[j].r < el.l && el.r < had[i].r) {
                    tr++;
                }
            }
            for (int k = 0; k < m / 2 - 1; k++) {
                if (had[j].r < had[i].l) {
                    cnt = 0;
                    if (k == m / 2 - 2) {
                        for (auto el: had) {
                            if (had[j].r < el.l && el.r < had[i].r) {
                                cnt++;
                            }
                            if (k == m / 2 - 2 && el.l > had[i].r) {
                                cnt++;
                            }
                        }
                    } else {
                        cnt = tr;
                    }
                    dp[i][k + 1] = min(dp[i][k + 1], dp[j][k] + cnt);
                    if (dp[i][k + 1] == dp[j][k] + cnt) {
                        pred[i][k + 1] = j;
                    }
                }
            }
        }
        been.push_back(i);
    }
    int st = -1;
    for (int i = 0; i < n; i++) {
        if (dp[i][m / 2 - 1] <= n / 2) {
            st = i;
            break;
        }
    }
//    cout << m << endl;
    vector<ll> main_ans;
    vector<pair<ll, ll>> cheker;
    vector<bool> bad(n, false);
    for (int k = m / 2 - 1; k > -1; k--) {
        main_ans.push_back(st);
        bad[had[st].i] = true;
        st = pred[st][k];
    }
    std::reverse(main_ans.begin(), main_ans.end());
    for (int i = 0; i < main_ans.size(); i++) {
        if (i == 0) {
            for (int j = 0; j < n; j++) {
                if (had[j].r < had[main_ans[i]].r) {
                    bad[had[j].i] = true;
                }
                if (m == 2 && had[j].l > had[main_ans[i]].r) {
                    bad[had[j].i] = true;
                }
            }
        } else {
            for (auto el: had) {
                if (had[main_ans[i - 1]].r < el.l && el.r < had[main_ans[i]].r) {
                    bad[el.i] = true;
                }
                if (i == m / 2 - 1 && el.l > had[main_ans[i]].r) {
                    bad[el.i] = true;
                }
            }
        }
    }
    vector<ll> real_ans;
    for (auto el: main_ans) {
        real_ans.push_back(had[el].i);
        cheker.push_back({had[el].l, had[el].r});
    }
    for (int i = 0; i < n; i++) {
        if (!bad[i] && real_ans.size() != n / 2) {
            real_ans.push_back(i);
            cheker.push_back({had[soot[i]].l, had[soot[i]].r});
        }
    }
    for (auto el: real_ans) {
        cout << el + 1 << " ";
    }
    cout << "\n";


}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}