#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>

using namespace std;

typedef long long ll;

int ans = 0;

int mex(vector<int> pref) {
    sort(pref.begin(), pref.end());
    for (int j = 1; j < pref.size(); j++) {
        if (pref[j] != pref[j - 1] + 1) {
            return pref[j - 1] + 1;
        }
    }
    return pref.size();
}

vector<int> ultra(vector<int> arr) {
    vector<int> res;
    int m = mex(arr);
    for (auto el: arr) {
        res.push_back(el ^ (m - 1));
    }
    return res;
}

void gen(int k, int n, int p, int mod, vector<int> pref={}) {
    if (pref.size() == n) {
        int last1 = -1, last2 = -1;
        vector<int> arr = pref;
        for (int _ = 0; _ < 2; _++) {
            last1 = last2;
            last2 = mex(arr);
            arr = ultra(arr);
        }
        if (last1 == last2) {
            if (last2 == p) {
                ans++;
            }
        }
        return;
    }
    if (pref.empty()) {
        pref.push_back(0);
        gen(k, n, p, mod, pref);
        pref.pop_back();
    } else {
        for (int i = pref.back() + 1; i < (1 << k); i++) {
            pref.push_back(i);
            gen(k, n, p, mod, pref);
            pref.pop_back();
        }
    }
}


signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int mod;
    cin >> mod;
    int t;
    cin >> t;
    while (t--) {
        ans = 0;
        int k, n, p;
        cin >> k >> n >> p;
        gen(k, n, p, mod);
        cout << ans << '\n';
    }
}