#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <deque>
#include <string>
#define endl '\n'
#define ALL(v) begin(v),end(v)

using namespace std;

const int32_t MAXN = 1E5;

template <typename T>
bool rmin(T& x, const T& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T>
bool rmax(T& x, const T& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

bool used[100001];

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout << fixed << setprecision(13);

	int n, q;
	cin >> n >> q;
	vector <int64_t> mas(n);
	for (int i = 0; i < n; i++)
	{
		cin >> mas[i];
	}
	sort(ALL(mas));
	int64_t z;
	cin >> z;

	used[0] = true;
	for (int i = 0; i < n; i++)
	{
		for (int w = 0; w <= 100000; w++)
		{
			if (used[w] and w + mas[i] <= 100000)
			{
				used[w + mas[i]] = true;
			}
		}
	}

	int mex = 1E5 + 1;
	for (int i = 0; i < 100001; i++)
	{
		if (!used[i])
		{
			mex = i;
			break;
		}
	}

	while (q--)
	{
		int64_t k, a, b;
		cin >> k >> a >> b;
		
		if (a < mex)
		{
			cout << "Yes" << endl;
		}
		else
			cout << "No" << endl;
	}
}