#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <deque>
#include <string>
#define endl '\n'
#define ALL(v) begin(v),end(v)

using namespace std;

const int32_t MAXN = 1E5;

template <typename T>
bool rmin(T& x, const T& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T>
bool rmax(T& x, const T& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

bool used[301][301];
int mex[301];

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout << fixed << setprecision(13);

	int n, q;
	cin >> n >> q;
	vector <int64_t> mas(n);
	for (int i = 0; i < n; i++)
	{
		cin >> mas[i];
	}
	sort(ALL(mas));
	int64_t z;
	cin >> z;

	used[0][0] = true;
	for (int i = 0; i < n; i++)
	{
		for (int a = 300; a >= 0; a--)
		{
			for (int b = 300; b >= 0; b--)
			{
				if (used[a][b])
				{
					if (a + mas[i] <= 300)
					{
						used[a + mas[i]][b] = true;
					}
					if (b + mas[i] <= 300)
					{
						used[a][b + mas[i]] = true;
					}
				}
			}
		}
	}

	for (int i = 0; i <= 300; i++)
	{
		mex[i] = 301;
		for (int j = 0; j <= 300; j++)
		{
			if (!used[i][j])
			{
				mex[i] = j;
				break;
			}
		}
	}

	while (q--)
	{
		int64_t k, a, b;
		cin >> k >> a >> b;
		int mn = 301;
		for (int i = 0; i <= a; i++)
		{
			rmin(mn, mex[i]);
		}
		if (mn > b)
		{
			cout << "Yes" << endl;
		}
		else
			cout << "No" << endl;
	}
}