#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ui unsigned int
#define ld long double
#define mp make_pair
#define ff first
#define ss second
#define pii pair<int, int>
#define pil pair<int, long long>
#define pli pair<long long, int>
#define pll pair<long long, long long>
#define pb push_back
#define ppb pop_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define uset unordered_set
#define umap unordered_map

const int N = 501;
vector<int> g[N];
vector<int> pin(N);
vector<int> pout(N);
bool used[N];
vector<int> dp(N);

void dfs(int v) {
    used[v] = true;
    for (int u : g[v]) {
        pin[u]--;
        dp[u] = max(dp[u], dp[v] + 1);
        if (!used[u] && pin[u] == 0)
            dfs(u);
    }
}

inline void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        g[i].clear();
        used[i] = false;
        dp[i] = 1;
        pin[i] = 0;
    }
    vector<pii> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i].ff >> a[i].ss;
    for (int i = 0; i < n; i++)
        for (int j = i + 1; j < n; j++) {
            if (a[i].ss < a[j].ff) {
                g[i].pb(j);
                pin[j]++;
            }
            if (a[j].ss < a[i].ff) {
                g[j].pb(i);
                pin[i]++;
            }
        }
    for (int v = 0; v < n; v++)
        if (!used[v] && pin[v] == 0)
            dfs(v);
    int m = 0;
    for (int v = 0; v < n; v++)
        m = max(m, dp[v]);
    for (int i = 0; i < n; i++) {
        used[i] = false;
        g[i].clear();
    }
    for (int i = 0; i < n; i++)
        for (int j = i + 1; j < n; j++) {
            if (a[i].ff < a[j].ff && a[j].ss < a[i].ss) {
                g[i].pb(j);
                pout[i]++;
            }
            if (a[j].ff < a[i].ff && a[i].ss < a[j].ss) {
                g[j].pb(i);
                pout[j]++;
            }
        }
    vector<int> ans;
    for (int i = 0; i < n; i++)
        if (pout[i] == 0 && ans.size() < m / 2) {
            ans.pb(i + 1);
            used[i] = true;
        }
    for (int i = 0; i < n; i++)
        if (!used[i] && ans.size() < n / 2)
            ans.pb(i + 1);
    for (int i : ans)
        cout << i << ' ';
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    cin >> tt;
    while (tt--) {
#ifdef DEBUG
        cout << "Test case#\n";
#endif
        solve();
    }
    return 0;
}