#include "iostream"
#include "vector"
#include "string"
#include "set"
#include "map"
#include "algorithm"
#include "random"
#include "chrono"

using namespace std;
typedef long long ll;
#define all(a) a.begin(), a.end()

void solve();

ll MOD = 1;

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    cin >> MOD;
    cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
}

ll get(vector<ll> &v) {
    ll m = 0;
    for (ll i: v) {
        if (i == m)
            m++;
    }
    m--;
    for (ll &i: v)
        i ^= m;
    sort(all(v));
    return m + 1;
}

void solve() {
    ll n, k, p;
    cin >> k >> n >> p;
    ll ans = 0;
    ll x = (1 << k) - 1;
    for (ll i = 0; i < (1 << x); i++) {
        vector<ll> v{0};
        for (ll j = 0; j < x; j++) {
            if ((i >> j) & 1)
                v.push_back(j + 1);
        }
        if (v.size() != n)
            continue;
        ll m1 = -1;
        bool is = 1;
        ll c = 0;
        while (1) {
            ll m2 = get(v);
            if (m2 == m1) {
                break;
            }
            m1 = m2;
            c++;
            if (c > 1e5)
                break;
        }
        if (p == m1)
            ans++;
    }
    cout << ans % MOD;
}