#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>

using namespace std;
typedef long long ll;

#define all(a) a.begin(), a.end();

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }

}


int k;

int dfs_c(int s, vector<vector<int>> &g, vector<int> &c, vector<int> &c1, int is) {
    if (g[s].size() == 0) {
        if (c[s] <= k)
            return 1;
        return 0;
    }
    if (is == 1) {
        c[g[s][0]] = c[s] + 1;
        c[g[s][1]] = c[s];
    } else if (is == 2) {
        c[g[s][0]] = c[s];
        c[g[s][1]] = c[s] + 1;
    }
    c1[s] += dfs_c(g[s][0], g, c, c1, 2);
    c1[s] += dfs_c(g[s][1], g, c, c1, 1);
    return c1[s];
}

void solve() {
    int n, q;
    cin >> n >> k >> q;
    vector<vector<int>> g(n);
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        if (t != 0) {
            int a, b;
            cin >> a >> b;
            a--;
            b--;
            g[i].push_back(a);
            g[i].push_back(b);
        }
    }
    vector<int> c(n), c1(n);
    dfs_c(0, g, c, c1, -1);
    while (q--) {
        int u;
        cin >> u;
        cout << c1[u - 1] << '\n';
    }
}