#include <bits/stdc++.h>
using namespace std;

void solve() {
    int h, w, k;
    cin >> h >> w >> k;
    vector<int> x(k), y(k);
    for (int i = 0; i < k; i++) {
        cin >> x[i] >> y[i];
        x[i]--, y[i]--;
    }
    pair<long long, long long> ans1 = {LLONG_MAX, LLONG_MAX};
    pair<long long, long long> ans2 = {LLONG_MAX, LLONG_MAX};
    for (int hr = 0; hr < h; hr++) {
        int min_r = INT_MAX, max_r = INT_MIN;
        for (int i = 0; i < k; i++) {
            min_r = min(min_r, (x[i] + hr) % h);
            max_r = max(max_r, (x[i] + hr) % h);
        }
        ans1 = min(ans1, {max_r - min_r + 1, min(hr, h - hr)});
    }
    for (int hr = 0; hr < w; hr++) {
        int min_r = INT_MAX, max_r = INT_MIN;
        for (int i = 0; i < k; i++) {
            min_r = min(min_r, (y[i] + hr) % w);
            max_r = max(max_r, (y[i] + hr) % w);
        }
        ans2 = min(ans2, {max_r - min_r + 1, min(hr, w - hr)});
    }
    cout << 1ll * ans1.first * ans2.first << " " << ans1.second + ans2.second << "\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
