#include <bits/stdc++.h>
using namespace std;

int run;

void solve() {
    int n, k;
    cin >> n >> k;
    int n0 = n;
    int input_mask = 0;
    for (int i = 0; i < k; i++) {
        int x;
        cin >> x;
        x--;
        input_mask |= (1 << x);
    }
    vector<int> masks;
    for (int mask = 0; mask < (1 << n); mask++) {
        if (__builtin_popcount(mask) == k) {
            masks.push_back(mask);
        }
    }
    n = (int)masks.size();
    vector<vector<int>> g(n);
    for (int u = 0; u < n; u++) {
        for (int v = 0; v < n; v++) {
            if ((masks[u] & masks[v]) == 0) {
                g[u].push_back(v);
            }
        }
    }
    vector path(1 << n, vector<int>(n, -1));
    vector possible(1 << n, vector<bool>(n, false));
    for (int i = 0; i < n; i++) {
        possible[1 << i][i] = true;
    }
    for (int mask = 0; mask < (1 << n); mask++) {
        for (int head = 0; head < n; head++) {
            if (possible[mask][head]) {
                for (int new_head : g[head]) {
                    if ((mask >> new_head) & 1) {
                        continue;
                    }
                    possible[mask | (1 << new_head)][new_head] = true;
                    path[mask | (1 << new_head)][new_head] = head;
                }
            }
        }
    }
    vector<int> cycle;
    for (int i = 0; i < n; i++) {
        if (possible[(1 << n) - 1][i]) {
            int mask = (1 << n) - 1, head = i;
            while (mask > 0) {
                cycle.push_back(head);
                int tmp = mask;
                mask &= ~(1 << head);
                head = path[tmp][head];
            }
            break;
        }
    }
    for (int p = 0; p < n; p++) {
        if (masks[cycle[p]] == input_mask) {
            int msk = (run == 1 ? masks[cycle[(p + 1) % n]] : masks[cycle[(p + n - 1) % n]]);
            int c = 0;
            for (int i = 0; i < n0; i++) {
                if ((msk >> i) & 1) {
                    c++;
                    cout << i + 1 << " \n"[c == k];
                }
            }
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> run;
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}