#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const ll INF = ((ll)1e9 + 7);
const ll MOD = ((ll)1e9 + 7);

#define all(x) ((x).begin()), ((x).end())
#define sz(x) (int)((x).size())

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

vector<int> encode(int n, int k, const vector<int>& a) {
    vector<int> cnt(n + 1);
    for (int i : a) ++cnt[i];
    vector<int> res;
    for (int i = 1; i <= n; ++i) {
        if (!cnt[i]) {
            res.push_back(i);
        }
    }
    return res;
}

void solve() {
    int pp;
    cin >> pp;
    int m;
    cin >> m;
    for (int _m = 0; _m < m; ++_m) {
        int n, k;
        cin >> n >> k;
        vector<int> a(k);
        for (int i = 0; i < k; ++i) cin >> a[i];
        vector<int> res = encode(n, k, a);
        for (int i : res) {
            cout << i << ' ';
            cout << '\n';
        }
    }

}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
#endif

    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }

    return 0;
}
