#include<bits/stdc++.h>
#define ll long long

using namespace std;

struct Node {
    ll j, c, d;
};

struct Nod {
    ll k, a, b;
};

ll n, q, z;
vector<ll> w;
vector<Node> e;
vector<string> ans;

void input() {
    cin >> n >> q;
    w.resize(n);
    e.resize(q);
    for (ll i = 0; i < n; i++) {
        cin >> w[i];
    }
    cin >> z;
    for (ll i = 0; i < q; i++) {
        cin >> e[i].j >> e[i].c >> e[i].d;
    }
}

void solve() {
    for (ll i = 0; i < q; i++) {
        ll k = e[i].j, a = e[i].c, b = e[i].d;
        vector<ll> nw;
        for (ll i = 0; i < n; i++) {
            if (w[i] <= k) {
                nw.push_back(w[i]);
            }
        }
        vector<vector<bool>> dp(a + 1, vector<bool> (b + 1));
        dp[0][0] = true;
        for (ll i = 0; i < nw.size(); i++) {
            vector<vector<bool>> ndp = dp;
            for (ll j = 0; j <= a; j++) {
                for (ll p = 0; p <= b; p++) {
                    if (j >= nw[i] && dp[j - nw[i]][p]) {
                        ndp[j][p] = true;
                    }
                    if (p >= nw[i] && dp[j][p - nw[i]]) {
                        ndp[j][p] = true;
                    }
                }
            }
            dp = ndp;
        }
        for (ll i = 0; i <= a; i++) {
            for (ll j = 0; j <= b; j++) {
                if (i > 0 && !dp[i - 1][j]) {
                    dp[i][j] = false;
                }
                if (j > 0 && !dp[i][j - 1]) {
                    dp[i][j] = false;
                }
            }
        }
        if (dp[a][b]) {
            ans.push_back("Yes");
        } else {
            ans.push_back("No");
        }
    }
}

void output() {
    for (ll i = 0; i < q; i++) {
        cout << ans[i] << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    //if (k == 1e18) {
        solve();
    //}
    output();
    return 0;
}
