#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const ll INF = 1e16;

void solve() {
    ll n;
    cin >> n;
    vector<ll> arr(n + 1);
    for (ll i = 1; i <= n; ++i) {
        cin >> arr[i];
    }

    vector<vector<pair<ll, ll>>> dp(n + 2, vector<pair<ll, ll>>(n + 2, {-INF, 0}));

    dp[0][0] = {0, n + 2};

    for (ll i = 1; i <= n; ++i) {
        for (ll prev = 0; prev <= n + 1; ++prev) {
            dp[i][prev] = max(dp[i][max(arr[i], prev)], {dp[i - 1][prev].first + (arr[i] > prev), dp[i][prev].second});
            dp[i][prev] = max(dp[i][prev], {dp[i - 1][prev].first + (arr[i] < dp[i][prev].second), min(dp[i][prev].second, arr[i])});
        }
    }


    ll mx = 0;
    for (auto x : dp[n]) {
        mx = max(mx, x.first);
    }
    cout << mx << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll t;
    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}