#include <bits/stdc++.h>
using namespace std;

#define rep(i, a, b) for (int i = (a); i < (b); i++)
typedef long long ll;
typedef long double ld;

int main() {
    ios_base::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    rep(tests, 0, t) {
        int n;
        cin >> n;
        int a[n];
        rep(i, 0, n) cin >> a[i];
        int ind[n + 1];
        rep(i, 0, n) ind[a[i]] = i;

        if(n > 16) {
            vector<int> d(n + 1);
            vector<int> p(n + 1);
            d[0] = 0;
            rep(i, 1, n + 1) d[i] = 1e9 + 17;
            rep(i, 0, n) {
                int j = lower_bound(d.begin(), d.end(), a[i]) - d.begin();
                if (d[j] > a[i]) {
                    d[j] = a[i];
                    p[a[i]] = d[j - 1];
                }
            }
            int ans = 0;
            int r = n;
            while(d[r] == 1e9 + 17) r--;
            ans += r;
            r = d[r];
            vector<int> used(n, 0);
            while(r != 0) {
                used[ind[r]] = 1;
                r = p[r];
            }

            int mi = 1e9 + 17;
            rep(i, 0, n) if(!used[i])  {
                if(a[i] < mi) {
                    ans++;
                    mi = a[i];
                }
            }

            cout << ans << endl;

            continue;
        }

        int ans = 0;

        rep(mask, 0, 1 << n) {
            int cur = 0;
            vector<int> v1, v2;
            rep(i, 0, n) {
                if(((mask >> i) & 1) == 0) {
                    v1.push_back(a[i]);
                } else {
                    v2.push_back(a[i]);
                }
            }
            if (v1.size() > 0 && v2.size() > 0) {
                int ma = 0;
                rep(i, 0, v1.size()) {
                    if (v1[i] > ma) cur++;
                    ma = max(ma, v1[i]);
                }
                int mi = 1e9 + 17;
                rep(i, 0, v2.size()) {
                    if (v2[i] < mi) cur++;
                    mi = min(mi, v2[i]);
                }
            }
            ans = max(ans, cur);
        }

        cout << ans << endl;
    }

    return 0;
}
