#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

//const int R = (1 << 30);
//
//struct Node {
//    Node *left = nullptr, *right = nullptr;
//    int s = 0;
//};
//
//void Push(Node *v) {
//    if (v->left == nullptr) {
//        v->left = new Node;
//        v->right = new Node;
//    }
//}
//
//void Set(int i, Node *v, int l = 0, int r = R) {
//    ++v->s;
//    if (r - l > 1) {
//        Push(v);
//        int m = (l + r) / 2;
//        if (i < m)
//            Set(i, v->left, l, m);
//        else
//            Set(i, v->right, m, r);
//    }
//}
//
//int Sum(int sl, int sr, Node *v, int l = 0, int r = R) {
//    if (sl >= r || l >= sr)
//        return 0;
//    if (sl <= l && r <= sr)
//        return v->s;
//    Push(v);
//    int m = (l + r) / 2;
//    return Sum(sl, sr, v->left, l, m) + Sum(sl, sr, v->right, m, r);
//}
//
//int Find(int x, Node *v, int l = 0, int r = R) {
//    if (r - l == 1)
//        return l;
//    Push(v);
//    int m = (l + r) / 2;
//    if (v->left->s >= )
//}

void solve1() {
    int n, k;
    cin >> n >> k;
    vi a(k);
    unordered_set<int> used;
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
        used.insert(a[i]);
    }
    vi b;
    int x = 0, c = 1, j = 0;
    while (b.size() < k && c <= n) {
        if (x == 0 || j < k && c == a[j]) {
            c = a[j];
            ++x;
            ++j;
        }
        else {
            b.push_back(c);
            --x;
            used.insert(c);
        }
        ++c;
    }
    c = 1;
    while (b.size() < k) {
        if (used.find(c) == used.end())
            b.push_back(c);
        ++c;
    }
    sort(all(b));
    for (int y: b)
        cout << y << ' ';
    cout << '\n';
}

void solve2() {
    int n, k;
    cin >> n >> k;
    vi a(k);
    unordered_set<int> used;
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
        a[i] = n - a[i] + 1;
        used.insert(a[i]);
    }
    reverse(all(a));
    vi b;
    int x = 0, c = 1, j = 0;
    while (b.size() < k && c <= n) {
        if (x == 0 || j < k && c == a[j]) {
            c = a[j];
            ++x;
            ++j;
        }
        else {
            b.push_back(c);
            --x;
            used.insert(c);
        }
        ++c;
    }
    c = 1;
    while (b.size() < k) {
        if (used.find(c) == used.end())
            b.push_back(c);
        ++c;
    }
    for (int i = 0; i < k; ++i)
        b[i] = n - b[i] + 1;
    sort(all(b));
    for (int y: b)
        cout << y << ' ';
    cout << '\n';
}

int main() {
    fast;
    int run, t;
    cin >> run >> t;
    while (t--) {
        if (run == 1)
            solve1();
        else
            solve2();
    }
}
