#include <bits/stdc++.h>

#define int long long

using namespace std;

pair<int, int> get_ans(int h, vector<int> &arr) {
    int i, j = 0, now_h = 0, mi_h = arr.back() - arr[0], ans_h = 0;
    for (i = 0; i < arr.size(); i++) {
        now_h += max((int)0, arr[i] - now_h);
        while (j < arr.size() && arr[j] - now_h <= 0) {
            j++;
        }
        if (j >= arr.size()) {
            continue;
        }
        if (h - arr[j] + now_h < mi_h) {
            mi_h = h - arr[j] + now_h, ans_h = now_h;
        }
    }
    ans_h = min(ans_h, h - ans_h);
    return {mi_h + 1, ans_h};
}

signed main() {
    //ifstream cin("text.in");
    //ofstream cout("text.out");
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int h, w, k, i;
    cin >> h >> w >> k;
    vector<int> arr_h(k), arr_w(k);
    for (i = 0; i < k; i++) {
        cin >> arr_h[i] >> arr_w[i];
    }
    sort(arr_h.begin(), arr_h.end()), sort(arr_w.begin(), arr_w.end());
    auto [mi_h, ans_h] = get_ans(h, arr_h);
    auto [mi_w, ans_w] = get_ans(w, arr_w);
    cout << mi_h * mi_w << ' ' << ans_h + ans_w;
    return 0;
}
