#include <bits/stdc++.h>

#define int long long

using namespace std;

int solve(vector<int> &components, vector<vector<int>> &arr) {
    int mask, i, n = components.size(), ans = 0, j;
    for (mask = 0; mask < (1 << n); mask++) {
        if (__builtin_popcount(mask) <= ans) {
            continue;
        }
        vector<int> now;
        for (i = 0; i < n; i++) {
            if ((mask >> i) & 1) {
                now.push_back(components[i]);
            }
        }
        bool flag = true;
        for (i = 0; i < now.size() && flag; i++) {
            for (j = i + 1; j < now.size(); j++) {
                if (arr[now[i]][1] < arr[now[j]][0] || arr[now[j]][1] < arr[now[i]][0]) {
                    continue;
                }
                flag = false;
                break;
            }
        }
        if (flag) {
            ans = __builtin_popcount(mask);
        }
    }
    return ans;
}

bool check(int mask, vector<vector<int>> &arr) {
    vector<int> now;
    int i, n = arr.size(), j;
    for (i = 0; i < n; i++) {
        if ((mask >> i) & 1) {
            now.push_back(i);
        }
    }
    for (i = 0; i < now.size(); i++) {
        for (j = i + 1; j < now.size(); j++) {
            if (arr[now[i]][1] < arr[now[j]][0] || arr[now[j]][1] < arr[now[i]][0]) {
                continue;
            }
            return false;
        }
    }
    return true;
}

signed main() {
    //ifstream cin("text.in");
    //ofstream cout("text.out");
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        int n, i, j, m;
        cin >> n;
        vector<int> components(n);
        vector<bool> used(n, false);
        vector<vector<int>> g(n), arr(n, vector<int>(3));
        for (i = 0; i < n; i++) {
            cin >> arr[i][0] >> arr[i][1];
            arr[i][2] = i, components[i] = i;
            if ((i + 1) <= n / 2) {
                cout << i + 1 << ' ';
            }
        }
        cout << '\n';
    }
    return 0;
}
