#include <bits/stdc++.h>

#define int long long

using namespace std;

vector<int> ans_arr;

bool check(vector<int> &now, vector<pair<int, int>> &arr, int dop) {
    for (int i = 0; i < now.size(); i++) {
        if (arr[now[i]].second < arr[dop].first || arr[dop].second < arr[now[i]].first) {
            continue;
        }
        return false;
    }
    return true;
}

int get_ans(int n, vector<pair<int, int>> &arr) {
    int mask, i, ans = 0;
    for (mask = 0; mask < (1 << n); mask++) {
        if (__builtin_popcount(mask) < ans) {
            continue;
        }
        vector<int> now;
        bool flag = true;
        for (i = 0; i < n; i++) {
            if (((mask >> i) & 1) && !check(now, arr, i)) {
                flag = false;
                break;
            }

            if ((mask >> i) & 1) {
                now.push_back(i);
            }
        }
        if (flag) {
            ans = __builtin_popcount(mask);
        }
    }
    return ans;
}

void perebor(int n, int m, vector<int> &now, vector<pair<int, int>> &arr) {
    if (!ans_arr.empty()) {
        return;
    }
    if (now.size() == n / 2) {
        vector<pair<int, int>> new_arr;
        for (int u : now) {
            new_arr.push_back(arr[u]);
        }
        if (get_ans(n / 2, new_arr) == m / 2) {
            ans_arr = now;
        }
        return;
    }
    int start = 0;
    if (!now.empty()) {
        start = now.back() + 1;
    }
    for (; start < n; start++) {
        if (!ans_arr.empty()) {
            return;
        }
        now.push_back(start);
        perebor(n, m, now, arr);
        now.pop_back();
    }
}

signed main() {
    //ifstream cin("text.in");
    //ofstream cout("text.out");
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        int n, i;
        cin >> n;
        vector<pair<int, int>> arr(n);
        for (i = 0; i < n; i++) {
            cin >> arr[i].first >> arr[i].second;
        }
        ans_arr.clear();
        vector<int> now;
        int m = get_ans(n, arr);
        perebor(n, m, now, arr);
        for (i = 0; i < ans_arr.size(); i++) {
            cout << ans_arr[i] + 1 << ' ';
        }
        cout << '\n';
    }
    return 0;
}