#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <functional>
#include <cassert>
#include <set>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

mt19937 rnd(1337);

#define int long long

void solve() {
	int n, k, q; cin >> n >> k >> q;
	vector <vector <int>> g(n);
	for (int i = 0; i < n; ++i) {
		int t; cin >> t;
		for (int j = 0; j < t; ++j) {
			int u; cin >> u; --u;
			g[i].push_back(u);
		}
	}

	vector <int> cnt(n);
	vector <int> sm(n);
	function <void(int, int)> dfs = [&](int v, int pw) {
		if (!g[v].empty()) {
			if (v == 0) {
				dfs(g[0][0], 0);
				dfs(g[0][1], 1);
			}
			else {
				cnt[g[v][pw]] = cnt[v];
				dfs(g[v][pw], pw);
				cnt[g[v][!pw]] = cnt[v] + 1;
				dfs(g[v][!pw], !pw);
			}
			sm[v] = sm[g[v][0]] + sm[g[v][1]];
		}
		else {
			sm[v] = (cnt[v] <= k);
		}
	};
	dfs(0, 0);

	while (q--) {
		int u; cin >> u; --u;
		cout << sm[u] << '\n';
	}
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int32_t t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}