#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <functional>
#include <cassert>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

mt19937 rnd(1337);

#define int long long

void solve() {
	int n, q; cin >> n >> q;
	vector <int> w(n);
	for (auto& x : w) cin >> x;
	sort(all(w));

	vector <int> sm(n + 1, 0);
	bool flag = true;
	for (int i = 1; i <= n; ++i) {
		if (!flag) sm[i] = sm[i - 1];
		else {
			if (sm[i - 1] >= w[i - 1] - 1) {
				sm[i] = sm[i - 1] + w[i - 1];
			}
			else {
				sm[i] = sm[i - 1];
				flag = false;
			}
		}
	}

	int z; cin >> z;
	while (q--) {
		int k, a, b; cin >> k >> a >> b;
		int ps = upper_bound(all(w), k) - w.begin();
		if (sm[ps] >= a) cout << "Yes\n";
		else cout << "No\n";
	}
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int32_t t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}