#include "bits/stdc++.h"

#define ll long long
#define ld long double
#define all(u) u.begin(), u.end()
//#define endl '\n'

using namespace std;

mt19937_64 gen(time(nullptr));
int n, k;

void encode(vector<int> &a) {
    sort(all(a));
    map<int, bool> locked;

    for(auto u : a)
        locked[u] = true;

    vector<int> ans;

    int buff = 0;
    for (int i = 1; i < k; ++i) {
        ++buff;
        int pz = a[i - 1] + 1;
        while (buff != 0 and pz < a[i]){
            --buff;
            ans.emplace_back(pz);
            locked[pz] = true;
            ++pz;
        }
    }
    ++buff;
    for (int i = a[k - 1] + 1; buff != 0 and  i <= n; ++i) {
        --buff;
        ans.emplace_back(i);
    }

    if(buff != 0){
        for (int i = 1; buff != 0 and i <= n; ++i) {
            if(!locked[i]){
                --buff;
                ans.emplace_back(i);
            }
        }
    }

    sort(all(ans));
    for (auto u : ans) {
        cout << u << ' ';
    }
    cout << endl;
}

void decode(vector<int> &a){
    sort(all(a));
    reverse(all(a));
    map<int, bool> locked;

    for(auto u : a)
        locked[u] = true;

    vector<int> ans;

    int buff = 0;
    for (int i = 1; i < k; ++i) {
        ++buff;
        int pz = a[i - 1] - 1;
        while (buff != 0 and pz != a[i]){
            --buff;
            ans.emplace_back(pz);
            locked[pz] = true;
            ++pz;
        }
    }
    ++buff;
    for (int i = a[k - 1] - 1; i >= 1; --i) {
        --buff;
        ans.emplace_back(i);
    }

    for (int i = n; buff != 0 and i >= 1; --i) {
        if(!locked[i]){
            --buff;
            ans.emplace_back(i);
        }
    }

    sort(all(ans));
    for (auto u : ans) {
        cout << u << ' ';
    }
    cout << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int a;
    cin >> a;
    int t;
    cin >> t;
    while(t--) {
        cin >> n >> k;
        vector<int> u(k);
        for (int i = 0; i < k; ++i) {
            cin >> u[i];
        }
        if (a == 1) {
            encode(u);
        }else{
            decode(u);
        }
    }

    return 0;
}
