#include "bits/stdc++.h"

#define ll long long
#define ld long double
#define all(u) u.begin(), u.end()
//#define endl '\n'

using namespace std;

mt19937_64 gen(time(nullptr));

vector<vector<int>> gr;
vector<ll> a1;
vector<ll> a2;
vector<ll> dp_null1;
vector<ll> dp_all1;
vector<ll> dp_null2;
vector<ll> dp_all2;

void dfs(int v, int p){
    ll null1 = 0;
    ll all1 = 0;
    ll null2 = 0;
    ll all2 = 0;
    for (auto u : gr[v]) {
        if(u == p)
            continue;
        dfs(u, v);
        null1 += dp_null1[u];
        all1 += dp_all1[u];
        null2 += dp_null2[u];
        all2 += dp_all2[u];
    }
    dp_null1[v] = all1;
    dp_all1[v] = max(null1 + a1[v], all1);
    dp_null2[v] = all2;
    dp_all2[v] = max(null2 + a2[v], all2);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t;
    cin >> t;
    while (t--){
        ll n, q;
        cin >> n >> q;
        ll x, y, m;
        cin >> x >> y >> m;
        gr.assign(n, {});
        a1.assign(n, -1);
        a2.assign(n, -1);
        dp_all1.assign(n, -1);
        dp_null1.assign(n, -1);
        dp_all2.assign(n, -1);
        dp_null2.assign(n, -1);
        for (int i = 0; i < n - 1; ++i) {
            int s, f;
            cin >> s >> f;
            --s, --f;
            gr[s].emplace_back(f);
            gr[f].emplace_back(s);
        }
        for (int i = 0; i < n; ++i) {
            cin >> a1[i] >> a2[i];
        }
        dfs(0, -1);
        ll u_min = dp_all1[0];
        ll u_max = dp_all2[0];
        ll k = 0;
        for (ll i = 0; i < n; ++i) {
            k ^= (x * (i + 1) % m + ((y * a1[i]) % m) * a1[i] % m) % m;
        }
        map<int, bool> we;
        for (int i = 0; i < q; ++i) {
            ll ui;
            cin >> ui;
            if(ui > u_max or ui < u_min){
                cout << -1 << endl;
            }else{
                we[i + 1] = true;
                cout << k << endl;
            }
        }
        while (true){
            int c;
            cin >> c;
            if(c == 0)
                break;
            if(!we[c]){
                cout << -1 << endl;
            }else{
                for(auto e : a1)
                    cout << e << ' ';
                cout << endl;
            }
        }
    }

    return 0;
}