#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

#define int long long
#define all(a) a.begin(), a.end()
#define F first
#define S second
#define fastIo(a) ios_base::sync_with_stdio(a) ; cin.tie(a); cout.tie(a);

const int INF = 1e9;
const ll INFll = 1e18;

void code() {
    int n, k;
    cin >> n >> k;
    vector<int> q(k);
    vector<bool> used(n + 1);
    for (auto &i : q) cin >> i;
    for (auto i : q) {
        for (auto j : q) {
            used[abs(i - j)] = true;
            used[n - max(i, j) + min(i, j)] = true;
        }
    }
    int d = 0;
    while (used[d]) d++;

    set<int> ans;
    for (auto i : q) {
        ans.insert((i + d - 1) % n + 1);
    }

    if (ans.size() != k) {
        int c = 0;
        while (true) {
            c++;
        }
    }


    for (auto i : ans) cout << i << ' ';
    cout << endl;
}

void decode() {
    int n, k;
    cin >> n >> k;
    vector<int> q(k);
    vector<bool> used(n + 1);
    for (auto &i : q) cin >> i;
    for (auto i : q) {
        for (auto j : q) {
            used[abs(i - j)] = true;
            used[n - max(i, j) + min(i, j)] = true;
        }
    }
    int d = 0;
    while (used[d]) d++;
    set<int> ans;
    for (auto i : q) {
        ans.insert((i - d - 1 + n) % n + 1);
    }
    for (auto i : ans) cout << i << ' ';
    cout << endl;
}

signed main() {
    fastIo(0);
    int type;
    cin >> type;
    int t = 1;
    cin >> t;
    while (t--) {
        if (type == 1) code();
        else decode();
    }
}