#include <bits/stdc++.h>
#define ll long long
#define int long long
#define x first
#define y second
#define pii pair <int, int>
#define all(x) x.begin(), x.end()
#define sz(x) (int)(x.size())
using namespace std;

const int sz = 2e5 + 5;

int tree[4 * sz];

void upd(int l, int r, int h, int pos, int x) {
    if (l == r) {
        tree[h] = x;
        return;
    }
    int m = (r + l) / 2, h1 = 2 * h + 1, h2 = 2 * h + 2;
    if (pos <= m) {
        upd(l, m, h1, pos, x);
    } else {
        upd(m + 1, r, h2, pos, x);
    }
    tree[h] = max(tree[h1], tree[h2]);
}

pii get(int l, int r, int h, int tl, int tr) {
    if(tl <= l && r <= tr) {
        return {tree[h], l};
    }
    if (tr <l || r < tl) {
        return {0, 0};
    }
    int m = (r + l) / 2, h1  = 2 * h + 1, h2 = 2 * h  + 2;
    return max(get(l, m, h1, tl, tr), get(m + 1, r, h2, tl, tr));
}

vector <pii> p;

ll get_nvp(vector <int> v) {
    int n = sz(v), mx = 1;
    upd(0, n, 0, v[0], 1);
    p.resize(n);
    for (int i  =1; i < n; i++) {
        auto pp = get(0, n, 0, 1, v[i] - 1);
        pp.x++;
        upd(0, n, 0, v[i], pp.x);
        p[i] = pp;
        mx = max(mx, pp.x);
    }
    return mx;
}

void solve() {
    ll n;
    cin >> n;

    vector <int> v(n), used(n), st, ind(n + 1);
    for (auto & e : v) cin >> e;
    for (int i = 0; i < n; i++) {
        ind[v[i]] = i;
    }
    st.push_back(v[0]); used[0] = 1;
    for (int i = 1; i < n; i++) {
        if (v[i] > st.back()) {
            st.push_back(v[i]);
            used[i] = 1;
        }
    }
    int mn = 0, cnt = 0;
    for (int i = n - 1; i >= 0; i--) {
        if (!used[i]) {
            cnt = 1;
        }
    }
    int mx = get_nvp(v);
    fill(all(used), 0);
    int pos = 0;
    for (int i = 1; i < n; i++) {
        if (p[i].x > p[pos].x) {
            pos = i;
        }
    }
    while (p[pos].y != 0) {
        used[ind[p[pos].y]] = 1;
        pos = p[pos].y;
    }
    int cnt2 = 0;
    mn = 0;
    for (int i = n - 1; i >= 0; i--) {
        if (!used[i]) {
            if (v[i] > mn) {
                cnt2++;
                mn = v[i];
            }
        }
    }
    cout << max(sz(st) + cnt, cnt2 + mx) << "\n";
}
//int solve2(vector <int> v) {
//    ll n = sz(v);
////    cin >> n;
//
//    vector <int>  used(n), st;
//    st.push_back(v[0]); used[0] = 1;
//    for (int i = 1; i < n; i++) {
//        if (v[i] > st.back()) {
//            st.push_back(v[i]);
//            used[i] = 1;
//        }
//    }
//    int mn = 0, cnt = 0;
//    for (int i = n - 1; i >= 0; i--) {
//        if (!used[i]) {
//            cnt
//        }
//    }
//    return sz(st) + cnt;
////    cout << sz(st) + cnt << "\n";
//}
//
//vector <int> v;
//int ans;
//
//void rec(int pos, int mx, int mn, int l1, int l2) {
//    if (pos == sz(v)) {
//        ans = max(ans, l1 + l2);
//        return;
//    }
//    rec(pos + 1, max(mx, v[pos]), mn, l1 + (v[pos] > mx), l2);
//    rec(pos + 1, mx, min(mn, v[pos]), l1, l2 + (v[pos] < mn));
//}


signed main() {
    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
//    for (int i = 2; i < 6; i++) {
//        v.resize(i);
//        iota(all(v), 1);
//        do {
//            ans = 0;
//            rec(0, 0, 2e9, 0, 0);
//            int cnt = solve2(v);
//            if (ans != cnt) {
//
//            }
//
//        } while (next_permutation(all(v)));
//    }
}
