#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <random>
#include <numeric>

using namespace std;

//#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define uset unordered_set
#define umap unordered_map

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef set<int> si;
typedef set<pi> spi;

mt19937 rnd(123);

template<typename t> bool minravno(t& a, const t& b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> bool maxravno(t& a, const t& b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> void input(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}
template<typename t> void print(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cout << a[k];
}

const int INF = 1e9 + 1, MAXN = 1e4 + 10;

int n,k,p;

int mex(vi a) {

	si s;
	for (int i = 0; i <= a.size(); ++i)
		s.insert(i);
	for (auto i : a)
		s.erase(i);
	return *s.begin();
}

int check(vi a) {
	int last = -1;
	for (int i = 0; i < 1; ++i) {
		int m = mex(a);
		if (m == last)
			return m;
		last = m;
		for (auto& j : a)
			j ^= (m - 1);
	}
	return 0;
}

int ans = 0;

void f(vi& a) {
	if (a.size() == n) {
		ans += (check(a) == p);
	}
	else {
		for (int i = a.back() + 1; i < (1 << k) - (n - a.size()) + 1; ++i) {
			a.push_back(i);
			f(a);
			a.pop_back();
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int MOD;
	cin >> MOD;
	int t;
	cin >> t;
	while (t--) {
		cin >> k >> n >> p;
		vi a = { 0 };
		ans = 0;
		f(a);
		cout << ans << '\n';
	}

	return 0;
}