#include<iostream>
#include<vector>
#include<set>
#include<algorithm>
#define vec vector
#define all(v) v.begin(), v.end()
#define sz(v) ((int)v.size())
typedef long long ll;
using namespace std;
ll M;

int mex(set<int>& a, int d) {
	for (int i = 0; i <= d; i++) {
		if (a.find(i) == a.end())
			return i;
	}
}

set<int> next(set<int> a, int d) {
	int m = mex(a, d) - 1;
	set<int> ans;
	for (auto el : a) 
		ans.insert(el ^ m);
	return ans;
}

ll symp(ll k, ll n, ll p) {
	ll d = (1LL << k);
	ll ans = 0;
	for (ll mask = 0; mask < (1LL << d); mask++) {
		if (!(mask & 1))
			continue;
		set<int> a;
		for (int i = 0; i < d; i++) {
			if ((mask >> i) & 1)
				a.insert(i);
		}
		if (sz(a) != n)
			continue;
		set<set<int>> b;
		while (next(a, d) != a && b.find(a) == b.end()) {
			b.insert(a);
			a = next(a, d);
		}
		if (next(a, d) == a && mex(a, d) == p)
			ans += 1;
	}
	return ans % M;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
#ifdef LOCAL
	freopen("in.txt", "r", stdin);
#endif
	cin >> M;
	int t;
	cin >> t;
	while (t--) {
		ll k, n, p;
		cin >> k >> n >> p;
		cout << symp(k, n, p) << "\n";
	}
}