#include<bits/stdc++.h>

#define ll long long
#define pb push_back
#define all(a) a.begin(), a.end()
#define ld long double

using namespace std;

const int N = 2e5 + 10;
int t[N];
int tin[N], tout[N], cnt = 0;
vector<int> g[N];

void inc(int i, int d) {
    for (; i < N; i = (i | (i + 1))) {
        t[i] += d;
    }
}

int get(int r) {
    int ans = 0;
    for (; r >= 0; r = (r & (r + 1)) - 1) {
        ans += t[r];
    }
    return ans;
}

int get(int l, int r) {
    return get(r) - get(l - 1);
}

int n, k, q;

void dfs(int v, int type, int kol) {
    tin[v] = cnt++;
    if (kol <= k && g[v].size() == 0) {
        inc(tin[v], 1);
    }
    for (int i = 0; i < g[v].size(); i++) {
        int u = g[v][i];
        dfs(u, i, kol + (type ^ i));
    }
    tout[v] = cnt - 1;
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> k >> q;
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        for (int j = 0; j < t; j++) {
            int v;
            cin >> v;
            v--;
            g[i].pb(v);
        }
    }
    if (g[0].size() == 0) inc(0, 1);
    tout[0] = n - 1;
    for (int i = 0; i < g[0].size(); i++) {
        dfs(g[0][i], i, 0);
    }
    while (q--) {
        int v;
        cin >> v;
        v--;
        cout << get(tin[v], tout[v]) << endl;
    }
    return 0;
}
