#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#pragma GCC optimize(3)
#pragma GCC optimie("O3,inline,unroll-loops")

using namespace std;
using namespace __gnu_pbds;

//#define int long long
#define ll long long
#define fi first
#define se second
#define sz(x) (int)(x.size())
#define all(x) x.begin(), x.end()

typedef tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

/*const int max_mem = 3e8;
char memory[max_mem];
int pos = 0;

void* operator new(size_t n) {
    //assert(pos + n < max_mem);
    auto it = memory + pos;
    pos += n;
    return it;
}*/
void operator delete(void*, size_t){}


const int MX = 2e5 + 10;
const int INF = 2e9;
const int MOD = 1e9 + 7;

int n, k, q;
int g[2][MX];
int least[MX];
int res[MX];

ordered_set L[MX], R[MX];
int lefts[MX], rights[MX];
int rev[MX];

void dfs2(int u, int step, int cnt) {
    rev[u] = cnt;
    if (least[u]) return;
    int v1 = g[0][u], v2 = g[1][u];

    if (step == 1) dfs2(v1, 0, cnt + 1);
    else dfs2(v1, 0, cnt);

    if (step == 0) dfs2(v2, 1, cnt + 1);
    else dfs2(v2, 1, cnt);
}

void dfs(int u, int step) {
    if (least[u]) {
        if (step == 0) {
            L[u].insert(0);
            lefts[u] = 0;
        } else if (step == 1) {
            R[u].insert(0);
            rights[u] = 0;
        }
        if (rev[u] <= k) res[u] = 1;
    } else {
        int v1 = g[0][u], v2 = g[1][u];
        dfs(v1, 0); dfs(v2, 1);
        /// LEFT
        rights[v1]++;
        while (sz(R[v1]) && (rights[v1] + (*(--R[v1].end()))) > k) {
            R[v1].erase(--R[v1].end());
        }
        if (sz(L[v1]) > sz(R[v1])) {
            swap(L[u], L[v1]);
            swap(lefts[u], lefts[v1]);
            for (int x : R[v1]) {
                L[u].insert(x + rights[v1] - lefts[u]);
            }
        } else {
            swap(L[u], R[v1]);
            swap(lefts[u], rights[v1]);
            for (int x: L[v1]) {
                L[u].insert(x + lefts[v1] - lefts[u]);
            }
        }
        /// RIGHTS
        lefts[v2]++;
        while (sz(L[v2]) && (lefts[v2] + (*(--L[v2].end()))) > k) {
            L[v2].erase(--L[v2].end());
        }
        if (sz(L[v2]) > sz(R[v2])) {
            swap( R[u], L[v2]);
            swap(rights[u], lefts[v2]);
            for (int x : R[v2]) {
                R[u].insert(x + rights[v2] - rights[u]);
            }
            R[v2].clear();
        } else {
            swap(R[u], R[v2]);
            swap(rights[u], rights[v2]);
            for (int x : L[v2]) {
                R[u].insert(x + lefts[v2] - rights[u]);
            }
            L[v2].clear();
        }
        if (step != 1) res[u] += L[u].order_of_key(k - rev[u] - lefts[u] + 1);
        else           res[u] += L[u].order_of_key(k - rev[u] - lefts[u]);
        if (step != 0) res[u] += R[u].order_of_key(k - rev[u] - rights[u] + 1);
        else           res[u] += R[u].order_of_key(k - rev[u] - rights[u]);
    }
}

void solve() {
    cin >> n >> k >> q;
    for (int i = 1; i <= n; i++) {
        int t; cin >> t;
        if (t == 2) {
            int l, r; cin >> l >> r;
            g[0][i] = l;
            g[1][i] = r;
        } else {
            least[i] = 1;
        }
    }
    dfs2(1, -1, 0);
    dfs(1, -1);
    while (q--) {
        int u; cin >> u;
        cout << res[u] << '\n';
    }
}

signed main() {
#ifndef LOCAL
    ios::sync_with_stdio(0); cin.tie(0);
#endif
    int T = 1;
    // cin >> T;
    while (T--) solve();
    return 0;
}