﻿#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

int main() {
	cin.tie(0)->sync_with_stdio(0);
	int tt;
	cin >> tt;
	while (tt --> 0) {
		int n, q;
		cin >> n >> q;
		ll x, y, m;
		cin >> x >> y >> m;
		vector<vector<int>> g(n);
		for (int i = 0; i < n - 1; ++i) {
			int s, f;
			cin >> s >> f, --s, --f;
			g[s].push_back(f);
			g[f].push_back(s);
		}
		vector<ll> l(n), r(n);
		for (int i = 0; i < n; ++i) 
			cin >> l[i] >> r[i];
		vector<ll> qries(q);
		for (int i = 0; i < q; ++i) {
			cin >> qries[i];
		}
		vector<ll> dp1(n), dp2(n);
		function<void(int, int)> Dfs = [&](int v, int par) {
			dp1[v] = l[v];
			dp2[v] = 0;
			for (int u : g[v]) {
				if (u == par) continue;
				Dfs(u, v);
				dp1[v] += dp2[u];
				dp2[v] += max(dp1[u], dp2[u]);
			}	
		};
		Dfs(0, -1);
		ll e = max(dp1[0], dp2[0]);
		int k = 0;
		for (int j = 0; j < n; ++j) {
			k ^= (x * (j + 1) + y * ((ll)l[j] * l[j] % m)) % m;
		}
		for (int i = 0; i < q; ++i) {
			if (e == qries[i]) {
				cout << k << ' ';
			}
			else {
				cout << "-1 ";
			}
		}
		cout << endl;
 		int i;
 		while (cin >> i, i > 0) {
 			--i;
 			if (qries[i] == e) {
 				for (int x : l) cout << x << ' ';
 				cout << endl;
 			}
 			else {
 				cout << "-1" << endl;
 			}
 		}	
	}
 	return 0;
}	