#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>

using namespace std;
using ll = long long;
using vll = vector<ll>;
using vi = vector<int>;
using vvi = vector<vi>;

const string yes = "Yes\n", no = "No\n";

bool query(ll k, ll a, ll b, const vll& w) {
    set<pair<ll, ll>> s, ns;
    s.insert({0, 0});

    for (ll apple : w) {
        if (apple > k) {
            continue;
        }

        ns = set<pair<ll, ll>>(s);
        for (auto p : s) {
            ns.insert({ p.first + apple, p.second });
            ns.insert({ p.first, p.second + apple });
        }
        s = ns;
    }

    for (ll i = a; i >= 0; --i) {
        for (ll j = b; j >= 0; --j) {
            if (s.find({a, b}) == s.end()) {
                return false;
            }
        }
    }
    return true;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, q, z;
    ll j, c, d;
    cin >> n >> q;
    vll w(n);
    for (ll& i : w) {
        cin >> i;
    }
    sort(w.begin(), w.end());
    cin >> z;

    ll v = 0;
    for (int it = 1; it <= q; ++it) {
        cin >> j >> c >> d;
        if (query(j - v * z, c - v * z, d - v * z, w)) {
            v += it;
            cout << yes;
        } else {
            cout << no;
        }
    }

    return 0;
}
