#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define int long long
using namespace std;
const int INF = 1e9 + 10;
int m, n, k;
vector<int> a;

void encode() {
    if (n == 4) {
        vector<bool> used(n + 1);
        for (int i : a) {
            used[i] = true;
        }
        for (int i = 1; i <= n; i++) {
            if (!used[i]) {
                cout << i << ' ';
            }
        }
        cout << endl;
        return;
    }
    int x = a[0];
    int y = a[1];
    if (x > y) {
        swap(x, y);
    }
    if (y - x == 1) {
        int to1 = x - 1;
        if (to1 == 0) {
            to1 = n;
        }
        int to2 = y + 1;
        if (to1 == n + 1) {
            to1 = 1;
        }
        cout << to1 << ' ' << to2 << '\n';
    } else {
        int to1 = x + 1;
        if (to1 == n + 1) {
            to1 = 1;
        }
        int to2 = y + 1;
        if (to1 == n + 1) {
            to1 = 1;
        }
        cout << to1 << ' ' << to2 << '\n';
    }
}

void decode() {
    if (n == 4) {
        vector<bool> used(n + 1);
        for (int i : a) {
            used[i] = true;
        }
        for (int i = 1; i <= n; i++) {
            if (!used[i]) {
                cout << i << ' ';
            }
        }
        cout << endl;
        return;
    }
    int x = a[0];
    int y = a[1];
    if (x > y) {
        swap(x, y);
    }
    if (y - x == 1) {
        int to1 = x + 1;
        if (to1 == n + 1) {
            to1 = 1;
        }
        int to2 = y - 1;
        if (to1 == 0) {
            to1 = n;
        }
        cout << to1 << ' ' << to2 << '\n';
    } else {
        int to1 = x - 1;
        if (to1 == 0) {
            to1 = n;
        }
        int to2 = y - 1;
        if (to1 == 0) {
            to1 = n;
        }
        cout << to1 << ' ' << to2 << '\n';
    }
}

::int32_t main() {
    int t;
    cin >> t;
    cin >> m;
    for (int i = 0; i < m; i++) {
        cin >> n >> k;
        a.assign(k, 0);
        for (int &el: a) {
            cin >> el;
        }
        if (t == 1) {
            encode();
        } else {
            decode();
        }
    }
    return 0;
}

/*
4
5
4 1 2 3 5
10
3 8 10 4 1 2 7 9 5 6
3
1 2 3
6
4 2 5 1 6 3
 */