#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define nl endl;
#else
#pragma GCC target("avx2")
#pragma GCC optimize("Ofast")
#define nl '\n'
#endif

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ll long long
#define forn(i, n) for(decltype(n) i = 0; i < n; i++)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define _ <<" "<<

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

#define int ll

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> w(n);
    forn(i, n) cin >> w[i];
    int z;
    cin >> z;

    if (n <= 10 && q <= 10) {
        forn(i, q) {
            int k, a, b;
            cin >> k >> a >> b;
            set<pair<int, int>> can;
            function<void(int, int, int)> f = [&](int c1, int c2, int pos) {
                if (pos == n) {
                    if (c1 <= a && c2 <= b) can.emplace(c1, c2);
                    return;
                }
                if (w[pos] <= k) {
                    f(c1 + w[pos], c2, pos + 1);
                    f(c1, c2 + w[pos], pos + 1);
                }
                f(c1, c2, pos + 1);
            };
            f(0, 0, 0);
            cerr << can.size() _ (a + 1) * (b + 1) << nl;
            if (can.size() == (a + 1) * (b + 1)) {
                cout << "Yes" << nl;
            } else {
                cout << "No" << nl;
            }
        }
        return;
    }

    sort(all(w));
    vector<int> mx(n + 1);
    forn(i, n) {
        if (mx[i] + 1 - w[i] >= 0) {
            mx[i + 1] = mx[i] + w[i];
        } else {
            mx[i + 1] = mx[i];
        }
    }
    forn(i, q) {
        int k, a, b;
        cin >> k >> a >> b;
        if (a <= mx[upper_bound(all(w), k) - w.begin()]) {
            cout << "Yes" << nl;
        } else {
            cout << "No" << nl;
        }
    }
}

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);

    int t = 1;
//    cin >> t;
    while (t--) solve();
}