#include <bits/stdc++.h>
 
using namespace std;
 
#ifdef DESPAIR_101
#include "debug.h"
#define dbg(x) cout << #x << ":\n "; debug::print(x); cout << "\n"
#else
#define dbg(x) 
#endif
 
using ll = long long;
using ld = long double;
 
template <class A>
bool umin(A& x, const A& y) {
    if (x <= y) return false;
    x = y;
    return true;
}
 
template <class A>
bool umax(A& x, const A& y) {
    if (x >= y) return false;
    x = y;
    return true;
}
 
// #define int ll
#define sz(x) int((x).size())
 
vector<int> mt[8][1 << 7];
 
vector<int> encrypt(int n, vector<int> a) {
    vector<bool> used(n);
    for (int x : a) used[x] = true;
 
    vector<int> res;
    for (int x : a) {
        while (used[x]) {
            x = (x + 1) % n;
        }
        used[x] = true;
        res.push_back(x);
    }

    sort(res.begin(), res.end());
 
    return res;
}
 
vector<int> decrypt(int n, vector<int> a) {
    int k = sz(a);
 
    vector<bool> used(n);
    for (int x : a) used[x] = true;
 
    set<int> sus;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) sus.insert(i);
    }
 
    vector<int> res;
 
    auto nxt = [&](int i) {
        if (i == n - 1) return 0;
        return i + 1;
    };
 
    auto prv = [&](int i) {
        if (i == 0) return n - 1;
        return i - 1;
    };
 
    while (sz(res) < k) {
        for (int i : sus) {
            if (!used[i] && used[(i + 1) % n]) {
                res.push_back(i);
                int j = nxt(i);
                while (used[j]) j = nxt(j);
                used[i] = true;
                j = prv(j);
                used[j] = false;
                j = prv(j);
                used[j] = false;
                sus.erase(i);
                break;
            }
        }
    }
 
    sort(res.begin(), res.end());
    return res;
}
 
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
 
    int kok;
    cin >> kok;
 
    int m;
    cin >> m;
 
    for (int i = 0; i < m; ++i) {
        int n, k;
        cin >> n >> k;
 
        vector<int> a(k);
        for (int& x : a) {
            cin >> x;
            --x;
        }
 
        vector<int> res = ((kok == 1) ? encrypt(n, a) : decrypt(n, a));
        for (int x : res) cout << x + 1 << ' ';
        cout << endl;
    }
}