#include <bits/stdc++.h>
 
using namespace std;
 
#ifdef DESPAIR_101
#include "debug.h"
#define dbg(x) cout << #x << ":\n "; debug::print(x); cout << "\n"
#else
#define dbg(x) 
#endif
 
using ll = long long;
using ld = long double;
 
template <class A>
bool umin(A& x, const A& y) {
    if (x <= y) return false;
    x = y;
    return true;
}
 
template <class A>
bool umax(A& x, const A& y) {
    if (x >= y) return false;
    x = y;
    return true;
}
 
// #define int ll
#define sz(x) int((x).size())

int k, n, p, MOD;
int ans;

int getMex(vector<int> a) {
    int j = 0, mex = 0;
    while (mex < sz(a)) {
        while (j < sz(a) && a[j] < mex) ++j;
        if (j == sz(a) || a[j] > mex) return mex;
        ++mex;
    }
    return mex;
}

bool check(vector<int> cur) {
    vector<int> res(100);
    for (int i = 0; i < 100; ++i) {
        sort(cur.begin(), cur.end());
        res[i] = getMex(cur);
        for (int& x : cur) x ^= (res[i] - 1);
    }
    bool ok = true;
    ok &= (*min_element(res.begin() + 50, res.end()) == p);
    ok &= (*max_element(res.begin() + 50, res.end()) == p);
    return ok;
}

void rec(vector<int>& cur) {
    if (sz(cur) == n) {
        ans += check(cur);
        return;
    }
    for (int i = cur.back() + 1; i < (1 << k); ++i) {
        cur.push_back(i);
        rec(cur);
        cur.pop_back();
    }
}

void solve() {
    cin >> k >> n >> p;
    
    ans = 0;
    vector<int> cur { 0 };
    rec(cur);

    cout << ans << '\n';
}
 
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> MOD;
 
    int T = 1;
    cin >> T;
 
    for (int t = 1; t <= T; ++t) {
        solve();    
    }
}