#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace  std;
#define int long long
int k;

int w, h;

pair<int, int> mn(vector<int> xs, int sz) {
    int mn = 1e10;
    int mni = 1e9;
    for (int i = 0; i <= 2 * k; i++) {
        if (xs[i + k - 1] - xs[i] < mn) {
            mn = xs[i + k - 1] - xs[i];
        }
        if (xs[i + k - 1] - xs[i] == mn) {
            int now = 0;
            if (i > k) {
                now = xs[i - 1];
            }
            else if (i < k) {
                now = abs(xs[i]) + 1;
            }
            if (now < mni) {
                mni = now;
            }
        }
    }
    return {mn, mni};
}

signed main() {

    cin >> w >> h;
    cin >> k;
    vector<int> xs;
    vector<int> ys;
    for (int i = 0; i < k; i++) {
        int x, y;
        cin >> x >> y;
        xs.push_back(x - w);
        xs.push_back(x);
        xs.push_back(x + w);
        ys.push_back(y - h);
        ys.push_back(y);
        ys.push_back(y + h);
    }
    sort(xs.begin(), xs.end());
    sort(ys.begin(), ys.end());
    auto f1 = mn(xs, w);
    auto f2 = mn(ys, h);
    cout << (f1.first + 1) * (f2.first + 1) << ' ' << f1.second + f2.second << endl;
}
