#include <bits/stdc++.h>

#define vc vector
#define pii pair <int, int>
#define pb push_back
#define sz(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define fi first
#define se second
#define int long long

using namespace std;

const int N = 2e5 + 1;

template <class T>
bool chmax (T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const int inf = 8e18;

struct node {
    int mn = 0, sum = 0;
    node *l, *r;
    node () {
        l = r = nullptr;
    }
};

void create (node *&t) {
    if (!t)
        t = new node;
}

void upd (node *t, int tl, int tr, int i, int x) {
    if (tr - tl == 1) {
        t->mn = x;
        t->sum = 1;
        return;
    }
    int tm = (tl + tr) / 2;
    if (i < tm) {
        create(t->l);
        upd(t->l, tl, tm, i, x);
    } else {
        create(t->r);
        upd(t->r, tm, tr, i, x);
    }
    t->mn = min((t->l ? t->l->mn : inf), (t->r ? t->r->mn : inf));
    t->sum = (t->l ? t->l->sum : 0) + (t->r ? t->r->sum : 0);
}

int get_sum (node *t, int tl, int tr, int l, int r) {
    if (tr <= l || r <= tl || !t)
        return 0;
    if (l <= tl && tr <= r) {
        return t->sum;
    }
    int tm = (tl + tr) / 2;
    return get_sum(t->l, tl, tm, l, r) + get_sum(t->r, tm, tr, l, r);
}

int get_min (node *t, int tl, int tr, int l, int r) {
    if (tr <= l || r <= tl || !t)
        return inf;
    if (l <= tl && tr <= r) {
        return t->mn;
    }
    int tm = (tl + tr) / 2;
    return min(get_min(t->l, tl, tm, l, r), get_min(t->r, tm, tr, l, r));
}

const int C = 1e18;

void solve () {
    int n, q;
    cin >> n >> q;
    vc <int> w(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    int Z; cin >> Z; assert(Z == 0);
    sort(all(w));
    vc <vc <vc <int>>> quer(n);
    vc <int> ans(q);
    for (int i = 0; i < q; ++i) {
        int a, b, k;
        cin >> k >> a >> b;
        int j = upper_bound(all(w), k) - w.begin() - 1;
        if (j >= 0) {
            quer[j].pb({i, a, b});
        } else {
            ans[i] = (a == 0 && b == 0);
        }
    }
    int cur = 1;
    map <int, int> bad_pairs;
    int sum = 0;
    node *root = new node;
    vc <int> c;
    for (int i = 0; i < n; ++i) {
        for (int a = sum - w[i] + 2; a < w[i]; ++a) {
            if (bad_pairs.find(a) != bad_pairs.end())
                continue;
            int x = a;
            if (sum - x + 1 < w[i]) {
                bad_pairs[x] = sum - x + 1;
                upd(root, 0, C, x, sum - x + 1);
            }
        }
        if (cur >= w[i])
            cur += w[i];
        sum += w[i];
        for (auto it : quer[i]) {
            int f = 1;
            if (it[1] < cur) {
                int l = sum - it[2] + 1;
                int r = it[1];
                if (get_min(root, 0, C, 0, it[1] + 1) <= it[2]) {
                    f = 0;
                }
                if (l <= r) {
                    int sm = get_sum(root, 0, C, l, r + 1);
                    if (sm != r - l + 1) {
                        f = 0;
                    }
                }
            } else
                f = 0;
            ans[it[0]] = f;
        }
    }
    for (int i = 0; i < q; ++i) {
        if (ans[i]) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}
/*
8 3
17 1 3 2 100 5 6 1
0
6 15 3
9 4 4
5 15 3
 */

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}
