#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;


void encode() {
    int n, k; cin >> n >> k;
    vector<int> a(k);
    set<int> s, m;
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
        s.insert(a[i]);
    }
    m = s;
    int i = 1, cnt = 0;
    auto u = s.begin();
    vector<int> ans;
    while (ans.size() < k) {
        while (cnt && i != *u) {
            if (m.find(i) == m.end() && s.find(i) == s.end()) {
                ans.push_back(i);
                m.insert(i);
                cnt--;
            }
            i++;
            if (i > n) {
                i = 1;
            }
        }
        i = *u + 1;
        if (i > n) {
            i = 1;
        }
        if (m.find(*u) != m.end()) {
            m.erase(*u);
            cnt++;
        }
        u++;
        if (u == s.end()) {
            u = s.begin();
        }
    }
    std::sort(ans.begin(), ans.end());
    for (int e : ans) {
        cout << e << ' ';
    }
    cout << '\n';
}

void decode() {
    int n, k; cin >> n >> k;
    vector<int> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
    }
    vector<bool> s(n + 1, false);
    for (int i = 0; i < k; ++i) {
        s[a[i]] = true;
    }
    auto flex = s;
    int cnt = 0, did = 0;
    for (int i = n; did < k; --i) {
        if (i == 0) {
            i = n;
        }
        if (!s[i] && cnt && !flex[i]) {
            s[i] = !s[i];
            cnt--;
            did++;
        } else if (flex[i] && s[i]) {
            s[i] = !s[i];
            cnt++;
        }
    }
    for (int i = 1; i <= n; ++i) {
        if (s[i]) {
            cout << i << ' ';
        }
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(20);
    cout.setf(ios_base::fixed);
    int a; cin >> a;
    int m; cin >> m;
    while (m--) {
        if (a == 1) {
            encode();
        } else {
            decode();
        }
        cout.flush();
    }
}