#include <iostream>
#include <vector>
#include <algorithm>

#define int long long
#define all(x) x.begin(), x.end()
using namespace std;

void solve() {
    int n; cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    if (n <= 16) {
        int ans = 0;
        int sas = 0;
        for (int mask = 1; mask < (1 << n) - 1; ++mask) {
            vector<int> x, y;
            for (int i = 0; i < n; ++i) {
                if (mask & (1 << i)) {
                    x.push_back(a[i]);
                } else {
                    y.push_back(a[i]);
                }
            }
            int res = 0;
            int prev = 0;
            for (int e : x) {
                if (e > prev) {
                    res++;
                    prev = e;
                }
            }
            prev = n + 1;
            for (int e : y) {
                if (e < prev) {
                    prev = e;
                    res++;
                }
            }
            if (ans < res) {
                sas = mask;
            }
            ans = max(ans, res);
        }
        cout << ans << endl;
//        cerr << sas << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(20);
    cout.setf(ios_base::fixed);
    int t; cin >> t;
    while (t--) {
        solve();
    }
}
