#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
using namespace std;
#define int long long
#define endl '\n'
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()



signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(20);
    cout.setf(ios::fixed);
    int n, q; cin >> n >> q;
    vector<int> s(n);
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    sort(rall(s));

    vector<bool> dp(100001, false);
    dp[0] = true;
    for (int i = 0; i < n; ++i) {
        vector<bool> lay = dp;
        for (int j = 0; j + s[i] < 100001; ++j) {
            if (dp[j]) {
                lay[j + s[i]] = true;
            }
        }
        dp = lay;
    }

    vector<int> cnt(100001);
    cnt[0] = 1;
    for (int i = 1; i < 100001; ++i) {
        cnt[i] = cnt[i - 1] + dp[i];
    }
    int z; cin >> z;
    while (q--) {
        int k, a, b; cin >> k >> a >> b;
        if (cnt[a] != a + 1) {
            cout << "No" << endl;
        } else {
            cout << "Yes" << endl;
        }
    }
    return 0;
}
