#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <bitset>
using namespace std;

typedef int64_t ll;
typedef uint64_t ull;

const ll inf = 1234567891;
const ll M = 1e9 + 7;
const ll INF = 1e18 + 21;
const double PI = acos(-1);

struct node {
	ll x, y;
};

void solve() {
	ll h, w; int n;
	cin >> h >> w >> n;
	vector<node> a(n);
	ll mxx = 0, mnx = inf, mxy = 0, mny = inf;
	for (auto& e : a) {
		cin >> e.y >> e.x;
		mxx = max(mxx, e.x);
		mnx = min(mnx, e.x);
		mny = min(mny, e.y);
		mxy = max(mxy, e.y);
	}
	set<ll> xx, yy;
	for (auto& e : a) {
		xx.insert(e.x);
		yy.insert(e.y);
	}
	ll sq = mxx - mnx + 1;
	ll ans = 0;
	for (int i = 0; i < n; ++i) {
		ll minx = inf, maxx = 0;
		auto it = xx.upper_bound(a[i].x);
		if (it == xx.end()) continue;
		if ((*it) <= a[i].x) {
			minx = w - (a[i].x - (*it));
		} else {
			minx = (*it) - a[i].x;
		}
		maxx = w;
		if (sq > (maxx - minx + 1) || (sq == maxx - minx + 1 && ans > a[i].x)) {
			sq = (maxx - minx + 1);
			ans = a[i].x;
		}
	}
	/*ll d = w - i + 1;
        for (int j = 0; j < n; ++j) {
            ll curx;
            if (a[j].x + d > w) {
                curx = a[j].x + d - w;
            } else {
                curx = a[j].x + d;
            }
            minx = min(curx, minx);
            maxx = max(curx, maxx);
        }
        if (sq > (maxx - minx + 1) || (sq == (maxx - minx + 1) && ans > d)) {
            sq = (maxx - minx + 1);
            ans = d;
        }*/
	for (int i = 0; i < n; ++i) {
		ll minx = inf, maxx = 0;
		auto it = xx.lower_bound(a[i].x);
		if (it == xx.begin()) continue;
		--it;
		minx = 1;
		ll d = w - a[i].x + 1;
		if ((*it) + d > w) {
			maxx = (*it) + d - w;
		}
		else {
			maxx = (*it) + d;
		}
		if (sq > (maxx - minx + 1) || (sq == (maxx - minx + 1) && ans > d)) {
			sq = (maxx - minx + 1);
			ans = d;
		}
 	}
	ll sqy = mxy - mny + 1;
	ll ansy = 0;
	for (int i = 0; i < n; ++i) {
		ll minx = inf, maxx = 0;
		auto it = yy.upper_bound(a[i].y);
		if (it == yy.end()) continue;
		if ((*it) <= a[i].y) {
			minx = w - (a[i].y - (*it));
		}
		else {
			minx = (*it) - a[i].y;
		}
		maxx = h;
		if (sqy > (maxx - minx + 1) || (sqy == maxx - minx + 1 && ansy > a[i].y)) {
			sqy = (maxx - minx + 1);
			ansy = a[i].y;
		}
	}
	for (int i = 0; i < n; ++i) {
		ll minx = inf, maxx = 0;
		auto it = yy.lower_bound(a[i].y);
		if (it == yy.begin()) continue;
		--it;
		minx = 1;
		ll d = h - a[i].y + 1;
		if ((*it) + d > w) {
			maxx = (*it) + d - w;
		}
		else {
			maxx = (*it) + d;
		}
		if (sqy > (maxx - minx + 1) || (sqy == (maxx - minx + 1) && ansy > d)) {
			sqy = (maxx - minx + 1);
			ansy = d;
		}
	}
	cout << sq * sqy << ' ' << min(ans, w - ans + 1) + min(h - ansy + 1, ansy) << '\n';
}

int main() {
	ios::sync_with_stdio(0); cin.tie(0);

	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}