#include <bits/stdc++.h>
#define forn(i, n) for (int i = 0; i < n; i++)
#define ff first
#define ss second

using namespace std;
typedef long long ll;

ll const N = 3e5, INF = 0x3f3f3f3f3f3f3f3f;

struct segment{
    ll l, r, i;
};

bool cmp(segment x, segment y) {
    return x.r < y.r;
}

ll t, n;
segment a[N];
ll m, last;
vector<bool> ans;

bool check() {
    ll m2 = 0, last2 = -INF, cnt = 0;
    forn(i, n) {
        if(ans[i]) {
            cnt++;
            if (a[i].l > last2) {
                m2++;
                last2 = a[i].r;
            }
        }
    }
    return (cnt * 2 == n) && (m2 * 2 == m);
}


bool solve(ll i) {
    if (i == n) {
        if(check()) {
            forn(j, n) {
                if (ans[j]) {
                    cout << a[j].i << " ";
                }
            }
            cout << "\n";
            return true;
        }
        return false;
    }
    ans.push_back(true);
    if (solve(i + 1))
        return true;
    ans.pop_back();

    ans.push_back(false);
    if (solve(i + 1))
        return true;
    ans.pop_back();

    return false;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    //freopen("inp.txt", "r", stdin);
    cin >> t;
    while (t--) {
        cin >> n;
        ans.clear();
        forn(i, n)cin >> a[i].l >> a[i].r, a[i].i = i + 1;
        sort(&a[0], &a[n], cmp);
        m = 0, last = -INF;
        forn(i, n) {
            if (a[i].l > last) {
                m++;
                last = a[i].r;
            }
        }
        solve(0);
    }
    return 0;
}