#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
typedef long long ll;
vector<vector<ll>> g1(128), g2(128);
vector<ll> z1(128, -1), z2(128, -1), u;
bool dfs(ll v) {
	if (u[v]) return false;
	u[v] = 1;
	for (auto to : g1[v]) {
		if (z2[to] == -1 || dfs(z2[to])) {
			z1[v] = to, z2[to] = v;
			return true;
		}
	}
	return false;
}
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	ll t;
	ll q;
	cin >> t >> q;
	for (ll i = 0; i < 128; ++i) {
		ll c = 0;
		for (ll j = 0; j < 7; ++j) c += ((i & ((ll)1 << j)) > 0);
		if (c != 3) continue;
		for (ll l = 0; l < 128; ++l) {
			ll c1 = 0;
			for (ll j = 0; j < 7; ++j) c1 += ((l & ((ll)1 << j)) > 0);
			if (c1 == 3 && (i & l) == 0) {
				g1[i].push_back(l);
				g2[l].push_back(i);
			}
		}
	}
	for (ll i = 0; i < 128; ++i) {
		u.assign(128, 0);
		if (z1[i] == -1) dfs(i);
	}
	while (q--) {
		ll n, k;
		cin >> n >> k;
		vector<ll> a(k);
		for (ll i = 0; i < k; ++i) cin >> a[i];
		vector<ll> b;
		if (t == 1) {
			bool b1 = (a[k - 1] <= n - 1);
			for (ll i = 1; i < k; ++i) b1 = (b1 && a[i] - a[i - 1] > 1);
			if (k == 1) b.push_back((a[0]) % n + 1);
			else if (k == 2) {
				if (a[1] - a[0] == 1 || a[1] - a[0] == n - 1) b.push_back((a[1] + 1) % n + 1), b.push_back((a[0] + 1) % n + 1);
				else b.push_back((a[0]) % n + 1), b.push_back((a[1]) % n + 1);
			}
			else if (n == 7 && k == 3) {
				ll x = 0;
				for (ll i = 0; i < k; ++i) x += (1 << (a[i] - 1));
				for (ll i = 0; i < n; ++i) {
					if (z1[x] & (1 << i)) b.push_back(i + 1);
				}
			}
			else if (k == n / 2 && n % 2 == 0) {
				vector<ll> u(n + 1);
				for (ll i = 0; i < k; ++i) u[a[i]] = 1;
				for (ll i = 1; i <= n; ++i) {
					if (!u[i]) b.push_back(i);
				}
			}
			else if (b1) {
				for (ll i = 0; i < k; ++i) b.push_back(a[i] % n + 1);
			}
			else {
				for (ll i = 0; i < k; ++i) b.push_back((a[i] + n / 2 - 1) % n + 1);
			}
		}
		else {
			bool b1 = true;
			for (ll i = 1; i < k; ++i) b1 = (b1 && a[i] - a[i - 1] > 1);
			if (k == 1) b.push_back((a[0] - 2 + n) % n + 1);
			else if (k == 2) {
				if (a[1] - a[0] == 1 || a[1] - a[0] == n - 1) b.push_back((a[0] - 3 + n) % n + 1), b.push_back((a[1] - 3 + n) % n + 1);
				else b.push_back((a[0] - 2 + n) % n + 1), b.push_back((a[1] - 2 + n) % n + 1);
			}
			else if (n == 7 && k == 3) {
				ll x = 0;
				for (ll i = 0; i < k; ++i) x += (1 << (a[i] - 1));
				for (ll i = 0; i < n; ++i) {
					if (z2[x] & (1 << i)) b.push_back(i + 1);
				}
			}
			else if (k == n / 2 && n % 2 == 0) {
				vector<ll> u(n + 1);
				for (ll i = 0; i < k; ++i) u[a[i]] = 1;
				for (ll i = 1; i <= n; ++i) {
					if (!u[i]) b.push_back(i);
				}
			}
			else if (b1) {
				for (ll i = 0; i < k; ++i) b.push_back((a[i] - 2 + n) % n + 1);
			}
			else {
				for (ll i = 0; i < k; ++i) b.push_back((a[i] - n / 2 - 1 + n) % n + 1);
			}
		}
		sort(b.begin(), b.end());
		for (ll i = 0; i < k; ++i) cout << b[i] << " ";
		cout << endl;
	}
	cout << endl;
	return 0;
}