#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define int long long
const ll INF = 2e9, MOD = 1e9 + 7, N = 1e5 + 100, K = 20;

void solve1() {
    int n, k;
    cin >> n >> k;
    vector<int> a(k);
    vector<int> unused, used(n + 1);
    for (int i = 0; i < k; i++) {
        cin >> a[i];
        used[a[i]] = 1;
    }
    vector<int> cur;
    for (int i = 1; i <= n; i++) {
        if (!used[i])
            unused.push_back(i);
        else {
            if (!unused.empty()) {
                cur.push_back(unused.back());
                used[unused.back()] = 1;
                unused.pop_back();
            }
        }
    }
    int curr = n;
    while (cur.size() < k) {
        if (!used[curr])
            cur.push_back(curr);
        curr--;
    }
    sort(cur.begin(), cur.end());
    for (auto to : cur) {
        cout << to << " ";
    }
    cout << endl;
}

void solve2() {
    int n, k;
    cin >> n >> k;
    vector<int> a(k);
    vector<int> unused, used(n + 1);

    for (int i = 0; i < k; i++) {
        cin >> a[i];
        used[a[i]] = 1;
    }
    vector<int> cur;
    for (int i = n; i >= 1; i--) {
        if (!used[i])
            unused.push_back(i);
        else {
            if (!unused.empty()) {
                cur.push_back(unused.back());
                used[unused.back()] = 1;
                unused.pop_back();
            }
        }
    }
    int curr = 1;
    while (cur.size() < k) {
        if (!used[curr])
            cur.push_back(curr);
        curr++;
    }
    sort(cur.begin(), cur.end());
    for (auto to : cur) {
        cout << to << " ";
    }
    cout << endl;


}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    int tt = 1;
    cin >> tt;
    while (tt--) {
        if (t == 1)
            solve1();
        else
            solve2();
    }
    return 0;
}
