#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define int long long
#define popcnt __builtin_popcount

const ll INF = 2e9, MOD = 1e9 + 7, N = 2e5 + 100, K = 20;

struct seg{
    int l, r, id;
};

bool cmp(seg a, seg b) {
    if (a.r == b.r)
        return a.l < b.l;
    return a.r < b.r;
}

bool cmp2(seg a, seg b) {
    if (a.l == b.l)
        return a.r < b.r;
    return a.l > b.l;
}

void solve() {
    int n;
    cin >> n;
    vector<seg> a(n);
    for (int i = 0; i < n; i++) {
        int l, r;
        cin >> l >> r;
        a[i] = {l, r, i};
    }
    sort(a.begin(), a.end(), cmp);
    vector<vector<int>> dp(2, vector<int> (n)), p(2, vector<int> (n, -1));
    vector<vector<int>> dp2(2, vector<int> (n)), p2(2, vector<int> (n, -1));
    dp[1][0] = 1;
    for (int i = 1; i < n; i++) {
        dp[0][i] = max(dp[0][i - 1], dp[1][i - 1]);
        int j = i - 1;
        while (j >= 0 && a[j].r >= a[i].l)
            j--;
        if (j < 0)
            dp[1][i] = 1;
        else
            dp[1][i] = max(dp[0][j], dp[1][j]) + 1;
    }
    int m = max(dp[0][n - 1], dp[1][n - 1]);
    assert(m % 2 == 0);
        dp.assign(2, vector<int>(n));
        p.assign(2, vector<int>(n, -1));
        dp[1][0] = 1;
        vector<int> used2(n);
        for (int i = 0; i < n; i++) {
            if (i != 0) {
                dp[0][i] = max(dp[0][i - 1], dp[1][i - 1]);
                p[0][i] = p[0][i - 1];
                if (dp[1][i - 1] > dp[0][i - 1])
                    p[0][i] = i - 1;
                int j = i - 1;
                while (j >= 0 && a[j].r >= a[i].l)
                    j--;
                if (j < 0)
                    dp[1][i] = 1;
                else {
                    dp[1][i] = max(dp[0][j], dp[1][j]) + 1;
                    p[1][i] = p[0][j];
                    if (dp[1][j] > dp[0][j])
                        p[1][i] = j;
                }
            }
            if (i + 1 >= n / 2 && dp[1][i] == m / 2) {
                int cnt = m / 2;
                vector<int> used(n);
                int cur = i;
                if (dp[1][i] != m / 2)
                    cur = p[0][i];
                vector<int> ans;

                while (cur != -1) {
                    used[cur] = 1;
                    ans.push_back(a[cur].id);
                    cur = p[1][cur];
                }
                int id = 0;
                while (cnt < n / 2) {
                    if (!used[id]) {
                        used[id] = 1, cnt++;
                        ans.push_back(a[id].id);
                    }
                    id++;
                }
                sort(ans.begin(), ans.end());
                for (auto to: ans)
                    cout << to + 1 << " ";
                cout << endl;
                return;
            }
        }
        // dp2!!!
        dp2[1][0] = 1;
        for (int i = n - 1; i >= 0; i--) {
            if (i != n - 1) {
                dp2[0][i] = max(dp2[0][i + 1], dp2[1][i + 1]);
                p2[0][i] = p2[0][i + 1];
                if (dp2[1][i + 1] > dp2[0][i + 1])
                    p2[0][i] = i + 1;
                int j = i + 1;
                while (j < n && a[j].l <= a[i].r)
                    j++;
                if (j == n)
                    dp2[1][i] = 1;
                else {
                    dp2[1][i] = max(dp2[0][j], dp2[1][j]) + 1;
                    p2[1][i] = p2[0][j];
                    if (dp2[1][j] > dp2[0][j])
                        p2[1][i] = j;
                }
            }
            if ((n - i - 1) + 1 >= n / 2 && dp2[1][i] == m / 2) {
                int cnt = m / 2;
                vector<int> used(n);
                int cur = i;
                if (dp2[1][i] != m / 2)
                    cur = p2[0][i];
                vector<int> ans;

                while (cur != -1) {
                    used[cur] = 1;
                    ans.push_back(a[cur].id);
                    cur = p2[1][cur];
                }
                int id = n - 1;
                while (cnt < n / 2) {
                    if (!used[id]) {
                        used[id] = 1, cnt++;
                        ans.push_back(a[id].id);
                    }
                    id--;
                }
                sort(ans.begin(), ans.end());
                for (auto to: ans)
                    cout << to + 1 << " ";
                cout << endl;
                return;
            }
        }





}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}