#include <algorithm>
#include <cassert>
#include <iostream>
#include <set>
#include <vector>

using namespace std;

int main() {
    int n, q;
    cin >> n >> q;
    vector<long long> w(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    int z;
    cin >> z;
    assert(z == 0);
    for (int qr = 0; qr < q; qr++) {
        long long k, a, b;
        cin >> k >> a >> b;
        set<pair<long long, long long>> goods;
        for (unsigned mask = 0; mask < (1u << n); mask++) {
            for (int mask2 = mask;; mask2 = (mask2 - 1) & mask) {
                bool good = true;
                long long sum1 = 0;
                long long sum2 = 0;
                for (int i = 0; i < n; i++) {
                    if ((mask2 >> i) & 1) {
                        if (w[i] > k) {
                            good = false;
                            break;
                        }
                        sum2 += w[i];
                    } else if ((mask >> i) & 1) {
                        if (w[i] > k) {
                            good = false;
                            break;
                        }
                        sum1 += w[i];
                    }
                }
                if (good) {
                    if (sum1 <= a && sum2 <= b) {
                        goods.emplace(sum1, sum2);
                    }
                }
                if (mask2 == 0) {
                    break;
                }
            }
        }

        if (goods.size() == (a + 1ll) * (b + 1ll)) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }

    return 0;
}