#include <bits/stdc++.h>

using namespace std;
#define int long long
const int N = 2e3;

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> vec(n);
    for (int i = 0; i < n; ++i) {
        cin >> vec[i];
    }
    int Z;
    cin >> Z;

    sort(vec.begin(), vec.end());
    vector<vector<int>> dp(n + 1, vector<int>(N, -1));
    dp[0][0] = 0;
    for (int i = 1; i <= n; ++i) {
        int el = vec[i - 1];
        for (int j = 0; j <= n; ++j) {
            if (dp[i - 1][j] >= el - 1) {
                dp[i][j] = dp[i - 1][j] + el;
            }
            if (j - el >= el - 1) {
                dp[i][j] = max(dp[i][j], dp[i - 1][j - el]);
            }
        }
    }
    for (int w = 0; w < q; ++w) {
        int k, a, b;
        cin >> k >> a >> b;
        int ind = 0;
        for (int i = 0; i < n; ++i) {
            if (vec[i] > k) {
                ind = i;
            }
        }
        if (dp[ind][a] >= b) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
