#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
vector<int> leafs;
vector<bool> is_leaf, left1;
vector<vector<int>> tree;
vector<int> dp;
void bfs(int v){
    for(int x:tree[v]){
        if(dp[x]==-1) {
            dp[x] = dp[v];
            if (left1[x] != left1[v]) {
                dp[x] +=1;
            }
        }
        bfs(x);
    }
}
void count_leafs(int v,int k){
    if(dp[v]>k){
        return;
    }
    if(is_leaf[v]){
        leafs[v]=1;
        return;
    }
    int l,r;
    l=tree[v][0];
    r=tree[v][1];
    count_leafs(l,k);
    count_leafs(r,k);
    leafs[v]=leafs[l]+leafs[r];
}
int main() {
    int n,k,q;
    cin>>n>>k>>q;
    leafs.resize(n+1,0);
    is_leaf.resize(n+1, false);
    tree.resize(n+1,vector<int>());
    left1.resize(n+1,false);
    for(int i=1;i<=n;++i){
        int t,l,r;
        cin>>t;
        if(t==2){
            cin>>l>>r;
            tree[i].push_back(l);
            tree[i].push_back(r);
            left1[l]=true;
        }
        else{
            is_leaf[i]=true;
        }
    }
    dp.resize(n+1,-1);
    dp[1]=0;
    for(auto x:tree[1]){
        dp[x]=0;
    }
    bfs(1);
    count_leafs(1,k);
    while(q--){
        int v;
        cin>>v;
        cout<<leafs[v]<<"\n";
    }
}
