//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,abm,popcnt,mmx")
#include<bits/stdc++.h>

using namespace std;

typedef int ll;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

const ll INF = 2'000'000'000;

mt19937 rnd(time(0));

vector<ll> solve(ll n, vector<pair<ll, ll>> arr) {
	vector<pair<pair<ll, ll>, ll>> narr(n);
	for (ll i = 0; i < n; i++) {
		narr[i].first = arr[i];
		narr[i].second = i;
	}
	shuffle(narr.begin(), narr.end(), rnd);
	vector<ll> to(n);
	for (ll i = 0; i < n; i++) {
		arr[i] = narr[i].first;
		to[i] = narr[i].second;
	}
	vector<pair<ll, ll>> sob;
	set<ll> he, cp;
	for (ll i = 0; i < n; i++) {
		he.insert(i);
		cp.insert(i);
		sob.emplace_back(arr[i].second, i);
	}
	ll l = 0, a = 0;
	sort(sob.begin(), sob.end());
	for (auto[x, i] : sob) {
		if (arr[i].first > l) {
			l = x;
			a++;
		}
	}
	if (a % 2 == 1) {
		return vector<ll>(0, 0);
	}
	vector<ll> nh, el;
	for (ll i = 0; i < a / 2; i++) {
		ll nm = -1, ii = 0;
		for (auto j : cp) {
			ll nc = 0;
			for (auto k : he) {
				if ((arr[k].first <= arr[j].first && arr[j].second <= arr[k].second) || (arr[j].first <= arr[k].first && arr[k].first <= arr[j].second && arr[k].second > arr[j].second)) {
					nc++;
				}
			}
			if (assign_max(nm, nc)) {
				ii = j;
			}
		}
		nh.push_back(ii);
		he.erase(ii);
		cp.erase(ii);
		vector<ll> np;
		for (auto k : he) {
			if ((arr[k].first <= arr[ii].first && arr[ii].second <= arr[k].second) || (arr[ii].first <= arr[k].first && arr[k].first <= arr[ii].second && arr[k].second > arr[ii].second)) {
				np.push_back(k);
			}
			if ((arr[ii].first <= arr[k].second && arr[k].second <= arr[ii].second) || (arr[ii].first <= arr[k].first && arr[k].first <= arr[ii].second)) {
				//cp.erase(k);
			}
		}
		for (auto j : np) {
			el.push_back(j);
			he.erase(j);
		}
	}
	while (nh.size() < n / 2) {
		nh.push_back(el.back());
		el.pop_back();
	}
	for (auto& i : nh) {
		i = to[i];
		i++;
	}
	return nh;
}

bool rec(ll n, vector<ll>& now, vector<pair<ll, ll>>& arr, ll ans, ll na, ll l) {
	if (na > ans / 2) {
		return false;
	}
	if (na == ans / 2 && now.size() == n / 2) {
		return true;
	}
	if (now.size() == n / 2) {
		return false;
	}
	if (n - (now.empty() ? 0 : now.back()) - 1 + now.size() < n / 2) {
		return false;
	}
	now.push_back((now.empty() ? 0 : now.back() + 1));
	for (; now.back() < n; now.back()++) {
		ll nna = na, nl = l;
		if (arr[now.back()].first > nl) {
			nna++;
			nl = arr[now.back()].second;
		}
		if (rec(n, now, arr, ans, nna, nl)) {
			return true;
		}
	}
	now.pop_back();
	return false;
}

bool cmp(pair<pair<ll, ll>, ll> p1, pair<pair<ll, ll>, ll> p2) {
	return p1.first.second < p2.first.second;
}

vector<ll> stupid(ll n, vector<pair<ll, ll>> arr) {
	vector<pair<pair<ll, ll>, ll>> narr(n);
	for (ll i = 0; i < n; i++) {
		narr[i].first = arr[i];
		narr[i].second = i;
	}
	sort(narr.begin(), narr.end(), cmp);
	vector<ll> to(n);
	for (ll i = 0; i < n; i++) {
		arr[i] = narr[i].first;
		to[i] = narr[i].second;
	}
	vector<pair<ll, ll>> sob;
	for (ll i = 0; i < n; i++) {
		sob.emplace_back(arr[i].second, i);
	}
	ll l = 0, ans = 0;
	sort(sob.begin(), sob.end());
	for (auto[x, i] : sob) {
		if (arr[i].first > l) {
			l = x;
			ans++;
		}
	}
	vector<ll> now;
	rec(n, now, arr, ans, 0, 0);
	for (auto& i : now) {
		i = to[i];
		i++;
	}
	return now;
}

bool check(ll n, vector<pair<ll, ll>> fir, vector<ll> a) {
	vector<pair<ll, ll>> sob;
	for (ll i = 0; i < n; i++) {
		sob.emplace_back(fir[i].second, i);
	}
	ll l = 0, ans = 0;
	sort(sob.begin(), sob.end());
	for (auto[x, i] : sob) {
		if (fir[i].first > l) {
			l = x;
			ans++;
		}
	}
	if (ans % 2 == 1) {
		return true;
	}
	if (a.size() != n / 2) {
		return false;
	}
	vector<pair<ll, ll>> sec;
	for (auto i : a) {
		sec.push_back(fir[i - 1]);
	}
	sob.clear();
	l = 0;
	ll na = 0;
	for (ll i = 0; i < n / 2; i++) {
		sob.emplace_back(sec[i].second, i);
	}
	sort(sob.begin(), sob.end());
	for (auto[x, i] : sob) {
		if (sec[i].first > l) {
			l = x;
			na++;
		}
	}
	return na == ans / 2;
}

bool l = false;

int main() {
#ifdef LOCAL
	l = true;
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	if (l) {
		for (ll t = 1;; t++) {
			ll n = 6, mx = 9;
			vector<pair<ll, ll>> arr(n);
			for (auto&[l, r] : arr) {
				l = rnd() % mx + 1;
				r = rnd() % mx + 1;
				if (r < l) {
					swap(l, r);
				}
			}
			if (!check(n, arr, solve(n, arr))) {
				cout << n << '\n';
				for (auto[l, r] : arr) {
					cout << l << ' ' << r << '\n';
				}
				break;
			}
			cout << "OK " << t << endl;
		}
	} else {
		ll t;
		cin >> t;
		while (t--) {
			ll n;
			cin >> n;
			vector<pair<ll, ll>> arr(n);
			for (auto&[l, r] : arr) {
				cin >> l >> r;
			}
			for (auto i : solve(n, arr)) {
				cout << i << ' ';
			}
			cout << '\n';
		}
	}
}
