#include <bits/stdc++.h>
using namespace std;
using ps = pair<size_t, size_t>;


struct DebugPrint : ostream {} cnul;
template <class T>
DebugPrint& operator<<(DebugPrint& dst, const T& src) {return dst;}
template <class X, class Y>
ostream& operator<<(ostream& dst, const pair<X, Y>& src) {
  return dst << "(" << src.first << "," << src.second << ")";
}
#ifdef LOCAL_JUDGE
#define cdbg cerr
#define dprint(x) cdbg << #x << ": " << x << endl;
#else
#define cdbg cnul
#define dprint(x)
#endif


size_t t, n, x, a;
map<ps, size_t> old_dp, new_dp;
int main() {
  ios_base::sync_with_stdio(false); cin.tie(NULL);

  cin >> t; while (t--) {
    cin >> n;

    new_dp.clear();
    new_dp[make_pair(0, -1ull)] = 0;
    while (n--) {
      swap(old_dp, new_dp); new_dp.clear();
      cin >> x;
      for (auto& [old_key, d] : old_dp) {
        auto& [qmax, rmin] = old_key;
        auto new_key_q = make_pair(max(qmax, x), rmin);
        auto new_key_r = make_pair(qmax, min(rmin, x));

        new_dp[new_key_q] = max(new_dp[new_key_q], d + (x > qmax ? 1 : 0));
        new_dp[new_key_r] = max(new_dp[new_key_r], d + (x < rmin ? 1 : 0));
      }
    }

    a = 0;
    for (auto& [_, d] : new_dp) a = max(a, d);
    cout << a << "\n";
    cdbg << flush;
  }

  return 0;
}
