#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

int m;

vector<int> b_to_v(int b) {
    vector<int> v;
    for (int i = 0; (1 << i) <= b; ++i) {
        if ((b >> i) & 1) {
            v.push_back(i);
        }
    }
    return v;
}

int v_to_b(const vector<int> &v) {
    int b = 0;
    for (int ai : v) {
        b += (1 << ai);
    }
    return b;
}

int mex(int a) {
    int i = 0;
    while ((a >> i) & 1) ++i;
    return i;
}

int next(int a, int z) {
    vector<int> av = b_to_v(a);
    for (int &ai : av) {
        ai ^= (z - 1);
    }
    return v_to_b(av);
}


void solve() {
    int k, n, p, ans = 0;
    cin >> k >> n >> p;

    for (int a = 1; a < (1 << (1 << k)); a += 2) {
        if (__builtin_popcount(a) != n) continue;

        unordered_map<int, int> w, nxt;
        int c = a;
        while (!w.count(c)) {
            w[c] = mex(c);
            nxt[c] = next(c, w[c]);
            c = nxt[c];
        }

        bool ok = (w[c] == p);
        int d = nxt[c];
        while (d != c) {
            ok &= (w[d] == p);
            d = nxt[d];
        }

        if (ok) {
            ans++;
        }
    }

    cout << ans % m << "\n";
}

int main() {
#ifndef NEKSTAS
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int t = 1;
    cin >> m >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}
