#include <bits/stdc++.h>
#define int long long

using namespace std;

void solve1() {
  int n, k;
  cin >> n >> k;
  bool p = false;
  auto inc = [&](int x) {
    if (x == n) {
      p = true;
      return 1ll;
    }
    else return x + 1;
  };
  vector<int> a(k);
  set<int> q;
  for (int i = 0; i < k; i++) {
    cin >> a[i];
    q.insert(a[i]);
  }
  vector<int> ans(k);
  int ptr = a[0];
  for (int i = 0; i < k; i++) {
    if (!p) ptr = max(ptr, a[i]);
    while (q.find(ptr) != q.end()) {
      ptr = inc(ptr);
    }
    q.insert(ptr);
    ans[i] = ptr;
  }
  for (auto& i : ans) cout << i << ' ';
  cout << '\n';
}

void solve2() {
  int n, k;
  cin >> n >> k;
  auto dec = [&](int x) {
    if (x == 1) return n;
    else return x - 1;
  };
  vector<int> a(k);
  for (auto& i : a) cin >> i;
  set<int> q;
  for (auto& i : a) q.insert(i);
  vector<int> ans;
  ans.push_back(dec(a[0]));
  for (int i = 1; i < k; i++) {
    if (q.find(dec(a[i])) == q.end()) {
      ans.push_back(dec(a[i]));
      q.insert(ans.back());
    } else {
      for (int j = i - 1; j >= 0; j--) {
        if (q.find(dec(ans[j])) == q.end()) {
          int x = dec(ans[j]);
          ans.insert(ans.begin() + j, x);
          q.insert(x);
          break;
        }
      }
    }
  }
  for (auto& i : ans) cout << i << ' ';
  cout << '\n';
}

signed main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
#ifdef LOCAL
  freopen("input", "r", stdin);
#endif
  int run;
  cin >> run;
  if (run == 1) {
    int q;
    cin >> q;
    while (q--) {
      solve1();
    }
  } else {
    int q;
    cin >> q;
    while (q--) {
      solve2();
    }
  }
}