#include <bits/stdc++.h>

#define int long long

using namespace std;

int M;

vector<int> cur;

int k, n, p;
int ans = 0;

int mex(vector<int> &a) {
    for (int i = 0; i < a.size(); ++i) {
        if (i != a[i]) {
            return i;
        }
    }
    return a.size();
}

vector<int> calc_next(vector<int> &a) {
    vector<int> b = a;
    int m = mex(a) - 1;
    for (int i = 0; i < b.size(); ++i) {
        b[i] ^= m;
    }
    sort(b.begin(), b.end());
    return b;
}


int calc() {
    int iters = 0;
    vector<int> a = cur;
    while (a != calc_next(a)) {
        a = calc_next(a);
        iters += 1;
        if (iters == 1000) {
            return 0;
        }
    }
    int m = mex(a);
    if (m == p) {
        return 1;
    }
    return 0;
}

void foo() {
    if (cur.size() == n) {
        ans = (ans + calc()) % M;
        return;
    }
    for (int i = cur.back() + 1; i < k; ++i) {
        cur.push_back(i);
        foo();
        cur.pop_back();
    }
}

void solve() {
    cin >> k >> n >> p;
    k = (1 << k);

    cur = {0};
    ans = 0;

    foo();

    cout << ans << '\n';
}

int32_t main() {
#ifdef DDD
    freopen("../input.txt", "r", stdin);
#else
    cin.tie(0);
    ios_base::sync_with_stdio(false);
#endif
    cin >> M;

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
