#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <string>
#include <random>
#include <cmath>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
void fastio() { ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0); }

const long long INF = 2e9;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;

int main() {
	fastio();
	ll t;
	cin >> t;
	while (t--) {
		ll n;
		cin >> n;
		vector<ll> a(n);
		for (ll i = 0; i < n; i++) cin >> a[i];
		vector<vector<ll>> dp(n + 1, vector<ll>(n + 1, 0));
		for (ll x : a) {
			vector<vector<ll>> ndp(n + 1, vector<ll>(n + 1, 0));
			for (ll i = 0; i <= n; i++) {
				for (ll j = 0; j <= n; j++) {
					ndp[min(i, x)][j] = max(ndp[min(i, x)][j], dp[i][j] + (i >= x));
					ndp[i][max(x, j)] = max(ndp[i][max(x, j)], dp[i][j] + (j <= x));
				}
			}
			dp.swap(ndp);
		}
		ll ans = 0;
		for (ll i = 0; i <= n; i++) {
			for (ll j = 0; j <= n; j++) {
				ans = max(ans, dp[i][j]);
			}
		}
		cout << ans << "\n";
	}
	return 0;
}
