#include <bits/stdc++.h>
#define pb push_back
#define all(x) (x).begin(), (x).end()
using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

template<typename T>
inline ll len(const T& x) {
    return x.size();
}

const int inf = 1e9 + 9;
const ll MOD = 1e9 + 7;
const int maxN = 2e3 + 9;

int dp[maxN][maxN], ndp[maxN][maxN];
int p[maxN];
void solve() {
    int n; cin >> n;
    for(int i = 1; i <= n; ++i) {
        cin >> p[i];
    }
    for(int j = 0; j <= n; ++j) {
        memset(dp[j], -0x3f, sizeof(dp[j][0]) * (n + 1));
    }
    dp[0][0] = 0;
    for(int i = 1; i <= n; ++i) {
        for(int j = 0; j <= n; ++j) {
            memcpy(ndp[j], dp[j], sizeof(ndp[j][0]) * (n + 1));
        }
        for(int j = 0; j < i; ++j) {
            if(j != 0 && p[j] > p[i]) continue;
            for(int k = 0; k < i; ++k) {
                ndp[i][k] = max(ndp[i][k], dp[j][k] + 1);
            }
        }
        for(int k = 0; k < i; ++k) {
            if(k != 0 && p[k] < p[i]) continue;
            for(int j = 0; j < i; ++j) {
                ndp[j][i] = max(ndp[j][i], dp[j][k] + 1);
            }
        }
        for(int j = 0; j <= n; ++j) {
            memcpy(dp[j], ndp[j], sizeof(ndp[j][0]) * (n + 1));
        }
    }

    int ans = 0;
    for(int i = 0; i <= n; ++i) {
        for(int j = 0; j <= n; ++j) {
            ans = max(ans, dp[i][j]);
        }
    }
    cout << ans << '\n';
}
int main() {
    cin.tie(0); cout.tie(0);
    ios_base::sync_with_stdio(0);
    int tc; cin >> tc;
    while(tc--) solve();
}
/*

4
5
4 1 2 3 5
10
3 8 10 4 1 2 7 9 5 6
3
1 2 3
6
4 2 5 1 6 3


 */