#include <bits/stdc++.h>
#define pb push_back
#define all(x) (x).begin(), (x).end()
using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template<typename T>
inline ll len(const T& x) {
    return x.size();
}

ll MOD = 1e9 + 7;
const int inf = 1e9 + 9;
const int maxN = 2e5 + 9;
ll X, Y;
inline ll mul(ll x, ll y) {
    x %= MOD, y %= MOD;
    return x * y % MOD;
}
inline ll add(ll x, ll y) {
    x %= MOD, y %= MOD;
    return (x + y) % MOD;
}
int n, q;
ll l[maxN], r[maxN];
ll lft[maxN];

void solve() {
    cin >> n >> q;
    cin >> X >> Y >> MOD;
    X %= MOD, Y %= MOD;
    for(int i = 1; i < n; ++i) {
        int u, v; cin >> u >> v;
        assert(u == 1);
        assert(v == i + 1);
    }
    for(int i = 1; i <= n; ++i) cin >> l[i] >> r[i];
    ll mn = 0, mx = 0;
    for(int i = 2; i <= n; ++i) {
        mn += l[i];
        mx += r[i];
    }

    vector<ll> val(q);
    vector<pll> qs;
    vector<ll> res(q);
    for(int i = 0; i < q; ++i) {
        ll v; cin >> v;
        val[i] = v;
        qs.pb({v, i});
    }
    sort(all(qs));
    int nxt = 2;
    ll cur_w = 0;
    ll kokus = 0;
    for(ll j = 1; j <= n; ++j) {
        cur_w += l[j];
        kokus = kokus ^ add(mul(X, j), mul(mul(Y, l[j]), l[j]));
    }
    ll defo = kokus;
    for(int i = 1; i <= n; ++i) lft[i] = r[i] - l[i];
    for(auto &i: qs) {
        while(cur_w < i.first && nxt <= n) {
            while(nxt <= n && lft[nxt] == 0) {
                ++nxt;
            }
            if(nxt > n) break;
            ll old = l[nxt] + (r[nxt] - l[nxt] - lft[nxt]);
            kokus = kokus ^ add(mul(X, nxt), mul(mul(Y, old), old));

            ll tak = min(i.first - cur_w, lft[nxt]);
            assert(tak > 0);
            lft[nxt] -= tak;
            cur_w += tak;

            ll nu = l[nxt] + (r[nxt] - l[nxt] - lft[nxt]);
            kokus = kokus ^ add(mul(X, nxt), mul(mul(Y, nu), nu));
        }
        if(cur_w == i.first) res[i.second] = kokus;
        else {
            if(cur_w < i.first && l[1] <= i.first && i.first <= r[1]) {
                ll sus = defo;
                ll old = l[1];
                sus = sus ^ add(mul(X, 1), mul(mul(Y, old), old));
                ll nu = i.first;
                sus = sus ^ add(mul(X, 1), mul(mul(Y, nu), nu));
                res[i.second] = sus;
            }
            else res[i.second] = -1;
        }
    }

    for(int i = 0; i < q; ++i) cout << res[i] << ' ';
    cout << endl;

    while(1) {
        ll k; cin >> k;
        if(k == 0) break;
        --k;
        if(res[k] != -1) {
            ll nid = val[k];

            nxt = 2;
            cur_w = mn + l[1];
            for(int i = 1; i <= n; ++i) lft[i] = r[i] - l[i];
            while(cur_w < nid && nxt <= n) {
                while(nxt <= n && lft[nxt] == 0) ++nxt;
                if(nxt > n) break;
                ll tak = min(nid - cur_w, lft[nxt]);
                lft[nxt] -= tak;
                cur_w += tak;
            }
            if(cur_w == nid) {
                for(int i = 1; i <= n; ++i) {
                    cout << l[i] + (r[i] - l[i] - lft[i]) << ' ';
                }
                cout << endl;
            }
            else {
                cout << nid << ' ';
                for(int i = 2; i <= n; ++i) cout << l[i] << ' ';
                cout << endl;
            }
        }
        else cout << -1 << endl;
    }
}
int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int tc; cin >> tc;
    while(tc--) solve();
}
/*

1
9 3
4 7 15
1 2
2 4
2 5
1 3
3 6
3 7
6 8
6 9
4 4
2 2
5 5
3 3
2 2
6 6
3 3
4 4
3 3
18 19 20


1
3 6
3 4 11
1 2
2 3
0 2
0 2
0 2
5 3 1 2 4 0



1
4 7
0 0 1
1 2
1 3
1 4
0 0
1 1
1 2
1 3
1 2 3 4 5 6 7


 */