#include <bits/stdc++.h>
#define pb push_back
#define all(x) (x).begin(), (x).end()
using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template<typename T>
inline ll len(const T& x) {
    return x.size();
}

ll MOD = 1e9 + 7;
const int inf = 1e9 + 9;
const int maxN = 2e5 + 9;
ll X, Y;
inline ll mul(ll x, ll y) {
    x %= MOD, y %= MOD;
    return x * y % MOD;
}
inline ll add(ll x, ll y) {
    x %= MOD, y %= MOD;
    return (x + y) % MOD;
}
int n, q;
vector<int> g[maxN];
ll dp[maxN][2];
ll l[maxN], r[maxN];
ll lft[maxN];
ll ans = 0;
void dfs(int v, int p = -1) {
    dp[v][0] = 0;
    dp[v][1] = r[v];
    for(auto &i: g[v]) {
        if(i == p) continue;
        dfs(i, v);
        dp[v][0] += max(dp[i][0], dp[i][1]);
        dp[v][1] += dp[i][0];
    }
    ans = max(ans, dp[v][0]);
    ans = max(ans, dp[v][1]);
}
bool got[maxN];
void get(int v, int gp = 0, int p = -1) {
    int tg = 0;
    if(gp == 0 && dp[v][1] > dp[v][0]) {
        got[v] = 1;
        tg = 1;
    }
    for(auto &i: g[v]) {
        if(i == p) continue;
        get(i, tg, v);
    }
}
void clear(int n) {
    ans = 0;
    for(int i = 0; i <= n; ++i) {
        got[i] = 0;
        g[i].clear();
        dp[i][0] = dp[i][1] = 0;
    }
}
void solve() {
    cin >> n >> q;
    clear(n);
    cin >> X >> Y >> MOD;
    X %= MOD, Y %= MOD;
    for(int i = 1; i < n; ++i) {
        int u, v; cin >> u >> v;
        g[u].pb(v);
        g[v].pb(u);
    }
    for(int i = 1; i <= n; ++i) cin >> l[i] >> r[i];
    ans = 0;
    dfs(1);
    get(1);

    vector<ll> val(q);
    vector<pll> qs;
    vector<ll> res(q);
    for(int i = 0; i < q; ++i) {
        ll v; cin >> v;
        val[i] = v;
        qs.pb({v, i});
    }
    sort(all(qs));
    int nxt = 1;
    ll cur_w = 0;
    ll kokus = 0;
    for(ll j = 1; j <= n; ++j) {
        kokus = kokus ^ add(mul(X, j), mul(mul(Y, l[j]), l[j]));
    }
    for(int i = 1; i <= n; ++i) lft[i] = r[i];
    for(auto &i: qs) {
        while(cur_w < i.first && nxt <= n) {
            kokus = kokus ^ add(mul(X, nxt), mul(mul(Y, r[nxt] - lft[nxt]), r[nxt] - lft[nxt]));
            ll tak = min(i.first - cur_w, lft[nxt]);
            lft[nxt] -= tak;
            cur_w += tak;
            kokus = kokus ^ add(mul(X, nxt), mul(mul(Y, r[nxt] - lft[nxt]), r[nxt] - lft[nxt]));
            while(nxt <= n && (lft[nxt] == 0 || !got[nxt])) {
                ++nxt;
            }
        }
        if(cur_w == i.first) res[i.second] = kokus;
        else res[i.second] = -1;
    }

    for(int i = 0; i < q; ++i) cout << res[i] << ' ';
    cout << endl;

    while(1) {
        ll k; cin >> k;
        if(k == 0) break;
        --k;
        if(res[k] != -1) {
            ll nid = val[k];


            nxt = 1;
            cur_w = 0;
            for(int i = 1; i <= n; ++i) lft[i] = r[i];
            while(cur_w < nid && nxt <= n) {
                ll tak = min(nid - cur_w, lft[nxt]);
                lft[nxt] -= tak;
                cur_w += tak;
                while(nxt <= n && (lft[nxt] == 0 || !got[nxt])) {
                    ++nxt;
                }
            }

            for(int i = 1; i <= n; ++i) {
                cout << r[i] - lft[i] << ' ';
            }
            cout << endl;
        }
        else cout << -1 << endl;
    }
}
int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int tc; cin >> tc;
    while(tc--) solve();
}
/*

1
9 3
4 7 15
1 2
2 4
2 5
1 3
3 6
3 7
6 8
6 9
4 4
2 2
5 5
3 3
2 2
6 6
3 3
4 4
3 3
18 19 20


1
3 6
3 4 11
1 2
2 3
0 2
0 2
0 2
5 3 1 2 4 0



 */