#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<vector<ll>> g;
vector<ll> a;
vector<ll> dp1, dp2;

void dfs(ll v, ll p) {
    dp1[v] = a[v];
    for (auto &to: g[v]) {
        if (to != p) {
            dfs(to, v);
            dp1[v] += dp2[to];
            dp2[v] += max(dp1[to], dp2[to]);
        }
    }
}

void solve() {
    ll n, q;
    cin >> n >> q;
    ll x, y, m;
    cin >> x >> y >> m;
    g.assign(n, {});
    a.assign(n, 0);
    for (ll i = 0; i < n - 1; i++) {
        ll u, v;
        cin >> u >> v;
        g[u - 1].push_back(v - 1);
        g[v - 1].push_back(u - 1);
    }
    for (ll i = 0; i < n; i++) {
        cin >> a[i] >> a[i];
    }
    dp1.assign(n, 0);
    dp2.assign(n, 0);
    dfs(0, 0);
    ll mx = max(dp1[0], dp2[0]);
    ll k = 0;
    for (ll i = 0; i < n; i++) {
        ll gg = (x * (i + 1) + y * (a[i] * a[i] % m)) % m;
        k = k ^ gg;
    }
    vector<ll> v(q);
    for (ll i = 0; i < q; i++) {
        cin >> v[i];
    }
    for (ll i = 0; i < q; i++) {
        if (v[i] == mx) {
            cout << k << ' ';
        } else {
            cout << "-1 ";
        }
    }
    cout << endl;
    while (true) {
        ll i;
        cin >> i;
        if (i == 0) {
            break;
        }
        i--;
        if (v[i] == mx) {
            for (ll j = 0; j < n; j++) {
                cout << a[j] << ' ';
            }
            cout << endl;
        } else {
            cout << -1 << endl;
        }
    }
}

int main() {
#ifdef DEBUG_Q
    freopen("INPUT.TXT", "r", stdin);
    freopen("OUTPUT.TXT", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
}
