#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()

using namespace std;

int RUN;

bool check1(const vector<int> &a, int n) {
	int k = a.size();
	if (RUN == 1 && a.back() == n) return 0;
   	for (int i = 1; i < k; ++i) {
		if (a[i] - a[i - 1] < 2) return 0;
	}
	return 1;	
}

vector<int> shift(const vector<int> &a, int v, int n) {
	int k = a.size();
	vector<int> res(k);
	for (int i = 0; i < k; ++i) {
		res[i] = (a[i] - 1 + n + v) % n + 1;
	}
	sort(all(res));
	return res;
}

bool have_sim(const vector<int> &a, const vector<int> &b) {
	int n = a.size();
	int j = 0;
	for (int i = 0; i < n && j < n; ++i) {
		if (a[i] == b[j]) return true;
		while (b[j] < a[i]) ++j;
	}
	return false;
}

void solve() {
	int n, k;
	cin >> n >> k;
	vector<int> t(k);
	for (auto &it : t) cin >> it;
	if (k == 1) {
		cout << (t[0] - 1 + n + (RUN == 1 ? 1 : -1)) % n + 1 << ' ';
	} else if (k == 2) {
		int a, b;
		if (t[0] == t[1] - 1 || (t[0] == 1 && t[1] == n)) {
			a = (t[0] - 1 + n + (RUN == 1 ? 2 : -2)) % n + 1;
			b = (t[1] - 1 + n + (RUN == 1 ? 2 : -2)) % n + 1;
		} else {
			a = (t[0] - 1 + n + (RUN == 1 ? 1 : -1)) % n + 1;
			b = (t[1] - 1 + n + (RUN == 1 ? 1 : -1)) % n + 1;	
		}
		cout << min(a, b) << ' ' << max(a, b) << endl;
	} else if (k * 2 == n) {
		int  j = 0;
		for (int i = 1; i <= n; ++i) {
			if (j < k && t[j] == i) {
				++j;
			} else cout << i << ' ';
		}
		cout << endl;
	} /* else if (n <= 7) {
		for (int i = 1; i <= 6; ++i) {
			vector<int> tmp = shift(t, (RUN == 1 ? i : -i), n);
			if (have_sim(tmp, t)) continue;
			else {
				for (auto &it : tmp) cout << it << ' ';
				cout << endl;
				break;
			}
		}
		
	}*/ else if (check1(t, n)) {
		for (auto &it : t) cout << it + (RUN == 1 ? 1 : -1)  << ' ';
		cout << endl;
	} else {
		for (auto &it : shift(t, (RUN == 1 ? n / 2 : - n / 2), n)) cout << it << ' ';
		cout << endl;
	}
}

signed main() {
	cin >> RUN;
	int m;
	cin >> m;
	while (m--) solve();
	return 0;
}

