#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

vector<int> up;
vector<pair<int, int>> d;
vector<int> dp;

void dfs(int v, int p) {
    if (d[v].first == 0) {
        return;
    }
    if (p == 0) {
        dp[d[v].first] = dp[v];
        dp[d[v].second] = dp[v] + 1;
        dfs(d[v].first, p);
        dfs(d[v].second, 1 - p);
    } else {
        dp[d[v].first] = dp[v] + 1;
        dp[d[v].second] = dp[v];
        dfs(d[v].first, 1 - p);
        dfs(d[v].second, p);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, k, q;
    cin >> n >> k >> q;
    d.resize(n);
    dp.resize(n);
    up.resize(n);
    for (int i = 0; i < n; ++i) {
        int t, u, v;
        cin >> t;
        if (t == 2) {
            cin >> u >> v;
            --u;
            --v;
            d[i] = {u, v};
            up[u] = i;
            up[v] = i;
        }
    }
    dp[0] = 0;
    dfs(d[0].first, 0);
    dfs(d[0].second, 1);
    for (int ii = 0; ii < q; ++ii) {
        int u;
        cin >> u;
        --u;
        if (dp[u] <= k) {
            cout << 1 << '\n';
        } else {
            cout << 0 << '\n';
        }
    }
    return 0;
}
