#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <random>
#include <chrono>

#include <unordered_map>
#include <unordered_set>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <stack>
#include <array>
#include <tuple>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;

using ll = long long;
using ull = unsigned long long;
using ld = long double;


constexpr ll INF = static_cast<ll>(1e18);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9L;


mt19937 rnd(45329843);


void solve(istream& cin, ostream& cout);


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);


	int _ = 1;
	// cin >> _;
	while (_--)
		solve(cin, cout);
}


void solve(istream& cin, ostream& cout) {
	ll n, q;
	cin >> n >> q;
	vector<ll> w(n);
	for (auto& t : w)
		cin >> t;
	sort(w.begin(), w.end());
	ll z;
	cin >> z;


	map<ll, bool> dp, dp_last;
	dp_last[0] = true;
	dp[0] = true;
	for (auto& t : w) {
		for (auto& [x, v] : dp_last) {
			if (x + t <= 1e5)
				dp[x + t] = true;
		}
		dp_last = dp;
	}
	ll max_a = 0;
	for (ll a = 1; a <= ll(1e5); ++a) {
		if (!dp[a])
			break;
		max_a = a;
	}


	while (q--) {
		ll k, a, b;
		cin >> k >> a >> b;

		if (a <= max_a)
			cout << "YES\n";
		else
			cout << "NO\n";
	}


	constexpr ll www = ll(3e5) * ll(3e5) / 64;
	constexpr bool qqq = www <= ll(9e8);
}