#include "bits/stdc++.h"

using namespace std;
#define int long long

#define sz(a)(int)a.size()
#define all(a) a.begin(),a.end()
const int inf = 1e18;
struct info {
    int l, r, ind;
};

void solve() {
    int n;
    cin >> n;
    vector<info> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].l >> a[i].r;
        a[i].ind = i;
    }
    sort(all(a), [&](info u, info v) {
        if (u.r != v.r)
            return u.r < v.r;
        return make_pair(u.l, u.ind) < make_pair(v.l, v.ind);
    });
    vector<int> t;
    int prev = -inf;
    while (true) {
        int found = -1;
        for (int i = 0; i < n && found == -1; ++i)
            if (a[i].r > prev && a[i].l > prev)
                found = i;

        if (found != -1) {
            t.push_back(found);
            prev = a[found].r;
        } else {
            break;
        }
    }
    assert(sz(t) % 2 == 0);
    vector<int> LEFT;
    vector<int> RIGHT;
    for (int i = 0; i < n; ++i) {
        if (a[i].r < a[t[sz(t) / 2]].l)
            LEFT.push_back(i);
        else
            RIGHT.push_back(i);
    }
    if (sz(LEFT) > sz(RIGHT))
        swap(LEFT, RIGHT);
    vector<int> mark(n);
    for (auto x: t)
        mark[x] = 2;
    for (auto x: LEFT)
        mark[x] = 1;
    int cnt = sz(LEFT);
    assert(cnt <= n / 2);
    for (int i = 0; i < n; ++i) {
        if (!mark[i] && cnt + 1 <= n / 2) {
            mark[i] = 1;
            cnt++;
        }
    }
    vector<int> ans;
    for (int i = 0; i < n; ++i) {
        if (!mark[i] || mark[i] == 2)
            ans.push_back(a[i].ind);
    }

    for (auto x: ans)
        cout << x + 1 << " ";
    cout << "\n";
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}
