#include <bits/stdc++.h>
  
using namespace std;
 
void solve() {
    int n;
    cin >> n;
    vector<int> p(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i];
        p[i]--;
    }
    vector<int> down(n + 1, -1);
    down[0] = n;
    vector<int> prv(n, -1);
    int len = 0;
    for (int i = n - 1; i >= 0; --i) {
        int l = 0, r = n;
        while (l < r - 1) {
            int m = (l + r) / 2;
            if (down[m] < p[i]) {
                r = m;
            } else {
                l = m;
            }
        }
        len = max(len, r);
        down[r] = p[i];
        prv[p[i]] = down[l];
    }
    vector<int> used(n);
    int nw = down[len];
    while (nw != -1) {
        used[nw] = 1;
        nw = prv[nw];
    }
    int ans = len;
    int mn = n;
    for (int i = 0; i < n; ++i) {
        if (!used[p[i]]) {
            if (mn > p[i]) {
                ans++;
                mn = p[i];
            }
        }
    }
    cout << ans << '\n';
}
  
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
