#include <bits/stdc++.h>

using namespace std;

const int maxn = 105, maxv = 305;

bool dp[maxn][maxv][maxv];
int mx_b[maxv];

void solve() {
    int n, q;
    cin >> n >> q;
    vector<long long> w(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    sort(w.begin(), w.end());
    dp[0][0][0] = true;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j <= maxv; ++j) {
            for (int k = 0; k <= maxv; ++k) {
                dp[i + 1][j][k] = dp[i][j][k];
                if (j >= w[i] && dp[i][j - w[i]][k]) {
                    dp[i + 1][j][k] = true;
                }
                if (k >= w[i] && dp[i][j][k - w[i]]) {
                    dp[i + 1][j][k] = true;
                }
            }
        }
    }
    for (int a = 0; a < maxv; ++a) {
        mx_b[a] = -1;
        for (int b = 0; b < maxv; ++b) {
            if (dp[n][a][b]) {
                mx_b[a]++;
            } else {
                break;
            }
        }
    }
    int z;
    cin >> z;
    while (q--) {
        long long j, c, d;
        cin >> j >> c >> d;
        if (mx_b[c] >= d) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
