#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <math.h>

using namespace std;
typedef long long ll;

vector<ll> w;

set<pair<ll, ll>> rsz;

void gen(ll k, ll a, ll b, int i) {
	if (i == w.size()) {
		rsz.insert({ a, b });
	}
	else {
		if (w[i] <= k) {
			gen(k, a + w[i], b, i + 1);
			gen(k, a, b + w[i], i + 1);
		}
		gen(k, a, b, i + 1);
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, q;
	cin >> n >> q;
	w.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> w[i];
	}
	int z;
	cin >> z;
	while (q--) {
		rsz.clear();
		ll k, a, b;
		cin >> k >> a >> b;
		gen(k, 0, 0, 0);
		if ((a + 1) * (b + 1) <= rsz.size()) {
			bool fl = 1;
			for (int x = 0; x <= a; ++x) {
				for (int y = 0; y <= b; ++y) {
					fl = fl && (rsz.find({ x,y }) != rsz.end());
				}
			}
			if (fl) {
				cout << "Yes\n";
			}
			else {
				cout << "No\n";
			}
		}
		else {
			cout << "No\n";
		}
	}
	return 0;
}
