#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <math.h>

using namespace std;
typedef long long ll;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, q, z;
	cin >> n >> q;
	vector<ll> w(n);
	for (int i = 0; i < n; ++i) {
		cin >> w[i];
	}
	cin >> z;
	vector<ll> dp(n+1, 0);
	sort(w.begin(), w.end());
	for (int i = 0; i < n; ++i) {
		dp[i + 1] = dp[i];
		if (dp[i] >= w[i] - 1) {
			dp[i+1] = dp[i] + w[i];
		}
	}
	while (q--) {
		ll k, a, b;
		cin >> k >> a >> b;
		int l = 0, r = n+1;
		while (r - l > 1) {
			int md = (l + r) / 2;
			if (w[md - 1] <= k) {
				l = md;
			}
			else {
				r = md;
			}
		}
		if (dp[l] >= a) {
			cout << "Yes" << endl;
		}
		else {
			cout << "No" << endl;
		}
	}
	return 0;
}