#include <iostream>
#include <vector>
#include <algorithm>

#define int long long

const int INF = 2e9;

inline void slave() {
    int n;
    std::cin >> n;
    std::vector<int> a(n);
    for (int i = 0; i < n; i++) {
        std::cin >> a[i];
    }
    std::vector<std::vector<int>> dp(n + 2, std::vector<int> (n + 2, -INF));
    dp[0][n + 1] = 0;
    for (auto e : a) {
        std::vector<std::vector<int>> dp1(n + 2, std::vector<int> (n + 2, -INF));
        for (int i = 0; i <= n + 1; i++) {
            for (int j = 0; j <= n + 1; j++) {
                if (e > i) {
                    dp1[e][j] = std::max(dp1[e][j], dp[i][j] + 1);
                } else {
                    dp1[i][j] = std::max(dp1[i][j], dp[i][j]);
                }
                if (e < j) {
                    dp1[i][e] = std::max(dp1[i][e], dp[i][j] + 1);
                } else {
                    dp1[i][j] = std::max(dp1[i][j], dp[i][j]);
                }
            }
        }
        dp = dp1;
    }
    int ans = 0;
    for (int i = 0; i <= n + 1; i++) {
        for (int j = 0; j <= n + 1; j++) {
            ans = std::max(dp[i][j], ans);
        }
    }
    std::cout << ans << '\n';
}

signed main() {
    //std::cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    std::cin >> t;
    while (t --> 0) {
        slave();
    }
    return 0;
}