#pragma gcc optimize("O3")
#include<bits/stdc++.h>
#define ft first
#define sc second
#define all(x) begin(x),end(x)
typedef long long ll;
typedef __int128 li;
typedef long double ld;
typedef unsigned int ui;
using namespace std;
const ll inf = 1e9;
vector<int> tr;
void upd(int i, int l, int r, int j, int v) {
    if (j < l || r <= j) return;
    if (l+1 == r) {
        tr[i] = v;
    } else {
        int k = (l+r)/2;
        upd(2*i+1, l, k, j, v);
        upd(2*i+2, k, r, j, v);
        tr[i] = max(tr[2*i+1], tr[2*i+2]);
    }
}
int get(int i, int l, int r, int ql, int qr) {
    if (qr <= l || r <= ql) return 0;
    if (ql <= l && r <= qr) return tr[i];
    int k = (l+r)/2;
    return max(get(2*i+1, l, k, ql, qr), get(2*i+2, k, r, ql, qr));
}
void solve() {
    int n, m = 0, l, r;
    cin >> n;
    vector<int> lg(n), rg(n);
    vector<tuple<int, int, int, int>> s;
    map<int, int> a;
    for (int i = 0; i < n; i++) {
        cin >> lg[i] >> rg[i];
        a[lg[i]] = 0;
        a[rg[i]] = 0;
        s.emplace_back(lg[i], -1, i, 0);
        s.emplace_back(rg[i], 1, i, 0);
    }
    int cnt = 1, nn = a.size()+5;
    for (auto &[x, y] : a) y = cnt++;
    for (int i = 0; i < n; i++) {
        lg[i] = a[lg[i]];
        rg[i] = a[rg[i]];
    }
    sort(all(s));
    vector<int> dp(n, 0), dp2(n, 0), st;
    tr.assign(4*nn, 0);
    for (auto [x, t, i, nl] : s) {
        if (t == 1) {
            dp[i] = 1 + get(0, 0, nn, 0, lg[i]);
            m = max(m, dp[i]);
            upd(0, 0, nn, rg[i], dp[i]);
        }
    }
    if (m%2 == 1) cout << 1/0;
    tr.assign(4*nn, 0);
    reverse(all(s));
    for (auto [x, t, i, nl] : s) {
        if (t == -1) {
            dp2[i] = 1 + get(0, 0, nn, rg[i]+1, nn);
            upd(0, 0, nn, lg[i], dp2[i]);
        }
    }
    //assert(m%2 == 0);
    int cm = m, left = 1e9;
    for (auto [x, t, i, nl] : s) {
        if (dp[i] == cm && rg[i] < left) {
            st.push_back(i);
            left = lg[i];
            cm--;
        }
    }
    reverse(all(st));
    vector<int> ans1, ans2, br(n, 0);
    for (int i = 0; i < m/2; i++) {
        br[st[i]] = 1;
        ans1.push_back(st[i]);
        br[st[i+m/2]] = 1;
        ans2.push_back(st[i+m/2]);
    }
    int g = lg[st[m/2]];
    for (int i = 0; i < n; i++) {
        if (br[i]) continue;
        if (lg[i] >= g) {
            ans2.push_back(i);
        } else if (rg[i] < g) {
            ans1.push_back(i);
        } else {
            if (dp[i] <= m/2) ans1.push_back(i);
            else ans2.push_back(i);
        }
    }
    if (ans1.size() < ans2.size()) swap(ans1, ans2);
    assert(ans1.size() >= n/2);
    while (ans1.size() > n/2) ans1.pop_back();
    for (auto i : ans1) cout << i+1 << " ";
    cout << endl;
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
