#include <bits/stdc++.h>

using namespace std;

#define int long long

const int N = 2 * (int) 1e5 + 10;

int n, q;
int x, y, m, l[N], r[N], a[N], dp[N][2];
vector<int> g[N];

void dfs(int v, int p) {
    dp[v][0] = dp[v][1] = 0;
    for(auto u : g[v]){
        if(u != p) {
            dfs(u, v);
            dp[v][0] += max(dp[u][0], dp[u][1]);
            dp[v][1] += dp[u][0];
        }
    }
    dp[v][1] += a[v];
}


pair<int, int> find() {
    dfs(0, -1);
    int res = (x * 1 + y * a[0] * a[0]) % m;
    for(int i = 1; i < n; i++)
        res = (res ^ ((x * (i + 1) + y * a[i] * a[i]) % m));
    return {max(dp[0][0], dp[0][1]), res};
}

void sol() {
    cin >> n >> q;
    cin >> x >> y >> m;
    for(int i = 0; i < n - 1; i++){
        int u, v;
        cin >> u >> v;
        g[u - 1].emplace_back(v - 1);
        g[v - 1].emplace_back(u - 1);
    }
    for(int i = 0; i < n; i++)
        cin >> l[i] >> r[i], a[i] = l[i];
    int f = find().first, s = find().second;
    int qr[q];
    for(int i = 0; i < q; i++){
        cin >> qr[i];
        if(qr[i] == f)
            cout << s << " ";
        else
            cout << "-1 ";
    }
    cout << endl;
    int i;
    while(true){
        cin >> i;
        if(i == 0)
            break;
        if(qr[i - 1] == f){
            for(int ii = 0; ii < n; ii++)
                cout << a[ii] << " ";
            cout << endl;
        }else{
            cout << -1 << endl;
        }
    }
    for(i = 0; i < n; i++)
        g[i].clear(), dp[i][0] = dp[i][1] = 0;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--)
        sol();
    return 0;
}