#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

const ll N = 100'005;

using bs = bitset<N>;

void solve() {
    int n, q;
    cin >> n >> q;
    vector<ll> w(n);
    bs r;
    r[0] = 1;
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
        r |= (r << w[i]);
    }
    int z;
    cin >> z;
    for (int qw = 0; qw < q; ++qw) {
        ll k, a, b;
        cin >> k >> a >> b;
        bool ok = true;
        for (int i = 0; i <= a; ++i) {
            if (!r[i]) {
                ok = false;
            }
        }
        cout << (ok ? "Yes" : "No") << en;
    }
}

int main() {
    int tests = 1;
#ifdef THEEVILBIRD
    freopen("input-c.txt", "r", stdin);
    tests = 1;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
    return 0;
}
