#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

const int N = 100'005;
const int A = 5005;

using bs = bitset<N>;

struct Query {
    ll k, a, b;
    int id;

    Query() = default;

};

void solve() {
    int n, q;
    cin >> n >> q;
    vector<ll> w(n);
    ll sum = 0;
    bs ra, rb;
    ra[0] = 1;
    rb[0] = 1;
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
        ra |= (ra << w[i]);
        sum += w[i];
    }
    sort(all(w));
    int z;
    cin >> z;
    vector<Query> qs(q);
    vector<int> ans(q, 0);
    for (int qw = 0; qw < q; ++qw) {
        cin >> qs[qw].k >> qs[qw].a >> qs[qw].b;
        qs[qw].id = qw;
    }

//    vector<int> prefa(N, 0);
//    prefa[0] = 1;
//    for (int i = 1; i < N; ++i) {
//        prefa[i] = prefa[i - 1] + (ra[i] == 1);
//        if (ra[i] == 1) {
//            rb[sum - i] = 1;
//        }
//    }
//
//    vector<int> prefb(N, 0);
//    prefb[0] = 1;
//    for (int i = 1; i < N; ++i) {
//        prefb[i] = prefb[i - 1] + (rb[i] == 1);
//    }
//
//    for (int qw = 0; qw < q; ++qw) {
//        ll k, a, b;
//        cin >> k >> a >> b;
//        bool ok = (prefa[a] == a + 1) && (prefb[b] == b + 1);
//        cout << (ok ? "Yes" : "No") << en;
//    }

    vector<vector<int>> dp(A, vector<int> (A, 0));
//    vector<vector<int>> ndp(2000, vector<int> (2000, 0));
//    dp[0][0] = 1;
//    ndp[0][0] = 1;

//    for (int i = 0; i < n; ++i) {
//        ndp = dp;
//        for (int a = 0; a < 2000; ++a) {
//            for (int b = 0; b < 2000; ++b) {
//                if (dp[a][b]) {
//                    if (a + w[i] < 2000) {
//                        ndp[a + w[i]][b] = 1;
//                    }
//                    if (b + w[i] < 2000) {
//                        ndp[a][b + w[i]] = 1;
//                    }
//                }
//            }
//        }
//        dp.swap(ndp);
//    }
//
    vector<vector<int>> pref(A, vector<int> (A, 0));
//    pref[0][0] = 1;

//    {
//        vector<int> prefA(2 * A);
//        int now = 0;
//        for (int i = 0; i < 2 * A; ++i) {
//            now += ra[i] == 1;
//            prefA[i] = now == i + 1;
//        }
//        vector<int> nxt(2 * A);
//        int last = 2 * A - 1;
//        for (int i = 2 * A - 1; i >= 0; --i) {
//            if (ra[i] == 0) {
//                last = i;
//            }
//            nxt[i] = last;
//        }
//        now = 0;
//        for (int i = 0; i < A; ++i) {
//            now += ra[i] == 1;
//            if (now == i + 1) {
//                pref[i][0] = 1;
//                int can = nxt[i] - i;
//                pref[i][can] = -1;
//            } else {
//                break;
//            }
//        }
//
//    }
//
//    for (int i = 0; i < A; ++i) {
//        int now = 0;
//        for (int j = 0; j < A; ++j) {
//            now += pref[i][j];
//            dp[i][j] = (now);
//            if (i) {
//                dp[i][j] &= dp[i - 1][j];
//            }
//        }
//    }

//
//    for (int i = 0; i < 2000; ++i) {
//        for (int j = 0; j < 2000; ++j) {
//            bool ok = dp[i][j];
//            if (i > 0) {
//                ok &= (pref[i - 1][j]);
//            }
//            if (j > 0) {
//                ok &= (pref[i][j - 1]);
//            }
//            pref[i][j] = ok;
//        }
//    }

    sort(all(qs), [](Query lhs, Query rhs) {
        return lhs.k < rhs.k;
    });
    int ptr = 0;
    ll can = 0;
    for (int qw = 0; qw < q; ++qw) {
        while (ptr < n && w[ptr] <= qs[qw].k) {
            if (w[ptr] <= can || w[ptr] == can + 1) {
                can += w[ptr];
            }
//            ndp = dp;
//            for (int a = 0; a < 2000; ++a) {
//                for (int b = 0; b < 2000; ++b) {
//                    if (dp[a][b]) {
//                        if (a + w[ptr] < 2000) {
//                            ndp[a + w[ptr]][b] = 1;
//                        }
//                        if (b + w[ptr] < 2000) {
//                            ndp[a][b + w[ptr]] = 1;
//                        }
//                    }
//                }
//            }
//            dp.swap(ndp);
//            for (int i = 0; i < 2000; ++i) {
//                for (int j = 0; j < 2000; ++j) {
//                    bool ok = dp[i][j];
//                    if (i > 0) {
//                        ok &= (pref[i - 1][j]);
//                    }
//                    if (j > 0) {
//                        ok &= (pref[i][j - 1]);
//                    }
//                    pref[i][j] = ok;
//                }
//            }
            ++ptr;
        }
//        ans[qs[qw].id] = dp[qs[qw].a][qs[qw].b];
        ans[qs[qw].id] = qs[qw].a <= can;
    }

    for (auto i : ans) {
        cout << (i ? "Yes" : "No") << en;
    }
}

int main() {
    int tests = 1;
#ifdef THEEVILBIRD
    freopen("input-c.txt", "r", stdin);
    tests = 1;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
    return 0;
}
