#include <iostream>
#include "vector"

#define ll long long
#define all(x) (x).begin(), (x).end()

using namespace std;

vector<vector<int>> g;
vector<pair<int, int>> bord;
vector<int> lst;

void dfs(int v, int r = 0, int prev = -1) {
    if (g[v].empty()) {
        bord[v] = {lst.size(), lst.size()};
        lst.push_back(r);
    } else {
        if (prev == -1) {
            dfs(g[v][0], r, 0);
            dfs(g[v][1], r, 1);
        } else if (prev == 0) {
            dfs(g[v][0], r, 0);
            dfs(g[v][1], r + 1, 1);
        } else {
            dfs(g[v][0], r + 1, 0);
            dfs(g[v][1], r, 1);
        }
        bord[v].first = bord[g[v][0]].first;
        bord[v].second = bord[g[v][1]].second;
    }
}

void solve() {
    int n, k, q; cin >> n >> k >> q;
    g.resize(n);
    for (int i = 0; i < n; ++i) {
        int t; cin >> t;
        if (t) {
            int a, b; cin >> a >> b;
            a--; b--;
            g[i].push_back(a);
            g[i].push_back(b);
        }
    }
    bord.resize(n);
    dfs(0);
    while (q--) {
        int v; cin >> v;
        v--;
        int ans = 0;
        for (int i = bord[v].first; i <= bord[v].second; ++i) {
            if (lst[i] <= k) ans++;
        }
        cout << ans << '\n';
    }
}

signed main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr); cout.tie(nullptr);
    int test = 1;
    while (test--) {
        solve();
    }
}
