#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <numeric>
#include <iomanip>
#include <random>
#include <cassert>

using namespace std;
using ll = long long;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define len(a) (ll) a.size()

const ll INF = 1e18;

void solve() {
    ll GO, Q;
    cin >> GO >> Q;
    while (Q--) {
        ll n, k;
        cin >> n >> k;
        vector<ll> t(k);
        for (auto &i: t)
            cin >> i;
        if (n % 2)
            assert(false);
        vector <ll> ans;
        for (auto& i : t) {
            if (i > n / 2)
                ans.emplace_back(i - n / 2);
            else
                ans.emplace_back(i + n / 2);
        }
        sort(all(ans));
        for (auto& i : ans)
            cout << i << endl;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll T = 1;
    while (T--) {
        solve();
    }
    return 0;
}
