#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <numeric>
#include <iomanip>
#include <random>

using namespace std;
using ll = long long;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define len(a) (ll) a.size()

const ll INF = 1e18;

void solve() {
    ll n; cin >> n;
    vector <ll> p(n);
    for (auto& i : p)
        cin >> i;
    ll ans = 0;
    if (n <= 16) {
        for (ll mask = 0; mask <= (1ll << n); mask++) {
            vector <ll> a, b;
            for (ll i = 0; i < n; i++) {
                if ((mask >> i) & 1)
                    b.emplace_back(p[i]);
                else
                    a.emplace_back(p[i]);
            }
            ll mx = -INF, mn = INF, c = 0;
            for (auto& i : a) {
                if (i > mx) {
                    mx = i;
                    c++;
                }
            }
            for (auto& i : b) {
                if (i < mn) {
                    mn = i;
                    c++;
                }
            }
            ans = max(ans, c);
        }
        cout << ans << '\n';
        return;
    }
    vector <bool> used(n);
    ll mx = -INF;
    for (ll i = 0; i < n; i++) {
        if (p[i] > mx) {
            used[i] = true;
            mx = p[i];
            ans++;
        }
    }
    mx = -INF;
    for (ll i = 0; i < n; i++) {
        if (!used[i]) {
            if (p[i] > mx) {
                mx = p[i];
            } else if (p[i] < mx) {
                ans += 2;
                cout << ans << '\n';
                return;
            }
        }
    }
    if (mx != -INF)
        ans++;
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    ll T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}