#include <bits/stdc++.h>

using namespace std;
vector<vector<int>> graph;
vector<bool> is_marked;
vector<int> cnt;

void dfs(int v, int lft, int prev_dd) {
    if (lft < 0) {
        return;
    }
    if (graph[v].empty()) {
        is_marked[v] = true;
        return;
    }
    if (prev_dd == -1) {
        dfs(graph[v][0], lft, 0);
        dfs(graph[v][1], lft, 1);
        return;
    }
    if (prev_dd == 0) {
        dfs(graph[v][0], lft, 0);
        dfs(graph[v][1], lft - 1, 1);
        return;
    }
    if (prev_dd == 1) {
        dfs(graph[v][0], lft - 1, 0);
        dfs(graph[v][1], lft, 1);
        return;
    }
}

void dfs2(int v) {
    if (is_marked[v]) {
        cnt[v]++;
    }
    if (!graph[v].empty()) {
        dfs2(graph[v][0]);
        dfs2(graph[v][1]);
        cnt[v] += cnt[graph[v][0]];
        cnt[v] += cnt[graph[v][1]];
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, k, q;
    cin >> n >> k >> q;
    graph.resize(n);
    is_marked.assign(n, false);
    cnt.assign(n, 0);
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        while (t--) {
            int a;
            cin >> a;
            a--;
            graph[i].push_back(a);
        }
    }
    dfs(0, k, -1);
    /*for (int el: is_marked) {
        cout << el << ' ';
    }*/
    dfs2(0);
    while (q--) {
        int a;
        cin >> a;
        cout << cnt[a - 1] << '\n';
    }
    return 0;
}
