#include <bits/stdc++.h>

using namespace std;
typedef pair<int, int> pp;

struct Seg {
    int l, r, id;
};

bool cmp1(Seg a, Seg b) {
    if (a.r == b.r) {
        return a.l < b.l;
    }
    return a.r < b.r;
}

int max_chain_lg(vector<Seg> &a) {
    sort(a.begin(), a.end(), cmp1);
    int r = -1, cnt = 0;
    for (int i = 0; i < a.size(); i++) {
        if (a[i].l > r) {
            r = a[i].r;
            cnt++;
        }
    }
    return cnt;
}

int count_bound(vector<Seg> &a, int id, int lg) {
    int r = -1, cnt = 0;
    for (int i = id; i < a.size(); i++) {
        if (a[i].l > r) {
            r = a[i].r;
            cnt++;
            if (cnt == lg) {
                return (int) a.size() - i;
            }
        }
    }
    return 0;
}


/*bool cmp2(Seg a, Seg b) {
    return make_pair(a.l, a.r) < make_pair(b.l, b.r);
}*/

void solve() {
    int n;
    cin >> n;
    vector<Seg> arr(n), source(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i].l >> arr[i].r;
        arr[i].id = i;
        source[i] = arr[i];
    }
    for (int i = 0; i < n / 2; i++) {
        cout << i + 1 << ' ';
    }
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int q;
    cin >> q;
    while (q--) {
        solve();
    }
    return 0;
}