#pragma GCC -Ofast

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vi = vector<int>;
using vll = vector<ll>;

#ifdef LOCAL
#define debug(x) cout << #x << ": " << x << endl;
#else
#define debug(x) ;
#endif
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define ff first
#define ss second
#define pb push_back

typedef tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

void solve();

int tp;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n = 1;
    cin >> tp >> n;
    while (n--) solve();
}

void solve1(ll n, vll &a){
    int k = sz(a);
    vll ans;
    for (ll &i : a) i--;
    int lst = 0;
    int cnt = 0;
    set<bool> used;
    for (int i = 0; i < n; i++) used.insert(i / 2);
    for (int i = 0; i < k; i++){
        ll nm = a[i] / 2;
        used.erase(a[i] / 2);
        if (i + 1 < k && a[i + 1] / 2 == nm) continue;
        if (i > 0 && a[i - 1] / 2 == nm) continue;
        ans.pb(a[i] ^ 1);
    }
    for (int i = 0; i < k; i++){
        if (!binary_search(all(a), a[i] ^ 1)) continue;
        if (a[i] % 2 == 1) continue;
        ll nm = a[i] / 2;
        ll cr;
        if (*used.rbegin() < nm) {
            cr = *used.begin();
            used.erase(used.begin());
        }
        else {
            cr = *used.upper_bound(nm);
            used.erase(cr);
        }
        ans.pb(cr * 2);
        ans.pb(cr * 2 + 1);
    }
    sort(all(ans));
    for (ll i : ans) cout << i + 1 << " ";
    cout << endl;
}

void solve2(ll n, vll &a){
    int k = sz(a);
    vll ans;
    for (ll &i : a) i--;
    int lst = 0;
    int cnt = 0;
    set<bool> used;
    for (int i = 0; i < n; i++) used.insert(i / 2);
    for (int i = 0; i < k; i++){
        used.erase(a[i] / 2);
        if (!binary_search(all(a), a[i] ^ 1)){
            ans.pb(a[i] ^ 1);
            continue;
        }
    }
    for (int i = k - 1; i >= 0; i--){
        if (!binary_search(all(a), a[i] ^ 1)) continue;
        if (a[i] % 2 != 0) continue;
        ll nm = a[i] / 2;
        ll cr;
        if (nm < *used.begin()){
            cr = *used.rbegin();
            used.erase(cr);
        }
        else {
            auto ind = used.lower_bound(nm);
            ind--;
            cr = *ind;
            used.erase(ind);
        }
        ans.pb(cr * 2);
        ans.pb(cr * 2 + 1);
    }
    for (ll i : ans) cout << i + 1 << " ";
    cout << endl;
}

void solve(){
    ll n, k;
    cin >> n >> k;
    n -= n % 2;
    vll a(k);
    for (int i = 0; i < k; i++) cin >> a[i];
    if (tp == 1) solve1(n, a);
    if (tp == 2) solve2(n, a);
}