#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vi = vector<int>;
using vll = vector<ll>;

#ifdef LOCAL
#define debug(x) cerr << #x << " " << x << endl;
#else
#define debug(x) ;
#endif

#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define pb push_back
#define ff first
#define ss second

typedef tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

void solve();

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n = 1;
    //cin >> n;
    while (n--) solve();
}

struct nd {
    ll k, a, b, i;
};

bool cmp(nd a, nd b){
    return a.k < b.k;
}

void solve() {
    int n, q;
    cin >> n >> q;
    vll a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    ll h = 0;
    sort(all(a));

    ll z;
    cin >> z;
    vector<nd> qr(q);
    for (int i = 0; i < q; i++){
        cin >> qr[i].k >> qr[i].a >> qr[i].b;
        qr[i].i = i;
    }
    sort(all(qr), cmp);
    vector<bool> ans(q);
    int l = 0;
    for (int i = 0; i < q; i++){
        while (l < n && a[l] < qr[i].k){
            if (h >= a[l] - 1) h += a[l];
            l++;
        }
        ans[qr[i].i] = qr[i].a >= h;
    }
    for (bool i : ans){
        cout << (i ? "Yes" : "No") << endl;
    }
}