#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <algorithm>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <queue>
#include <fstream>
#include <deque>
#include <stack>

#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
#define endl "\n"
#define speed_up ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)

const ll INF = 1e18;

int main() {
	speed_up;
	cout << fixed;
	cout.precision(10);

	ll t; cin >> t;
	while (t--) {
		ll n; cin >> n;
		vector<ll> vec(n);
		for (ll i = 0; i < n; i++) cin >> vec[i];
		gp_hash_table<ll, gp_hash_table<ll, ll>> now;
		now[vec[0]][n + 1] = 1;
		now[0][vec[0]] = 1;
		
		for (ll i = 0; i < n - 1; i++) {
			gp_hash_table<ll, gp_hash_table<ll, ll>> nnew;
			for (auto &p : now) {
				ll j = p.first;
				for (auto &p2 : p.second) {
					ll k = p2.first;
					ll nxt = vec[i + 1];
					if (nxt > j) nnew[nxt][k] = max(nnew[nxt][k], now[j][k] + 1);
					if (nxt < k) nnew[j][nxt] = max(nnew[j][nxt], now[j][k] + 1);
					if (nxt <= j || nxt >= k) nnew[j][k] = max(nnew[j][k], now[j][k]);
				}
			}
			now = nnew;
		}
		ll ans = 0;
		for (ll i = 0; i < n + 2; i++) {
			for (ll j = 0; j < n + 2; j++) {
				ans = max(ans, now[i][j]);
			}
		}
		cout << ans << endl;
	}
}