#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <algorithm>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <queue>
#include <fstream>
#include <deque>
#include <stack>
#include <random>

using namespace std;

typedef long long ll;
#define endl "\n"
#define speed_up ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)

const ll INF = 1e18;

vector<ll> now;

mt19937 rnd;

vector<vector<ll>> prem;

void gen(ll i, ll cnt) {
	if (cnt < 0) return;
	if (i == 0 && cnt == 0 && now[0] == 1) prem.push_back(now);
	if (i == 0) return;

	now.push_back(1);
	gen(i - 1, cnt - 1);
	now.pop_back();
	now.push_back(0);
	gen(i - 1, cnt);
	now.pop_back();
}

ll mex(vector<ll>& vec) {
	vector<bool> used(vec.size() + 1);
	for (auto p : vec) {
		if (p < used.size()) used[p] = true;
	}
	for (ll i = 0; i < used.size(); i++) {
		if (!used[i]) return i;
	}
	return 0;
}

ll ultra(vector<ll>& vec) {
	ll m = mex(vec);
	for (ll i = 0; i < vec.size(); i++) {
		vec[i] ^= m - 1;
	}
	return m;
}

const ll cnt = 100;

ll check(vector<ll>& vec) {
	vector<ll> v;
	ll cc = 0;
	unordered_map<ll, ll> used;
	for (ll i = 0; i < cnt; i++) {
		v.push_back(ultra(vec));
		if (i > 0 && v[i - 1] == v[i]) cc++;
		else cc = 0;
		if (cc > 1) return v[i];
		if (used[v[i]] > 1) return -1;
		used[v[i]]++;
	}
	bool ans = true;
	for (ll i = cnt / 2; i < cnt - 1; i++) {
		ans &= v[i] == v[i + 1];
		if (!ans) break;
	}
	if (!ans) return -1;
	return v[cnt - 1];
}

int main() {
	speed_up;
	cout << fixed;
	cout.precision(10);

	ll mod; cin >> mod;
	ll t; cin >> t;
	while (t--) {
		ll k, n, p; cin >> k >> n >> p;
		prem.clear();
		gen(1 << k, n);
		ll ans = 0;
		for (ll i = 0; i < prem.size(); i++) {
			vector<ll> vec;
			for (ll j = 0; j < prem[i].size(); j++) {
				if (prem[i][j]) vec.push_back(j);
			}

			ans += check(vec) == p;
		}
		cout << ans << endl;
	}
}