#include <bits/stdc++.h>

using namespace std;

#define rep(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define sz(x) int(size(x))
#define all(x) begin(x), end(x)
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;

vi encode(int n, const vi &a) {
    vi ans(sz(a));
    transform(all(a), begin(ans), [&](int x) {
        return (x + n / 2) % n;
    });
    return ans;
}

vi decode(int n, const vi &a) {
    vi ans(sz(a));
    transform(all(a), begin(ans), [&](int x) {
        return (x - n / 2 + n) % n;
    });
    return ans;
}

int main() {
    cin.tie(nullptr)->exceptions(ios::failbit);
    ios::sync_with_stdio(false);

    int type;
    cin >> type;

    int q;
    cin >> q;
    while (q--) {
        int n, k;
        cin >> n >> k;

        vi a(k);
        for (auto &el: a) cin >> el, --el;
        for (auto el: (type == 1? encode(n, a): decode(n, a))) {
            cout << el + 1 << ' ';
        }
        cout << '\n';
    }
}