#include <bits/stdc++.h>

using namespace std;

#define rep(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define sz(x) int(size(x))
#define all(x) begin(x), end(x)
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;

int mex(const vi &a) {
    int prev = -1;
    for (auto el: a) {
        if (el - prev > 1) {
            return prev + 1;
        }
        prev = el;
    }
    return a.back() + 1;
}

int main() {
    cin.tie(nullptr)->exceptions(ios::failbit);
    ios::sync_with_stdio(false);

    int M;
    cin >> M;

    int t;
    cin >> t;
    while (t--) {
        int k, n, p;
        cin >> k >> n >> p;
        k = 1 << k;

        int ans = 0;

        for (int mask = 1; mask < (1 << k); mask += 2) {
            if (__builtin_popcount(mask) != n) continue;

            vi a;
            a.reserve(n);
            rep(i, 0, k) {
                if ((mask >> i) & 1) {
                    a.push_back(i);
                }
            }
            vi m;
            int cnt = 0;

            map<vi, int> as;
            as[a] = 0;

            bool stable = true;
            while (true) {
                int mx = mex(a);
                m.push_back(mx);
                rep(i, 0, n) a[i] ^= (mx - 1);
                std::sort(a.begin(), a.end());

                if (as.find(a) != as.end()) {
                    int prev = as[a];
                    rep(i, prev, sz(m)) {
                        if (m[i] != mx) {
                            stable = false;
                            break;
                        }
                    }

                    break;
                }
                as[a] = sz(m);
            }

            if (stable && m.back() == p) ans += 1;
        }
        cout << ans << '\n';
    }
}