#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <string>
#include <cmath>

using namespace std;

typedef pair<int, int> pii;

#define X first
#define Y second
#define All(x) (x).begin(), (x).end()
#define f(x) (x + n) % n

signed main()
{
	int run;
	cin >> run;
	int t;
	cin >> t;
	while (t--) {
		if (run == 1) {
			int n, k, v;
			cin >> n >> k;
			vector<int> used(n, 0);
			for (int i = 0; i < k; i++) {
				cin >> v;
				v--;
				used[v] = 1;
			}
			vector<int> ans;
			for (int i = 0; i < n; i++) {
				if (used[i] == 1) {
					int j = i;
					while (used[f(j)] != 0)
						j++;
					used[f(j)] = 2;
					ans.push_back(f(j));
				}
			}
			sort(All(ans));
			for (int x : ans)
				cout << x + 1 << ' ';
			cout << '\n';
			cout << endl;
		}
		else {
			int n, k, v;
			cin >> n >> k;
			vector<int> used(n, 0);
			for (int i = 0; i < k; i++) {
				cin >> v;
				v--;
				used[v] = 1;
			}
			vector<int> ans;
			for (int i = 0; i < n; i++) {
				if (used[i] == 1) {
					int j = i;
					while (used[f(j)] != 0)
						j--;
					used[f(j)] = 2;
					ans.push_back(f(j));
				}
			}
			sort(All(ans));
			for (int x : ans)
				cout << x + 1 << ' ';
			cout << '\n';
			cout << endl;
		}
	}
}