#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <string>
#include <cmath>
#include <set>
#include <cassert>

using namespace std;

typedef pair<int, int> pii;

#define X first
#define Y second
#define All(x) (x).begin(), (x).end()

void solve() {
	int n;
	cin >> n;
	vector<int> p(n);
	for (int i = 0; i < n; i++)
		cin >> p[i];
	int ans = 0;
	for (int mask = 1; mask < (1 << n) - 1; mask++) {
		int mx = -1, mn = n + 1;
		int cur = 0;
		for (int i = 0; i < n; i++) {
			if (mask & (1 << i)) {
				if (p[i] > mx) {
					cur++;
					mx = p[i];
				}
			}
			else {
				if (p[i] < mn) {
					mn = p[i];
					cur++;
				}
			}
		}
		ans = max(ans, cur);
	}
	
	bool ok = 0;

	for (int mask = 1; mask < (1 << n) - 1; mask++) {
		int mx = -1, mn = n + 1;
		bool inc = 1;
		int cur = 0;
		for (int i = 0; i < n; i++) {
			if (mask & (1 << i)) {
				if (p[i] > mx) {
					cur++;
					mx = p[i];
				}
				else
					inc = 0;
			}
			else {
				if (p[i] < mn) {
					mn = p[i];
					cur++;
				}
			}
		}
		ok |= (inc && cur == ans);
	}
	assert(ok);
	cout << ans << '\n';
}

signed main()
{
	int t;
	cin >> t;
	while (t--)
		solve();
}