#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define int ll

int calc(vector<array<int, 3>> a) {
	int n = a.size();
    vector<int> dp(n + 1);
    for (int i = 0; i < n; i++) {
    	dp[i + 1] = 1;
    	dp[i + 1] = max(dp[i + 1], dp[i]);
    	for (int j = 0; j < i; j++) {
    		if (a[j][1] < a[i][0]) {
    			dp[i + 1] = max(dp[i + 1], dp[j + 1] + 1);
    		}
    	}
    }
    return dp[n];
}
 
void solve() {
 
    int n;
    cin >> n;
    std::vector<array<int, 3>> a(n);
    for (int i = 0; i < n; i++) {
    	cin >> a[i][0] >> a[i][1];
    	a[i][2] = i;
    }
    sort(a.begin(), a.end(), [&](array<int, 3> a, array<int, 3> b) {return a[1] < b[1] || a[1] == b[1] && a[0] < b[0];});
    int m = calc(a);
    vector<int> ans(n, 1);

    cerr << "m: " << m << endl;

    for (int _ = 0; _ < n; _++) {
    	vector<int> dp(n + 1);

    	for (int i = 0; i < n; i++) {
    		dp[i + 1] = 1;
    		dp[i + 1] = max(dp[i + 1], dp[i]);
    		if (ans[i]) {
		    	for (int j = 0; j < i; j++) {
		    		if (a[j][1] < a[i][0]) {
		    			dp[i + 1] = max(dp[i + 1], dp[j + 1] + 1);
		    		}
		    	}
		    	if (dp[i + 1] > m / 2) {
		    		// rem
		    		ans[i] = 0;
		    		break;
		    	}
    		}
	    }
    }

    for (int i = 0; i < n; i++) {
    	if (ans[i] == 1) {
    		cout << a[i][2] + 1 << " ";
    	}
    }
    cout << "\n";

}

signed main() {
	ios::sync_with_stdio(0);cin.tie(0);
	int t = 1;
	cin >> t;
	while (t--) solve();
}