#include <bits/stdc++.h>
#define int long long
using namespace std;

int get(int l, int r, int w) {
    return min(min(l - 1, r - w), min(2 * w - r, w - l + 1));
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int h, w, k;
    cin >> w >> h >> k;
    vector<int> row(k * 2), col(k * 2);
    for (int i = 0; i < k; i++) {
        int r, c;
        cin >> r >> c;
        row[i] = r;
        row[i + k] = r + w;
        col[i] = c;
        col[i + k] = c + h;
    }
    sort(row.begin(), row.end());
    sort(col.begin(), col.end());
    int mw = row[k - 1] - row[0] + 1;
    int mh = col[k - 1] - col[0] + 1;
    int answ = 0;
    int ansh = 0;
    for (int i = 1; i < k; i++) {
        int cur1 = row[i + k - 1] - row[i] + 1;
        int cur2 = get(row[i], row[i + k - 1], w);
        if (cur1 < mw) {
            mw = cur1;
            answ = cur2;
        } else if (cur1 == mw && answ > cur2) {
            answ = cur2;
        }
    }
    for (int i = 1; i < k; i++) {
        int cur1 = col[i + k - 1] - col[i] + 1;
        int cur2 = get(col[i], col[i + k - 1], h);
        if (cur1 < mh) {
            mh = cur1;
            ansh = cur2;
        } else if (cur1 == mh && ansh > cur2) {
            ansh = cur2;
        }
    }
    cout << mh * mw << " " << answ + ansh << "\n";
    return 0;
}
