#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <queue>

using std::cin;
using std::cout;
using std::vector;
using std::string;
using ll = long long;
using ld  = long double;
using pl = std::pair<ll, ll>;
using sl = std::pair<ll, vector<pl>>;
#define all(x) x.begin(),x.end()



void solve()
{
	ll n; cin >> n;
	vector<ll> vc(n); for (ll& i : vc)cin >> i;
	
	ll ans = 0;
	for (ll i = 0; i < (1 << n); ++i)
	{
		ll mx = 0;
		ll mn = n + 1;
		ll s = 0;
		for (ll j = 0; j < n; ++j)
		{
			if (i & (1 << j))
			{
				if (mx < vc[j])
				{
					++s;
					mx = vc[j];
				}
			}
			else
			{
				if (mn > vc[j])
				{
					++s;
					mn = vc[j];
				}
			}
		}
		ans = std::max(ans, s);
	}
	cout << '\t';
	cout << ans;
	cout << '\n';
}

int main()
{
	std::ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll t; cin >> t;
	while (t--)
	{
		solve();
	}

}