#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <cassert>
#include <random>
#include <chrono>
#include <iomanip>
#include <fstream>

using namespace std;

#define endl '\n'
#define int long long
#define float long double

random_device rd;
#ifndef int
mt19937 rng(rd());
#else
mt19937_64 rng(rd());
#endif

#ifdef LOCAl
//ifstream input("input");
//#define cin input
#define debug(x) cerr << #x << "=" << (x) << endl
#else
#define debug(x) ;
#endif

template<class T> int ckmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int ckmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void solve1() {
	int n, k;
	cin >> n >> k;
	vector<int> used(n, 0);
	for (int i = 0; i < k; ++i) {
		int x;
		cin >> x;
		--x;
		used[x] = 1;
	}
	for (int i = 1; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			int jj = j ^ i;
			if (jj < n && used[j] == 1 && used[jj] == 0) {
				used[j] = -1;
				used[j ^ i] = 2;
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		if (used[i] == 2) {
			cout << i + 1 << " ";
		}
	}
	cout << endl << flush;
}

void solve2() {
	int n, k;
	cin >> n >> k;
	vector<int> used(n, 0);
	for (int i = 0; i < k; ++i) {
		int x;
		cin >> x;
		--x;
		used[x] = 1;
	}
	for (int i = n - 1; i > 0; --i) {
		for (int j = 0; j < n; ++j) {
			int jj = j ^ i;
			if (jj < n && used[j] == 1 && used[jj] == 0) {
				used[j] = 0;
				used[j ^ i] = 2;
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		if (used[i]) {
			assert(used[i] == 2);
			cout << i + 1 << " ";
		}
	}
	cout << endl << flush;
}


void solve() {
	int t, T;
	cin >> t >> T;
	while (T--) {
		if (t == 1) {
			solve1();
		} else {
			solve2();
		}
	}
}

int32_t main() {
	int T = 1;
	for (int i = 1; i <= T; ++i) {
		cerr << "TEST #" << i << endl;
		solve();
	}
}
