#include <iostream>
#include <iomanip>
#include <cmath>
#include <string>
#include <vector>
#include <cassert>
#include <algorithm>
#include <ctime>
#include <random>
#include <map>
#include <set>

using namespace std;

typedef long long ll;

mt19937 gen(time(0));

ll M;
ll k, n, p;

ll ans = 0;
vector<ll> a = { 0 }, b;
void rec() {
	if (a.size() == n) {
		b = a;
		ll last = -1, mex;
		while (true) {
			vector<bool> used(n + 1, false);
			for (ll elem : b) {
				if (elem <= n) {
					used[elem] = true;
				}
			}
			mex = 0;
			while (used[mex]) {
				mex++;
			}
			for (ll& elem : b) {
				elem ^= (mex - 1);
			}
			if (last == mex) {
				break;
			}
			last = mex;
		}
		if (p == last) {
			ans++;
			if (ans == M) {
				ans = 0;
			}
		}
		return;
	}
	for (ll x = a.back() + 1; x + (n - a.size() - 1) < (1ll << k); x++) {
		a.push_back(x);
		rec();
		a.pop_back();
	}
}

void solve() {
	cin >> k >> n >> p;
	ans = 0;
	rec();
	cout << ans << "\n";
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	ll t = 1;
	cin >> M >> t;
	while (t--) {
		solve();
	}
}