#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define all(x) x.begin(), x.end()

void solve() {
    int n;
    cin >> n;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];

    vector<vector<vector<int>>> dp(n, vector<vector<int>>(n + 1, vector<int> (n + 1, -1)));

    for (int j = 1; j <= n; ++j) {
        for (int k = 1; k <= n; ++k) {
            if (a[0] <= j || a[0] >= k) dp[0][j][k] = 1;
        }
    }

    for (int j = a[0]; j <= n; ++j) dp[0][j][0] = 1;
    for (int k = a[0]; k >= 1; --k) dp[0][0][k] = 1;

    int ans = 1;

    for (int i = 1; i < n; ++i) { // 3
        for (int j = 0; j <= n; ++j) { // 1
            for (int k = 0; k <= n; ++k) { // 8
                dp[i][j][k] = max(dp[i][j][k], dp[i - 1][j][k]);

                if (j == 0) {
                    if (k == 0) continue;

                    int dop = 0;
                    if (k == a[i]) dop = 1;
                    if (dp[i - 1][j][k] != -1) dp[i][j][k] = max(dp[i][j][k], dp[i - 1][j][k] + dop);
                    continue;
                }
                if (k == 0) {
                    int dop = 0;
                    if (j == a[i]) dop = 1;
                    if (dp[i - 1][j][k] != -1) dp[i][j][k] = max(dp[i][j][k], dp[i - 1][j][k] + dop);
                    continue;
                }
                if (a[i] <= j) {
                    for (int new_j = 1; new_j < a[i]; ++new_j) {
                        if (dp[i - 1][new_j][k] != -1) dp[i][j][k] = max(dp[i][j][k], dp[i - 1][new_j][k] + 1);
                    }
                    if (dp[i - 1][0][k] != -1) dp[i][j][k] = max(dp[i][j][k], dp[i - 1][0][k] + 1);
                }
                if (a[i] >= k) {
                    for (int new_k = a[i] + 1; new_k <= n; ++new_k) {
                        if (dp[i - 1][j][new_k] != -1) dp[i][j][k] = max(dp[i][j][k], dp[i - 1][j][new_k] + 1);
                    }
                    if (dp[i - 1][j][0] != -1) dp[i][j][k] = max(dp[i][j][k], dp[i - 1][j][0] + 1);
                }

                ans = max(ans, dp[i][j][k]);
            }
        }
    }

//    for (int i = 0; i < n; ++i) {
//        cout << "! " << i << endl;
//        for (int j = 0; j <= n; ++j) {
//            for (int k = 0; k <= n; ++k) {
//                cout << dp[i][j][k] << ' ';
//            }
//            cout << endl;
//        }
//        cout << endl;
//        cout << endl;
//        cout << endl;
//    }

    cout << ans << '\n';
}

signed main() {
    int tests = 1;
    cin >> tests;

    while (tests--) {
        solve();
    }
}

/*
1
10
3 8 10 4 1 2 7 9 5 6
 */