#include <iostream>
#include <iomanip>
#include <cmath>
#include <vector>
#include <deque>
#include <set>
#include <algorithm>
#include <map>
#define ll long long

const ll inf = 1e18;

using namespace std;

void solve1() {
	ll n, k;
	cin >> n >> k;
	map<ll, ll> u;
	vector<ll> a(k);
	for (ll i = 0; i < k; i++) {
		cin >> a[i];
		a[i]--;
		u[a[i]] = 1;
	}
	ll cnt = 1;
	for (ll i = 1; i < k; i++) {
		if (a[i] - a[i - 1] > 1) {
			for (ll j = a[i - 1] + 1; j < min(a[i - 1] + 1 + cnt, a[i]); j++) {
				u[j] = 2;
			}
			cnt -= min(cnt, a[i] - a[i - 1] - 1);
		}
		cnt++;
	}
	ll ind = a[k - 1] + 1;
	ind %= n;
	while (cnt > 0) {
		if (u[ind] == 0) {
			u[ind] = 2;
			cnt--;
		}
		ind = (ind + 1) % n;
	}
	for (auto& to : u) {
		if (to.second == 2) {
			cout << to.first + 1 << ' ';
		}
	}
	cout << endl;
}

void solve2() {
	ll n, k;
	cin >> n >> k;
	vector<ll> a(k);
	map<ll, ll> u;
	for (ll i = 0; i < k; i++) {
		cin >> a[i];
		a[i]--;
		u[a[i]] = 2;
	}
	ll cnt = 1;
	for (ll i = k - 2; i >= 0; i--) {
		if (a[i + 1] - a[i] > 1) {
			for (ll j = a[i + 1] - 1; j > max(a[i], a[i + 1] - cnt - 1); j--) {
				u[j] = 1;
			}
			cnt -= min(cnt, a[i + 1] - a[i] - 1);
		}
		cnt++;
	}
	ll ind = (a[0] - 1 + n) % n;
	while (cnt > 0) {
		if (u[ind] == 0) {
			u[ind] = 1;
			cnt--;
		}
		ind = (ind - 1 + n) % n;
	}
	for (auto& to : u) {
		if (to.second == 1) {
			cout << to.first + 1 << ' ';
		}
	}
	cout << endl;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	
	ll a;
	cin >> a;
	ll m;
	cin >> m;
	while (m--) {
		if (a == 1) {
			solve1();
		} else {
			solve2();
		}
	}

	return 0;
}