#include <bits/stdc++.h>

#define inf 123456789123456789

typedef long long ll;

using namespace std;

template<typename t1, typename t2>istream& operator>>(istream& din, pair<t1, t2>& p) {
    din >> p.first >> p.second;
    return din;
}

template<typename t1, typename t2>ostream& operator<<(ostream& dout, pair<t1, t2> p) {
    dout << p.first << ' ' << p.second << ' ';
    return dout;
}

template<typename t>istream& operator>>(istream& din, vector<t>& a) {
    for (t& e : a) {
        din >> e;
    }
    return din;
}

template<typename t>ostream& operator<<(ostream& dout, vector<t> a) {
    for (t e : a) {
        dout << e << ' ';
    } dout << '\n';
    return dout;
}

bool cmp(pair<pair<ll, ll>, ll> a, pair<pair<ll, ll>, ll> b) {
    return a.first.second < b.first.second || (a.first.second == b.first.second && a.first.first < b.first.first || (a.first.first == b.first.first && a.second < b.second));
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    ll n, q;
    cin >> n >> q;
    vector<ll> w(n);
    cin >> w;
    sort(w.begin(), w.end());
    ll s = 0;
    for (ll e : w) s += e;
    ll z;
    cin >> z;
    vector<vector<ll>> dp(s+1, vector<ll>(s+1, inf));
    dp[0][0] = 0;
    for (ll i = 0; i < n; i++) {
        for (ll j = s; j >= 0; j--) {
            for (ll k = s; k >= 0; k--) {
                if (j >= w[i]) {
                    dp[j][k] = min(dp[j][k], (dp[j - w[i]][k] != inf ? w[i] : inf));
                } if (k >= w[i]) {
                    dp[j][k] = min(dp[j][k], (dp[j][k - w[i]] != inf ? w[i] : inf));
                }
            }
        }
    }
    for (ll i = 1; i <= s; i++) {
        dp[i][0] = max(dp[i-1][0], dp[i][0]);
    }
    for (ll j = 1; j <= s; j++) {
        dp[0][j] = max(dp[0][j-1], dp[0][j]);
    }
    for (ll i = 1; i <= s; i++) {
        for (ll j = 1; j <= s; j++) {
            dp[i][j] = max(max(dp[i-1][j], dp[i][j-1]), dp[i][j]);
        }
    }
    ll v = 0;
    for (ll i = 1; i <= q; i++) {
        ll j, c, d;
        cin >> j >> c >> d;
        ll k = j - v * z, a = c - v * z, b = d - v * z;
        if (a <= s && b <= s && dp[a][b] <= k) {
            cout << "Yes\n";
            v += i;
        } else {
            cout << "No\n";
        }
    }
    return 0;
}
