
#include <bits/stdc++.h>

using namespace std;
#define int long long

vector<vector<int> > gr, dp;
vector<pair<int, int> > bounds;

void dfs(int v = 0, int pr = -1) {
    dp[v][1] = bounds[v].second;
    dp[v][0] = 0;
    for (auto u: gr[v]) {
        if (u == pr)
            continue;
        dfs(u, v);
        dp[v][1] += dp[u][0];
        dp[v][0] += max(dp[u][0], dp[u][1]);
    }
}

vector<int> besty;

void dfsFindAns(int v, int type, int pr = -1) {
    if (type)
        besty.push_back(v);
    for (auto u: gr[v]) {
        if (u == pr)
            continue;
        if (type)
            dfsFindAns(u, 0, v);
        else {
            int new_type = 0;
            if (dp[u][0] < dp[u][1])
                new_type = 1;
            dfsFindAns(u, new_type, v);
        }
    }
}

void solve() {
    int n, q;
    cin >> n >> q;
    int my_xx, my_yy, mod;
    cin >> my_xx >> my_yy >> mod;
    gr.clear();
    gr.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int x, y;
        cin >> x >> y;
        --x;
        --y;
        gr[x].push_back(y);
        gr[y].push_back(x);
    }
    bounds.clear();
    bounds.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> bounds[i].first >> bounds[i].second;
    }
    vector<int> v(q);
    vector<pair<int, int> > v_sorted(q);
    vector<int> k(q, -1);
    for (int i = 0; i < q; ++i) {
        cin >> v[i];
        v_sorted[i].first = v[i];
        v_sorted[i].second = i;
    }
    dp.clear();
    dp.resize(n, vector<int>(2));
    dfs();
    besty.clear();
    int type = 0;
    if (dp[0][0] < dp[0][1])
        type = 1;
    dfsFindAns(0, type);
    int ans = 0;
    vector<bool> used(n, false);
    for (auto u: besty) {
        used[u] = 1;
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            ans ^= ((my_xx * 1LL * (int) (i + 1) + my_yy * ((bounds[i].second * bounds[i].second) % mod)) % mod);
        }
    }
    sort(v_sorted.begin(), v_sorted.end());
    sort(besty.begin(), besty.end());
    vector<int> suf_xor(besty.size() + 1, 0);
    for (int i = (int) besty.size() - 1; i >= 0; --i) {
        suf_xor[i] = suf_xor[i + 1] ^ ((my_xx * 1LL * (besty[i] + 1)) % mod);
    }
    int pos_i = 0, cur_sum = 0;
    for (auto [vvv, id]: v_sorted) {
        int help_plz = bounds[besty[pos_i]].second;
        while (pos_i < (int) besty.size() && help_plz + cur_sum < vvv) {
            cur_sum += help_plz;
            ans ^= (((my_xx * 1LL * (besty[pos_i] + 1)) % mod) +
                    my_yy * ((help_plz * help_plz) % mod)) % mod;
            pos_i++;
        }
        if (pos_i < (int) besty.size()) {
            if(v[id] != vvv)
                exit(-1);
            k[id] = ans ^ suf_xor[pos_i + 1] ^
                    ((((my_xx * (besty[pos_i] + 1)) % mod) + my_yy * (((vvv - cur_sum) * (vvv - cur_sum)) % mod)) %
                     mod);
        }
    }
    for (auto u: k)
        cout << u << " ";
    cout << endl;
    int c;
    cin >> c;
    while (c > 0) {
        --c;
        if (k[c] == -1) {
            cout << -1 << endl;
            cin >> c;
            continue;
        }
        int cur_ans = 0;
        int cur_ansss = 0;
        for (int i = 0; i < n; ++i) {
            if (!used[i]) {
                cout << 0 << " ";
                cur_ansss ^= ((my_xx * (i + 1)) % mod);
            } else {
                int help = min(v[c] - cur_ans, bounds[i].second);
                cout << help << " ";
                cur_ans += help;
                cur_ansss ^= ((((my_xx * (i + 1)) % mod) + ((my_yy * ((help * help) % mod)) % mod)) % mod);
            }
        }
        if (cur_ansss != k[c])
            exit(-1);
        cout << endl;
        cin >> c;
    }
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}