#include "bits/stdc++.h"

using namespace std;

#define int long long
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define dbg(x) cout << #x << " = " << x << endl;

const int infll = 1e18;

mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

int T;

void decode () {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    if (k == 1) {
        cout << (a[0] + 1) % n + 1 << endl;
    }
}

void encode () {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    if (k == 1) {
        cout << (a[0] - 1 + n * 2) % n + 1 << endl;
    }
}

signed main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef home
    freopen("in.txt", "r", stdin);
#endif
    cin >> T;
    int t = 1;
    cin >> t;
    while (t--) {
        if (T == 1) {
            decode();
        } else {
            encode();
        }
    }
    cout << endl;
    return 0;
}