#include "bits/stdc++.h"

using namespace std;

#define ll long long
#define int long long
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define dbg(x) cout << #x << " = " << (x) << endl;


mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 2e5 + 10;

int l[N], r[N];
vector<int> g[N];

int dp[N][2];

void dfs (int u, int p = -1) {
    dp[u][1] = l[u];
    dp[u][0] = 0;
    for (auto v : g[u]) {
        if (v == p) continue;
        dfs(v, u);
        dp[u][0] += max(dp[v][0], dp[v][1]);
        dp[u][1] += dp[v][0];
    }
}

int add (int a, int b, int m) {
    return (a + b) % m;
}

int mul (int a, int b, int m) {
    return (a * b) % m;
}

void solve() {
    int n, q;
    cin >> n >> q;
    for (int i = 0; i < n; i++) {
        g[i].clear();
    }
    int x, y, m;
    cin >> x >> y >> m;
    for (int i = 0; i < n - 1; i++) {
        cin >> l[i] >> r[i];
    }
    vector<int> v(q);
    for (int i = 0; i < q; i++) {
        cin >> v[i];
    }
    dfs(0);
    int ans = max(dp[0][0], dp[0][1]);
    int plan = 0;
    for (int j = 0; j < n; j++) {
        int value = mul(x, j + 1, m);
        int second = mul(l[j], mul(l[j], y, m), m);
        value = add(value, second, m);
        plan ^= value;
    }
    for (int i = 0; i < q; i++) {
        if (ans == v[i]) {
            cout << plan << " ";
        } else {
            cout << -1 << " ";
        }
        cout << endl;
    }
    while (true) {
        int j;
        cin >> j;
        j--;
        if (j == -1) {
            break;
        }
        if (v[j] == ans) {
            for (int d = 0; d < n; d++) {
                cout << l[d] << " ";
            }
            cout << endl;
        } else {
            cout << -1 << endl;
        }
    }
}

signed main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef home
    freopen("in.txt", "r", stdin);
#endif
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}

// короче план
/*
набираю баллы по CD
come back to B
набираю как можно больше
 */