#include<iostream>
#include<algorithm>
#include<cmath>
#include<vector>
#include<bitset>
using  namespace std;

#define int long long

int w[300005];
pair<int, pair<int, int>>quest[300005];
bitset<100005>dp;
void solve2(int n,int q) {
	dp[0] = 1;
	for (int i = 0; i < n; i++) {
		dp |= (dp << w[i]);
	}
	int pr = 1e5 + 3;
	for (int i = 0; i < 100005; i++) {
		if (dp[i] == 0) {
			pr = i;
			break;
		}
	}
	for (int i = 0; i < q; i++) {
		if (quest[i].second.first < pr)
			cout << "Yes" << '\n';
		else {
			cout << "No" << '\n';
		}
	}
	return;
}

bool dp5[305][305];
bool ans5[305][305];
void solve5(int n, int q) {
	dp5[0][0] = true;
	for (int i = 0; i < n; i++) {
		for (int x = 300; x >= 0; x--) {
			for (int y = 300; y >= 0; y--) {
				if (x >= w[i])
					dp5[x][y] |= dp5[x - w[i]][y];
				if (y >= w[i])
					dp5[x][y] |= dp5[x][y - w[i]];

			}
		}
	}
	
	for (int x = 0; x <= 300; x++) {
		for (int y = 0; y <= 300; y++) {
			ans5[x][y] = dp5[x][y];
			if (x > 0)
				ans5[x][y] &= ans5[x - 1][y];
			if (y > 0)
				ans5[x][y] &= ans5[x][y - 1];
		}
	}
	for (int i = 0; i < q; i++) {
		if (ans5[quest[i].second.first][quest[i].second.second])
			cout << "Yes" << '\n';
		else {
			cout << "No" << '\n';
		}
	}
} 

void solve() {
	int n, q, z;
	cin >> n >> q;
	for (int i = 0; i < n; i++) {
		cin >> w[i];
	}
	cin >> z;
	bool fl2 = true, fl5 = true;
	for (int i = 0; i < q; i++) {
		long long k, a, b;
		cin >> k >> a >> b;
		quest[i] = { k, {a, b} };
		if (b != 0)
			fl2 = false;
		if (a > 300 || b > 300)
			fl5 = false;
	}
	if(n<=10 && q <= 10)
	if (fl2) {
		solve2(n, q);
		return;
	}
	if (fl5 && n <= 100) {
		solve5(n, q);
		return;
	}
}

signed main() {
	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; i++) {
		solve();
	}
}