#pragma GCC optimize("Ofast", "inline", "no-stack-processor")
#include <bits/stdc++.h>
using namespace std;

//#define endl "\n"
#define int long long
#define all(a) a.begin(), a.end()
#define uni(a) sort(all(a)); a.erase(unique(all(a)), a.end())
#define pii pair<int, int>
#define X first
#define Y second

using namespace std;

template<typename T, typename G>
bool rmax(T &a, G b1) {
    T b = b1;
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T, typename G>
bool rmin(T &a, G b1) {
    T b = b1;
    if (b < a) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
istream& operator >> (istream& in, vector<T> &a) {
    for (auto &it : a) {
        in >> it;
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& in, vector<T> &a) {
    for (auto &it : a) {
        in << it << ' ';
    }
    return in;
}

int M;

int add(int a, int b) {
    int c = (a + b - M);
    while (c < 0) {
        c += M;
    }
    return c;
}

int mul(int a, int b) {
    int c = (a * b) % M;
    if (c < 0) {
        c += M;
    }
    return c;
}

const int MAXN = 10;
bool matr[MAXN][MAXN];
map<int, vector<int>> my;

void perebor(int curr, vector<int> plan, vector<pii> ogr) {
    if (curr == ogr.size()) {
        int n = ogr.size();
        for (int mask = 0; mask < (1 << ogr.size()); mask++) {
            vector<int> activated;
            bool good = 1;
            int sum;
            for (int i = 0; i < n; i++) {
                if (mask & (1 << i)) {
                    for (int &it : activated) {
                        if (matr[it][i] == 1) {
                            good = 0;
                            break;
                        }
                    }
                }
                activated.push_back(i);
                sum += plan[i];
                if (!good) {
                    break;
                }
            }

            if (good) {
                my[sum] = plan;
            }
        }
        return;
    }

    for (int i = ogr[curr].X; i <= ogr[curr].Y; i++) {
        plan.push_back(i);
        perebor(curr + 1, plan, ogr);
        plan.pop_back();
    }
}

void solve() {
    for (int i = 0; i < MAXN; i++) {
        for (int j = 0; j < MAXN; j++) {
            matr[i][j] = 0;
        }
    }
    my.clear();

    int n, q;
    cin >> n >> q;

    int x, y;
    cin >> x >> y >> M;

    for (int i = 0; i + 1 < n; i++) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        matr[u][v] = matr[v][u] = 1;
    }

    vector<pii> ogr;
    for (int i = 0; i < n; i++) {
        int l, r;
        cin >> l >> r;

        ogr.emplace_back(l, r);
    }
    vector<int> plan;

    perebor(0, plan, ogr);

    vector<vector<int>> v1;
    while (q--) {
        int v;
        cin >> v;

        if (my.count(v) != 0) {
            vector<int> plan = my[v];
            int sert = 0;

            for (int i = 0; i < n; i++) {
                int val = mul(x, i + 1);
                int val2 = mul(plan[i], plan[i]);
                val2 = mul(val2, y);
                val = add(val, val2);
                sert ^= val;
            }
            v1.push_back(plan);
            cout << sert << endl;
        } else {
            v1.push_back({-1});
            cout << -1 << endl;
        }
    }

    int p;
    cin >> p;

    while (p != 0) {
        cout << v1[p - 1] << endl;
        cin >> p;
    }
}

signed main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

#ifdef LOCAL_CLION
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif

    int t = 1;
    cin >> t;

    while (t--) {
        solve();
    }
}
