#include <bits/stdc++.h>

#define all(x) (x).begin(),(x).end()
#define len(x) (int)(x).size()

typedef long long ll;
using namespace std;

#define MT

struct cut {
    int l, r, ind;
};

int n, m;
vector<cut> cuts;

struct sost {
    int i, j, k;
};

void solve_stupid() {

    bool flag = false;
    function<void(int, int, vector<int>&)> gen = [&] (int curr, int cnt, vector<int>& arr) {
        if (flag)
            return;
        if (cnt > (n - curr))
            return; // слишком много нужно еще выбрать
        if (curr == n) {
            // обрабатываем arr
            if (cnt)
                return;

            int last = -1e9;
            int res = 0;
            for (auto &ind : arr) {
                cut c = cuts[ind];
                if (last < c.l) {
                    last = c.r;
                    ++res;
                }
            }

            if (res == m / 2) {
                flag = true;
                for (auto &el : arr) {
                    cout << cuts[el].ind + 1 << ' ';
                }
                cout << '\n';
                return;
            }
        } else {
            if (cnt) {
                arr.push_back(curr);
                gen(curr + 1, cnt - 1, arr);
                arr.pop_back();
            }
            gen(curr + 1, cnt, arr);
        }
    };

    vector<int> arr;
    gen(0, n / 2, arr);
}

void solve_smarter() {
    vector<vector<vector<int>>> dp(n + 1, vector<vector<int>>(n + 1, vector<int>(n + 1, false)));
//
//    for (int i = 0; i < n; ++i) {
//        dp[i][]
//    }
}

void solve() {
    cin >> n;
    cuts.resize(n);
    for (int i = 0; i < n; ++i) {
        int l, r;
        cin >> l >> r;
        cuts[i] = {l, r, i};
    }

    sort(all(cuts), [&](const cut &c1, const cut &c2) {
        if (c1.r == c2.r) {
            return c1.l > c2.l;
        }
        return c1.r < c2.r;
    });

    int last = -1e9;
    m = 0;
    for (auto &el: cuts) {
        if (el.l > last) {
            ++m;
            last = el.r;
        }
    }

    if (n <= 30) {
        solve_stupid();
    } else {
        for (int i = 0; i < n / 2; ++i) {
            cout << i + 1 << ' ';
        }
        cout << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
#ifdef MT
    cin >> T;
#endif
    while (T--) {
        solve();
    }
    return 0;
}