#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int time=0;

void dfs(int v, vector <vector <int> > &versh, vector <int> &ans, int last=0)
{
    for (int i=0; i<versh[v].size(); i++)
    {
        if (last==1 and i==1)
        {
            ans[versh[v][i]]=ans[v]+1;
        }
        else if (last==2 and i==0)
        {
            ans[versh[v][i]]=ans[v]+1;
        }
        else
        {
            ans[versh[v][i]]=ans[v];
        }
        dfs(versh[v][i],versh,ans,i+1);
    }
}

void dfs2(int v, vector <vector <int> > &versh, vector <int> &ans, vector <int> &ans2, int k)
{
    for (int i=0; i<versh[v].size(); i++)
    {
        dfs2(versh[v][i],versh,ans,ans2,k);
        ans2[v]+=ans2[versh[v][i]];
    }
    if (versh[v].size()==0 and ans[v]<=k)
    {
        ans2[v]++;
    }
}

void solve()
{
    int n,k,q;
    cin>>n>>k>>q;
    vector <vector <int> > versh(n);
    for (int i=0; i<n; i++)
    {
        int o;
        cin>>o;
        for (int j=0; j<o; j++)
        {
            int x;
            cin>>x;
            x--;
            versh[i].push_back(x);
        }
    }
    vector <int> ans(n,0),ans2(n,0);
    dfs(0,versh,ans);
    dfs2(0,versh,ans,ans2,k);
    for (int i=0; i<q; i++)
    {
        int x;
        cin>>x;
        x--;
        cout<<ans2[x]<<"\n";
    }
}

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    int t=1;
    //cin>>t;
    while (t--)
    {
        solve();
    }
    return 0;
}
