#include <bits/stdc++.h>

#define pb push_back
#define st string
#define vec vector
#define ff first
#define ss second
#define all(a) a.begin(), a.end()
#define int long long

#define endl "\n";

using namespace std;
using vi = vec<int>;
using vvi = vec<vi>;
using pi = pair<int, int>;
using vpi = vec<pi>;

vi t;

void build(int v, int tl, int tr, vi &a) {
    if (tr - tl == 1) {
        t[v] = a[tl];
        return;
    }
    int m = (tl + tr) / 2;
    build(2 * v + 1, tl, m, a);
    build(2 * v + 2, m, tr, a);
    t[v] = max(t[2 * v + 1], t[2 * v + 2]);
}

int get(int v, int tl, int tr, int l, int r) {
    if (l >= tr || r <= tl) {
        return 0;
    }
    if (tl >= l && tr <= r) {
        return t[v];
    }
    int m = (tl + tr) / 2;
    int ans1 = get(2 * v + 1, tl, m, l, r);
    int ans2 = get(2 * v + 2, m, tr, l, r);
    return max(ans1, ans2);
}

void upd(int v, int tl, int tr, int id, int val) {
    if (tr - tl == 1) {
        t[v] = val;
        return;
    }
    int m = (tl + tr) / 2;
    if (id < m) {
        upd(2 * v + 1, tl, m, id, val);
    }
    else {
        upd(2 * v + 2, m, tr, id, val);
    }
    t[v] = max(t[2 * v + 1], t[2 * v + 2]);
}

// < x
int gett(vi &a, int r, int x) {
    int n = a.size();
    int k = 1;
    while (k < n) {
         k *= 2;
    }
    t.assign(2 * k - 1, 0);
    int ans = 0;
    int mx = 0;
    for (int i = 0; i <= r; i++) {
        if (a[i] < x) {
            ans = get(0, 0, n, mx, a[i] + 1) + a[i] + 1;
            upd(0, 0, n, a[i], ans);
            mx = a[i];
        }
        else {
            int xx = get(a[i] - 1) + a[i] + 1;
            upd(a[i], n, xx);
        }
    }
    return get(n - 1);
}

void solve() {
    int n;
    cin >> n;
    vi a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
    }
    // sum
    vvi dp1(n, vi(n, -1));
    for (int i = 0; i < n; i++) {
        for (int j = n - 1; j >= 0; j--) {
            dp1[i][j] = gett(a, i, j);
        }
    }

    for (auto u : dp1[n - 1]) {
        cout << u << " ";
    }
    cout << endl;

    vvi dp2(n, vi(n, -1));
    for (int i = 0; i < n; i++) {
        if (i) {
            dp2[i][n - 1] = dp2[i - 1][n - 1];
        }
        for (int j = n - 2; j >= 0; j--) {
            dp2[i][j] = dp2[i][j + 1];
            if (j == a[i]) {
                dp2[i][a[i]] = max(dp2[i][a[i]], dp1[i][a[i]] + a[i] + 1);
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        ans = max(ans, dp2[n - 1][i]);
    }
    cout << ans << endl;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }
}
