#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

pair<ll, ll> slv(deque<pair<int, int>> cs, int n) {
    sort(cs.begin(), cs.end());
    int ans = cs.back().first - cs.front().first + 1, steps = 0, add = 0;
    if (ans == 1) return {1, 0};
    for (int i = 0; i < (int)cs.size(); ) {
        int bx = cs.back().first;
        while (cs.back().first == bx && i < cs.size()) {
            cs.push_front(cs.back());
            cs.pop_back();
            i++;
        }
        bx = (bx + add) % n;
        if (bx == 0) bx = n;
        add += n - bx + 1;
        int nans = (cs.back().first + add) % n;
        if (nans == 0) nans = n;
        if (nans < ans) {
            ans = nans;
            steps = add;
        }
        /*cout << add << '\n';
        cout << "omg\n";
        for (auto e : cs) {
            cout << e.first << '\n';
        }*/
    }
    return {ans, min(steps, n - steps)};
}

void solve() {
    int h, w;
    cin >> h >> w;
    int k;
    cin >> k;
    deque<pair<int, int>> cs;
    for (int i = 0; i < k; i++) {
        int x, y;
        cin >> x >> y;
        cs.push_back({x, y});
    }
    auto [ansx, stepsx] = slv(cs, h);
    for (int i = 0; i < k; i++) {
        swap(cs[i].first, cs[i].second);
    }
    /*cout << "kek\n";
    for (auto [x, y] : cs) {
        cout << x << ' ' << y << '\n';
    }
    cout << "kek\n";*/
    auto [ansy, stepsy] = slv(cs, w);
    //cout << ansy << ' ' << stepsy << '\n';
    cout << ansx * ansy << ' ' << stepsx + stepsy << '\n';
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    t = 1;
    for (int i = 0; i < t; i++) solve();
}
