#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4.1")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

vector<int> solve1(int n, int k, vector<int> &v);
vector<int> solve2(int n, int k, vector<int> &v);

void print(vector<int> v){
    sort(v.begin(), v.end());
    if (unique(v.begin(), v.end()) != v.end()){
//        while (true){
//
//        }
    }
    for (auto el : v){
        cout << el + 1 << ' ';
    }
    cout << endl;
}

tuple<int, int, vector<int>> input(){
    int n, k;
    cin >> n >> k;
    vector<int> v(k);
    for (int i = 0; i < k; ++i) {
        cin >> v[i];
        v[i]--;
    }
    sort(v.begin(), v.end());
    return {n, k, v};
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int z;
    int t;
    cin >> z >> t;
    for (int i = 0; i < t; ++i) {
        auto [n, k, v] = input();
        if (z == 1){
            print(solve1(n, k, v));
        } else{
            print(solve2(n, k, v));
        }
//        if (solve2(n, k, solve1(n, k, v)) != v){
//            while (true){
//
//            }
//        }
    }
}

vector<int> solve1(int n, int k, vector<int> &v){
    vector<bool> used(n, false);
    for (int i = 0; i < k; ++i) {
        used[v[i]] = true;
    }
    vector<int> w;
    int bal = 0;
    for (int i = 0; i < n; ++i) {
        if (used[i]){
            bal++;
        } else{
            if (bal){
                bal--;
                used[i] = true;
                w.push_back(i);
            }
        }
    }
    for (int i = 0; w.size() < k; ++i) {
        if (!used[i]) {
            used[i] = true;
            w.push_back(i);
        }
    }
    return w;
}

vector<int> solve2(int n, int k, vector<int> &v){
    vector<bool> used(n, false);
    for (int i = 0; i < k; ++i) {
        used[v[i]] = true;
    }
    vector<int> w;
    int bal = 0;
    int i = 0;
    while (used[i]) {
        ++i;
    }
    i = (i - 1 + n) % n;
    for (; i >= 0; --i) {
        if (used[i]){
            bal++;
        } else{
            if (bal){
                bal--;
                w.push_back(i);
            }
        }
    }
    if (w.size() < k){
        i = n - 1;
        for (; w.size() < k && i >= 0; --i) {
            if (used[i]){
                bal++;
            } else{
                if (bal){
                    bal--;
                    w.push_back(i);
                }
            }
        }
    }
    return w;
}

