#pragma GCC optimize/("Ofast,unroll-loops")
#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4.1")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;
using ll = long long;

void solve();
const int maxa = 300;
const int maxb = 300;
const int maxn = 100;
bool dp[maxn + 1][maxa + 1][maxb + 1];


signed main(){
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
    int n;
    cin >> n;
    int q;
    cin >> q;
    vector<ll> v(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }
    sort(v.begin(), v.end());
    for (int nn = 0; nn <= n; ++nn) {
        dp[nn][0][0] = true;
        for (int i = 0; i < nn; ++i) {
            for (int a_ = maxa; a_ >= 0; --a_) {
                for (int b_ = maxb; b_ >= 0; --b_) {
                    if (a_ >= v[i]) {
                        dp[nn][a_][b_] = dp[nn][a_][b_] || dp[nn][a_ - v[i]][b_];
                    }
                    if (b_ >= v[i]) {
                        dp[nn][a_][b_] = dp[nn][a_][b_] || dp[nn][a_][b_ - v[i]];
                    }
                }
            }
        }
        for (int i = 0; i <= maxa; ++i) {
            for (int j = 0; j <= maxb; ++j) {
                if (i > 0) {
                    dp[nn][i][j] = dp[nn][i][j] && dp[nn][i - 1][j];
                }
                if (j > 0) {
                    dp[nn][i][j] = dp[nn][i][j] && dp[nn][i][j - 1];
                }
            }
        }
    }
    int z;
    cin >> z;
    for (int i = 0; i < q; ++i) {
        ll k, a, b;
        cin >> k >> a >> b;
        int n_ = upper_bound(v.begin(), v.end(), k) - v.begin();
        if (dp[n_][a][b]){
            cout << "Yes" << '\n';
        } else{
            cout << "No" << '\n';
        }
    }
    cout << endl;
}
