#include <bits/stdc++.h>

#define x first
#define y second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define ll int64_t
#define ld long double

#define int ll
#define double ld
#define endl '\n'


using namespace std;

const int inf = 1e9;
const int INF = 1e18;

const int maxn = 3e5;

int w[maxn];

struct Req {
    int k, a, b, i;
};


void solve() {
    int n, q;
    cin >> n >> q;
    for (int i = 0; i < n; ++i)
        cin >> w[i];
    sort(w, w + n);

    int z;
    cin >> z;

    vector<Req> req(q);
    for (int i = 0; i < q; ++i) {
        int j, c, d;
        cin >> j >> c >> d;

        int k = j, a = c, b = d;
        req[i].k = k;
        req[i].a = a;
        req[i].b = b;
        req[i].i = i;
    }

    sort(all(req), [&](auto a, auto b) {
        return a.k < b.k;
    });
    vector<bool> ans(q);


    vector<pair<int, int>> flex;
    flex.push_back({0, 0});

    auto process = [&](int x) {
        vector<pair<int, int>> new_flex = flex;

        for (auto e : flex) {
            new_flex.push_back({e.x + x, e.y});
            if (e.y + 1 >= x) {
                new_flex.push_back({e.x, e.y + x});
            }
        }

        sort(all(new_flex), [&](auto a, auto b) {
           if (a.x != b.x)
               return a.x < b.x;
           return a.y > b.y;
        });

        flex.resize(0);

        int lst = -1, r = INF;

        for (auto e : new_flex) {
            if (e.x == lst)
                continue;
            lst = e.x;

            if (e.y < r) {
                flex.push_back(e);
                r = e.y;
            } else {
                e.y = r;
                flex.push_back(e);
            }
        }

        sort(all(flex));
    };

    int j = 0;
    for (auto e : req) {
        while (j < n and w[j] <= e.k) {
            process(w[j]);
            ++j;
        }

        auto g = lower_bound(all(flex), make_pair(e.a, (int)-1)) - flex.begin();
        if (g == flex.size() or flex[g].y < e.b)
            ans[e.i] = false;
        else
            ans[e.i] = true;
    }

    for (auto e : ans) {
        cout << (e ? "Yes" : "No") << endl;
    }
}

signed main() {
#ifndef LOCAL
    cin.tie(NULL);
    cout.tie(NULL);
    ios_base::sync_with_stdio(false);
#endif

    solve();

    return 0;
}