#include <bits/stdc++.h>

#define x first
#define y second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define ll int64_t
#define ld long double

#define int ll
#define double ld
#define endl '\n'


using namespace std;

const int inf = 1e9;

const int maxn = 3e5;
const int maxa = 1500;

int dp[maxa + 1][maxa + 1];

int w[maxn];

void solve() {
    int n, q;
    cin >> n >> q;
    for (int i = 0; i < n; ++i)
        cin >> w[i];
    sort(w, w + n);

    for (int i = 0; i <= maxa; ++i) {
        for (int j = 0; j <= maxa; ++j) {
            dp[i][j] = inf;
        }
    }

    dp[0][0] = -1;
    for (int i = 0; i <= maxa; ++i) {
        for (int j = 0; j <= maxa; ++j) {
            for (int v = dp[i][j] + 1; v < n; ++v) {
                if (i + w[v] <= maxa)
                    dp[i + w[v]][j] = min(dp[i + w[v]][j], v);
                if (j + w[v] <= maxa)
                    dp[i][j + w[v]] = min(dp[i][j + w[v]], v);
            }
        }
    }

    int z;
    cin >> z;

    for (int i = 0; i < q; ++i) {
        int j, c, d;
        cin >> j >> c >> d;

        int k = j, a = c, b = d;


        int res = -1;
        for (int x = 0; x <= a; ++x) {
            for (int y = 0; y <= b; ++y) {
                res = max(res, dp[x][y]);
            }
        }

        if (res == inf or (res != -1 and w[res] > k)) {
            cout << "No" << endl;
            continue;
        }

        cout << "Yes" << endl;
    }
}

signed main() {
#ifndef LOCAL
    cin.tie(NULL);
    cout.tie(NULL);
    ios_base::sync_with_stdio(false);
#endif

    solve();

    return 0;
}
