#include <bits/stdc++.h>

#define x first
#define y second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define ll int64_t
#define ld long double

#define int ll
#define double ld


using namespace std;

const int maxn = 2e5;

vector<int> g[maxn + 1];
int l[maxn + 1];
int r[maxn + 1];

int mx[maxn + 1][2];
int mn[maxn + 1][2];
int vl[maxn + 1][2];

int a[maxn + 1];
int parent[maxn + 1];

void dfs(int u, int p) {
    parent[u] = p;
    mx[u][0] = mx[u][1] = 0;
    mn[u][0] = mn[u][1] = 0;

    mx[u][1] = r[u];
    mn[u][1] = l[u];

    for (int v : g[u]) {
        if (v == p)
            continue;

        dfs(v, u);


        mx[u][0] += max(mx[v][0], mx[v][1]);
        mn[u][0] += max(mn[v][0], mn[v][1]);

        mx[u][1] += mx[v][0];
        mn[u][1] += mn[v][0];
    }
}

int amogus = 0;

void proc(int u) {
    vl[u][0] = vl[u][1] = 0;

    if (u <= amogus)
        vl[u][1] = r[u];
    else
        vl[u][1] = a[u];

    for (int v : g[u]) {
        if (v != parent[u]) {
            vl[u][0] += max(vl[v][0], vl[v][1]);
            vl[u][1] += vl[v][0];
        }
    }
}

void flexdfs(int u, int p) {
    for (int v : g[u]) {
        if (v == p)
            continue;
        flexdfs(v, u);
    }
    proc(u);
}


void up(int u) {
    while (u != 0) {
        proc(u);
        u = parent[u];
    }
}

int x, y, m;
int n, q;

int aboba(int start = -1) {
    if (start == -1)
        flexdfs(1, 0);
    else
        up(start);

    int res = max(vl[1][0], vl[1][1]);
    return res;
}

int d[maxn + 1];
int start[maxn + 1];

int pref[maxn + 2];
int suff[maxn + 2];

int flex(int val, bool print) {
    amogus = upper_bound(d, d + n + 1, val) - d - 1;

    if (d[amogus] == val) {
        if (print)
            return pref[amogus] ^ suff[amogus + 1];
        else {
            for (int i = 1; i <= amogus; ++i)
                cout << r[i] << " ";
            for (int i = amogus + 1; i <= n; ++i)
                cout << l[i] << " ";
            cout << endl;

            return 1000-7;
        }
    }


    int i = amogus + 1;
    int we = start[i] + val - d[amogus];

    if (print) {
        return pref[amogus] ^ ((((x * i  % m + y * (we * we % m) % m) % m))) ^ suff[amogus + 2];
    }

    for (int i = 1; i <= amogus; ++i) {
         cout << r[i] << " ";
    }
    cout << start[i] + val - d[amogus] << " ";
    for (int i = amogus + 2; i <= n; ++i)
        cout << l[i] << " ";
    cout << endl;

    return 1000-7;
}

void precalc() {
    for (int i = 1; i <= n; ++i)
        a[i] = l[i];

    suff[n + 1] = 0;
    for (int i = 1; i <= n; ++i) {
        pref[i] = pref[i - 1] ^ (((x * i  % m + y * (r[i] * r[i] % m) % m) % m));
    }
    for (int i = n; i >= 1; --i) {
        suff[i] = suff[i + 1] ^ (((x * i  % m + y * (l[i] * l[i] % m) % m) % m));
    }

    for (int i = 0; i <= n; ++i) {
        amogus = i;

        if (i == 0)
            d[i] = aboba();
        else
            d[i] = aboba(i);
    }

    amogus = 0;
    aboba();

    for (int i = 1; i <= n; ++i) {
        amogus = i - 1;
        int v = d[i - 1];

        int left = l[i], right = r[i] + 1;
        while (left + 1 != right) {
            int mid = (left + right) / 2;
            a[i] = mid;
            int res = aboba(i);
            if (res == v)
                left = mid;
            else
                right = mid;
        }
        start[i] = left;
        a[i] = l[i];
        aboba();
    }
}

void solve() {
    cin >> n >> q;
    for (int i = 1; i <= n; ++i) {
        g[i].clear();
    }

    cin >> x >> y >> m;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    for (int i = 1; i <= n; ++i) {
        cin >> l[i] >> r[i];
    }

    dfs(1, 0);

    precalc();

    int le = max(mn[1][0], mn[1][1]);
    int b = max(mx[1][0], mx[1][1]);

    vector<int> ask(q);
    for (int & e : ask)
        cin >> e;

    for (int v : ask) {
        if (v < le or b < v) {
            cout << -1 << " ";
            continue;
        }

        cout << flex(v, true) << " ";
    }
    cout << endl;


    while (true) {
        int i;
        cin >> i;
        if (i == 0)
            break;
        --i;

        if (le <= ask[i] and ask[i] <= b) {
            flex(ask[i], false);
        } else {
            cout << -1;
        }

        cout << endl;
    }
}

signed main() {
#ifndef LOCAL
    cin.tie(NULL);
    cout.tie(NULL);
    ios_base::sync_with_stdio(false);
#endif
    int t;
    cin >> t;
    while (t--)
        solve();

    return 0;
}