#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;

int fw[700][700];
const int sz = 310;
int askin(int out, int r) {
	int ans = 0;
	while (r >= 0) {
		ans += fw[out][r];
		r = (r & (r + 1)) - 1;
	}
	return ans;
}
int askin(int out, int l, int r) {
	return askin(out, r) - askin(out, l - 1);
}
void addin(int out, int pos,int val) {
	while (pos < sz) {
		fw[out][pos] += val;
		pos = pos | (pos + 1);
	}
}
int ask(int r, int lin, int rin) {
	int ans = 0;
	while (r >= 0) {
		ans += askin(r, lin, rin);
		r = (r & (r + 1)) - 1;
	}
	return ans;
}
int ask(int l, int r, int lin, int rin) {
	return ask(r, lin, rin) - ask(l - 1, lin, rin);
}
void add(int pos, int posin, int val) {
	while (pos < sz) {
		addin(pos, posin, val);
		pos = pos | (pos + 1);
	}
}
int fw2[700][700];
int  main() {
	int n,q;
	cin >> n>>q;
	vector<long long> w(n);
	for (int i = 0; i < n; i++) {
		cin >> w[i];
	}
	sort(w.begin(), w.end());
	vector<int> k(q);
	vector<int> a(q), b(q);
	vector<int> rqs(q);
	int z;
	cin >> z;
	for (int i = 0; i < q; i++) {
		cin >> k[i] >> a[i] >> b[i];
		rqs[i] = i;
	}
	sort(rqs.begin(), rqs.end(), [&](int aa, int bb) {
		return k[aa] < k[bb]; });


	vector<int> ans(q);
	int proc = -1;
	add(0, 0, 1);
	//fw[0][0] = 1;
	
	for (int zz = 0; zz < n; zz++) {
		
			for (int i = sz - 1; i >= 0; i--) {
				for (int j = sz - 1; j >= 0; j--) {
					if ((long long)i >= w[zz]) {
						if (!ask(i, i, j, j) && ask(i - w[zz], i - w[zz], j, j)) {
							add(i, j, 1);
						}
					}
					if ((long long)j >= w[zz]) {
						if (!ask(i, i, j, j) && ask(i, i, j - w[zz], j - w[zz])) {
							add(i, j, 1);
						}
					}
				}
			}
		
	}
	/*for (int i = 0; i < sz; i++) {
		for (int j = 0; j < sz; j++) {
			if (i != 0) {
				fw[i][j] += fw[i - 1][j];
			}
			if (j != 0) {
				fw[i][j] += fw[i][j - 1];
			}
			if (i != 0 && j != 0) {
				fw[i][j] -= fw[i - 1][j - 1];
			}
		}
	}*/
	for (int qq = 0; qq < q; qq++) {
		int kk = k[rqs[qq]];
		int aa = a[rqs[qq]];
		int bb = b[rqs[qq]];
		
	
		
		int exp = (aa + 1) * (bb + 1);
		int real = ask(0,aa,0,bb);
		
		if (exp == real) {
			ans[rqs[qq]] = 1;
		}

	}
	for (auto h : ans) {
		if (h) {
			cout << "Yes"<<endl;
		}
		else {
			cout << "No"<<endl;
		}
	}
}