#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;

int fw[700][700];
const int sz = 305;
int askin(int out, int r) {
	int ans = 0;
	while (r >= 0) {
		ans += fw[out][r];
		r = (r & (r + 1)) - 1;
	}
	return ans;
}
int askin(int out, int l, int r) {
	return askin(out, r) - askin(out, l - 1);
}
void addin(int out, int pos, int val) {
	while (pos < sz) {
		fw[out][pos] += val;
		pos = pos | (pos + 1);
	}
}
int ask(int r, int lin, int rin) {
	int ans = 0;
	while (r >= 0) {
		ans += askin(r, lin, rin);
		r = (r & (r + 1)) - 1;
	}
	return ans;
}
int ask(int l, int r, int lin, int rin) {
	return ask(r, lin, rin) - ask(l - 1, lin, rin);
}
void add(int pos, int posin, int val) {
	while (pos < sz) {
		addin(pos, posin, val);
		pos = pos | (pos + 1);
	}
}

int  main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, q;
	cin >> n >> q;
	vector<long long> w(n);
	for (int i = 0; i < n; i++) {
		cin >> w[i];
	}
	sort(w.begin(), w.end());
	vector<long long> k(q);
	vector<long long> a(q), b(q);
	vector<int> rqs(q);
	int z;
	cin >> z;
	for (int i = 0; i < q; i++) {
		cin >> k[i] >> a[i] >> b[i];
		rqs[i] = i;
	}
	sort(rqs.begin(), rqs.end(), [&](long long aa, long long bb) {
		return k[aa] < k[bb]; });
	reverse(w.begin(), w.end());
	vector<int> ans(q);
	long long maxto = 0;
	long long fail = 1e18;
	
	for (int i = 0; i < q; i++) {
		long long kk = k[rqs[i]];
		long long aa = a[rqs[i]];
		long long bb = b[rqs[i]];
		
		vector<int> wgts;
		for (auto h : w) {
			if (h <= kk) {
				wgts.push_back(h);
			}
		}
		int deg = 1;
		for (int j = 0; j < wgts.size(); j++)
			deg *= 3;
		set<pair<int, int> > st;
		for (int mask = 0; mask < deg; mask++) {
			int ina = 0;
			int inb = 0;
			int cur = mask;
			for (int j = 0; j < wgts.size(); j++) {
				if (cur % 3 == 1) {
					ina += wgts[j];
				}
				if (cur % 3 == 2) {
					inb += wgts[j];
				}
cur /= 3;
			}
			
			st.insert({ ina,inb });
		}
		long long real = 0;
		long long need = (aa + 1) * (bb + 1);
		for (auto h : st) {
			if (h.first <= aa && h.second <= bb) {
				real++;
			}
		}
		if (real == need) {
			ans[rqs[i]] = 1;
		}

	}
	
	for (auto h : ans) {
		if (h) {
			cout << "Yes\n";
		}
		else {
			cout << "No\n";
		}
	}
}