#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

#define ll long long
#define int ll

using namespace std;

const int Inf = 1e9 + 10;

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	int t;
	cin >> t;
	if (t == 1) {
		int m;
		cin >> m;
		for (int ii = 0; ii < m; ++ii) {
			int n, k;
			cin >> n >> k;
			vector<int>used(n);
			vector<int>a(k);
			vector<int>ans(n);
			for (int i = 0; i < k; ++i) {
				cin >> a[i];
				--a[i];
				used[a[i]] = 1;
			}
			int cnt = 0;
			int cnt1 = 0;
			int ind = 0;
			while (cnt1 < k) {
				if (used[ind] == 0 && ans[ind] == 0) {
					if (cnt > 0) {
						ans[ind] = 1;
						cnt1 += 1;
						--cnt;
					}
				}
				if (used[ind] == 1) {
					used[ind] = 2;
					++cnt;
				}
				ind = (ind + 1) % n;
			}
			for (int i = 0; i < n; ++i) {
				if (ans[i]) cout << i + 1 << ' ';
			}
			cout << endl;
		}
	}
	else {
		int m;
		cin >> m;
		for (int ii = 0; ii < m; ++ii) {
			int n, k;
			cin >> n >> k;
			vector<int>used(n);
			vector<int>a(k);
			for (int i = 0; i < k; ++i) {
				cin >> a[i];
				--a[i];
				used[a[i]] = 1;
			}
			int ind = 0;
			int cnt1 = 0;
			int mx = 0;
			for (int i = 0; i < n; ++i) {
				if (used[i]) cnt1++;
				else cnt1--;
				if (cnt1 > mx) {
					ind = i;
					mx = cnt1;
				}
			}
			vector<int>ans(n);
			int cnt = 0;
			cnt1 = 0;
			while (cnt1 < k) {
				if (used[ind] == 0 && ans[ind] == 0) {
					if (cnt > 0) {
						ans[ind] = 1;
						cnt1 += 1;
						--cnt;
					}
				}
				if (used[ind] == 1) {
					used[ind] = 2;
					++cnt;
				}
				ind = (ind - 1 + n) % n;
			}
			for (int i = 0; i < n; ++i) {
				if (ans[i]) cout << i + 1 << ' ';
			}
			cout << endl;
		}
	}
}
