#include <iostream>
#include <vector>
#include <algorithm>

#define ll long long
#define int ll

using namespace std;

const int N = 2e5 + 10;
vector<int>a[N];
int c[N];
bool used[N];
int cnt[N];

void dfs(int v) {
	used[v] = 1;
	for (auto to : a[v]) {
		if (!used[to]) {
			if (c[v] == c[to] || c[v] == -1) {
				cnt[to] = cnt[v];
			}
			else {
				cnt[to] = cnt[v] + 1;
			}
			dfs(to);
		}
	}
}

bool can[N];
bool used1[N];
int ans[N];

void dfs1(int v) {
	used1[v] = 1;
	if (can[v] == 1) {
		ans[v] = 1;
	}
	for (auto to : a[v]) {
		if (!used1[to]) {
			dfs1(to);
			ans[v] += ans[to];
		}
	}
}

bool cmp(pair<int, int> a, pair<int, int>b ) {

	if (a.second == b.second) return a.first > b.first;
	return a.second < b.second;
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		vector<pair<int, int>>a(n);
		vector<pair<int, int>>a1(n);
		for (int i = 0; i < n; ++i) {
			cin >> a[i].first >> a[i].second;
			a1[i] = a[i];
		}
		sort(a1.begin(), a1.end(), cmp);
		int m = 0;
		int r = -1;
		for (int i = 0; i < n; ++i) {
			if (a1[i].first > r) {
				m += 1;
				r = a1[i].second;
			}
		}
		int msk = (1 << n);
		for (int ii = 0; ii < msk; ++ii) {
			int cnt = 0;
			for (int i = 0; i < n; ++i) {
				if (ii & (1 << i)) {
					cnt++;
				}
			}
			if (cnt == n / 2) {
				vector<pair<int, int>>b;
				for (int i = 0; i < n; ++i) {
					if (ii & (1 << i)) {
						b.push_back(a[i]);
					}
				}
				sort(b.begin(), b.end(), cmp);
				int m1 = 0;
				int r1 = -1;
				for (int i = 0; i < n/2; ++i) {
					if (b[i].first > r1) {
						m1 += 1;
						r1 = b[i].second;
					}
				}
				if (m1 == m / 2) {
					for (int i = 0; i < n; ++i) {
						if (ii & (1 << i)) {
							cout << i + 1 << ' ';
						}
					}
					cout << '\n';
					break;
				}
			}
		}
	}
}
