#pragma GCC optimize("O3")
#pragma GCC optimize("avx2")
#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()
typedef long long ll;

const ll N = 1501;
bool dp1[N][N][N], all[N][N][N];

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll n, q; cin >> n >> q;
    vector<ll> w(n);
    for (ll i = 0; i < n; i++) cin >> w[i];
    sort(all(w));

    dp1[0][w[0]][0] = 1;
    dp1[0][0][w[0]] = 1;
    dp1[0][0][0] = 1;
    for (ll i = 1; i < n; i++) {
        dp1[i][0][0] = 1;
        for (ll x = 0; x < N; x++) {
            for (ll y = 0; y < N; y++) {
                dp1[i][x][y] = dp1[i - 1][x][y];
                if (x >= w[i]) dp1[i][x][y] |= dp1[i - 1][x - w[i]][y];
                if (y >= w[i]) dp1[i][x][y] |= dp1[i - 1][x][y - w[i]];
            }
        }
    }

    for (ll i = 0; i < n; i++) {
        all[i][0][0] = 1;
        for (ll j = 1; j < N; j++) {
            all[i][0][j] = all[i][0][j - 1] & dp1[i][0][j];
            all[i][j][0] = all[i][j - 1][0] & dp1[i][j][0];
        }
        for (ll x = 1; x < N; x++) {
            for (ll y = 1; y < N; y++) {
                all[i][x][y] = (all[i][x][y - 1] & all[i][x - 1][y] & dp1[i][x][y]);
            }
        }
    }

    ll z, k, a, b; cin >> z;
    while (q--) {
        cin >> k >> a >> b;
        ll it = upper_bound(all(w), k) - w.begin();
        if (it > 0) {
            if (all[it - 1][a][b]) cout << "Yes\n";
            else cout << "No\n";
        } else {
            if (a == 0 && b == 0) cout << "Yes\n";
            else cout << "No\n";
        }
        //cout << endl;
    }
    return 0;
}
/*
8 5
7 1 3 2 9 5 6 1
0
6 15 3
9 4 4
5 15 3
17 34 1
16 33 2
 */