#include <bits/stdc++.h>

#define sz(a) int((a).size())

using namespace std;

typedef long long ll;

const int INF = 1e9;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    vector dp(n + 1, vector(n + 2, vector(n + 2, -INF)));
    dp[0][0][n + 1] = 0;

    for (int i = 0; i < n; ++i) {
        for (int x = 0; x <= n + 1; ++x) {
            for (int y = 0; y <= n + 1; ++y) {
                if (x != a[i] && y != a[i]) {
                    if (a[i] > x && a[i] < y) {
                        dp[i + 1][x][y] = -INF;
                    } else {
                        dp[i + 1][x][y] = dp[i][x][y];
                    }
                } else if (y != a[i]) { // x == a[i]
                    for (int j = 0; j < x; ++j) {
                        dp[i + 1][x][y] = max(dp[i + 1][x][y], dp[i][j][y] + 1);
                    }
                } else if (x != a[i]) { // y == a[i]
                    for (int j = n + 1; j > y; --j) {
                        dp[i + 1][x][y] = max(dp[i + 1][x][y], dp[i][x][j] + 1);
                    }
                } else {
                    dp[i + 1][x][y] = -INF;
                }
            }
        }
    }

    int ans = 0;
    for (int x = 1; x <= n; ++x) {
        for (int y = 1; y <= n; ++y) {
            ans = max(ans, dp[n][x][y]);
        }
    }
    cout << ans << '\n';
}

int main() {
#ifdef LOCAL
    freopen("../in.txt", "r", stdin);
    freopen("../out.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    int t;
    cin >> t;
    while (t--) solve();

    return 0;
}