#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define ff first
#define ss second

#pragma GCC target("avx2")
#pragma GCC optimize("O3,Ofast,unroll-loops")

bool check(vector<int> &a, deque<int> &b, int k) {
    int r = 0;
    for (int x : b) {
        while (r < k && a[r] < x) {
            ++r;
        }
        if (r < k && a[r] == x) {
            return false;
        }
    }
    return true;
}

void shifr(vector<int> &a, int n, int k) {
    deque<int> b(a.begin(), a.end());
    while (true) {
        for (int &x : b) {
            ++x;
            if (x > n) {
                x -= n;
            }
        }
        if (b.back() == 1) {
            b.pop_back();
            b.push_front(1);
        }
        if (check(a, b, k)) {
            for (int x : b) {
                cout << x << ' ';
            }
            cout << '\n';
            return;
        }
    }
}

void deshifr(vector<int> &a, int n, int k) {
    deque<int> b(a.begin(), a.end());
    while (true) {
        for (int &x : b) {
            --x;
            if (x == 0) {
                x += n;
            }
        }
        if (b.front() == n) {
            b.pop_front();
            b.push_back(n);
        }
        if (check(a, b, k)) {
            for (int x : b) {
                cout << x << ' ';
            }
            cout << '\n';
            return;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t;
    cin >> t;
    if (t == 1) {
        int q;
        cin >> q;
        while (q--) {
            int n, k;
            cin >> n >> k;
            vector<int> a(k);
            for (int &x : a) {
                cin >> x;
            }
            shifr(a, n, k);
        }
    } else {
        int q;
        cin >> q;
        while (q--) {
            int n, k;
            cin >> n >> k;
            vector<int> a(k);
            for (int &x : a) {
                cin >> x;
            }
            deshifr(a, n, k);
        }
    }
    return 0;
}


