#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;
//#define int long long
#define sz(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
using pii = pair <int, int>;
#define ff first
#define ss second

template <typename T1, typename T2>
void mnr(T1& a, const T2& b) {
    if (a > b) {
        a = b;
    }
}

template <typename T1, typename T2>
void mxr(T1& a, const T2& b) {
    if (a < b) {
        a = b;
    }
}

constexpr const int INF = 1e9;
constexpr const int MAXN = 2002;
int td1[MAXN][4096];
int td2[MAXN][4096];

int n1;

void upd1(int layer, int i) {
    td1[layer][i] = max(td1[layer][2 * i], td1[layer][2 * i + 1]);
}

int get1(int layer, int l, int r) {
    int res = -INF;
    for (l += n1, r += n1; l < r; l >>= 1, r >>= 1) {
        if (l & 1) {
            mxr(res, td1[layer][l++]);
        }
        if (r & 1) {
            mxr(res, td1[layer][--r]);
        }
    }
    return res;
}

void upd1(int layer, int i, int x) {
    i += n1;
    td1[layer][i] = x;
    while (i >>= 1) {
        upd1(layer, i);
    }
}


void upd2(int layer, int i) {
    td2[layer][i] = max(td2[layer][2 * i], td2[layer][2 * i + 1]);
}

int get2(int layer, int l, int r) {
    int res = -INF;
    for (l += n1, r += n1; l < r; l >>= 1, r >>= 1) {
        if (l & 1) {
            mxr(res, td2[layer][l++]);
        }
        if (r & 1) {
            mxr(res, td2[layer][--r]);
        }
    }
    return res;
}

void upd2(int layer, int i, int x) {
    i += n1;
    td2[layer][i] = x;
    while (i >>= 1) {
        upd2(layer, i);
    }
}

int dp[MAXN][MAXN];

void solve(int T) {
    int n;
    cin >> n;
    vector <int> p(n);
    for (auto &i : p) {
        cin >> i;
    }
    n1 = 1;
    while (n1 < (n + 2)) {
        n1 <<= 1;
    }
    vector <priority_queue <int> > todel(n + 2);
    vector <vector <int> > st(n + 2, vector <int> (n + 2));
    auto upd = [&](int i, int j, int val) {
        dp[i][j] = val;
        if (dp[i][j] >= 0 && !st[i][j]) {
            todel[i].push(j);
            st[i][j] = true;
        }
        upd1(i, j, val);
        upd2(j, i, val);
    };
    upd(n + 1, 0, 0);
    int ALLMX = 0, ALLMN = n + 1;
    vector <int> vmn(n + 2), vmx(n + 2);
    for (int i = 1; i <= n; ++i) {
        int val = p[i - 1];
        for (int mn = ALLMN; mn <= n + 1; ++mn) {
            vmn[mn] = get1(mn, 0, val) + 1;
        }
        for (int mx = 0; mx <= ALLMX; ++mx) {
            vmx[mx] = get2(mx, val + 1, n + 2) + 1;
        }
        for (int mn = ALLMN; mn <= n + 1; ++mn) {
            upd(mn, val, vmn[mn]);
        }
        for (int mx = 0; mx <= ALLMX; ++mx) {
            upd(val, mx, vmx[mx]);
        }
        for (int mn = max(ALLMN, val + 1); mn <= n + 1; ++mn) {
            while (!todel[mn].empty() && todel[mn].top() < val) {
                upd(mn, todel[mn].top(), -INF);
                todel[mn].pop();
            }
        }
        mxr(ALLMX, val);
        mnr(ALLMN, val);
    }
    int res = 0;
    for (int i = 0; i <= n + 1; ++i) {
        mxr(res, get1(i, 0, n + 2));
    }
    cout << res;
    if (T) {
        for (int i = 0; i <= n + 1; ++i) {
            fill(td1[i], td1[i] + 2 * n1, -INF);
            fill(td2[i], td2[i] + 2 * n1, -INF);
            fill(dp[i], dp[i] + n + 2, -INF);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
#ifdef SYSTY257
    freopen("inputik.txt", "r", stdin);
    freopen("outputik.txt", "w", stdout);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    for (int i = 0; i < MAXN; ++i) {
        fill(td1[i], td1[i] + 4096, -INF);
        fill(td2[i], td2[i] + 4096, -INF);
        fill(dp[i], dp[i] + MAXN, -INF);
    }
    int t;
    cin >> t;
    while (t--) {
        solve(t);
        cout << "\n";
    }
}