//#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;
//#define int long long
#define sz(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
using pii = pair <int, int>;
#define ff first
#define ss second

template <typename T1, typename T2>
void mnr(T1& a, const T2& b) {
    if (a > b) {
        a = b;
    }
}

template <typename T1, typename T2>
void mxr(T1& a, const T2& b) {
    if (a < b) {
        a = b;
    }
}

constexpr const int MAXK = 1;
constexpr const int MAXP = (1 << MAXK);
constexpr const int MAXM = (1 << MAXP);

unordered_map <int, int> DP[MAXM];

int used[MAXM];
int stable[MAXM];
int mexlim[MAXM];
int mex[MAXM];
int nx[MAXM];
int dpt[MAXM];

int cnt[MAXM + 1];

int getmex(const vector <int>& cur) {
    for (auto i : cur) {
        cnt[i]++;
    }
    int ptr = 0;
    while (cnt[ptr]) {
        ++ptr;
    }
    for (auto i : cur) {
        --cnt[i];
    }
    return ptr;
}

void dfs(int mask, int prcolor, int prbadpos, int depth) {
    used[mask] = 1;
    dpt[mask] = depth;
    auto to = nx[mask];
    if (prcolor != mex[mask]) {
        prbadpos = depth;
    }
    {
        if (used[to] == 1) {
            if (dpt[to] >= prbadpos) {
                stable[mask] = 1;
                mexlim[mask] = mex[mask];
            }
        } else {
            if (used[to] != 2) {
                dfs(to, mex[mask], prbadpos, depth + 1);
            }
            stable[mask] = stable[to];
            mexlim[mask] = mexlim[to];
        }
    }
    used[mask] = 2;
}

signed main() {
    ios_base::sync_with_stdio(false);
#ifdef SYSTY257
    freopen("inputik.txt", "r", stdin);
    freopen("outputik.txt", "w", stdout);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int MOD;
    cin >> MOD;
    int m = (1 << MAXK);
    for (int mask = 0; mask < (1 << m); ++mask) {
        if (!(mask & 1)) {
            continue;
        }
        vector <int> pr;
        for (int i = 0; i < m; ++i) {
            if (mask >> i & 1) {
                pr.push_back(i);
            }
        }
        int mx = getmex(pr);
        mex[mask] = mx;
        for (int i = 0; i < sz(pr); ++i) {
            pr[i] ^= (mx - 1);
        }
        int mask2 = 0;
        for (int i = 0; i < sz(pr); ++i) {
            mask2 |= (1 << pr[i]);
        }
        nx[mask] = mask2;
    }
    for (int i = 0; i < (1 << m); ++i) {
        if (!(i & 1)) {
            continue;
        }

        if (!used[i]) {
            dfs(i, -1, -1, 0);
        }
    }
    int t;
    cin >> t;
    while (t--) {
        int k, n, p;
        cin >> k >> n >> p;
        int res = 0;
        for (int mask = 0; mask < (1 << m); ++mask) {
            if (__builtin_popcount(mask) == n) {
                if (stable[mask] && mexlim[mask] == p) {
                    ++res;
                }
            }
        }
        cout << res << "\n";
    }
}