#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#ifdef LOCAL
#define FAST_IO ;
#else
#define FAST_IO ios_base::sync_with_stdio(false), cin.tie(0);
#endif

#define int ll
#define vec vector
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define endl "\n"
#define mp(a, b) make_pair(a, b)
#define eb emplace_back
#define sz(v) (int)(v.size())


const int INF = 1e18 + 10;

int h, w, k;
vec<int> ys, xs;

typedef pair<int, int> pii;


void input() {
    cin >> h >> w >> k;

    for (int i = 0; i < k; ++i) {
        int x, y;
        cin >> y >> x;
        --y, --x;
        xs.eb(x);
        ys.eb(y);
    }

    sort(all(xs));
    xs.resize(unique(all(xs)) - xs.begin());

    sort(all(ys));
    ys.resize(unique(all(ys)) - ys.begin());

}



pii solve(const vec<int>& a, int bound) {
    int res = INF, moves = INF;

    // moving left
    for (int i = 0; i < sz(a); ++i) {
        int mov = i ? a[i - 1] + 1 : 0, le, ri;
        le = a[i] - mov;
        ri = i ? bound - 1 : a.back();
        int val = ri - le + 1;
        mov = min(mov, bound - a[i]);

        if (val < res || (val == res && mov < moves))
            res = val, moves = mov;
    }

    return mp( res, moves );
}


signed main() {
#ifdef LOCAL
    freopen("C:\\work\\untitled\\bigTest.in", "r", stdin);
#endif
    FAST_IO

    input();

    auto yy = solve(ys, h);
    auto xx = solve(xs, w);

    ll area = xx.first * yy.first;
    int moves = xx.second + yy.second;

    cout << area << " " << moves;

}