#pragma GCC optimize("O3, unroll-loops")

#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#ifdef LOCAL
#define FAST_IO ;
#else
#define FAST_IO ios_base::sync_with_stdio(false), cin.tie(0);
#endif

#define vec vector
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define endl "\n"
#define mp(a, b) make_pair(a, b)
#define eb emplace_back
#define sz(v) (int)(v.size())



const int N = 205, INF = 1e9 + 10;



int n;
int a[N];
int nxt[N][N];
int cur[N][N];


inline void upd(int& x, int y) {
    x = max(x, y);
}


vec<pair<int, int>> bra;

void solve() {
    cin >> n;
    for (int i = 1; i <= n; ++i)
        cin >> a[i];

    for (int j = 0; j <= n; ++j)
        for (int k = 0; k <= n + 1; ++k)
            nxt[j][k] = cur[j][k] = -INF;

    bra.clear();
    cur[0][n + 1] = 0;
    bra.eb(0, n + 1);

    for (int i = 0; i + 1 <= n; ++i) {
        int x = a[i + 1];
        for (auto& [ma, mi] : bra) {
            upd(nxt[max(ma, x)][mi], cur[ma][mi] + (ma < x));
            upd(nxt[ma][min(mi, x)], cur[ma][mi] + (x < mi));
        }

        swap(nxt, cur);
        bra.clear();
        for (int j = 0; j <= n; ++j)
            for (int k = 0; k <= n + 1; ++k) {
                nxt[j][k] = -INF;
                if (cur[j][k] >= 0)
                    bra.eb(j, k);
            }
    }

    int res = 0;
    for (int ma = 1; ma <= n; ++ma)
        for (int mi = 1; mi <= n; ++mi)
            upd(res, cur[ma][mi]);

    cout << res << endl;

}



signed main() {
#ifdef LOCAL
    freopen("C:\\work\\untitled\\bigTest.in", "r", stdin);
#endif
    FAST_IO

    int t; cin >> t;
    while (t--)
        solve();

}