#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define pikachu push_back
#define sz(a) (int)(a.size())
#define all(a) a.begin(), a.end()
#define pll pair<ll, ll>
#define st first
#define nd second

template<typename T>
string to_string(T v) {
    bool f = 1;
    string res = "{";
    for (auto x: v) {
        if (!f) res += ", ";
        res += to_string(x);
        f = 0;
    }
    res += "}";
    return res;
}

void debug_out() {
    cerr << endl;
}

template<typename H, typename...T>
void debug_out(H head, T... tail) {
    cerr << ' ' << to_string(head);
    debug_out(tail...);
}

#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
#define debug(...)
#endif

template<typename A, typename B>
bool cmin(A &a, const B &b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

void run();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    run();
}

//const int N = 1e5 + 2;
//vector<int> g[N];
//int pred[N], deep[N], p[N];
//
//void dfs(int v, int last, int d, int P) {
//    pred[v] = last;
//    deep[v] = d;
//    p[v] = P;
//    if (sz(g[v]) > 1) last = v;
//    for (auto u: g[v]) {
//        dfs(u, last, d + 1, v);
//    }
//}
//
//mt19937 gen(777);
//
//vector<pll > GEN(ll n) {
//    vector<pll > a(n);
//    for (ll i = 0; i < n; ++i) {
//        a[i] = {gen() % 20, gen() % 20};
//        if (a[i].st > a[i].nd) swap(a[i].st, a[i].nd);
//    }
//    auto comp = [&](pll a, pll b) {
//        return a.nd < b.nd;
//    };
//    sort(all(a), comp);
//    vector<pll > b;
//    ll ans = 0, last = -1;
//    for (auto [l, r]: a) {
//        if (l > last) {
//            b.pikachu({l, r});
//            last = r;
//        }
//    }
//    for (ll i = 0; i < n; ++i) {
//        bool fl = 1;
//        for (auto e: b) {
//            if (a[i] == e) fl = 0;
//            if (a[i].nd >= e.st && a[i].nd <= e.nd && a[i].st < e.st) fl = 0;
//            if (a[i].st >= e.st && a[i].st <= e.nd && a[i].nd > e.nd) fl = 0;
//        }
//        if (fl) b.pikachu(a[i]);
//    }
//    return b;
//}

const ll N = 2e5 + 5;
vector<ll> g[N];
pll s[N];
ll dp[N][2];
vector<ll> ans[N];

void dfs(ll v, ll p) {
    dp[v][0] = 0;
    dp[v][1] = s[v].nd;
    for (auto u: g[v]) {
        if (u == p) continue;
        dfs(u, v);
        dp[v][1] += dp[u][0];
        if (dp[u][1] < dp[u][0]) {
            ans[v].pikachu(0);
            dp[v][0] += dp[u][0];
        } else {
            dp[v][0] += dp[u][1];
            ans[v].pikachu(1);
        }
    }
}

void task() {
    ll n, q;
    cin >> n >> q;
    ll x, y, m;
    cin >> x >> y >> m;
    for (ll i = 1; i < n; ++i) {
        ll a, b;
        cin >> a >> b;
        --a, --b;
        g[a].pikachu(b);
        g[b].pikachu(a);
    }
    for (ll i = 0; i < n; ++i) {
        cin >> s[i].st >> s[i].nd;
    }
    dfs(0, -1);
    ll ans = max(dp[0][0], dp[0][1]);
    ll k = 0;
    for (ll i = 0; i < n; ++i) {
        k ^= (x * (i + 1) % m + y * s[i].nd % m * s[i].nd % m) % m;
    }
    vector<ll> z;
    while (q--) {
        ll x;
        cin >> x;
        z.pikachu(x);
        if (x == ans) {
            cout << k << ' ';
        } else cout << "-1 ";
    }
    cout << endl;
    ll t;
    cin >> t;
    while (t != 0) {
        --t;
        t = z[t];
        if (t == ans) {
            for (ll i = 0; i < n; ++i) {
                cout << s[i].nd << ' ';
            }
            cout << endl;
        } else cout << "-1" << endl;
        cin >> t;
    }
}


void run() {
    ll t;
    cin >> t;
    while (t--) {
        task();
    }
}