#include<bits/stdc++.h>

#define ft first
#define sd second
#define mp make_pair
#define pb push_back

using namespace std;

using ll = long long;
using ii = pair<int, int>;
using ld = long double;

bool cmp (pair<ii, int>& a, pair<ii, int>& b) {
    if (a.ft.ft < b.ft.ft)
        return true;
    if (a.ft.ft > b.ft.ft)
        return false;
    return a.ft.sd > b.ft.sd;
}

inline int get_ans1 (vector<ii>& v) {
    int n = v.size();
    int dp[n + 1];
    dp[0] = 0;
    int last = -1;
    for (int i = 0; i < n; i++) {
        dp[i + 1] = max(dp[i], 1);
        for (int j = last + 1; j < i; j++) {
            if (v[j].sd < v[i].ft) {
                last = j;
            } else {
                break;
            }
        }
        dp[i + 1] = max(dp[last + 1] + 1, dp[i + 1]);
    }
    return dp[n];
}
inline int get_ans (vector<ii> &v1) {
    int n = v1.size();
    vector<bool> bad(n, false);
    int minr[n + 1];
    minr[n] = 1e9 + 5;
    for (int i = n - 1; i >= 0; i--) {
        minr[i] = min(minr[i + 1], v1[i].second);
    }
    vector<ii> v;
    for (int i = 0; i < n; i++) {
        int r1 = v1[i].second;
        if (minr[i + 1] <= r1) {
            bad[i] = true;
        } else {
            v.push_back(v1[i]);
        }
    }
    return get_ans1(v);
}

mt19937 rnd(12217);

void solve() {
    int n;
    cin >> n;
    vector<pair<ii, int>> w1(n);
    for (int i = 0; i < n; i++) {
        cin >> w1[i].ft.ft >> w1[i].ft.sd;
        w1[i].sd = i;
    }
    sort(w1.begin(), w1.end(), cmp);
    vector<ii> w(n);
    for (int i = 0; i < n; i++) {
        w[i] = w1[i].ft;
    }
    int M = get_ans(w);
    vector<ii> order(0);
    for (int i = 0; i < (n / 2) + 1; i++) {
        order.push_back(mp(rnd(), i));
    }
    sort(order.begin(), order.end());
    for (int i1 = 0; i1 < (n / 2) + 1; i1++) {
        int i = order[i1].sd;
        vector<ii> v1;
        for (int j = i; j < (i + (n / 2)); j++) {
            v1.push_back(w[j]);
        }
        int r = get_ans(v1);
        if (r * 2 == M) {
            for (int j = i; j < (i + (n / 2)); j++) {
                cout << w1[j].sd + 1 << " ";
            }
            cout << endl;
            return;
        }
    }
    return;
}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int tt;
    cin >> tt;
    while (tt--)
        solve();

    return 0;
}