#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k, q;
    cin >> n >> k >> q;

    vector<vector<int>> adj(n);

    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;

        adj[i].resize(t);

        for (int &x : adj[i]) {
            cin >> x;
            x -= 1;
        }
    }

    vector<int> sub(n);

    auto dfs = [&](auto self, int v, int mv, int sum) -> void {
        if (adj[v].empty()) {
            sub[v] = sum <= k;
            return;
        }

        for (int i = 0; i < 2; ++i) {
            int to = adj[v][i];

            self(self, to, i, sum + (mv != -1 && mv != i));

            sub[v] += sub[to];
        }
    };

    dfs(dfs, 0, -1, 0);


    while (q--) {
        int u;
        cin >> u;
        --u;

        cout << sub[u] << '\n';
    }

    return 0;
}
