#pragma GCC optimize ("O3")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define assing assign
#define all(x) x.begin(), x.end()
//#define int ll

int get(const vector<pair<int, int>>& a) {
    int n = a.size();

    vector<pair<int, int>> rs(n);
    for (int i = 0; i < n; ++i)
        rs[i] = {a[i].second, i};
    sort(all(rs));

    vector<int> dp(n + 1);
    for (int i = 1; i <= n; ++i) {
        auto [l, r] = a[rs[i - 1].second];
        int it = upper_bound(all(rs), make_pair(l, -1)) - rs.begin();
        dp[i] = max(dp[i - 1], dp[it] + 1);
    }
    return dp.back();
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (auto& [l, r] : a)
        cin >> l >> r;

    int k = get(a);

    for (int m = 0; m < (1 << n); ++m) {
        int cnt = 0;
        for (int i = 0; i < n; ++i)
            if ((m >> i) & 1)
                ++cnt;
        if (cnt != n / 2)
            continue;
        vector<pair<int, int>> a1;
        for (int i = 0; i < n; ++i)
            if ((m >> i) & 1)
                a1.push_back(a[i]);
        if (get(a1) == k / 2) {
            for (int i = 0; i < n; ++i)
                if ((m >> i) & 1)
                    cout << i + 1 << " ";
            cout << endl;
            return;
        }
    }


void solve1() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (auto& [l, r] : a)
        cin >> l >> r;

    if (get(a) != vector<int>()) {
        for (auto i : get(a))
            cout << i + 1 << " ";
        cout << endl;
    } else {
        for (auto& [l, r] : a)
            l *= -1, r *= -1;
        for (auto i : get(a))
            cout << i + 1 << " ";
        cout << endl;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t=  1;
    cin >> t;
    while (t--)
        solve();
}
