#pragma GCC optimize ("O3")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define assing assign
#define all(x) x.begin(), x.end()
//#define int ll

vector<pair<int, int>> a;
vector<vector<int>> g;
vector<vector<ll>> dp;

void dfs(int v, int p) {
    for (auto u : g[v])
        if (u != p) {
            dfs(u, v);
            dp[v][0] += max(dp[u][0], dp[u][1]);
            dp[v][1] += dp[u][0];
        }
    dp[v][1] += a[v].first;
}

void solve() {
    int n, q;
    ll x, y, m;
    cin >> n >> q >> x >> y >> m;

    g.assign(n, {});
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    a.assing(n, {-1, -1});
    for (auto& [l, r] : a)
        cin >> l >> r;

    dp.assing(n, vector<ll>(2));
    dfs(0, -1);

    ll w = max(dp[0][0], dp[0][1]);
    ll hash = 0;
    for (int i = 0; i < n; ++i)
        hash = hash ^ ((x * (i + 1) + y * a[i].first * a[i].first) % m);

    vector<int> qr(q);
    for (auto& i : qr)
        cin >> i;

    for (auto& i : qr)
        cout << (i == w ? hash : -1) << " " ;
    cout << endl;

    while (true) {
        int i;
        cin >> i;
        --i;

        if (i == -1)
            return;
        else {
            if (qr[i] != w)
                cout << -1 << endl;
            else {
                for (auto& [l, r] : a)
                    cout << l << " ";
                cout << endl;
            }
        }
    }
}

int main() {
    int t = 1;
    cin >> t;
    while (t--)
        solve();
}
