#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <string>
#include <iostream>
#define f first
#define s second
#define int long long
#define debug(x) cerr << (#x)<<": "<<x<<endl
#define pb push_back
#define INF 1e9+7
using namespace std;
int min(int a, int b) {
	if (a <= b) return a;
	return b;
}
int max(int a, int b) {
	if (a >= b) return a;
	return b;
}
struct node {
	int i, j, p;
};
int n, m;
const int MAXN = 30;
vector<pair<int, int> > all;
vector<pair<int, int> > k;
vector<vector<int> > st;
vector<pair<int, pair<int, int> > > for_sort;
int make_start(vector<pair<int,pair<int,int> > > k) {
	int nn = k.size();
	st = vector<vector<int> >(nn + 1, vector<int>(nn + 1, INF));
	st[0][0] = 0;
	st[0][1] = k[0].second.first;
	for (int i = 1; i < nn; i++) {
		int l = k[i].first, r = k[i].second.first;
		for (int j = 0; j <= i; j++) {
			int cur_r = st[i - 1][j];
			if (cur_r == INF) continue;
			st[i][j] = min(st[i - 1][j], st[i][j]);
			if (l > cur_r) st[i][j + 1] = min(st[i][j + 1], r);
		}
	}
	int mm = 0;
	for (int i = 0; i <= nn; i++) {
		if (st[nn - 1][i] != INF) {
			mm = i;
		}
	}
	return mm;
}
vector<int> p;
vector<int> ans;
void perebor() {
	if (p.size() == n) {
		vector<int> add;
		for (int i = 0; i < p.size(); i++) {
			if (p[i]) add.pb(i);
		}
		if (add.size() != n / 2) return;
		vector<pair<int, pair<int, int> > > k;
		for (auto c : add) {
			k.pb(for_sort[c]);
		}
		sort(k.begin(), k.end());
		int y = make_start(k);
		if (y == m / 2) {
			ans.clear();
			for (auto c : k) {
				if (c.first == 0) continue;
				ans.pb(c.second.second);
			}
		}
	}
	else {
		for (int i = 0; i < 2; i++) {
			p.pb(i);
			perebor();
			p.pop_back();
		}
	}
}
void solve() {
	all.clear();
	for_sort.clear();
	k.clear();
	p.clear();
	ans.clear();
	cin >> n;
	for (int i = 0; i < n; i++) {
		int l, r;
		cin >> l >> r;
		all.pb({ l,r });
		for_sort.pb({ l,{r,i} });
	}
	for (int i = 0; i < n / 2; i++) cout << i + 1 << " ";
	cout << endl;
}
signed main()
{
	ios_base::sync_with_stdio();
	cout.tie(0);
	cin.tie(0);
	int t = 1;
	cin>>t;
	while (t--) {
		solve();
	}
}
