#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    set<int> b;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        b.insert(a[i]);
    }
    map<int, int> ind;
    int ii = 0;
    for (auto elem: b) {
        ind[elem] = ++ii;
    }
    for (auto &i: a) {
        i = ind[i];
    }
    vector<vector<int>> dp(ii + 2, vector<int>(ii + 2, -1e9));
    dp[0][ii + 1] = 0;
    for (int i = 0; i < n; ++i) {
        for (int j1 = 0; j1 < ii + 2; ++j1) {
            for (int j2 = 0; j2 < ii + 2; ++j2) {
                if (a[i] > j1) {
                    dp[a[i]][j2] = max(dp[a[i]][j2], dp[j1][j2] + 1);
                } else {
                    dp[j1][j2] = max(dp[j1][j2], dp[j1][j2]);
                }
                if (a[i] < j2) {
                    dp[j1][a[i]] = max(dp[j1][a[i]], dp[j1][j2] + 1);
                } else {
                    dp[j1][j2] = max(dp[j1][j2], dp[j1][j2]);
                }
            }
        }
        swap(dp, new_dp);
    }
    int ans = 0;
    for (auto i: dp) {
        for (auto j: i) {
            ans = max(ans, j);
        }
    }
    cout << ans << "\n";
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}