#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, t, q;
    long long h, z;
    cin >> n >> q;
    vector <int> w;
    for (int i = 0; i < n; i++) {
        cin >> h;
        w.push_back((int)h);
    }
    sort(w.begin(), w.end());
    cin >> z;
    int ct = 400;
    vector < vector < vector <int> > > dp(ct, vector < vector <int> > (ct, vector <int> (n + 1, 0)));
    for (int i = 0; i <= n; i++) {
        dp[0][0][i] = 1;
    }
    for (int a = w[0]; a < ct; a++) {
        for (int b = 0; b <= a; b++) {
            for (int i = 0; i < n; i++) {
                if (dp[a][b][i] || (a - w[i] >= 0 && dp[max(b, a - w[i])][min(b, a - w[i])][i]) || (b - w[i] >= 0 && dp[a][b - w[i]][i])) {
                    dp[a][b][i + 1] = 1;
                }
            }
//            cout << dp[a][b][n] << ' ';
            if (!dp[a][b][n]) break;
        }
        cout << endl;
    }
    long long x, y, c, v = 0;
    while (q--) {
        cin >> x >> y >> c;
        long long k = x - v * z, a = y - v * z, b = c - v * z;
        if (w[0] > k && (a != 0 || b != 0)) {
            cout << "No" << '\n';
            continue;
        }
        int l = -1, r = n;
        while (r - l > 1) {
            int g = (r + l) / 2;
            if (w[g] > k) {
                r = g;
            } else {
                l = g;
            }
        }
        if (w[0] > k || dp[a][b][r]) {
            cout << "Yes\n";
            v++;
        } else {
            cout << "No\n";
        }
    }
    return 0;
}
