#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <set>
#include <map>
#include <deque>
#include <cmath>

using namespace std;

typedef long long ll;

#define all(x) x.begin(), x.end()

void solve1() {
	int n, k; cin >> n >> k;
	vector<int> a(k), b;
	set<int> al;
	for (int i = 0; i < k; ++i) {
		cin >> a[i];
		a[i] %= n;
		al.insert(a[i]);
	}
	for (int i = 0; i < k; ++i) {
		int nw = a[i];
		while (al.count(nw)) {
			nw = (nw + 1) % n;
		}
		if (nw == 0) {
			b.push_back(n);
		} else {
			b.push_back(nw);
		}
		al.insert(nw);
	}
	sort(all(b));
	for (int i = 0; i < k; ++i) {
		cout << b[i] << ' ';
	}
	cout << '\n'; cout.flush();
}

void solve2() {
	int n, k; cin >> n >> k;
	vector<int> a(k), b;
	set<int> al;
	for (int i = 0; i < k; ++i) {
		cin >> a[i];
		a[i] %= n;
		al.insert(a[i]);
	}
	for (int i = 0; i < k; ++i) {
		int nw = a[i];
		while (al.count(nw)) {
			nw = (nw + n - 1) % n;
		}
		if (nw == 0) {
			b.push_back(n);
		} else {
			b.push_back(nw);
		}
		al.insert(nw);
	}
	sort(all(b));
	for (int i = 0; i < k; ++i) {
		cout << b[i] << ' ';
	}
	cout << '\n'; cout.flush();
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int tp; cin >> tp;
	int t = 1; cin >> t;
	while (t--) {
		if (tp == 1) {
			solve1();
		} else {
			solve2();
		}
	}
}
