#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <deque>
#include <iomanip>

using namespace std;

#define all(x) x.begin(), x.end()

int max_nez(vector<pair<int, int>>& otr) {
	int r = -1, ans = 0;
	for (int i = 0; i < (int)otr.size(); ++i) {
		if (otr[i].second > r) {
			++ans;
			r = otr[i].first;
		}
	}
	return ans;
}

void solve() {
	int n; cin >> n;
	vector<pair<pair<int, int>, int>> otr_ws(n);
	for (int i = 0; i < n; ++i) {
		cin >> otr_ws[i].first.second >> otr_ws[i].first.first;
		otr_ws[i].second = i;
	}
	sort(all(otr_ws));
	vector<pair<int, int>> otr(n);
	for (int i = 0; i < n; ++i) {
		otr[i] = otr_ws[i].first;
	}
	int m = max_nez(otr);
	vector<vector<int>> dp(n, vector<int>(n, n + 5));
	vector<vector<int>> nx(n, vector<int>(n, -1));
	int opt_i = -1, mn = n + 5;
	for (int i = n - 1; i >= 0; --i) {
		int ta = 0;
		for (int j = i + 1; j < n; ++j) {
			if (otr[j].second > otr[i].first) {
				for (int k = 2; k < n; ++k) {
					if (dp[i][k] > dp[j][k - 1] + ta) {
						dp[i][k] = dp[j][k - 1] + ta;
						nx[i][k] = j;
					}
				}
				++ta;
			}
		}
		dp[i][1] = ta;
		if (dp[i][m / 2] + i < mn) {
			mn = dp[i][m / 2] + i;
			opt_i = i;
		}
	}
	vector<int> ans;
	int nxt = opt_i, lst, K = m / 2;
	int ost = (n - m) / 2;
	for (int i = opt_i; i < n; ++i) {
		if (i == nxt) {
			lst = i;
			nxt = nx[i][K];
			--K;
			ans.push_back(otr_ws[i].second + 1);
		} else {
			if (otr[i].second < otr[lst].first && ost) {
				ans.push_back(otr_ws[i].second + 1);
				--ost;
			}
		}
	}
	for (int i = 0; i < (int)ans.size(); ++i) {
		cout << ans[i] << ' ';
	}
	cout << '\n';
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1; cin >> t;
	while (t--) {
		solve();
	}
}
