#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <deque>
#include <iomanip>

using namespace std;

typedef long long ll;

#define all(x) x.begin(), x.end()
ll inf = 1e18;

void solve() {
	int n, q; cin >> n >> q;
	vector<ll> w(n);
	for (int i = 0; i < n; ++i) {
		cin >> w[i];
	}
	ll _; cin >> _;
	sort(all(w));
	while (w.back() > 5000LL) {
		w.pop_back();
	}
	n = w.size();
	vector<ll> a(5001, 1);
	vector<ll> d(5001, 1);
	vector<ll> dw(5001);
	vector<ll> aw(5001);
	d[0] = 1;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j <= 5000; ++j) {
			aw[i] = a[i];
			dw[i] = d[i];
		}
		for (int j = 0; j <= 5000; ++j) {
			if (d[j] == 0) {
				if (j >= w[i]) {
					d[j] = dw[j - w[i]];
					a[j] = aw[j - w[i]];
				}
			} else {
				if (a[j] >= w[i]) {
					a[j] += w[i];
				}
				if (j >= w[i]) {
					a[j] = max(a[j], aw[j - w[i]]);
				}
			}
		}
		for (int j = 1; j <= 5000; ++j) {
			a[j] = min(a[j], a[j - 1]);
			d[j] = min(d[j], d[j - 1]);
		}
	}
	for (int i = 0; i < q; ++i) {
		ll K, A, B; cin >> K >> A >> B;
		if (a[A] > B && d[A]) {
			cout << "Yes\n";
		} else {
			cout << "No\n";
		}
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1; //cin >> t;
	while (t--) {
		solve();
	}
}
