#include <bits/stdc++.h>
using namespace std;

struct node {
    int l = -1, r = -1;
    node() {}
};

vector<node> tree;

vector<int> turns;

int mx;

void count_turns(int v, int prv, int k) {
    turns[v] = k;
    if (tree[v].l == -1) return;
    if (prv == 0) {
        count_turns(tree[v].l, 0, k);
        count_turns(tree[v].r, 1, k + 1);
    } else if (prv == 1) {
        count_turns(tree[v].l, 0, k + 1);
        count_turns(tree[v].r, 1, k);
    } else {
        count_turns(tree[v].l, 0, k);
        count_turns(tree[v].r, 1, k);
    }
}

vector<int> ans;

void count_ans(int v) {
    if (tree[v].l == -1) {
        if (turns[v] <= mx) {
            ans[v] = 1;
        } else {
            ans[v] = 0;
        }
        return;
    }
    count_ans(tree[v].l);
    count_ans(tree[v].r);
    ans[v] = ans[tree[v].l] + ans[tree[v].r];
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, k, q;
    cin >> n >> k >> q;
    mx = k;
    tree.resize(n);
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        if (t == 0) continue;
        else {
            int l, r;
            cin >> l >> r;
            tree[i].l = l - 1;
            tree[i].r = r - 1;
        }
    }

    turns.resize(n, 0);
    count_turns(0, -1, 0);
    ans.resize(n, 0);
    count_ans(0);

    for (int i = 0; i < q; i++) {
        int v;
        cin >> v;
        cout << ans[v - 1] << "\n";
    }
}