#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;
typedef long long ll;
struct Node {
	int sum = 0;
	int ls = -1, rs = -1;
};
vector <Node> tree;
int n, k, ind;
bool getmn(int ql, int qr, int v = 0, int l = 0, int r = n) {
	if (r <= ql || qr <= l || tree[v].sum == r - l) return 0;
	if (l == r - 1) { ind = l; return 1; }
	if (tree[v].rs == -1) {
		tree.push_back(Node());
		tree[v].rs = tree.size() - 1;
	}
	bool fl = getmn(ql, qr, tree[v].rs, (l + r) / 2, r);
	if (!fl) {
		if (tree[v].ls == -1) {
			tree.push_back(Node());
			tree[v].ls = tree.size() - 1;
		}
		getmn(ql, qr, tree[v].ls, l, (l + r) / 2);
	}
	return 1;
}
bool getmx(int ql, int qr, int v = 0, int l = 0, int r = n) {
	if (r <= ql || qr <= l || tree[v].sum == r - l) return 0;
	if (l == r - 1) { ind = l; return 1; }
	if (tree[v].ls == -1) {
		tree.push_back(Node());
		tree[v].ls = tree.size() - 1;
	}
	bool fl = getmx(ql, qr, tree[v].ls, l, (l + r) / 2);
	if (!fl) {
		if (tree[v].rs == -1) {
			tree.push_back(Node());
			tree[v].rs = tree.size() - 1;
		}
		getmx(ql, qr, tree[v].rs, (l + r) / 2, r);
	}
	return 1;
}
void upd(int ind, int v = 0, int l = 0, int r = n) {
	if (ind < l || ind >= r) return;
	if (l == r - 1) { tree[v].sum++; return; }
	if (tree[v].ls == -1) {
		tree.push_back(Node());
		tree[v].ls = tree.size() - 1;
	}
	upd(ind, tree[v].ls, l, (l + r) / 2);
	if (tree[v].rs == -1) {
		tree.push_back(Node());
		tree[v].rs = tree.size() - 1;
	}
	upd(ind, tree[v].rs, (l + r) / 2, r);
	tree[v].sum = tree[tree[v].ls].sum + tree[tree[v].rs].sum;
}
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int t, q; cin >> t >> q;
	if (t == 1) {
		while (q--) {
			cin >> n >> k;
			tree.clear();
			tree.push_back(Node());
			vector <int> a(k);
			for (int i = 0; i < k; i++) cin >> a[i], a[i]--, upd(a[i]);
			vector <int> ans;
			for (int i = 0; i < k; i++) {
				ind = -1;
				getmn(0, a[i]);
				if (ind == -1) getmn(a[i] + 1, n);
				ans.push_back(ind + 1);
				upd(ind);
			}
			sort(ans.begin(), ans.end());
			for (auto i : ans) cout << i << ' ';
			cout << endl;
		}
	}
	else {
		while (q--) {
			cin >> n >> k;
			tree.clear();
			tree.push_back(Node());
			vector <int> a(k);
			for (int i = 0; i < k; i++) cin >> a[i], a[i]--, upd(a[i]);
			vector <int> ans;
			for (int i = 0; i < k; i++) {
				ind = -1;
				getmx(a[i] + 1, n);
				if (ind == -1) getmx(0, a[i]);
				ans.push_back(ind + 1);
				upd(ind);
			}
			sort(ans.begin(), ans.end());
			for (auto i : ans) cout << i << ' ';
			cout << endl;
		}
	}
	return 0;
}