#include <iostream>
#include <fstream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <random>
#include <map>
#include <set>
#include <cassert>
using namespace std;
#define int long long
#define pi pair<int, int>
#define vi vector<int> 
const int INF = 1e9 + 10;
bool isKthBitSet(int num, int k) {
	return num & (1ll << k);
}
int gt(vector<pair<pi, int>>& sgs) {
	int N = sgs.size();
	vector<int> dp;
	dp.assign(N + 1, 0);
	for (int i = 1; i <= N; ++i) {
		dp[i] = 1;
		for (int j = i - 1; j > 0; --j) {
			if (sgs[j - 1].first.second < sgs[i - 1].first.first) dp[i] = max(dp[i], dp[j] + 1);
		}
	}
	return *max_element(dp.begin(), dp.end());
}
void solve() {
	int N = 0; cin >> N;
	vector<pair<pi, int>> sgs;
	for (int i = 0; i < N; ++i) {
		int l = 0, r = 0; cin >> l >> r;
		sgs.push_back({ { l, r }, i });
	}
	sort(sgs.begin(), sgs.end());
	vector<int> dp;
	dp.assign(N + 1, 0);
	for (int i = 1; i <= N; ++i) {
		dp[i] = 1;
		for (int j = i - 1; j > 0; --j) {
			if (sgs[j - 1].first.second < sgs[i - 1].first.first) dp[i] = max(dp[i], dp[j] + 1);
		}
	}
	int opt = *max_element(dp.begin(), dp.end());
	for (int i = 0; i < (1ll << N); ++i) {
		int tmp = 0;
		vector<pair<pi, int>> segs;
		for (int j = 0; j < N; ++j) {
			tmp += isKthBitSet(i, j);
			if (isKthBitSet(i, j)) segs.push_back(sgs[j]);
		}
		if (tmp != N / 2) continue;
		if (gt(segs) == opt / 2) {
			for (int j = 0; j < N; ++j) {
				if (isKthBitSet(i, j)) cout << sgs[j].second + 1 << " ";
			}
			cout << "\n";
			return;
		}
	}
}

signed main() {
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios_base::sync_with_stdio(false);
	int T = 1; cin >> T;
	for (int i = 0; i < T; ++i) {
		solve();
	}
	return 0;
}
