#include <bits/stdc++.h>
using namespace std;

int n;
pair<int, int> a[100100];
pair<pair<int, int>, int> b[100100];

int dp[1000][10000];
pair<int, int> pr[1000][10000];

void solve1() {
    int n, m, k = 0;

    cin >> n;
    set<int> s;
    map<int, int> mp;
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
        s.insert(a[i].first);
        s.insert(a[i].second);
    }
    for (auto j : s) {
        mp[j] = k;
        k++;
    }
    for (int i = 0; i < n; i++) {
        a[i].first = mp[a[i].first];
        a[i].second = mp[a[i].second];
        b[i] = {a[i], i};
    }

    for (int i = 0; i < n; i++) {
        swap(a[i].first, a[i].second);
        swap(b[i].first.first, b[i].first.second);
        a[i].second *= -1;
        b[i].first.second *= -1;
    }
    sort(a, a + n);
    sort(b, b + n);
    for (int i = 0; i < n; i++) {
        a[i].second *= -1;
        b[i].first.second *= -1;
        swap(a[i].first, a[i].second);
        swap(b[i].first.first, b[i].first.second);
    }

    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= k; j++) {
            dp[i][j] = -1e9;
        }
    }
    dp[0][0] = 0;
    for (int i = 0; i < n; i++) {
        for (int h = n; h >= 1; h--) {
            for (int j = b[i].first.first; j <= k; j++) {
                if (dp[h - 1][j] > dp[h][j]) {
                    dp[h][j] = dp[h - 1][j];
                    pr[h][j] = {j, i};
                }
            }
            for (int j = 0; j < b[i].first.first; j++) {
                if (dp[h - 1][j] + 1 > dp[h][b[i].first.second]) {
                    dp[h][b[i].first.second] = dp[h - 1][j] + 1;
                    pr[h][b[i].first.second] = {j, i};
                }
            }
        }
    }

    m = 0;
    for (int j = 0; j <= k; j++) {
        m = max(m, dp[n][j]);
    }
    for (int j = 0; j <= k; j++) {
        if (dp[n / 2][j] == m / 2) {
            int cnt = n / 2, r = j;
            vector<int> v;
            while (cnt != 0) {
                v.push_back(b[pr[cnt][r].second].second);
                r = pr[cnt][r].first;
                cnt--;
            }
            for (auto j : v) {
                cout << j + 1 << ' ';
            }
            cout << '\n';
            return;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;

    cin >> t;
    while (t--) {
        solve1();
    }

    return 0;
}
