#include <bits/stdc++.h>
using namespace std;
void solve_case() {
    int n;
    cin >> n;
    vector<int> l(n), r(n);
    vector<int> all;
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
        all.push_back(l[i]);
        all.push_back(r[i]);
    }
    sort(all.begin(), all.end());
    all.erase(unique(all.begin(), all.end()), all.end());
    for (int i = 0; i < n; i++) {
        l[i] = lower_bound(all.begin(), all.end(), l[i]) - all.begin();
        r[i] = lower_bound(all.begin(), all.end(), r[i]) - all.begin();
    }
    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), [&](int left, int right){
        return r[left] < r[right] || (r[left] == r[right] && l[left] > l[right]);
    });
    function<int(vector<int>&)> calc = [&](vector<int>& who) {
        if (who.empty()) return 0;
        int ret = 1;
        int curR = r[who[0]];
        for (int i : who) {
            if (l[i] > curR) {
                curR = r[i];
                ret++;
            }
        }
        return ret;
    };
    int m = calc(ord);
    vector<int> ans;
    vector<int> cur;
    function<void(int, int)> rec = [&](int step, int take) {
        if (!ans.empty()) return;
        if (step == n) {
            assert(take == n / 2);
            if (calc(cur) == m / 2) {
                ans = cur;
                return;
            }
        }
        if (cur.size() != n / 2) {
            cur.push_back(ord[step]);
            rec(step + 1, take + 1);
            cur.pop_back();
        }
        if (n - step > n / 2 - take) {
            rec(step + 1, take);
        }
    };
    rec(0, 0);
    assert(!ans.empty());
    for (int i : ans) cout << i + 1 << " ";
    cout << "\n";
}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
#endif
    int T;
    cin >> T;
    while (T--) {
        solve_case();
    }
}