#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;
typedef long long ll;
#define endl '\n'
#define int long long

int n, q;
int w[300010];
int Z;
const int inf = 1e18 + 10;

int sum = 0;
vector <pair <int, int>> block;

bool solve(int k, int a, int b)
{
	if (a > b) swap(a, b);
	int l = -1, r = block.size() - 1;

	while (l + 1 < r)
	{
		int mid = (l + r) >> 1;

		if (a >= block[mid].first) r = mid;
		else l = mid;
	}

	return block[r].second >= a + b;
}

bool ans[300010];

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> q;

	for (int i = 1; i <= n; ++i)
	{
		cin >> w[i];
	}

	sort(w + 1, w + 1 + n);
	w[n + 1] = inf;

	cin >> Z;
	int v = 0;

	vector <vector <int>> all;
	for (int _ = 0; _ < q; ++_)
	{
		int j, c, d;
		int k = 1e18, a = _, b = 0;
		cin >> j >> c >> d;
		k = j - v * Z, a = c - v * Z, b = d - v * Z;

		all.push_back({ k, a, b, _ });

/*
		auto got1 = solve(k, a, b);

		v += got1;
		cout << (got1 ? "Yes" : "No") << endl;*/
	}

	sum = 0;
	block.clear();
	for (int i = 1; i <= n; ++i)
	{
		int mi;
		if (block.empty()) mi = sum / 2 + 1;
		else mi = sum - block.back().first + 2;
		if (w[i] <= mi)
		{
			sum += w[i];
		}
		else
		{
			int f = sum - w[i] + 2;
			f = max(f, (int)0);
			//assert((block.empty() || (block.back().first > f)));
			block.push_back({ f, sum });
			sum += w[i];
		}
		block.push_back({ -1, sum });

		for (auto qq : all)
		{
			if (w[i] <= qq[0] && w[i + 1] > qq[0])
			{
				ans[qq[3]] = solve(qq[0], qq[1], qq[2]);
			}
		}

		block.pop_back();
	}

	for (int i = 0; i < q; ++i) cout << (ans[i] ? "Yes" : "No") << endl;

	return 0;
}