#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;
typedef long long ll;
//#define endl '\n'
#define int long long

const int N = 200010;

int n, q;
int x, y, m;

vector <int> g[N];
int l[N];
int r[N];

int v[N];
int k[N];

int mx[N][2];
int a[N];

void dfs(int u, int p)
{
	mx[u][1] = l[u];
	for (auto v : g[u]) if ( v != p)
	{
		dfs(v, u);
		mx[u][0] += max(mx[v][0], mx[v][1]);
		mx[u][1] += mx[v][0];	
	}
}

int plan()
{
	int ans = 0;
	for (int i = 1; i <= n; ++i)
	{
		ans ^= ((x * i + y * a[i] % m * a[i] % m) % m);
	}
	return ans;
}

inline void solve()
{
	cin >> n >> q;
	cin >> x >> y >> m;

	for (int i = 1; i <= n; ++i) g[i].clear();

	for (int i = 1; i <= n - 1; ++i)
	{
		int u, v;
		cin >> u >> v;
		g[u].push_back(v);
		g[v].push_back(u);
	}

	for (int i = 1; i <= n; ++i)
	{
		cin >> l[i] >> r[i];
		a[i] = l[i];
	}

	dfs(1, 1);

	int ans = max(mx[1][0], mx[1][1]);
	int k = plan();

	for (int i = 1; i <= q; ++i)
	{
		cin >> v[i];
	}
	for (int i = 1; i <= q; ++i)
	{
		if (v[i] == ans)
		{
			cout << k << ' ';
		}
		else
		{
			cout << -1 << ' ';
		}
	}
	cout << endl;
	while (true)
	{
		int x;
		cin >> x;

		if (x == 0) return;
		if (v[x] == ans)
		{
			for (int i = 1; i <= n; ++i) cout << a[i] << ' ';
			cout << endl;
		}
		else
		{
			cout << -1 << endl;
		}
	}
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	int t;
	cin >> t;
	while (t--)
	{
		solve();
	}
	cout << endl;

	return 0;
}