//
// Created by roi on 03.04.2023.
//
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2,bmi,bmi2,ssse3,lzcnt,popcnt")

#include<bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

#define int long long
typedef long long ll;
using namespace std;

map<pair<int, int>, vector<int>> calc;
map<pair<int, int>, int> rcalc;


gp_hash_table<int, unordered_set<int>> freeMask;
mt19937 engine;

void pre() {
    for (int n = 1; n <= 7; n++) {
        freeMask.clear();
        for (int mask = 0; mask < (1 << n); mask++) {
            int cnt = 0;
            for (int i = 0; i < n; i++) {
                if (mask & (1 << i)) cnt++;
            }
            freeMask[cnt].insert(mask);
        }
        for (int mask = 0; mask < (1 << n); mask++) {
            unordered_set<int> used;
            vector<int> s;
            for (int i = 0; i < n; i++) {
                if (mask & (1 << i)) s.push_back(i);
                else used.insert(i);
            }
            int k = n - used.size();
            if (used.size() * 2 < n || k == 0) {
                continue;
            }
            int pos = 0;
            for (int i: used) pos += (1 << i);
            int res = -1;
            for (int i: freeMask[k]) {
                if ((pos | i) == pos) {
                    res = i;
                    break;
                }
            }
            assert(res != -1);
            freeMask[k].erase(res);
            calc[{n, res}] = s;
            rcalc[{n, mask}] = res;
        }
    }
}

void encode() {
    int n, k;
    cin >> n >> k;
    int mask = 0;
    for (int i = 0; i < k; i++) {
        int a;
        cin >> a;
        a--;
        mask += (1 << a);
    }
    for (int i = 0; i < n; i++) {
        if (rcalc[{n, mask}] & (1 << i)) {
            cout << i + 1 << ' ';
        }
    }
}

void decode() {
    int n, k;
    cin >> n >> k;
    int mask = 0;
    for (int i = 0; i < k; i++) {
        int a;
        cin >> a;
        a--;
        mask += (1 << a);
    }
    for (int i: calc[{n, mask}]) {
        cout << i + 1 << ' ';
    }
}

int c;

void solve() {
    if (c == 1) {
        encode();
    } else {
        decode();
    }
}

int32_t main() {
    cin >> c;
    pre();
#ifdef LOCAL
    if (c == 1) {
        freopen("b1.in", "r", stdin);
    } else {
        freopen("b2.in", "r", stdin);
    }
#endif
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
        cout << '\n';
//        cout << endl;
    }
    cout << endl;
}