#include <iostream>
#include <vector>
#include <iomanip>
#include <assert.h>
#include <map>
#include  <set>
#include  <random>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) begin(x), end(x)

const int maxn = (int)5010;
int dp[maxn][maxn];
void solve() {
	int n, q;
	cin >> n >> q;
	vector<ll> a(n + 1), pr(n + 1);
	for (int i = 0; i < n; i++) {
		cin >> a[i + 1];
	}
	sort(all(a));
	for (int i = 0; i < n; i++) {
		pr[i + 1] = pr[i] + a[i + 1];
	}
	
	int z;
	cin >> z;
	for (int i = 0; i < q; i++) {
		int k, A, B;
		cin >> k >> A >> B;
		int it = upper_bound(a.begin(), a.end(), k) - a.begin() - 1;
		ll sum = pr[it];
		if (sum != A + B) {
			cout << "No\n";
		} else {
			cout << "Yes\n";
			continue;
			bool ok = 1;
			for (int x = 0; x <= min(A, B); x++) {
				ok &= (dp[it][x]);
			}
			if (ok) {
				cout << "Yes\n";
			} else {
				cout << "No\n";
			}
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	while (t--) {
		solve();
	}
	return 0;
}