#include <bits/stdc++.h>
#define int long long

using namespace std;

vector<vector<int>> g;
vector<int> rots;

void dfs(int v, int p = -1, int prevdir = -1, int prevrots = 0) {
    rots[v] = prevrots;
    if (g[v].size() == 0)
        return;
    dfs(g[v][0], v, 0, prevrots + (prevdir == 1));
    dfs(g[v][1], v, 1, prevrots + (prevdir == 0));
}

vector<int> tin, tout;
vector<int> path;
int k;

void dfs_path(int v, int p = -1) {
    tin[v] = path.size();
    bool flag = g[v].size() == 0;
    flag &= rots[v] <= k;
    path.push_back(flag);
    if (g[v].size()) {
        dfs_path(g[v][0], v);
        dfs_path(g[v][1], v);
    }
    tout[v] = path.size() - 1;
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int n, q;
    cin >> n >> k >> q;
    g.resize(n), rots.resize(n), tin.resize(n), tout.resize(n);
    path.reserve(n);
    for (int i = 0; i < n; ++i) {
        int cn;
        cin >> cn;
        g[i].resize(cn);
        for (auto& el : g[i]) {
            cin >> el;
            --el;
        }
    }
    dfs(0);
    dfs_path(0);
    vector<int> prefsums(n);
    for (int i = 0; i < n; ++i)
        prefsums[i] = (i ? prefsums[i - 1] : 0) + path[i];
    for (int qc = 0; qc < q; ++qc) {
        int v;
        cin >> v;
        --v;
        int ans = prefsums[tout[v]];
        if (tin[v])
            ans -= prefsums[tin[v] - 1];
        cout << ans << '\n';
    }
}