#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

const int sz = 100100;

struct otr {
	ll l = 0, r = 0;
	int num = 0;
	bool operator <(otr a) {
		if (l != a.l) return l < a.l;
		return r > a.r;
	}
};

int dp[sz], mx[sz], cnt[sz], pr[sz];

bool cmp(otr a, otr b) {
	return cnt[a.num] > cnt[b.num];
}

void solve() {
	int n;
	cin >> n;
	vector <otr> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i].l >> a[i].r;
		a[i].num = i + 1;
		cnt[i + 1] = 0;
		pr[i + 1] = 0;
	}
	vector <otr> v, b;
	sort(a.begin(), a.end());
	for (auto& p : a) {
		while (!v.empty() && v.back().l <= p.l && p.r <= v.back().r) {
			cnt[p.num] = cnt[v.back().num] + 1;
			pr[p.num] = v.back().num;
			b.push_back(v.back());
			v.pop_back();
		}
		v.push_back(p);
 	}
	int cnt = 0;
	int n = (n - v.size()) / 2;
	for (int i = 0; i < v.size() / 2; ++i) {
		cout << v[i].num << ' ';
		int it = pr[v[i].num];
		while (it != 0 && cnt < n) {
			cout << it << ' ';
			++cnt;
			it = pr[it];
		}
	}
	cout << '\n';
} 

int main() {
	//freopen("in.txt", "r", stdin);
	//freopen("out.txt", "w", stdout);
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}