#include <bits/stdc++.h>
#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,bmi,bmi2,lzcnt,popcnt,tune=native")
using namespace std;

typedef long long ll;
typedef long double ld;
#define F first
#define S second
#define endl '\n'

const int mx = 1510;
int dp[mx][mx];
vector <pair <int, int>> v;

void solve() {
    int n, q;
    cin >> n >> q;
    vector <int> p;
    for (int i = 0; i < n; i++) {
        ll x;
        cin >> x;
        if (x < mx)
            p.push_back(x);
    }
    sort(p.begin(), p.end());
    for (int i = 0; i < mx; i++)
        fill(dp[i], dp[i] + mx, int(1e9));
    v.reserve(mx * mx);
    dp[0][0] = 0;
    v.emplace_back(0, 0);
    for (auto& x : p)
        for (int i = mx - 1; i >= 0; i--)
            for (int j = mx - 1; j >= 0; j--) {
                if (dp[i][j] != int(1e9) && i + x < mx && dp[i + x][j] == int(1e9)) {
                    dp[i + x][j] = x;
                    v.emplace_back(i + x, j);
                }
                if (dp[i][j] != int(1e9) && j + x < mx && dp[i][j + x] == int(1e9)) {
                    dp[i][j + x] = x;
                    v.emplace_back(i, j + x);
                }
            }
    int z;
    cin >> z;
    while (q--) {
        ll k; int a, b;
        cin >> k >> a >> b;
        bool flag = true;
        for (int i = 0; i <= a; i++)
            for (int j = 0; j <= b; j++)
                if (dp[i][j] > k) {
                    flag = false;
                    break;
                }
        if (flag)
            cout << "Yes" << endl;
        else
            cout << "No" << endl;
    }
}

signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);

    int tt = 1;
    // cin >> tt;
    while (tt--)
        solve();

    cerr << "Ulyanovsk is the best" << endl;
}
