#include <bits/stdc++.h>
#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,bmi,bmi2,lzcnt,popcnt,tune=native")
using namespace std;

typedef long long ll;
typedef long double ld;
#define F first
#define S second
//#define endl '\n'

#define int long long

int n, v;
vector <int> g[200010];
int now[200010], l[200010], r[200010];
int dp[200010][2];

int dfs(int s, int c, int p) {
    if (dp[s][c] != -1)
        return dp[s][c];
    if (c == 0) {
        int ret = 0;
        for (auto &e: g[s])
            if (e != p)
                ret += max(dfs(e, 0, s), dfs(e, 1, s));
        return dp[s][c] = ret;
    }
    int ret = now[s];
    for (auto &e: g[s])
        if (e != p)
            ret += dfs(e, 0, s);
    return dp[s][c] = ret;
}

int used[200010];

int get_values(int s, int c, int p) {
    if (c == 1)
        used[s] = 1;
    for (auto& e : g[s])
        if (e != p) {
            if (c == 1 || dp[e][0] > dp[e][1])
                get_values(e, 0, s);
            else
                get_values(e, 1, s);
        }
}

void solve() {
    int q;
    cin >> n >> q;
    int x, y, m;
    cin >> x >> y >> m;
    for (int i = 0; i < n; i++)
        g[i].clear();
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    for (int i = 0; i < n; i++)
        cin >> l[i] >> r[i];

    for (int i = 0; i < n; i++)
        dp[i][0] = dp[i][1] = -1;
    for (int i = 0; i < n; i++)
        now[i] = l[i];
    int mn = max(dfs(0, 0, -1), dfs(0, 1, -1));

    for (int i = 0; i < n; i++)
        dp[i][0] = dp[i][1] = -1;
    for (int i = 0; i < n; i++)
        now[i] = r[i];
    int mx = max(dfs(0, 0, -1), dfs(0, 1, -1));
    fill(used, used + n, 0);
    if (dfs(0, 0, -1) == mx)
        get_values(0, 0, -1);
    else
        get_values(0, 1, -1);

    vector <int> k = {0};
    for (int i = 0; i < n; i++)
        if (used[i] == 0)
            k[0] ^= (x * (i + 1) + y * 0 * 0) % m;
    for (int i = 0; i < n; i++)
        if (used[i] == 1)
            k.push_back(k.back() ^ ((x * (i + 1) + y * 1 * 1) % m));

    for (int i = 0; i < q; i++) {
        cin >> v;
        if (v >= mn && v <= mx)
            cout << k[v] << endl;
        else
            cout << -1 << endl;
    }
    cout << endl;
    int ind;
    cin >> ind;
    while (ind != 0) {
        ind--;
        cout << -1 << endl;
        cin >> ind;
    }
}

signed main() {
    //cin.tie(nullptr);
    //cout.tie(nullptr);
    //ios_base::sync_with_stdio(false);

    int tt = 1;
    cin >> tt;
    while (tt--)
        solve();

    cerr << "Ulyanovsk is the best" << endl;
}
