#include <iostream>
#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define F first
#define S second
mt19937 rnd(100);

struct otr {
    ll l, r, num;
};

bool cmp(otr &o1, otr &o2) {
    if (o1.r < o2.r)
        return 1;
    if (o1.r > o2.r)
        return 0;
    return 0;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);

    ll _;
    cin >> _;
    while (_--) {
        ll n, l, r;
        cin >> n;
        vector<otr> arr;
        for (int i = 0; i < n; ++i) {
            cin >> l >> r;
            arr.push_back({l, r, i + 1});
        }
        sort(arr.begin(), arr.end(), cmp);

        r = LLONG_MIN;
        vector<otr> good, bad;
        for (int i = 0; i < n; ++i)
            if (arr[i].l <= r)
                bad.push_back(arr[i]);
            else {
                good.push_back(arr[i]);
                r = arr[i].r;
            }
        l = LLONG_MAX;
        r = LLONG_MIN;
        ll m = good.size();
        for (int i = 0; i < m / 2; ++i) {
            l = min(l, good[i].l);
            r = max(r, good[i].r);
        }
        ll k = bad.size();
        ll h = 0;
        vector<bool> cross(k);
        for (int i = 0; i < k; ++i)
            cross[i] = bad[i].l <= l && bad[i].r >= l || bad[i].l <= r && bad[i].r >= r ||
                       bad[i].l >= l && bad[i].r <= r, h += cross[i];
        if (h * 2 >= k) {
            h = k / 2;
            for (int i = 0; i < m / 2; ++i)
                cout << good[i].num << ' ';
            for (int i = 0; i < k && h; ++i)
                if (cross[i])
                    cout << bad[i].num << ' ', h--;
        } else {
            h = k / 2;
            for (int i = m / 2; i < m; ++i)
                cout << good[i].num << ' ';
            for (int i = 0; i < k && h; ++i)
                if (cross[i])
                    cout << bad[i].num << ' ', h--;
        }
        cout << endl;
    }
    return 0;
}
/*
2
8
12 14
1 3
2 4
1 10
5 6
7 9
8 10
11 13
6
1 2
2 4
1 2
1 4
5 7
6 8

*/
/*
Есть набор отрезков.
Нужно удалить половину из них чтобы наибольшее множество взаимнонепересекающихся отрезков также уменьшилось в 2 раза.


Возьмем множество нужных нам отрезков. Нужно удалить половину из них чтобы из оставшихся отрезков хотя-бы половина пересекалась с какими-то из них.
Возьмем половину левых хороших отрезков. Если они пересекаются с менее чем с половиной остальных то возьмем остальных хороших.

Как понимать какие отрезки пересекаются с набором наших?
 Просто один из их концов должен быть внутри ряда хороших отрезков.
*/
/*
8
1 3
2 4
5 6
7 9
1 10
8 10
11 13
12 14

1 3 | 5 6 || 7 9 | 11 13

2 4, 1 10
*/
/*
6
1 2
1 2
2 4
1 4
5 7
6 8

1 2 | 5 7
*/