#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

void solve() {
    int n, k;
    cin >> n >> k;
    vector<ll> a(k);
    vector<bool> used(n + 1, false);
    for (auto &el : a){
        cin >> el;
        used[el] = true;
    }
    for (auto &el : a){
       for (int j = el + 1; ; j++){
           if (j > n){
               j -= n;
           }
           if (!used[j]){
               used[j] = true;
               el = j;
               break;
           }
       }
       cout << el << " ";
    }
    cout << "\n";

}

void decode(){
    int n, k;
    cin >> n >> k;
    vector<ll> a(k);
    vector<bool> used(n + 1, false);
    for (auto &el : a){
        cin >> el;
        used[el] = true;
    }
    std::reverse(a.begin(), a.end());
    for (auto &el : a){
        for (int j = el - 1; ; j--){
            if (j < 1){
                j += n;
            }
            if (!used[j]){
                used[j] = true;
                el = j;
                break;
            }
        }
    }
    std::reverse(a.begin(), a.end());
    for (auto el : a){
        cout << el << " ";
    }
    cout << "\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int type;
    cin >> type;
    int t = 1;
    cin >> t;
    while (t--) {
        if (type == 1){
            solve();
        }
        else{
            decode();
        }
    }
    return 0;
}
