#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
vector<int> pred;
int get(int x){
    if (pred[x] == x){
        return x;
    }
    return pred[x] = get(pred[x]);
}
void solve() {
    int n, k;
    cin >> n >> k;
    vector<ll> a(k);
    pred.resize(n + 1);
    for (int i = 0; i <= n; i++) {
        pred[i] = i;
    }
    vector<bool> used(n + 1, false);
    for (auto &el: a) {
        cin >> el;
        used[el] = true;
        pred[el] = el + 1;
        if (pred[el] > n){
            pred[el] -= n;
        }
    }
    for (auto &el: a) {
        int nx = get(el);
        pred[nx] = nx + 1;
        if (pred[nx] > n){
            pred[nx] -= n;
        }
        el = nx;
    }
    std::sort(a.begin(), a.end());
    for (auto el: a) {
        cout << el << " ";
    }
    cout << "\n";

}

void decode() {
    int n, k;
    cin >> n >> k;
    vector<ll> a(k);
    vector<bool> used(n + 1, false);
    for (auto &el: a) {
        cin >> el;
        used[el] = true;
    }
    std::reverse(a.begin(), a.end());
    for (auto &el: a) {
        for (int j = el - 1;; j--) {
            if (j < 1) {
                j += n;
            }
            if (!used[j]) {
                used[j] = true;
                el = j;
                break;
            }
        }
    }
    std::sort(a.begin(), a.end());
    for (auto el: a) {
        cout << el << " ";
    }
    cout << "\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int type;
    cin >> type;
    int t = 1;
    cin >> t;
    while (t--) {
        if (type == 1) {
            solve();
        } else {
            decode();
        }
    }
    return 0;
}
