#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>

using namespace std;

typedef long long ll;

int dp[2002][2002];
int dp1[2002][2002];
pair<int, int> segs[(int)5000000], new_segs[(int)5000000], eee[(int)5000000];

vector<int> t;
vector<int> cc;

void update(int v, int l, int r, int idx, int x) {
	if (l + 1 == r) {
		t[v] = x;
		return;
	}
	int mid = (l + r) / 2;
	if (idx < mid) {
		update(2 * v + 1, l, mid, idx, x);
	}
	else {
		update(2 * v + 2, mid, r, idx, x);
	}
	t[v] = max(t[2 * v + 1], t[2 * v + 2]);
}

int get_max(int v, int l, int r, int a, int b) {
	if (b <= l || r <= a) {
		return 0;
	}
	if (a <= l && r <= b) {
		return t[v];
	}
	int mid = (l + r) / 2;
	return max(get_max(2 * v + 1, l, mid, a, b), get_max(2 * v + 2, mid, r, a, b));
}

int NUP(int n, vector<int> arr) {
	t.assign(4 * (n + 1), 0);
	for (int i = 0; i < n; i++) {
		update(0, 0, n + 1, arr[i], get_max(0, 0, n + 1, arr[i] + 1, n) + 1);
	}
	return get_max(0, 0, n, 0, n);
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		vector<int> arr(n);
		for (int i = 0; i < n; i++) {
			cin >> arr[i];
		}
		
		if (NUP(n, arr) == 1) {
			cout << n << '\n';
			continue;
		}
		/*if (NUP(n, arr) == 2) {
			::t.assign(4 * (n + 1), 0);
			for (int i = 0; i < n; i++) {
				update(0, 0, n + 1, arr[i], get_max(0, 0, n + 1, 0, arr[i]) + 1);
			}
			cout << get_max(0, 0, n, 0, n) + 1 << '\n';;
			continue;
		}*/


		for (int i = 0; i <= n + 1; i++) {
			for (int j = 0; j <= n + 1; j++) {
				dp[i][j] = 0;
			}
		}
		dp[n + 1][arr[0]] = 1;
		dp[arr[0]][0] = 1;
		int IDX = 2;
		segs[0] = { n + 1, arr[0] };
		segs[1] = { arr[0], 0 };
		/*vector<pair<int, int>> segs = {{n + 1, arr[0]}, {arr[0], 0}};
		vector<pair<int, int>> new_segs = {};
		vector<pair<int, int>> eee = {};
		new_segs.reserve(3 * n);
		eee.reserve(3 * n);*/
		for (int i = 1; i < n; i++) {
			int NEW_IDX = 0;
			for (int j = 0; j < IDX; j++) {
				auto el = segs[j];
				if (true) {
					pair<int, int> new_seg = el;
					if (el.first > arr[i]) {
						new_seg.first = arr[i];
						if (dp1[new_seg.first][new_seg.second] < dp[el.first][el.second] + 1) {
							dp1[new_seg.first][new_seg.second] = dp[el.first][el.second] + 1;
						}
					}
				}
				if (true) {
					pair<int, int> new_seg = el;
					if (arr[i] > el.second) {
						new_seg.second = arr[i];
						if (dp1[new_seg.first][new_seg.second] < dp[el.first][el.second] + 1) {
							dp1[new_seg.first][new_seg.second] = dp[el.first][el.second] + 1;
						}
					}
				}
				if (true) {
					pair<int, int> new_seg = el;
					if (arr[i] < el.second || arr[i] > el.first) {
						if (dp1[new_seg.first][new_seg.second] < dp[el.first][el.second]) {
							dp1[new_seg.first][new_seg.second] = dp[el.first][el.second];
						}
					}
				}
			}
			for (int j = 0; j < IDX; j++) {
				auto el = segs[j];
				if (true) {
					pair<int, int> new_seg = el;
					if (el.first > arr[i]) {
						new_seg.first = arr[i];
						if (dp1[new_seg.first][new_seg.second] == dp[el.first][el.second] + 1) {
							dp1[new_seg.first][new_seg.second] = dp[el.first][el.second] + 1;
							// new_segs.push_back(new_seg);
							new_segs[NEW_IDX++] = new_seg;
						}
					}
				}
				if (true) {
					pair<int, int> new_seg = el;
					if (arr[i] > el.second) {
						new_seg.second = arr[i];
						if (dp1[new_seg.first][new_seg.second] == dp[el.first][el.second] + 1) {
							dp1[new_seg.first][new_seg.second] = dp[el.first][el.second] + 1;
							// new_segs.push_back(new_seg);
							new_segs[NEW_IDX++] = new_seg;
						}
					}
				}
				if (true) {
					pair<int, int> new_seg = el;
					if (arr[i] < el.second || arr[i] > el.first) {
						if (dp1[new_seg.first][new_seg.second] == dp[el.first][el.second]) {
							dp1[new_seg.first][new_seg.second] = dp[el.first][el.second];
							// new_segs.push_back(new_seg);
							new_segs[NEW_IDX++] = new_seg;
						}
					}
				}
			}
			int NEW_NEW_IDX = 0;
			for (int j = 0; j < NEW_IDX; j++) {
				auto el = new_segs[j];
				if (dp1[el.first][el.second] != 0) {
					dp[el.first][el.second] = dp1[el.first][el.second];
					dp1[el.first][el.second] = 0;
					eee[NEW_NEW_IDX++] = el;
				}
			}
			IDX = NEW_NEW_IDX;
			for (int j = 0; j < NEW_NEW_IDX; j++) {
				segs[j] = eee[j];
			}
		}
		int ans = 0;
		for (int i = 1; i <= n; i++) {
			for (int j = 1; j <= n; j++) {
				ans = max(dp[i][j], ans);
			}
		}
		cout << ans << '\n';
	}
}