#include <bits/stdc++.h>

typedef long long ll;

template<typename t> using vc = std::vector<t>;

using namespace std;

const int N = 5005;
#define int ll

bool check(vc<int> w, int k, int a, int b) {
    set<pair<int, int>> nw = {{0, 0}};
    for (auto &i: w) {
        if (i > k) continue;
        set<pair<int, int>> lo = nw;
        for (auto [x, y]: nw) {
            lo.insert({x + i, y});
            lo.insert({x, y + i});
        }
        nw = lo;
    }
    set<pair<int, int>> good = {{0, 0}};
    for (auto [x, y]: nw) {
        if (x == 0 && y) {
            if (good.count({x, y - 1})) good.insert({x, y});
        }
        if (y == 0 && x) {
            if (good.count({x - 1, y})) good.insert({x, y});
        }
        int e1 = max(0ll, x - 1);
        int e2 = max(0ll, y - 1);
        if (good.count({e1, y}) && good.count({x, e2})) good.insert({x, y});
    }
    return good.count({a, b});
}

int32_t main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);
    int n, q;
    cin >> n >> q;
    vc<int> w(n);
    for (auto &i: w) cin >> i;
    int z;
    cin >> z;
    while (q--) {
        int k, a, b;
        cin >> k >> a >> b;
        if (check(w, k, a, b)) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}

//8 5
//17 1 3 2 100 5 6 1
//0
//6 15 3
//9 4 4
//5 15 3
//17 34 1
//19 36 5
