#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;
typedef long long ll;

const int mx_b = 5000;

void solve() {
	int n, q;
	cin >> n >> q;
	vector<ll>arr(n);
	for (auto& i : arr)
		cin >> i;
	sort(arr.begin(), arr.end());
	vector<ll>dp(mx_b + 1);
	for (int i = 0; i < n; i++) {
		for (int b = 0; b <= mx_b; b++) {
			if (arr[i] <= dp[b] + 1)
				dp[b] += arr[i];
			if (b >= arr[i] && dp[b - 1] >= dp[b - arr[i]])
				dp[b] = max(dp[b], dp[b - arr[i]]);
		}
	}
	int z; cin >> z;
	while (q--) {
		ll k, a, b;
		cin >> k >> a >> b;
		if (b > mx_b)
			return;
		if (dp[b] >= a)
			cout << "Yes\n";
		else
			cout << "No\n";
	}
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}