#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <deque>
#include <string>
#define endl '\n'
#define ALL(v) begin(v),end(v)

using namespace std;

const int32_t MAXN = 1E5;

template <typename T>
bool rmin(T& x, const T& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T>
bool rmax(T& x, const T& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

struct Otr
{
	int l, r, ind;
	Otr(int l = 0, int r = 0, int ind = 0) :l(l), r(r), ind(ind) {}
	bool operator< (const Otr& o) const
	{
		return r < o.r;
	}
};

bool per(Otr o1, Otr o2)
{
	if (o2.l < o1.l)
	{
		swap(o1, o2);
	}
	if (o1.r >= o2.l)
	{
		return true;
	}
	return false;
}

void solve()
{
	int n;
	cin >> n;
	vector <Otr> mas(n);
	for (int i = 0; i < n; i++)
	{
		cin >> mas[i].l >> mas[i].r;
		mas[i].ind = i;
	}
	sort(ALL(mas));
	vector <Otr> mx_s;
	vector <vector <Otr>> cnt(n);
	mx_s.push_back(mas[0]);
	for (int i = 1; i < n; i++)
	{
		if (!per(mx_s.back(), mas[i]))
		{
			mx_s.push_back(mas[i]);
		}
		else
		{
			cnt[mx_s.back().ind].push_back(mas[i]);
		}
	}

	set <pair <int, Otr>> mp;
	for (int i = 0; i < mx_s.size(); i++)
	{
		mp.insert({ cnt[mx_s[i].ind].size(),mx_s[i] });
	}
	auto t = prev(mp.end());
	int tot = 0, m = mx_s.size();
	int n_cnt = n - m;
	vector <Otr> answ;
	set <Otr> us_ans;
	while (tot < n_cnt / 2)
	{
		for (int i = 0; i < cnt[t->second.ind].size() and tot < n_cnt / 2; i++)
		{
			answ.push_back(cnt[t->second.ind][i]);
			++tot;
		}
		us_ans.insert(t->second);
		--t;
	}

	for (int i = 0; i < mx_s.size() and us_ans.size() < m / 2; i++)
	{
		if (!us_ans.count(mx_s[i]))
		{
			us_ans.insert(mx_s[i]);
		}
	}

	for (int i = 0; i < answ.size(); i++)
	{
		cout << answ[i].ind + 1 << ' ';
	}
	for (auto x : us_ans)
	{
		cout << x.ind + 1 << ' ';
	}
	cout << endl;
	return;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout << fixed << setprecision(13);

	int t;
	cin >> t;
	while (t--)
	{
		solve();
	}
}