#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <bitset>
#include <map>
#include <unordered_map>
#include <set>
#include <string>
#include <iomanip>
#include <random>
#include <chrono>
#include <queue>
#include <deque>
#include <utility>

#define all(a) (a).begin(), (a).end()
#define v std::vector

using ll = long long;
using ld = long double;
using pll = std::pair<ll, ll>;
using str = std::string;

const ll Max = 1e17, Min = -1e17;
const ld Pi = std::acos(-1);
const ld eps = 1e-12;
const ll Mod = 1e9 + 7;
const ll Lg = 20;

std::mt19937 rnd(42);

struct node {
	ll k, a, b;
	ll num;
};

void solve() {
	ll n, q;
	std::cin >> n >> q;
	v<ll> list(n);
	for (int i = 0; i < n; ++i) {
		std::cin >> list[i];
	}
	ll z;
	std::cin >> z;
	v<node> qu(q);
	v<std::set<pll>> ans(q);
	for (int i = 0; i < q; ++i) {
		std::cin >> qu[i].k >> qu[i].a >> qu[i].b;
		qu[i].num = i;
	}
	for (int i = 0; i < (1ll << n); ++i) {
		for (int j = 0; j < (1ll << n); ++j) {
			if (i & j) continue;
			ll suma = 0, sumb = 0;
			for (int k = 0; k < n; ++k) {
				if ((1ll << k) & i) {
					suma += list[k];
				}
				if ((1ll << k) & j) {
					sumb += list[k];
				}
			}
			for (int k = 0; k < q; ++k) {
				bool check = true;
				for (int tmp = 0; tmp < n; ++tmp) {
					if (((1ll << tmp) & i) || ((1ll << tmp) & j)) {
						if (list[tmp] > qu[k].k) {
							check = false;
						}
					}
				}
				if (check) {
					if (suma <= qu[k].a && sumb <= qu[k].b) {
						ans[k].insert({ suma, sumb });
					}
				}
			}
		}
	}
	for (int i = 0; i < q; ++i) {
		std::cout << (ans[i].size() == (qu[i].a + 1) * (qu[i].b + 1) ? "Yes" : "No") << '\n';
	}
}

int main() {
	std::ios::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cout << std::fixed << std::setprecision(10);
	ll t = 1;
	//std::cin >> t;
	while (t--) {
		solve();
	}
}