#include <bits/stdc++.h>
using namespace std;

void solve() {
    int h, w, k;
    cin >> h >> w >> k;
    vector<int> x(k), y(k);
    for (int i = 0; i < k; i++) {
        cin >> x[i] >> y[i];
        x[i]--, y[i]--;
    }
    pair<long long, long long> ans = {LLONG_MAX, LLONG_MAX};
    for (int hr = 0; hr < h; hr++) {
        for (int wr = 0; wr < w; wr++) {
            int min_r = INT_MAX, max_r = INT_MIN, min_c = INT_MAX, max_c = INT_MIN;
            for (int i = 0; i < k; i++) {
                min_r = min(min_r, (x[i] + hr) % h);
                max_r = max(max_r, (x[i] + hr) % h);
                min_c = min(min_c, (y[i] + wr) % w);
                max_c = max(max_c, (y[i] + wr) % w);
            }
            ans = min(ans, {1ll * (max_r - min_r + 1) * (max_c - min_c + 1), min(hr, h - hr) + min(wr, w - wr)});
        }
    }
    cout << ans.first << " " << ans.second << "\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
