#include <bits/stdc++.h>
using namespace std;

void solve() {
    int n, q;
    cin >> n >> q;
    vector<long long> w(n);
    for (auto &v : w) {
        cin >> v;
    }
    long long z;
    cin >> z;
    sort(w.begin(), w.end());
    for (int i = 0; i < q; i++) {
        int k, a, b;
        cin >> k >> a >> b;
        vector dp(a + 1, vector<bool>(b + 1, false));
        dp[0][0] = true;
        for (int j = 0; j < n   ; j++) {
            if (w[j] <= k) {
                vector new_dp = dp;
                for (int ap = 0; ap <= a; ap++) {
                    for (int bp = 0; bp <= b; bp++) {
                        if (ap + w[j] <= a) {
                            new_dp[ap + w[j]][bp] = new_dp[ap + w[j]][bp] || dp[ap][bp];
                        }
                        if (bp + w[j] <= b) {
                            new_dp[ap][bp + w[j]] = new_dp[ap][bp + w[j]] || dp[ap][bp];
                        }
                    }
                }
                dp = new_dp;
            }
        }
        bool good = true;
        for (int j = 0; j <= a; j++) {
            for (int jj = 0; jj <= b; jj++) {
                if (!dp[j][jj]) {
                    good = false;
                }
            }
        }
        cout << (good ? "YES\n" : "NO\n");
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    // int t;
    // cin >> t;
    // while (t--) {
    solve();
    // }
}