#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define sz(x) (ll)(x.size())
const ll INF = LLONG_MAX;

void solve() {
    ll n;
    cin >> n;
    vector<ll> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    ll cnt = 0;
    vector<ll> help;
    for (int i = 1; i < n; ++i) {
        if (a[i] < a[i - 1]) {
            ++cnt;
            help.push_back(a[i]);
        }
    }
    ll m = sz(help);
    vector<ll> dp(m + 1);
    dp[0] = -INF;
    for (int i = 1; i <= m; ++i) {
        ll l = 0, r = i;
        while (r - l > 1) {
            ll mi = (r + l) / 2;
            if (dp[mi] < a[i - 1]) {
                l = mi;
            } else {
                r = mi;
            }
        }
        dp[l + 1] = min(dp[l + 1], a[i - 1]);
    }
    ll mx = -INF, p = -1;
    for (int i = 0; i < m; ++i) {
        if (dp[i] != 0) {
            p = i;
        }
    }
    cout << min(n, n - cnt + p);
}

void solve1() {
    ll n;
    cin >> n;
    vector<ll> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    ll ans = 0;
    for (int i = 0; i < (1ll << n); ++i) {
        vector<ll> q, r;
        for (int j = 0; j < n; ++j) {
            if (i & (1 << j)) {
                q.push_back(a[j]);
            } else {
                r.push_back(a[j]);
            }
        }
        ll cnt1 = 0, mx = -INF, mn = INF;
        for (int j = 0; j < sz(q); ++j) {
            if (q[j] > mx) {
                cnt1++;
                mx = q[j];
            }
        }
        for (int j = 0; j < sz(r); ++j) {
            if (r[j] < mn) {
                ++cnt1;
                mn = r[j];
            }
        }
        ans = max(ans, cnt1);
    }
    cout << ans;
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    ll times = 1;
    cin >> times;
    while (times--) {
        solve(), cout << '\n';
    }
//    stress();
    return 0;
}
