#include <bits/stdc++.h>

using namespace std;

#define ssize(a) static_cast<ptrdiff_t>(size(a));
#define ALL(a) (a).begin(), (a).end()
#define RALL(a) (a).rbegin(), (a).rend()

using i32 = int32_t;
using i64 = int64_t;
using f64 = double;
using f128 = long double;

template <typename T>
void chmin(T& a, const T& b) {
  if (b < a) a = b;
}
template <typename T>
void chmax(T& a, const T& b) {
  if (a < b) a = b;
}

void solve();

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  i32 t;
  cin >> t;
  while (t--) solve();
  return 0;
}

void solve() {
  i32 n;
  cin >> n;
  vector<i32> p(n);
  for (auto& e : p) {
    cin >> e;
  }
  i32 ans = 0;
  vector<vector<i32>> dp(n + 2, vector<i32>(n + 2, -INT32_MAX));
  dp[0][n + 1] = 0;
  for (int i = 0; i < n; ++i) {
    for (int max_rec = 0; max_rec < p[i]; ++max_rec) {
      for (int min_anti = 0; min_anti < n + 2; ++min_anti) {
        if (min_anti == p[i]) continue;
        chmax(dp[p[i]][min_anti], dp[max_rec][min_anti] + 1);
        chmax(ans, dp[p[i]][min_anti]);
      }
    }
    for (int min_anti = n + 1; min_anti > p[i]; --min_anti) {
      for (int max_rec = 0; max_rec < n + 2; ++max_rec) {
        if (max_rec == p[i]) continue;
        chmax(dp[max_rec][p[i]], dp[max_rec][min_anti] + 1);
        chmax(ans, dp[max_rec][p[i]]);
      }
    }
  }
  cout << ans << "\n";
}
