#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
//#define int long long

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9 + 7, N = (1 << 11);

int seg[2][N][2 * N - 1];
int dp[N][N], p[N], sz;

void upd(int num, int x, int v, int y) {
    v += sz - 1;
    seg[num][x][v] = y;
    while (v > 0) {
        v = (v - 1) / 2;
        seg[num][x][v] = max(seg[num][x][2 * v + 1], seg[num][x][2 * v + 2]);
    }
}

int get(int num, int x, int l, int r) {
    l += sz - 1, r += sz - 2;
    int res = 0;
    while (l <= r) {
        if (!(l & 1)) res = max(res, seg[num][x][l]);
        if (r & 1) res = max(res, seg[num][x][r]);
        l /= 2;
        r = r / 2 - 1;
    }
    return res;
}

void solve() {
    int n;
    cin >> n;
    sz = 1;
    n += 2;
    while (sz < n) sz *= 2;
    for (auto &d : seg) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < 2 * sz - 1; j++) d[i][j] = 0;
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) dp[i][j] = 0;
    }
    int ans = 0;
    for (int i = 0; i < n - 2; i++) {
        int x;
        cin >> x;
        for (int y = 0; y < n; y++) {
            if (y == x) continue;
            dp[x][y] = max(dp[x][y], get(1, y, 0, x) + 1);
            dp[y][x] = max(dp[y][x], get(0, y, x + 1, sz) + 1);
            upd(0, x, y, dp[x][y]);
            upd(0, y, x, dp[y][x]);
            upd(1, y, x, dp[x][y]);
            upd(1, x, y, dp[y][x]);
            ans = max({ans, dp[x][y], dp[y][x]});
        }
    }
    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) solve();
}
