#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

ll safe_mod(ll a, ll b) {
    a %= b;
    a += b;
    return a % b;
}

ll get_pos(ll i, ll x) {
    --i;
    i = safe_mod(i, x);

    return i + 1;
}

pair<ll, ll> cnt(ll sz, vector<ll> pos) {
    sort(pos.begin(), pos.end());
    ll best = pos[pos.size() - 1] - pos[0] + 1;
    ll act = 0;

    set<ll> all;
    for (auto x : pos) {
        all.insert(x);
    }

    // move to 1
    // right
    for (auto x : all) {
        ll need_act = sz - x + 1;

        ll will_be_mx = 1;
        for (auto it = all.begin(); it != all.end(); ++it) {
            will_be_mx = max(will_be_mx, get_pos(ll(*it) + need_act, sz));
        }


        if (best > will_be_mx || (best == will_be_mx && act > need_act)) {
            best = will_be_mx;
            act = need_act;
        }
    }

    // left
    for (auto x : all) {
        ll need_act = x - 1;

        ll will_be_mx = 1;
        for (auto it = all.begin(); it != all.end(); ++it) {
            will_be_mx = max(will_be_mx, get_pos(ll(*it) - need_act, sz));
        }

        if (best > will_be_mx || (best == will_be_mx && act > need_act)) {
            best = will_be_mx;
            act = need_act;
        }
    }

    // move to sz
    // right
    for (auto x : all) {
        ll need_act = sz - x;

        ll will_be_min = LLONG_MAX;
        for (auto it = all.begin(); it != all.end(); ++it) {
            will_be_min = min(will_be_min, get_pos(ll(*it) + need_act, sz));
        }

        if (best > sz - will_be_min + 1 || (best == sz - will_be_min + 1 && act > need_act)) {
            best = sz - will_be_min + 1;
            act = need_act;
        }
    }

    // left
    for (auto x : all) {
        ll need_act = x;

        ll will_be_min = LLONG_MAX;
        for (auto it = all.begin(); it != all.end(); ++it) {
            will_be_min = min(will_be_min, get_pos(ll(*it) - need_act, sz));
        }

        if (best > sz - will_be_min + 1 || (best == sz - will_be_min + 1 && act > need_act)) {
            best = sz - will_be_min + 1;
            act = need_act;
        }
    }

    return {best, act};
}

void solve() {
    ll h, w, k;
    cin >> h >> w >> k;

    vector<ll> h_pos(k);
    vector<ll> w_pos(k);
    for (ll i = 0; i < k; ++i) {
        cin >> h_pos[i] >> w_pos[i];
    }

    pair<ll, ll> res1 = cnt(h, h_pos);
    pair<ll, ll> res2 = cnt(w, w_pos);

    cout << res1.first * res2.first << " " << res1.second + res2.second << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}