#include <bits/stdc++.h>

using namespace std;
#define int long long
#define pb push_back
#define ff first
#define ss second
#define all(v) v.begin(), v.end()
using ll = long long;
const int MOD = 1ll << 60;

template<typename T1, typename T2>
inline bool relaxma(T1 &a, const T2 &b) {
    return (a < b ? a = b, true : false);
}


template<typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return (a > b ? a = b, true : false);
}

const int N = 2e5 + 5;

int tr[4 * N];
int n;

int get(int l, int r, int v = 0, int L = 0, int R = n) {
    if (l == L && r == R) return tr[v];
    int res = 0, M = (L + R) / 2;
    if (l < M) res = max(res, get(l, min(M, r), v * 2 + 1, L, M));
    if (M < r) res = max(res, get(max(l, M), r, v * 2 + 2, M, R));
    return res;
}

void upd(int p, int x, int v = 0, int L = 0, int R = n) {
    if (R - L == 1) {
        tr[v] = x;
        return;
    }
    int M = (L + R) / 2;
    if (p < M) upd(p, x, v * 2 + 1, L, M);
    else upd(p, x, v * 2 + 2, M, R);
    tr[v] = max(tr[v * 2 + 1], tr[v * 2 + 2]);
}


void solve() {
    cin >> n;
    for (int i = 0; i < 4 * n; i++) tr[i] = 0;
    vector<int> v(n);
    for (auto &i: v) {
        cin >> i;
        i--;
    }
    int res = 0;
    for (int i = 0; i < n; i++) {
        int cur = get(0, v[i] + 1) + 1;
        upd(v[i], cur);
    }
    res = min(n, tr[0] + 1);
    cout << res << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    cin >> tt;
    while (tt--) solve();
}