#include <bits/stdc++.h>
#define all(x) x.begin(), x.end()
#define frl(i, x) for(auto& i : x)
#define F first
#define S second
const int inf = 1e9+1000-7;
using namespace std;

mt19937 rnd(228);
int score(vector<int>& v, vector<bool>& mask){
    int ans = 0;
    int cmx = 0, cmn = 1e9;
    for(int i = 0; i < v.size(); i++){
        if(mask[i] && cmx < v[i]){
            ans++, cmx = v[i];
        }
        else if(!mask[i] && cmn > v[i]){
            ans++, cmn = v[i];
        }
    }
    return ans;
}
double kok(){
    return (rnd()&0b111111111111)/(double)0b111111111111;
}
int simulate(int x, vector<int>& v){
    int n = v.size();
    vector<bool> mask(n);
    for(int i = 0; i < n; i++) mask[i] = rnd() & 1;
    int cur = score(v, mask), ans = cur;
    double t = 1;
    for(int i = 0; i < x; i++){
        int bit = rnd() % n;
        mask[bit] = !mask[bit];
        int nsc = score(v, mask);
        if(nsc > cur || t > kok()) {
            cur = nsc;
            ans = max(ans, cur);
        }
        else{
            mask[bit] = !mask[bit];
        }
    }
    return ans;
}
void solve(){
    int n;
    cin >> n;
    vector<int> v(n);
    frl(i, v) cin >> i;
    int best = 0;
    for(int i = 0; i < 10; i++){
        if(n <= 10) best = max(best, simulate(10000, v));
        else if(n <= 100) best = max(best, simulate(10000, v));
        else best = max(best, simulate(10000, v));
    }
    cout << best << '\n';
}
int main() {
    cin.tie(0)->ios::sync_with_stdio(0);
    int t;
    cin >> t;
    while(t--) {
        solve();
    }
    return 0;
}
