#include <iostream>
#include <random>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

mt19937 rnd(228);

#define int long long

void solve1() {
	int n, k; cin >> n >> k;
	vector <int> v(k); for (auto& x : v) cin >> x;

	vector <int> ans;
	set <int> used;
	for (auto x : v) used.insert(x);
	int pr = v[0];
	int p = 0;
	for (auto x : v) {
		if (p < pr && pr < x) pr = x;
		p = x;
		while (used.count(pr)) pr = pr % n + 1;
		used.insert(pr);
		ans.push_back(pr);
	}
	sort(all(ans));
	for (auto x : ans) cout << x << ' ';
}

void solve2() {
	int n, k; cin >> n >> k;
	vector <int> v(k); for (auto& x : v) cin >> x;

	vector <int> ans;
	set <int> used;
	for (auto x : v) used.insert(x);
	reverse(all(v));
	int pr = v[0];
	int p = n;
	for (auto x : v) {
		if (x < pr && pr < p) pr = x;
		p = x;
		while (used.count(pr)) pr = (pr - 2 + n) % n + 1;
		used.insert(pr);
		ans.push_back(pr);
	}
	sort(all(ans));
	for (auto x : ans) cout << x << ' ';
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int32_t a; cin >> a;
	int32_t t = 1;
	cin >> t;
	while (t--) {
		if (a == 1) solve1();
		else solve2();
		cout << '\n';
	}
}