#include <iostream>
#include <random>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

mt19937 rnd(228);

#define int long long

int MOD;

void solve() {
	int k, n, p; cin >> k >> n >> p;

	int ans = 0;
	for (int mask = 0; mask < (1ll << (1ll << k)); ++mask) {
		vector <int> v;
		for (int i = 0; i < (1ll << k); ++i) {
			if (mask >> i & 1) v.push_back(i);
		}
		if (v.size() != n || v[0] != 0) continue;

		int pr = 0;
		int xr = 0;
		set <int> st = { 0 };
		while (true) {
			int mx = 0;
			while (mx < v.size() && v[mx] == mx) ++mx;
			if (pr == mx || mx == 1) {
				ans += (mx == p);
				break;
			}
			pr = mx;

			xr ^= mx - 1;
			if (st.count(xr)) break;

			st.insert(xr);
			vector <int> v1;
			for (auto x : v) v1.push_back(x ^ (mx - 1));
			sort(all(v1));
			v = v1;
		}
	}

	cout << ans % MOD;
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	cin >> MOD;
	int32_t t = 1;
	cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}