#include <bits/stdc++.h>

#define int int64_t
#define pb push_back
#define pii pair<int, int>
#define vi vector<int>
#define vii vector<vi>
#define all(x) x.begin(), x.end()
#define tests int t; cin >> t; while(t--)

using namespace std;

mt19937 rnd(412);
struct line{
    int first, second, id;
};

vector<line> a;

bool comp(line l, line r){
    return l.second < r.second || l.second == r.second && l.first < r.first;
}

int check(int n) {
    sort(a.begin(), a.begin() + n, comp);
    line last = {-1, -1};
    int res = 0;
    for (int i = 0; i < n; ++i) {
        if (last.second < a[i].first) {
            last = a[i];
            ++res;
        }
    }
    return res;
}

int32_t main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    tests{
        int n;
        cin >> n;
        a.assign(n + 1, line());
        sort(all(a), comp);
        vector<vii> dp(n + 1, vii(n + 1, vi(n + 1)));
        vector<vii> pr(n + 1, vii(n + 1, vi(n + 1)));
        for (int i = 0; i < n; ++i) {
            int l, r;
            cin >> l >> r;
            a[i + 1] = {l, r, i + 1};
        }
        a[0] = {-1, -1, -1};
        dp[0][0][0] = 1;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j <= n; ++j) {
                for (int k = j + 1; k <= n; ++k) {
                    if (a[k].first > a[j].second) {
                        dp[i + 1][j + 1][k] = dp[i][j];
                        pr[i + 1][j + 1][k] = j;
                    }
                }
            }
        }
        int m = check(n) / 2;
        int last = 0;
        for (int i = 0; i < n; ++i) {
            if(dp[m][i]) {
                last = i;
                break;
            }
        }
        vi ans;
        while(m != 0) {
            ans.pb(last);
            last = pr[--m][last];
        }
        for (auto u: ans){
            cout << u << ' ';
        }
        cout << endl;
    }
}