#include <bits/stdc++.h>
#include <unordered_map>
#include <unordered_set>

#define umap unordered_map
#define uset unordered_set

#define spc << ' ' <<
#define space << ' '
#define newl << '\n'
#define endl << endl

#define elfi else if
#define pb push_back
#define repeat(a) for (int i31 = 0; i31 < a; ++i31)
#define all(a) (a).begin(), (a).end()

using namespace std;

using ll = long long;
using vl = vector <ll>;
using vvl = vector <vl>;
using vi = vector <int>;
using vvi = vector <vi>;
using pll = pair <ll, ll>;

ll LINF = LLONG_MAX;

void upd(int x, ll d, vl & mas) {
    for (; x < (int)mas.size(); x = (x | (x + 1))) {
        mas[x] = max(mas[x], d);
    }
}

ll get(int x, vl & mas) {
    ll res = -LINF;
    for (; x >= 0; x = (x & (x + 1)) - 1) {
        res = max(res, mas[x]);
    }
    return res;
}

void solve() {
    int n;
    cin >> n;
    vl p(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i];
    }

    ll ans = 0;
    vvl dp(n + 1, vl (n + 1, -LINF));
    dp[0][0] = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j <= n; ++j) {
            if (j != p[i]) {
                ll res = -LINF;
                for (int t = 0; t < n - p[i] + 1; ++t) {
                    res = max(res, dp[j][t]);
                }

                if (res != -LINF) {
                    res++;
                    ans = max(ans, res);
                    dp[j][n - p[i] + 1] = res;
                }
            }
            if (j != n - p[i] + 1) {
                ll res = -LINF;
                for (int t = 0; t < p[i]; ++t) {
                    res = max(res, dp[t][j]);
                }

                if (res != -LINF) {
                    res++;
                    ans = max(ans, res);
                    dp[p[i]][j] = res;
                }
            }
        }
        for (int j = 0; j < p[i]; ++j) {
            for (int t = 0; t < n - p[i] + 1; ++t) {
                dp[j][t] = -LINF;
            }
        }
    }
    cout << ans;
}

void tests() {
    int t = 1;
    cin >> t;
    repeat(t) {
        solve();
        cout newl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    //freopen("tests.txt", "r", stdin);

    tests();
}
