#include <bits/stdc++.h>

#define all(_a) _a.begin(), _a.end()
#define rall(_a) _a.rbegin(), _a.rend()

using namespace std;

#define int long long

const int MAX_N = 3e5;

int n;

long long w[MAX_N];

const int MAX = 201;

bool dp[101][MAX][MAX];

void calc_dp() {
    dp[0][0][0] = true;
    for (int i = 0; i < n; ++i) {
        for (int a = 0; a < MAX; ++a) {
            for (int b = 0; b < MAX; ++b) {
                if (dp[i][a][b]) {
                    if (a + w[i] < MAX) {
                        dp[i + 1][a + w[i]][b] = true;
                    }
                    if (b + w[i] < MAX) {
                        dp[i + 1][a][b + w[i]] = true;
                    }
                    dp[i + 1][a][b] = true;
                }
            }
        }
    }
}

bool run(long long k, long long a, long long b) {
    int len = upper_bound(w, w + n, k) - w;
    if (a >= MAX || b >= MAX) {
        return 0;
    }
    for (long long A = a; A >= 0; --A) {
        for (long long B = b; B >= 0; --B) {
            if (!dp[len][A][B]) {
                return 0;
            }
        }
    }
    return 1;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int q;
    cin >> n >> q;
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    sort(w, w + n);

    calc_dp();

    //cerr << dp[6][15][3] << '\n';
//    for (int a = 0; a <= 15; ++a) {
//        for (int b = 0; b <= 3; ++b) {
//            cerr << a << ' ' << b << ' ' << dp[6][a][b] << '\n';
//        }
//    }

    int z;
    cin >> z;
    int v = 0;
    for (int i = 0; i < q; ++i) {
        long long j, c, d;
        cin >> j >> c >> d;
        long long k = j - 1ll * v * z;
        long long a = c - 1ll * v * z;
        long long b = d - 1ll * v * z;

        bool ans = run(k, a, b);
        if (ans) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
        v += ans;
    }
}