#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define vll vector<ll>
#define pll pair<ll, ll>
#define vpl vector<pll>
#define vbo vector<bool>

#define sz(a) a.size()
#define all(a) a.begin(),a.end()
#define sor(a) sort(all(a))

#define pub push_back

#define FOR(i, a, b) for(ll i = a; i < b; ++i)
#define F0R(i, b) FOR(i, 0, b)
#define ROF(i, a, b) for(ll i = b - 1; i >= a; --i)
#define R0F(i, b) ROF(i, 0, b)
#define each(i, a) for(auto i : a)

#define fastio ios_base::sync_with_stdio(false); cin.tie(0)

using namespace std;

vector<vll> tree;
vpl cnt;
vpl dist;
vll ans;

void dfs(ll v = 0, ll p = -1, bool pick = false){
    if (pick){
        each(u, tree[v]){
            if (u == p){
                continue;
            }
            dfs(u, v, false);
        }
    } else {
        if (cnt[v].first > cnt[v].second){
            ans.pub(v);
            each(u, tree[v]){
                if (u == p){
                    continue;
                }
                dfs(u, v, true);
            }
        } else {
            each(u, tree[v]){
                if (u == p){
                    continue;
                }
                dfs(u, v, false);
            }
        }

    }
}

void calc(ll v = 0, ll p = -1){
    cnt[v].first += dist[v].second;
    each(u, tree[v]){
        if (u == p){
            continue;
        }
        calc(u, v);
        cnt[v].second += max(cnt[u].first, cnt[u].second);
        cnt[v].first = max(cnt[v].first, cnt[u].second);
    }
}

void solve(){
    tree.clear();
    cnt.clear();
    ans.clear();
    dist.clear();
    ll n, q;
    cin >> n >> q;
    ll x, y, m;
    cin >> x >> y >> m;
    tree.resize(n);
    cnt.resize(n);
    dist.resize(n);
    F0R(i, n - 1){
        ll v, u;
        cin >> v >> u;
        v--;
        u--;
        tree[v].pub(u);
        tree[u].pub(v);
    }
    F0R(i, n){
        ll l, r;
        cin >> l >> r;
        dist[i] = {l, r};
    }
    calc();
    vll contr(n + 1, 0);
    FOR(i, 1, n + 1){
        if (sz(ans) < i){
            contr[i] = -1;
        } else {
            contr[i] = (contr[i - 1] ^ ((x * i + y) % m));
        }
    }
    vll req(q);
    F0R(i, q){
        ll k;
        cin >> k;
        req[i] = k;
        cout << contr[i] << ' ';
        cout << endl;
        cout.flush();
    }
    while (true){
        ll t;
        cin >> t;
        if (t == 0){
            return;
        }
        t--;
        if (contr[req[t]] == -1){
            cout << -1 << endl;
            cout.flush();
        } else {
            F0R(i, req[t]){
                cout << 1 << ' ';
            }
            cout << endl;
            cout.flush();
        }
    }
}

int main() {
    fastio;
    ll t;
    cin >> t;
    F0R(i, t){
        solve();
    }
    return 0;
}
