#include <bits\stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;

#pragma GCC optimize(3)
#pragma GCC optimize("O3")
#pragma GCC optimize("avx2")

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
#define vec vector

//#define endl '\n'
//#define int long long

const int INF = 2e18 + 333;

random_device RD;
mt19937 rnd(RD());

vec<int> tree, pr;
int n;

pair<int, int> get(int x) {
    x++;
    int mx = 0, ind = -1;
    for (; x > 0; x -= x & -x) {
        if (mx < tree[x]) {
            mx = tree[x];
            ind = pr[x];
        }
    }
    return {mx, ind};
}

void upd(int i, int x, int j) {
    i++;
    for (; i < 2 * n + 10; i += i & -i) {
        if (tree[i] < x) {
            tree[i] = x;
            pr[i] = j;
        }
    }
}

bool comp(pair<int, int>& a, pair<int, int>& b) {
    return a.second < b.second;
}

bool comp2(pair<pair<int, int>, int>& a, pair<pair<int, int>, int>& b) {
    return a.first.second < b.first.second;
}

void solve() {
    cin >> n;
    vec<pair<int, int>> a(n);
    vec<pair<pair<int, int>, int>> ind(n);
    map<int, int> mp;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
        mp[a[i].first] = 0;
        mp[a[i].second] = 0;
        ind[i].first = a[i];
        ind[i].second = i;
    }
    sort(all(ind));
    int c = 0;
    for (auto it : mp) {
        mp[it.first] = (c++);
    }
    for (int i = 0; i < n; ++i) {
        a[i].first = mp[a[i].first];
        a[i].second = mp[a[i].second];
    }
    sort(all(a));
    int m = 0;
    vec<int> pred(n);
    tree.assign(2 * n + 10, 0);
    pr.assign(2 * n + 10, -1);
    int mx = 0, id = -1;
    for (int i = 0; i < n; ++i) {
        auto c = get(a[i].first - 1);
        upd(a[i].second, c.first + 1, i);
        mx = max(mx, c.first + 1);
        if (mx == c.first + 1) id = i;
        pred[i] = c.second;
    }
    vec<int> p;
    int cur = id;
    vec<bool> used(n);
    while (cur != -1) {
        p.pb(cur);
        used[cur] = 1;
        cur = pred[cur];
    }
    m = mx;
    vec<int> bc, cc;
    reverse(all(p));
    int gr = a[p[m / 2 - 1]].second;
    int gl = a[p[m / 2]].first;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            if (a[i].first <= gr) bc.pb(i);
            if (a[i].second >= gl) cc.pb(i);
        }
    }
    if ((int)bc.size() >= (n - mx) / 2) {
        for (int i = 0; i < (n - mx) / 2; ++i) cout << ind[bc[i]].second + 1 << " ";
        for (int i = 0; i < m / 2; ++i) cout << ind[p[i]].second + 1 << " ";
        cout << endl;
    }
    else if ((int)cc.size() >= (n - mx) / 2) {
        for (int i = 0; i <  (n - mx) / 2; ++i) cout << ind[cc[i]].second + 1 << " ";
        for (int i = m / 2; i < m; ++i) cout << ind[p[i]].second + 1 << " ";
    }
    else assert(0);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    for (; t > 0; --t) {
        solve();
    }
}