#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <random>
#include <algorithm>


#define int long long
using namespace std;


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector <int> a(n);
        for (int i = 0; i < n; i++) {
            cin >> a[i];
        }
        vector <vector <int>> dp(n + 2, vector <int> (n + 2, -1));
        dp[0][n + 1] = 0;
        int ans = 1;
        for (int i = 0; i < n; i++) {
            int nw = a[i];
            vector <vector <int>> ndp(n + 2, vector <int> (n + 2, -1));
            for (int bl = 0; bl <= n + 1; bl++) {
                for (int mn = 0; mn <= n + 1; mn++) {
                    if (dp[bl][mn] != -1) {
                        int zn = dp[bl][mn] + 1;
                        if (bl < nw and ndp[nw][mn] < zn) {
                            ndp[nw][mn] = zn;
                            ans = max(ans, zn);
                        }
                        else if (bl >= nw) {
                            ndp[bl][mn] = zn - 1;
                            ans = max(ans, zn - 1);
                        }
                        if (mn > nw and ndp[bl][nw] < zn) {
                            ndp[bl][nw] = zn;
                            ans = max(ans, zn);
                        }
                        else if (mn <= nw) {
                            ndp[bl][mn] = zn - 1;
                            ans = max(ans, zn - 1);
                        }
                    }
                }
            }
            dp = ndp;
        }
        cout << ans << "\n";
    }
}
