#include <bits/stdc++.h>
//#define int long long
#define ll long long
#define x first
#define y second
#define pii pair <int, int>
#define all(x) x.begin(), x.end()
#define sz(x) (int)(x.size())
using namespace std;

vector <vector <int> > v, mrg;


void dfs(int h, int prev, int cnt) {
    if (v[h].empty()) {
        mrg[h].push_back(cnt);
//        cout << h + 1 << endl;
        return;
    }
    dfs(v[h][0], -1, cnt + (prev == 1));
    dfs(v[h][1], 1, cnt + (prev == -1));
    merge(all(mrg[v[h][0]]), all(mrg[v[h][1]]), back_inserter(mrg[h]));
}

int get(int h, int k) {
    auto p = upper_bound(all(mrg[h]), k) - mrg[h].begin();
    return p;
}

signed main() {
    ll n, k, q;
    cin >> n >> k >> q;
    v.resize(n); mrg.resize(n);
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        while (x > 0) {
            int a;
            cin >> a; a--;
            v[i].push_back(a);
            x--;
        }
    }
    dfs(0, 0, 0);
    while (q--) {
        int h;
        cin >> h; h--;
        cout << get(h, k) << "\n";
    }
}
