#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

bool dp[101][301][301] = {};
bool good[301][301][301] = {};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;
    vector<ll> w(n);
    for (int i = 0; i < n; i++) cin >> w[i];
    sort(all(w));
    ll z;
    cin >> z;

    dp[0][0][0] = true;
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j <= 300; j++) {
            for (int k = 0; k <= 300; k++) {
                dp[i][j][k] = dp[i - 1][j][k];
                if (j >= w[i - 1]) {
                    dp[i][j][k] |= dp[i - 1][j - w[i - 1]][k];
                }
                if (k >= w[i - 1]) {
                    dp[i][j][k] |= dp[i - 1][j][k - w[i - 1]];
                }
            }
        }
    }

    for (int k = 0; k <= 300; k++) {
        int mx = upper_bound(all(w), k) - w.begin();

        for (int i = 0; i <= 300; i++) {
            for (int j = 0; j <= 300; j++) {
                bool ok = true;
                if (i > 0) {
                    ok = ok && good[k][i - 1][j];
                }
                if (j > 0) {
                    ok = ok && good[k][i][j - 1];
                }
                ok = ok && dp[mx][i][j];
                good[k][i][j] = ok;
            }
        }
    }

    for (int i = 0; i < q; i++) {
        ll k, a, b;
        cin >> k >> a >> b;
        cout << (good[min(k, 300LL)][a][b] ? "Yes\n" : "No\n");
    }

    return 0;
}