#include <iostream>
#include <vector>

using namespace std;
typedef long long ll;

#define ve vector

ve<ll> cnt;
ve<ve<ll>> gr;

ll n, k, q;
ll dfs(ll v, ll state, ll c)
{
    if(c > k)
        return 0;
    if(gr[v].size() == 0)
    {
        cnt[v] = 1;
        return cnt[v];
    }
    ll sm = 0;
    if(state == 1)
    {
        sm += dfs(gr[v][0], 0, c + 1);
        sm += dfs(gr[v][1], 1, c);
    }
    if(state == 0)
    {
        sm += dfs(gr[v][0], 0, c);
        sm += dfs(gr[v][1], 1, c + 1);
    }
    if(state == -1)
    {
        sm += dfs(gr[v][0], 0, c);
        sm += dfs(gr[v][1], 1, c);
    }
    cnt[v] = sm;
    return sm;
}

int main() {
    cin >> n >> k >> q;
    gr.resize(n);
    cnt.resize(n, 0);
    for (ll i = 0; i < n; ++i) {
        ll c = 0;
        cin >> c;
        for (int j = 0; j < c; ++j) {
            ll x;
            cin >> x;
            gr[i].push_back(x - 1);
        }
    }
    dfs(0, -1, 0);
    for (int i = 0; i < q; ++i) {
        ll x;
        cin >> x;
        cout << cnt[x - 1] << endl;
    }
}
