#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <stack>

using namespace std;
typedef long long ll;
typedef pair<ll, ll> ii;
typedef tuple<ll, ll, ll, ll> iii;
#define ve vector
#define all(x) x.begin(), x.end()

void solve();

int main() {
   ll t;
   cin >> t;
   while(t --)
   {
       solve();
   }
}


ll dist(ll v, ve<ll> &prt, ve<ll> &gr)
{
    if(prt[v] == -1)
        return 0;
    if(gr[prt[v]] > 1)
        return 1;
    return dist(prt[v], prt, gr) + 1;
}

void del(ll v, ve<ll> &prt, ve<ll> &gr)
{
    if(prt[v] == -1)
        return;
    gr[prt[v]]--;
    if(gr[prt[v]] == 0)
        del(prt[v], prt, gr);
}

void solve() {
    ll n;
    cin >> n;
    ve<iii> a;
    ve<ll> gr(n);
    ve<ll> prt(n);
    for (int i = 0; i < n; ++i) {
        ll l, r;
        cin >> l >> r;
        a.push_back({l, 1, -r, i});
        a.push_back({r, -1, 1, -1});
    }
    sort(all(a));
    ll b = -1;
    ll cnt = 0;

    ve<ll> leaves;
    stack<ll> pt;

    for(auto [_, __, r, i]: a)
    {
        if(i < 0)
        {
            if(gr[pt.top()] == 0)
            {
                leaves.push_back(pt.top());
            }
            pt.pop();
            continue;
        }
        if(!pt.empty())
        {
//            gr[pt.top()].push_back(i);
            gr[pt.top()]++;
            prt[i] = pt.top();
        }
        else
            prt[i] = -1;
        pt.push(i);
    }
//    ll root = a[0].second;
    ll m = leaves.size();

    ve<bool> used(m);

    for (int i = 0; i < m / 2 ; ++i) {
        ll best;
        ll mn = 1e17;
        for (int j = 0; j < m; ++j)
        {
            if(used[j])
                continue;
            ll dst = dist(leaves[j], prt, gr);
            if(dst < mn)
            {
                mn = dst;
                best = j;
            }
        }
        del(leaves[best], prt, gr);
        used[best] = 1;
    }
    ve<ll> ans;
    for (int i = 0; i < m; ++i) {
        if(!used[i])
            ans.push_back(leaves[i]);
    }
    ve<bool> uss(n);
    ll i = 0;
    while(ans.size() < n / 2)
    {
        if(used[i])
        {
            i++;
            continue;
        }

        ll tmp = prt[leaves[i]];
        while(ans.size() < n / 2 && (!uss[tmp]) && tmp != -1)
        {
            ans.push_back(tmp);
            uss[tmp] = 1;
            tmp = prt[tmp];
        }
        i++;
    }
    for(auto x: ans)
    {
        cout << x + 1 << ' ';
    }
    cout << '\n';
}


