#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <stack>

using namespace std;
typedef long long ll;
typedef pair<ll, ll> ii;
typedef tuple<ll, ll, ll, ll> iii;
#define ve vector
#define all(x) x.begin(), x.end()

void solve();

int main() {
   ll t;
   cin >> t;
   while(t --)
   {
       solve();
   }
}

ve<ll> prt, gr;
ve<set<ll>> gr1;
set<ii> dists;
ll dist(ll v)
{
    if(prt[v] == -1)
        return 0;
    if(gr[prt[v]] > 1)
        return 1;
    return dist(prt[v]) + 1;
}

ll dist1(ll v, ll depth)
{
    if(gr1[v].empty())
    {
        dists.erase(ii{depth, v});
        dists.insert({dist(v), v});
    }
    for(auto x: gr1[v])
        dist1(x, depth + 1);
}

void del(ll v)
{
    if(prt[v] == -1)
        return;
    gr[prt[v]]--;
    gr1[prt[v]].erase(v);
    if(gr[prt[v]] == 0)
        del(prt[v]);
    if(gr[prt[v]] == 1)
    {
        dist1(prt[v], 0);
    }
}



void solve() {
    ll n;
    cin >> n;
    ve<iii> a;
    gr = ve<ll>(n);
    prt = ve<ll>(n);
    gr1 = ve<set<ll>>(n);
    dists = set<ii>();
    for (int i = 0; i < n; ++i) {
        ll l, r;
        cin >> l >> r;
        a.push_back({l, 1, -r, i});
        a.push_back({r, -1, 1, -1});
    }
    sort(all(a));
    ll b = -1;
    ll cnt = 0;

    ve<ll> leaves;

    stack<ll> pt;

    for(auto [_, __, r, i]: a)
    {
        if(i < 0)
        {
            if(gr[pt.top()] == 0)
            {
                leaves.push_back(pt.top());
            }
            pt.pop();
            continue;
        }
        if(!pt.empty())
        {
            gr1[pt.top()].insert(i);
            gr[pt.top()]++;
            prt[i] = pt.top();
        }
        else
            prt[i] = -1;
        pt.push(i);
    }
//    ll root = a[0].second;
    ll m = leaves.size();

    ve<bool> used(m);
    for (int i = 0; i < leaves.size(); ++i)
    {
        dists.insert({dist(leaves[i]), leaves[i]});
    }
    for (int i = 0; i < m / 2 ; ++i) {
        ll bets = dists.begin()->second;
        dists.erase(dists.begin());
        del(bets);

    }
    ve<ll> ans;
    for(auto x: dists)
    {
        ans.push_back(x.second);
    }

    ve<bool> uss(n);
    auto cur = dists.begin();
    while(ans.size() < n / 2)
    {
        ll tmp = prt[cur->second];
        while(ans.size() < n / 2 && (!uss[tmp]) && tmp != -1)
        {
            ans.push_back(tmp);
            uss[tmp] = 1;
            tmp = prt[tmp];
        }
        cur++;
    }
    for(auto x: ans)
    {
        cout << x + 1 << ' ';
    }
    cout << '\n';
}


