#include <bits/stdc++.h>

using namespace std;

#define int long long

map <pair <int, vector <int>>, vector <int>> g, rev;

vector <int> gr[100], mt(100, -1), used(100, -1);

int timer = 0;

vector <vector <int>> s;

vector <int> v;

void gen(int x, int n, int k) {
    if (v.size() == k) {
        s.push_back(v);
        return;
    }
    if (x == n + 1)
        return;
    v.push_back(x);
    gen(x + 1, n, k);
    v.pop_back();
    gen(x + 1, n, k);
}

bool dfs(int v) {
    used[v] = timer;
    for (int to : gr[v]) {
        if (mt[to] == -1 || (used[mt[to]] != timer && dfs(mt[to]))) {
            mt[to] = v;
            return true;
        }
    }
    return false;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    for (int n = 2; n <= 7; ++n) {
        for (int k = 1; k * 2 <= n; ++k) {
            gen(1, n, k);
            for (int i = 0; i < s.size(); ++i) {
                gr[i].clear();
                mt[i] = -1;
                used[i] = -1;
            }
            timer = 0;
            for (int i = 0; i < s.size(); ++i) {
                for (int j = 0; j < s.size(); ++j) {
                    vector <int> v1 = s[i], v2 = s[j], used(n + 1, 0);
                    for (auto x : v1) {
                        used[x] = 1;
                    }
                    bool flag = true;
                    for (auto x : v2) {
                        if (used[x]) {
                            flag = false;
                            break;
                        }
                    }
                    if (flag) {
                        gr[i].push_back(j);
                        gr[j].push_back(i);
                    }
                }
            }
            for (int i = 0; i < s.size(); ++i) {
                if (dfs(i))
                    ++timer;
            }
            for (int i = 0; i < s.size(); ++i) {
                int j = mt[i];
                g[{n, s[j]}] = s[i];
                rev[{n, s[i]}] = s[j];
            }
            s.clear();
        }
    }
    int t, m;
    cin >> t >> m;
    for (int i = 0; i < m; ++i) {
        int n, k;
        cin >> n >> k;
        vector <int> v(k);
        for (auto &x : v)
            cin >> x;
        vector <int> ans;
        if (t == 1) {
            ans = g[{n, v}];
        } else {
            ans = rev[{n, v}];
        }
        for (auto x : ans)
            cout << x << " ";
        cout << endl;
    }
    return 0;
}
