#include<bits/stdc++.h>

#define int long long
#define vec vector
#define f first
#define s second
#define pii pair<int, int>
#define FOR(i, n) for(int i = 0; i < (n); i++)
#define pb push_back
#define all(x) x.begin(), x.end()
#define sz(x) (int)(x).size()

using namespace std;

vec<int> func(vec<pii> segs)
{
    int n = sz(segs);
    vec<int> ans;
    vec<pair<pii, int>> scan;
    FOR(i, n)
    {
        scan.pb({segs[i], i});
    }
    sort(all(scan));
    vec<int> dp (n);
    vec<int> prev (n, -1);

    FOR(i, n)
    {
        dp[i] = 1;
        for(int j = 0; j < i; j++)
        {
            if(scan[j].f.s < scan[i].f.f)
            {
                if(dp[i] < dp[j] + 1)
                {
                    dp[i] = dp[j] + 1;
                    prev[i] = j;
                }
            }
        }
    }

    int pos = max_element(all(dp)) - dp.begin();
    while(pos != -1)
    {
        ans.pb(scan[pos].s);
        pos = prev[pos];
    }
    cout << *max_element(all(dp)) << " : " << endl;
    reverse(all(ans));
    return ans;
}

void solve()
{
    int n;
    cin >> n;
    vec<pii> a (n);
    for(auto &[x, y] : a)
        cin >> x >> y;

    vec<vec<int>> save (n, vec<int> (n));
    vec<int> order (n);
    vec<int> d (n);
    iota(all(d), 0);
    sort(all(d), [&](int x, int y){
        if(a[x].s - a[x].f == a[y].s - a[y].f)
            return x > y;
        return a[x].s - a[x].f > a[y].s - a[y].f;
    });

    FOR(i, n)
        order[d[i]] = i;

    FOR(i, n)
    {
        for(int j = i + 1; j < n; j++)
        {
            if(min(a[i].s, a[j].s) > max(a[i].f, a[j].f) && !(a[i].f <= a[j].f && a[j].s <= a[i].s) && !(a[j].f <= a[i].f && a[i].s <= a[j].s))
            {
                save[i][j] = 1;
            }
        }
    }

    vec<vec<int>> g (n);

    int root = order[0];
    FOR(i, n)
    {
        if(!i) continue;
        int pos = -1;
        for(int j = i - 1; j >= 0; j--)
        {
            if(save[i][j])
            {
                pos = order[j];
                break;
            }
        }
        g[order[i]].pb(pos);
        g[pos].pb(order[i]);
    }

    int m = 0;
    function<void(int, int)> go = [&](int v, int p)
    {
        if(sz(g[v]) == 1)
        {
            m++;
            return;
        }

        for(auto u : g[v])
        {
            if(u == p) continue;
            go(u, v);
        }
    };

    go(root, -1);

    int needn = n / 2;
    int needm = m / 2;
    vec<int> bad (n);

    function<void(int, int)> banning1 = [&](int v, int p)
    {
        if(!needm) return;
        if(sz(g[v]) == 1)
        {
            if(sz(g[p]) > 2)
            {
                bad[v] = 1;
                g[p].erase(find(all(g[p]), v));
                needm--;
                needn--;
            }
            return;
        }

        for(auto u : g[v])
        {
            if(u != p)
                banning1(u, v);
        }
        if(!needm) return;
    };

    function<void(int, int)> banning2 = [&](int v, int p)
    {
        if(!needm) return;
        if(sz(g[v]) == 1)
        {
            if(sz(g[p]) == 2)
            {
                bad[v] = 1;
                g[p].erase(find(all(g[p]), v));
                needn--;
            }
            else
            {
                bad[v] = 1;
                g[p].erase(find(all(g[p]), v));
                needn--;
                needm--;
            }
            return;
        }

        for(auto u : g[v])
        {
            if(u != p)
                banning2(u, v);
        }

        if(!needm) return;

        if(sz(g[v]) == 1)
        {
            if(sz(g[p]) == 2)
            {
                bad[v] = 1;
                g[p].erase(find(all(g[p]), v));
                needn--;
            }
            else
            {
                bad[v] = 1;
                g[p].erase(find(all(g[p]), v));
                needn--;
                needm--;
            }
            return;
        }
    };

    function<void(int, int)> banning3 = [&](int v, int p)
    {
        if(!needn) return;
        needn--;
        bad[v] = 1;

        for(auto u : g[v])
        {
            if(u != p)
                banning3(u, v);
        }
    };

    banning1(0, -1);
    if(needm)
    {
        banning2(0, -1);
        banning3(0, -1);
    }
    else
    {
        banning3(0, -1);
    }

    FOR(i, n)
        if(!bad[i])
            cout << i + 1 << ' ';
    cout << endl;
}

signed main()
{
    int t = 1;
    cin >> t;
    while(t--)
    {
        solve();
    }
}

