#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>
#include <map>

using namespace std;
#define int long long
int n, m, k;

const int N = 2e5 + 7;

bool used[N], answ[N];

void solve1() {
	cin >> n >> k;
	vector<int> p = {};
	for (int i = 0; i <= n; i++) {
		answ[i] = 0;
		used[i] = 0;
	}
	for (int i = 0; i < k; i++) {
		int x;
		cin >> x;
		used[x] = 1;
	}
	for (int i = 1; i <= n; i++) {
		if (used[i]) {
			answ[i] = 1;
		}
	}
	for (int i = 1; i <= n; i++) {
		if (answ[i]) {
			cout << i << " ";
		}
	}
	cout << "\n";
}

void solve2() {
	cin >> n >> k;
	for (int i = 0; i <= n; i++) {
		answ[i] = 0;
		used[i] = 0;
	}
	for (int i = 0; i < k; i++) {
		int x;
		cin >> x;
		answ[x] = 1;
	}

	for (int i = 1; i <= n; i++) {
		if (!answ[i]) {
			cout << i << " ";
		}
	}
	cout << "\n";
}


signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	int t;
	cin >> t;
	if (t == 1) {
		cin >> t;
		while (t--) {
			solve1();
		}
	}
	else {
		cin >> t;
		while (t--) {
			solve2();
		}
	}
}