#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <unordered_map>
#include <iomanip>
#include <iostream>
typedef long long ll;
typedef long double ld;
using namespace std;

void encode() {
	ll n, k;
	cin >> n >> k;
	vector<ll> a(k);
	for (int i = 0; i < k; ++i) cin >> a[i];
	if (k == 1) {
		cout << a[0] % n + 1 << '\n';
		return;
	}
	if (k == 2) {
		if (a[1] - a[0] == 1 || (a[0] == 1 && a[1] == n)) {
			a[0] = (a[0] + 1) % n + 1;
			a[1] = (a[1] + 1) % n + 1;
			if (a[1] < a[0]) swap(a[0], a[1]);
			cout << a[0] << " " << a[1] << '\n';
		}
		else {
			a[0] = a[0] % n + 1;
			a[1] = a[1] % n + 1;
			if (a[1] < a[0]) swap(a[0], a[1]);
			cout << a[0] << " " << a[1] << '\n';
		}
	}
}

void decode() {
	ll n, k;
	cin >> n >> k;
	vector<ll> a(k);
	for (int i = 0; i < k; ++i) cin >> a[i];
	if (k == 1) {
		cout << (a[0] == 1 ? n : a[0] - 1) << '\n';
	}
	else if (k == 2){
		if (a[1] - a[0] == 1 || (a[1] == n && a[0] == 1)) {
			if (a[0] <= 2) {
				a[0] = n - (2 - a[0]);
			}
			else a[0] -= 2;
			if (a[1] <= 2) {
				a[1] = n - (2 - a[1]);
			}
			else a[1] -= 2;
		}
		else {
			a[0] = (a[0] == 1 ? n : a[0] - 1);
			a[1] = (a[1] == 1 ? n : a[1] - 1);
		}
		if (a[1] < a[0]) swap(a[1], a[0]);
		cout << a[0] << " " << a[1] << '\n';
	}
}

int main() {
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	ll nm;
	cin >> nm;
	if (nm == 1) {
		ll tc;
		cin >> tc;
		while (tc--) {
			encode();
		}
	}
	else {
		ll tc;
		cin >> tc;
		while (tc--) {
			decode();
		}
	}
}
