#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define F first
#define S second


pii solve(vector<int> a, int w) {
    sort(all(a));
    deque<int> arr;
    int cur = 0;
    for (int v : a)
        arr.push_back(v);
    pii ans = { arr.back() - arr.front() + 1, 0 };
    for (int i = 0; i < a.size(); i++) {
        cur += w - arr.back() - cur;
        arr.push_front(-cur);
        arr.pop_back();
        ans = min(ans, { arr.back() - arr.front() + 1, cur });
    }
    return ans;
}

pii solve_rev(vector<int> a, int w) {
    sort(all(a));
    deque<int> arr;
    int cur = 0;
    for (int v : a)
        arr.push_back(v);
    pii ans = { arr.back() - arr.front() + 1, 0 };
    for (int i = 0; i < a.size(); i++) {
        cur += arr.front() + 1 - cur;
        arr.push_back(w + cur - 1);
        arr.pop_front();
        ans = min(ans, { arr.back() - arr.front() + 1, cur });
    }
    return ans;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int h, w, n;
    cin >> h >> w >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i] >> b[i];
        a[i]--; b[i]--;
    }
    pii _w = min(solve(b, w), solve_rev(b, w)), _h = min(solve(a, h), solve_rev(a, h));
    cout << _w.F * 1ll * _h.F << ' ' << _w.S + _h.S << endl;
}