#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

vector <int> leaves;
int sz = 0;

const int maxn = 1e6;

vector <int> g[maxn];
int l[maxn], r[maxn];

void dfs(int v, int pr, int sw) {
    if (g[v].empty()) {
        l[v] = sz; r[v] = sz;
        leaves.push_back(sw);
        sz++;
        return;
    }
    if (pr == -1) {
        dfs(g[v][0], pr, sw);
        dfs(g[v][1], -pr, sw + 1);
    } else if (pr == 1) {
        dfs(g[v][0], -pr, sw + 1);
        dfs(g[v][1], pr, sw);
    } else {
        dfs(g[v][0], -1, sw);
        dfs(g[v][1], 1, sw);
    }
    l[v] = l[g[v][0]];
    r[v] = r[g[v][1]];
}

signed main() {
    if (1) {
        ios_base::sync_with_stdio(false);
        cin.tie(0); cout.tie(0);
    }
    int n, k, q; cin >> n >> k >> q;
    for (int i = 0; i < n; ++i) {
        int ln; cin >> ln;
        if (ln == 2) {
            int v, u; cin >> v >> u;
            v--; u--;
            g[i].push_back(v);
            g[i].push_back(u);
        }
    }
    dfs(0, 0, 0);
    vector <int> pref(sz + 1, 0);
    for (int i = 1; i <= sz; ++i) {
        pref[i] = pref[i - 1] + (leaves[i - 1] <= k);
    }
    for (int w = 0; w < q; ++w) {
        int u; cin >> u;
        u--;
        cout << pref[r[u] + 1] - pref[l[u]] << "\n";
    }
}
