#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <iomanip>
#include <stdio.h>
#include <set>
#include <unordered_map>
#include <deque>
#include <stack>
#include <queue>
#include <cmath>
#include <random>
#include <climits>

using namespace std;

#pragma GCC optimize("Ofast")

#define int long long
#define endl '\n'

long long mod = 1e9 + 7;

vector<int> getbin(int x, int c)
{
	vector<int> ret;
	for (int j = 0; j < c; j++)
	{
		ret.push_back(x % 2);
		x /= 2;
	}
	return ret;
}

int mex(set<int> s)
{
	for (int i = 0; i < 1000000; i++)
	{
		if (s.find(i) == s.end()) return i;
	}
}

set<int> modify(set<int> s)
{
	int m = mex(s);
	m--;
	set<int> ns;
	for (auto it : s)
	{
		ns.insert(it ^ m);
	}
	return ns;
}

int k, n, p;

bool check(set<int> s)
{
	set<set<int>> ss;
	ss.insert(s);

	while (true)
	{
		s = modify(s);
		if (ss.find(s) != ss.end())
		{
			set<int> ls = s;
			int cur = mex(s);
			if (cur != p) return false;
			do
			{
				s = modify(s);
				if (mex(s) != cur) return false;
			} while (s != ls);
			return true;
		}
		else
		{
			ss.insert(s);
		}
	}
}

int ans = 0;
set<int> cur;

void rec(int mm)
{
	if (cur.size() == n)
	{
		ans += check(cur);
	}
	for (int i = mm + 1; i < ((int)1 << k); i++)
	{
		cur.insert(i);
		rec(i);
		cur.erase(i);
	}
}

void task()
{
	ans = 0;
	cin >> k >> n >> p;
	rec(-1);
	cout << ans << endl;
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	cout << fixed << setprecision(15);

	cin >> mod;

	bool multitest = 1;
	int t = 1;
	if (multitest) cin >> t;
	while (t--) task();

	return 0;
}
