#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <random>
#include <climits>
#include <deque>
#include <stack>
#include <queue>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <chrono>
#include <iomanip>
#include <stdio.h>

using namespace std;

#define int long long
#define endl '\n'

struct Seg
{
	int l, r, num;
	bool operator<(Seg s) const
	{
		return l < s.l || (l == s.l && r > s.r);
	}
};

void task()
{
	int n;
	cin >> n;
	vector<Seg> v(n);

	for (int i = 0; i < n; i++)
	{
		cin >> v[i].l >> v[i].r;
		v[i].num = i;
	}

	sort(v.begin(), v.end());

	vector<int> dp(n, 0);
	vector<int> prev(n, -1);
	for (int i = 0; i < n; i++)
	{
		int maxx = 0;
		int p = -1;
		for (int j = 0; j < i; j++)
		{
			if (v[j].r < v[i].l)
			{
				if (dp[j] >= maxx)
				{
					maxx = dp[j];
					p = j;
				}
			}
		}

		dp[i] = maxx + 1;
		prev[i] = p;
	}

	int num = 0;
	for (int i = 1; i < n; i++)
	{
		if (dp[i] > dp[num]) num = i;
	}

	vector<int> b;
	while (num != -1)
	{
		b.push_back(num);
		num = prev[num];
	}
	reverse(b.begin(), b.end());

	vector<int> ans;
	set<int> s;

	for (int i = n - 1; i >= 0; i--)
	{
		if (dp[i] == b.size() / 2)
		{
			if (i + 1 <= n / 2)
			{
				int num = n - 1;
				for (int j = 0; j < b.size() / 2; j++)
				{
					ans.push_back(v[num].num + 1);
					s.insert(v[num].num + 1);
					num = prev[num];
				}
				for (int j = i + 1; j < n; j++)
				{
					if (ans.size() < n / 2 && s.find(v[j].num + 1) == s.end())
					{
						ans.push_back(v[j].num + 1);
					}
				}

				for (int j = 0; j < ans.size(); j++)
				{
					cout << ans[j] << ' ';
				}
				cout << endl;
				return;
			}
			else
			{
				int num = i;
				for (int j = 0; j < b.size() / 2; j++)
				{
					ans.push_back(v[num].num + 1);
					s.insert(num);
					num = prev[num];
				}
				for (int j = 0; j < i + 1; j++)
				{
					if (ans.size() < n / 2 && s.find(j) == s.end())
					{
						ans.push_back(v[j].num + 1);
					}
				}

				for (int j = 0; j < ans.size(); j++)
				{
					cout << ans[j] << ' ';
				}
				cout << endl;
				return;
			}
		}
	}

	/*vector<int> in(n, 0);
	for (int i = 0; i < b.size(); i++)
	{
		in[b[i]] = 1;
	}

	vector<int> ans;
	int cnt1 = b.size() / 2;
	int cnt0 = (n - b.size()) / 2;

	for (int i = n - 1; i >= 0; i--)
	{
		if (in[i])
		{
			if (cnt1 > 0)
			{
				cnt1--;
			}
			else
			{
				ans.push_back(v[i].num + 1);
			}
		}
		else
		{
			if (cnt0 > 0)
			{
				cnt0--;
			}
			else
			{
				ans.push_back(v[i].num + 1);
			}
		}
	}

	sort(ans.begin(), ans.end());

	for (int i = 0; i < ans.size(); i++)
	{
		cout << ans[i] << ' ';
	}
	cout << endl;*/
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	cout << fixed << setprecision(15);

	bool multitest = 1;
	int t = 1;
	if (multitest) cin >> t;
	while (t--) task();

	return 0;
}
