#include <iostream>
#include <vector>
#include <algorithm>

#define int long long
#define all(x) x.begin(), x.end()
using namespace std;

void solve() {
    int n, m; cin >> n >> m;
}

void encode() {
    int n, k; cin >> n >> k;
    vector<int> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
    }
    vector<bool> s(n + 1, false);
    for (int i = 0; i < k; ++i) {
        s[a[i]] = true;
    }
    int cnt = 0, did = 0;
    for (int i = 1; did < k; ++i) {
        if (i > n) {
            i = 1;
        }
        if (!s[i] && cnt) {
            s[i] = !s[i];
            cnt--;
        } else if (s[i]) {
            s[i] = !s[i];
            cnt++;
            did++;
        }
    }
    for (int i = 1; i <= n; ++i) {
        if (s[i]) {
            cout << i << ' ';
        }
    }
    cout << endl;
}

void decode() {
    int n, k; cin >> n >> k;
    vector<int> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
    }
    vector<bool> s(n + 1, false);
    for (int i = 0; i < k; ++i) {
        s[a[i]] = true;
    }
    int cnt = 0, did = 0;
    for (int i = n; did < k; --i) {
        if (i == 0) {
            i = n;
        }
        if (!s[i] && cnt) {
            s[i] = !s[i];
            cnt--;
        } else if (s[i]) {
            s[i] = !s[i];
            cnt++;
            did++;
        }
    }
    for (int i = 1; i <= n; ++i) {
        if (s[i]) {
            cout << i << ' ';
        }
    }
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(20);
    cout.setf(ios_base::fixed);
    int a; cin >> a;
    int m; cin >> m;
    while (m--) {
        if (a == 1) {
            encode();
        } else {
            decode();
        }
    }
}