#include <iostream>
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

vector<ll> ans;

struct V {
    ll left, right;
};

vector<V> g;

void dfs(ll v, ll eta, bool isLeft) {
    if (eta < 0) {
        ans[v] = 0;
        return;
    }
    if (g[v].left == -1) {
        ans[v] = 1;
        return;
    } else {
        dfs(g[v].left, eta - (!isLeft && v != 0), true);
        dfs(g[v].right, eta - (isLeft && v != 0), false);
        ans[v] = ans[g[v].left] + ans[g[v].right];
    }
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll n, k, q;
    cin >> n >> k >> q;

    g.assign(n, {});
    ans.assign(n, 0);

    for (ll i = 0; i < n; i++) {
        ll t;
        cin >> t;
        if (t == 2) {
            cin >> g[i].left >> g[i].right;
            g[i].left--;
            g[i].right--;
        } else {
            g[i].left = g[i].right = -1;
        }
    }

    dfs(0, k, true);

    while (q--) {
        ll u;
        cin >> u;
        u--;
        cout << ans[u] << "\n";
    }

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}
