#include <bits/stdc++.h>

using namespace std;

typedef int64_t ll;

struct Solution {
    int TEST = -1;

    Solution(int TEST = -1) : TEST(TEST) {}

    vector<vector<int>> g;
    vector<int> lmt;
    array<vector<int>, 2> dp;

    void dp1(int v = 0, int p = -1) {
        dp[1][v] = lmt[v];
        for (auto& it : g[v]) {
            if (it == p)
                continue;
            dp1(it, v);
            dp[0][v] += dp[1][it];
            dp[1][v] += dp[0][it];
        }
        dp[1][v] = max(dp[0][v], dp[1][v]);
    }

    vector<int> ok;

    void dp2(int v = 0, int p = -1, bool tk = true) {
        if (dp[1][v] == dp[0][v])
            tk = false;
        if (tk) {
            if (lmt[v]) {
                ok.push_back(v);
            }
            for (auto& it : g[v]) {
                if (it == p)
                    continue;
                dp2(it, v, false);
            }
        } else {
            for (auto& it : g[v]) {
                if (it == p)
                    continue;
                dp2(it, v, true);
            }
        }
    }

    signed operator()() {
        int n, q; cin >> n >> q;
        g.resize(n);
        ll x, y, m; cin >> x >> y >> m;
        for (int _ = 0; _ < n - 1; ++_) {
            int a, b; cin >> a >> b;
            g[a - 1].push_back(b - 1);
            g[b - 1].push_back(a - 1);
        }
        lmt.resize(n);
        for (int i = 0; i < n; ++i) {
            int _;
            cin >> _ >> lmt[i];
        }
        dp.fill(vector<int>(n, 0));
        dp1();
        dp2();
        auto ghf = [&](int i, int vl) -> ll {
            return ((x * (ll)i) % m + ((((ll)vl * (ll)vl) % m) * y) % m) % m;
        };
        ll intr = 0;
        for (int i = 0; i < n; ++i) {
            intr ^= ghf(i + 1, 0);
        }
        vector<ll> stmp(ok.size() + 1);
        stmp[0] = intr;
        for (int i = 1; i <= (int)ok.size(); ++i) {
            stmp[i] = stmp[i - 1] ^ ghf(ok[i - 1] + 1, 0) ^ ghf(ok[i - 1] + 1, 1);
        }
        vector<int> qrs(q);
        for (auto& it : qrs) {
            cin >> it;
            if (it >= (int)stmp.size()) {
                cout << "-1 ";
                continue;
            }
            cout << stmp[it] << " ";
        }
        cout << endl;
        while (true) {
            int c; cin >> c;
            if (c == 0) {
                return 0;
            }
            vector<int> rs(n);
            int vl = qrs[c - 1];
            if (vl >= (int)stmp.size()) {
                cout << -1 << endl;
                continue;
            }
            for (int i = 0; i < vl; ++i) {
                rs[ok[i]] = 1;
            }
            for (auto& it : rs) {
                cout << it << " ";
            }
            cout << endl;
        }
        return 0;
    }
};

signed main() {
    (*cin.tie(0)).sync_with_stdio(0);
    int t; cin >> t;
    for (int test = 1; test <= t; ++test) {
        int res = Solution(test)();
        if (res != 0) {
            return res;
        }
    }
    return 0;
}

//1
//3 4
//3 4 11
//1 2
//2 3
//0 1
//0 1
//0 1
//0 1 2 3

//1
//3 4
//3 4 11
//1 2
//2 3
//0 1
//0 1
//0 0
//0 1 2 3

//1
//9 3
//4 7 15
//1 2
//2 4
//2 5
//1 3
//3 6
//3 7
//6 8
//6 9
//4 4
//2 2
//5 5
//3 3
//2 2
//6 6
//3 3
//4 4
//3 3
//1 5 8
//1
//2
//3
//0

//1
//9 3
//4 7 15
//1 2
//2 4
//2 5
//1 3
//3 6
//3 7
//6 8
//6 9
//4 4
//2 2
//5 5
//3 3
//2 2
//6 6
//3 3
//4 4
//3 3
//18 19 20
//1
//2
//3
//0
