#include <iostream>
#include <vector>
#include <bitset>
#include <algorithm>
#include <map>

using namespace std;

#define mp make_pair
#define int long long
const int maxa = 1501;
const int maxb = 1501;

struct bitss {
	vector <long long> a;
	bitss(int a)
		:a((a + 633)/64, 0)
	{}
	void g(int x) {
		a[x / 64] |= (1ll << (x % 64));
	}
	int get(int x) {
		return (a[x / 64] >> (x % 64)) & 1;
	}
	void oq(int x, int b)  {
		if (b) a[x / 64] |= (1ll << (x % 64));
	}
};

signed main() {
	int n, q;
	cin >> n >> q;
	vector <int> a(n);
	for (auto& i : a) cin >> i;
	sort(a.begin(), a.end());
	int tr; cin >> tr;
	while (q--) {
		int k, o, o2;
		cin >> k >> o >> o2;
		if (o >= 1e6 || o2 >= 1e6) {
			cout << "No\n";
			continue;
		}
		map <pair <int, int>, int> p;
		int ans = (o + 1) * (o2 + 1);
		
		for (int i = 0; i < pow(3, n); i++) {
			vector <int> b;
			int i2 = i;
			for (int j = 0; j < n; j++) {
				b.push_back(i2 % 3);
				i2 /= 3;
			}
			int l = 0, r = 0, f = 1;
			for (int j = 0; j < n; j++) {
				if (b[j] > 0 && a[j] > k) f = 0;
				if (b[j] == 1) l += a[j];
				if (b[j] == 2) r += a[j];
			}
			if (f && l <= o && r <= o2) {
				ans -= (1 - p[mp(l, r)]);
				p[mp(l, r)] = 1;
			}
		}
		if (ans) cout << "No\n";
		else cout << "Yes\n";
	}
}