#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;
typedef long long ll;
vector<vector<ll>> ch;
vector<ll> s, u, par;
void dfs(ll v) {
	u[v] = 1;
	for (auto to : ch[v]) {
		s[to] = s[v] + 1;
		dfs(to);
	}
}
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	ll t;
	cin >> t;
	while (t--) {
		ll n;
		cin >> n;
		vector<ll> l(n), r(n);
		vector<vector<ll>> p(n);
		for (ll i = 0; i < n; ++i) cin >> l[i] >> r[i], p[i] = { r[i], l[i], i + 1 };
		sort(p.begin(), p.end());
		vector<ll> dp(n, 0), mx(n, 0);
		for (ll i = 0; i < n; ++i) {
			ll L = -1, R = i;
			while (R - L > 1) {
				ll M = (L + R) / 2;
				if (p[M][0] < p[i][1]) L = M;
				else R = M;
			}
			if (R) dp[i] = mx[L] + 1;
			else dp[i] = 1;
			if (i) mx[i] = mx[i - 1];
			mx[i] = max(mx[i], dp[i]);
		}
		ll m = mx[n - 1];
		if (n <= 20) {
			for (ll I = 0; I < ((ll)1 << n); ++I) {
				vector<vector<ll>> p1;
				for (ll j = 0; j < n; ++j) {
					if (I & ((ll)1 << j)) p1.push_back(p[j]);
				}
				if ((ll)p1.size() != n / 2) continue;
				vector<ll> dp1(n / 2, 0), mx1(n / 2, 0);
				for (ll i = 0; i < n / 2; ++i) {
					ll L = -1, R = i;
					while (R - L > 1) {
						ll M = (L + R) / 2;
						if (p1[M][0] < p1[i][1]) L = M;
						else R = M;
					}
					if (R) dp1[i] = mx1[L] + 1;
					else dp1[i] = 1;
					if (i) mx1[i] = mx1[i - 1];
					mx1[i] = max(mx1[i], dp1[i]);
				}
				if (mx1[n / 2 - 1] == m / 2) {
					for (auto x : p1) cout << x[2] << " ";
					cout << "\n";
					break;
				}
			}
		}
		else {
			vector<vector<ll>> e;
			for (ll i = 0; i < n; ++i) e.push_back({ l[i], 1, i }), e.push_back({ r[i], -1, i });
			sort(e.begin(), e.end());
			ch.resize(n);
			vector<ll> st;
			par.assign(n, -1);
			for (ll i = 0; i < 2 * n; ++i) {
				if (e[i][1] == -1) st.pop_back();
				else {
					if ((ll)st.size()) ch[st.back()].push_back(e[i][2]), par[e[i][2]] = st.back();
					st.push_back(e[i][2]);
				}
			}
			s.assign(n, 0);
			u.assign(n, 0);
			for (ll i = 0; i < n; ++i) {
				if (!u[i] && par[i] == -1) dfs(i);
			}
			set<pair<ll, ll>> z;
			vector<ll> d(n);
			for (ll i = 0; i < n; ++i) {
				d[i] = (ll)ch[i].size();
				if (d[i] == 0) z.insert({ s[i], i });
			}
			vector<ll> U(n, 1);
			ll y = m, N = n;
			while (y > m / 2) {
				auto it = z.begin();
				ll v = (*it).second;
				U[v] = 0;
				z.erase(it);
				--N;
				if (par[v] != -1) {
					--d[par[v]];
					if (d[par[v]] == 0) z.insert({ s[par[v]], par[v] });
					else --y;
				}
				else --y;
			}
			while (N > n / 2) {
				auto it = z.end();
				--it;
				ll v = (*it).second;
				U[v] = 0;
				z.erase(it);
				--N;
				if (par[v] != -1) {
					--d[par[v]];
					if (d[par[v]] == 0) z.insert({ s[par[v]], par[v] });
					else --y;
				}
				else --y;
			}
			for (ll i = 0; i < n; ++i) {
				if (U[i]) cout << i + 1 << " ";
			}
			cout << "\n";
		}
	}
	cout << endl;
	return 0;
}