#include <algorithm>
#include <cassert>
#include <iostream>
#include <set>
#include <vector>

using namespace std;

int m;

int mex(const vector<int>& a) {
    for (int i = 1; i < (int)a.size(); i++) {
        if (a[i] - a[i - 1] != 1) {
            assert(a[i] > a[i - 1] + 1);
            return a[i - 1] + 1;
        }
    }
    return a.back() + 1;
}

int good(vector<int> st) {
    set<vector<int>> seen;
    vector<int> prev(0);
    while (seen.find(st) == seen.end()) {
        seen.insert(st);
        prev = st;
        int ck = mex(st);
        for (auto& el : st) {
            el ^= (ck - 1);
        }
        sort(st.begin(), st.end());
        st.resize(unique(st.begin(), st.end()) - st.begin());
    }
    if (st == prev) {
        return mex(st);
    } else {
        return -1;
    }
}

void solve() {
    int k, n, p;
    cin >> k >> n >> p;

    int maxel = (1 << k);
    int res = 0;
    for (unsigned mask = 1; mask < (1u << maxel); mask += 2) {
        if (__builtin_popcount(mask) != n) {
            continue;
        }
        vector<int> cset;
        for (int i = 0; i < maxel; i++) {
            if ((mask >> i) & 1) {
                cset.emplace_back(i);
            }
        }

        if (good(cset) == p) {
            res++;
            if (res >= m) {
                res -= m;
            }
        }
    }

    cout << res << "\n";
}

int main() {
    cin >> m;
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}