#include <bits/stdc++.h>

using namespace std;
#define int long long

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> w(n);
    for (auto &i: w) cin >> i;
    sort(w.begin(), w.end());
    int z;
    cin >> z;
    int k = 1e18, a = 302, b = 302;
    vector<vector<vector<bool>>> dp(n + 1, vector<vector<bool>>(a + 1, vector<bool>(b + 1)));
    dp[0][0][0] = 1;
    for (int i = 1; i <= n; i++) {
        if (w[i - 1] > k) break;
        for (int x = 0; x <= a; x++) {
            for (int y = 0; y <= b; y++) {
                dp[i][x][y] = dp[i - 1][x][y];
                if (!dp[i][x][y] && x - w[i - 1] >= 0) dp[i][x][y] = dp[i - 1][x - w[i - 1]][y];
                if (!dp[i][x][y] && y - w[i - 1] >= 0) dp[i][x][y] = dp[i - 1][x][y - w[i - 1]];
            }
        }
    }
    while (q--) {
        cin >> k >> a >> b;
        bool f = 1;
        for (int x = 0; x <= a; x++) {
            for (int y = 0; y <= b; y++) {
                dp[n][x][y] = dp[n - 1][x][y];
                if (!dp[n][x][y] && x - w[n - 1] >= 0) dp[n][x][y] = dp[n - 1][x - w[n - 1]][y];
                if (!dp[n][x][y] && y - w[n - 1] >= 0) dp[n][x][y] = dp[n - 1][x][y - w[n - 1]];
                if(!dp[n][x][y]) f = 0;
            }
        }
        if (f) cout << "Yes\n";
        else cout << "No\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int _ = 1;
    while (_--) {
        solve();
    }
    return 0;
}
