#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <numeric>
#include <cassert>
#include <bitset>

using namespace std;
using ll = unsigned long long;

//constexpr int C = 1003;
//bitset<C> dp[C];
//constexpr int INF = 0x3f3f3f3f;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
//    dp[0][0] = true;
    cin.tie(0)->sync_with_stdio(0);
    int n, q;
    cin >> n >> q;
    vector<ll> w(n);
    for (ll &now : w) cin >> now;
    std::sort(w.begin(), w.end());
    int z;
    cin >> z;
//    for (int i = 0; i < n; ++i) {
//        if (w[i] > C) continue;
//        for (int f = C - 1; f >= 0; --f) {
////            if (f + w[i] < C) dp[f + w[i]] = dp[f + w[i]] | dp[f];
////            dp[f] = dp[f] | (dp[f] << w[i]);
//            for (int s = C - 1; s >= 0; --s) {
//                if (f >= w[i]) dp[f][s] = dp[f][s] || dp[f - w[i]][s];
//                if (s >= w[i]) dp[f][s] = dp[f][s] || dp[f][s - w[i]];
//            }
//        }
//    }
    int sv = 0;
    for (int qi = 0; qi < q; ++qi) {
        int k, a, b;
        cin >> k >> a >> b;
        k -= sv * z;
        a -= sv * z;
        b -= sv * z;
        if (a > 2000 || b > 2000) {
            cout << "No\n";
            continue;
        }
        vector<vector<bool>> ach(a + 1, vector<bool>(b + 1));
        for (int mask = 0; mask < (1 << n); ++mask) {
            for (int mask2 = 0; mask2 < (1 << n); ++mask2) {
                if (mask & mask2) continue;
                ll s1 = 0, s2 = 0;
                for (int bb = 0; bb < n; ++bb) {
                    if (w[bb] > k || s1 > a || s2 > b) break;
                    if (mask >> bb & 1) {
                        s1 += w[bb];
                    }
                    if (mask2 >> bb & 1) {
                        s2 += w[bb];
                    }
                }
                if (s1 <= a && s2 <= b) {
                    ach[s1][s2] = true;
                }
            }
        }
        bool ok = true;
        for (int i = 0; ok && i <= a; ++i) {
            for (int j = 0; j <= b; ++j) {
                if (!ach[i][j]) {
                    ok = false;
//                    cerr << i << ' ' << j << '\n';
                    break;
                }
            }
        }
//        bool ok = true;
//        for (int i = 0; i <= a && ok; ++i) {
//            for (int j = 0; j <= b; ++j) {
//                if (!dp[i][j]) {
//                    ok = false;
//                    break;
//                }
//            }
//        }
        if (ok) {
            cout << "Yes\n";
            sv += qi + 1;
        } else {
            cout << "No\n";
        }
    }
    return 0;
}