//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,popcmt,abm,mmx")
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
T square(T a) {
	return a * a;
}

ll M;

ll mex(vector<ll>& arr) {
	vector<bool> be(arr.size() + 1, false);
	for (auto i : arr) {
		if (i < be.size()) {
			be[i] = true;
		}
	}
	for (ll i = 0;; i++) {
		if (!be[i]) {
			return i;
		}
	}
}

void solve() {
	ll k, n, p;
	cin >> k >> n >> p;
	ll s2 = 1;
	while (s2 < p) {
		s2 *= 2;
	}
	if (s2 != p) {
		cout << 0 << '\n';
		return;
	}
	ll mx = (1 << k);
	ll ans = 0;
	for (ll i = 1; i < (1 << mx); i += 2) {
		vector<ll> am;
		vector<ll> now;
		for (ll j = 0; j < mx; j++) {
			if ((i >> j) & 1) {
				now.push_back(j);
			}
		}
		if (now.size() != n) {
			continue;
		}
		set<vector<ll>> have;
		while (have.find(now) == have.end()) {
			have.insert(now);
			am.push_back(mex(now));
			for (auto& i : now) {
				i ^= am.back() - 1;
			}
		}
		if (am.back() == p && (am.back() == 1 || am[am.size() - 1] == am[am.size() - 2])) {
			ans++;
		}
	}
	cout << ans % M << '\n';
}

bool l = false;

int main() {
#ifdef LOCAL
	l = true;
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> M;
	ll t;
	cin >> t;
	while (t--) {
		solve();
	}
}
