#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

struct query {
    int a, b, k;
};

void solve() {
    int n, q, z;
    cin >> n >> q;

    vector<ll> w(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    sort(w.begin(), w.end());

    cin >> z;
    int MAX_A = 0, MAX_B = 0;
    vector<query> qs(q);
    for (int i = 0; i < q; ++i) {
        cin >> qs[i].k >> qs[i].a >> qs[i].b;
        MAX_A = max(MAX_A, qs[i].a);
        MAX_B = max(MAX_B, qs[i].b);
    }
    MAX_A++;
    MAX_B++;

    vector<vector<bool>> dp(MAX_A, vector<bool>(MAX_B));
    dp[0][0] = true;
    for (int i = 0; i < n; ++i) {
        for (int ai = MAX_A - 1; ai >= 0; --ai) {
            for (int bi = MAX_B - 1; bi >= 0; --bi) {
                if (ai - w[i] >= 0 && dp[ai - w[i]][bi]) {
                    dp[ai][bi] = true;
                }
                if (bi - w[i] >= 0 && dp[ai][bi - w[i]]) {
                    dp[ai][bi] = true;
                }
            }
        }
    }

//    for (int ai = 0; ai < MAX_A; ++ai) {
//        for (int bi = 0; bi < MAX_B; ++bi) {
//            if (ai > 0 && !dp[ai - 1][bi]) {
//                dp[ai][bi] = false;
//            }
//            if (bi > 0 && !dp[ai][bi - 1]) {
//                dp[ai][bi] = false;
//            }
//        }
//    }

//    for (int i = 0; i < MAX_A; ++i) {
//        for (int j = 0; j < MAX_B; ++j) {
//            cerr << dp[i][j] << " ";
//        }
//        cerr << "\n";
//    }

    for (int i = 0; i < q; ++i) {
        bool ok = true;
        for (int x = 0; x <= qs[i].a; ++x) {
            for (int y = 0; y <= qs[i].b; ++y) {
                ok = ok && dp[x][y];
            }
        }
        if (ok) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}

int main() {
#ifndef NEKSTAS
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int t = 1;
//    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}
