#include <bits/stdc++.h>
#define int long long

using namespace std;

const int inf = 1e9 + 1;
const int maxn = 1 << 17;
struct node {
  int mx = 0;
  int ind = -1;
  static node combine(node a, node b) {
    return a.mx > b.mx ? a : b;
  }
} tree[2 * maxn - 1];
set<int> vis;
void edit(int x, int l, int r, int ind, int val, int iind) {
  vis.insert(x);
  if (r < ind || ind < l) return;
  if (l == r) {
    tree[x].mx = val;
    tree[x].ind = iind;
    return;
  }
  int mid = (l + r) >> 1;
  edit(2 * x + 1, l, mid, ind, val, iind);
  edit(2 * x + 2, mid + 1, r, ind, val, iind);
  tree[x] = node::combine(tree[2 * x + 1], tree[2 * x + 2]);
}
node get(int x, int l, int r, int ll, int rr) {
  if (r < ll || rr < l) return {};
  if (ll <= l && r <= rr) return tree[x];
  int mid = (l + r) >> 1;
  return node::combine(get(2 * x + 1, l, mid, ll, rr),
             get(2 * x + 2, mid + 1, r, ll, rr));
}

pair<vector<int>, set<int>> calc_dp(vector<pair<int, int>> p) {
  for (auto& vv : vis)
    tree[vv] = {};
  vis.clear();
  vector<int> b;
  for (auto& i : p) {
    b.push_back(i.first);
    b.push_back(i.second);
  }
  sort(b.begin(), b.end());
  b.resize(unique(b.begin(), b.end()) - b.begin());
  for (auto& i : p) {
    i.first = lower_bound(b.begin(), b.end(), i.first) - b.begin();
    i.second = lower_bound(b.begin(), b.end(), i.second) - b.begin();
  }
  int n = (int)p.size();
  vector<int> pp(n);
  iota(pp.begin(), pp.end(), 0ll);
  sort(pp.begin(), pp.end(), [&](int i, int j) {
    return p[i].first < p[j].first;
  });
  vector<int> dp(n);
  vector<int> pr(n, -1);
  for (auto& i : pp) {
    auto gg = get(0, 0, maxn - 1, 0, p[i].first - 1);
    dp[i] = gg.mx + 1;
    pr[i] = gg.ind;
    if (gg.mx == 0)
      pr[i] = -1;
    edit(0, 0, maxn - 1, p[i].second, dp[i], i);
  }
  set<int> cc;
  int x = max_element(dp.begin(), dp.end()) - dp.begin();
  while (x != -1) {
    cc.insert(x);
    x = pr[x];
  }
  return {dp, cc};
}

signed main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
#ifdef LOCAL
  freopen("input", "r", stdin);
#endif
  int tt;
  cin >> tt;
  while (tt--) {
    int n;
    cin >> n;
    vector<pair<int, int>> p(n);
    for (int i = 0; i < n; i++) {
      cin >> p[i].first >> p[i].second;
    }
    vector<vector<int>> g(n), rg(n);
    vector<int> dp = calc_dp(p).first;
    int m = *max_element(dp.begin(), dp.end());
    vector<vector<int>> h(m + 1);
    set<pair<int, int>> ss;
    for (int i = 0; i < n; i++) {
      h[dp[i]].push_back(i);
    }
    for (int i = 1; i <= m; i++) {
      ss.emplace((int)h[i].size(), i);
    }
    int need = m / 2;
    int d = 0;
    vector<bool> bl(n);
    while (need > 0) {
      int mn = ss.begin()->second;
      ss.erase(ss.begin());
      for (auto& i : h[mn]) bl[i] = true;
      if (!h[mn].empty()) {
        d += (int) h[mn].size();
        need -= 1;
        h[mn].clear();
      }
    }
    assert(d <= n / 2);
    auto pp = p;
    for (int i = 0; i < n; i++) {
      if (bl[i]) {
        pp[i].first = 0;
        pp[i].second = inf;
      }
    }
    auto cc = calc_dp(pp).second;
    for (int i = 1; i <= m; i++) {
      vector<bool> block(h[i].size());
      for (int j = (int)h[i].size() - 1; j >= 0; j--) {
        if (d < n / 2 && cc.find(h[i][j]) == cc.end()) {
          block[j] = true;
          d++;
        }
      }
      vector<int> nh;
      for (int j = 0; j < (int)h[i].size(); j++) {
        if (block[j] == false) {
          nh.push_back(h[i][j]);
        }
      }
      h[i] = nh;
    }
    vector<int> ans;
    for (int i = 1; i <= m; i++) {
      for (auto& j : h[i]) ans.push_back(j);
    }
    sort(ans.begin(), ans.end());
    // assert(ans.size() == n / 2);
    for (auto& i : ans) cout << i + 1 << ' ';
    cout << '\n';
  }
}